﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// Address / Address - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class Address
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for Address
        /// </summary>
	    public Address()
		{
		}

		///// <summary>
        ///// Creates a new instance of Address
        ///// </summary>
	    //internal Address CreateEntity()
		//{
		//    return new Address();
		//}

		#region Members

		
        /// <summary>
        /// AddressId / Address.AddressID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("AddressID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? AddressId
        {
            get
            {
                return (int?)this["AddressID"];
            }
            set
            {
                this.Add("AddressID", value, typeof(int?));
            }
        }

        /// <summary>
        /// AddressLine1 / Address.AddressLine1
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("AddressLine1"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string AddressLine1
        {
            get
            {
                return (string)this["AddressLine1"];
            }
            set
            {
                this.Add("AddressLine1", value, typeof(string));
            }
        }

        /// <summary>
        /// AddressLine2 / Address.AddressLine2
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("AddressLine2"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string AddressLine2
        {
            get
            {
                return (string)this["AddressLine2"];
            }
            set
            {
                this.Add("AddressLine2", value, typeof(string));
            }
        }

        /// <summary>
        /// City / Address.City
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("City"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string City
        {
            get
            {
                return (string)this["City"];
            }
            set
            {
                this.Add("City", value, typeof(string));
            }
        }

        /// <summary>
        /// StateProvinceId / Address.StateProvinceID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("StateProvinceID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("StateProvince")]
        public virtual int? StateProvinceId
        {
            get
            {
                return (int?)this["StateProvinceID"];
            }
            set
            {
                this.Add("StateProvinceID", value, typeof(int?));
            }
        }

        /// <summary>
        /// PostalCode / Address.PostalCode
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("PostalCode"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string PostalCode
        {
            get
            {
                return (string)this["PostalCode"];
            }
            set
            {
                this.Add("PostalCode", value, typeof(string));
            }
        }

        /// <summary>
        /// SpatialLocation / Address.SpatialLocation
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("SpatialLocation"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string SpatialLocation
        {
            get
            {
                return (string)this["SpatialLocation"];
            }
            set
            {
                this.Add("SpatialLocation", value, typeof(string));
            }
        }

        /// <summary>
        /// Rowguid / Address.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / Address.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to StateProvince

        /// <summary>
        /// Link to parent/super Entity StateProvince / StateProvince (this.StateProvinceId)
		/// Foreign key FK_Address_StateProvince_StateProvinceID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual StateProvince StateProvince
        {
            get
            {
			    // Lazy loading
                if (this._StateProvince == null && this.StateProvinceId != null)
                {
                    this._StateProvince = ((AdvEntityManager)this.Manager).GetStateProvince(this.StateProvinceId);
                    if (! _StateProvince.ResultInfo.IsValid)
                    {
						this._StateProvince = null; // reset value
                        throw new Exception("wrong/missed constraint from Address to StateProvince.");
                    }
                }
                return this._StateProvince;
            }
            set
            {
                // reassign foreign key values from setter value
                this.StateProvinceId = (value != null ? value.StateProvinceId : null);


				// set foreign table
                this._StateProvince = value;
            }
        }
        private StateProvince _StateProvince = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from BusinessEntityAddress

        /// <summary>
        /// List of sub entities BusinessEntityAddress / BusinessEntityAddress (AddressID)
		/// Foreign Key FK_BusinessEntityAddress_Address_AddressID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual BusinessEntityAddressList BusinessEntityAddressList
        {
            get
            {
			    // Lazy Loading
                if (_BusinessEntityAddressList == null && this.AddressId != null)
                {
					var where = new SqlWhereClause("WHERE BusinessEntityAddress.AddressID = @AddressID",
					    "@AddressID", this.AddressId);
                    _BusinessEntityAddressList = ((AdvEntityManager)this.Manager).GetBusinessEntityAddressList(where);
                }
				if (_BusinessEntityAddressList == null)
				{
					_BusinessEntityAddressList = new BusinessEntityAddressList();
				}
                return _BusinessEntityAddressList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private BusinessEntityAddressList _BusinessEntityAddressList = null;

        #endregion

        #region Sub Entites from SalesOrderHeader

        /// <summary>
        /// List of sub entities SalesOrderHeader / SalesOrderHeader (BillToAddressID)
		/// Foreign Key FK_SalesOrderHeader_Address_BillToAddressID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesOrderHeaderList SalesOrderHeaderList
        {
            get
            {
			    // Lazy Loading
                if (_SalesOrderHeaderList == null && this.AddressId != null)
                {
					var where = new SqlWhereClause("WHERE SalesOrderHeader.BillToAddressID = @BillToAddressID",
					    "@BillToAddressID", this.AddressId);
                    _SalesOrderHeaderList = ((AdvEntityManager)this.Manager).GetSalesOrderHeaderList(where);
                }
				if (_SalesOrderHeaderList == null)
				{
					_SalesOrderHeaderList = new SalesOrderHeaderList();
				}
                return _SalesOrderHeaderList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private SalesOrderHeaderList _SalesOrderHeaderList = null;

        #endregion

        #region Sub Entites from SalesOrderHeader

        /// <summary>
        /// List of sub entities SalesOrderHeader / SalesOrderHeader (ShipToAddressID)
		/// Foreign Key FK_SalesOrderHeader_Address_ShipToAddressID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesOrderHeaderList SalesOrderHeaderShipToAddressIdList
        {
            get
            {
			    // Lazy Loading
                if (_SalesOrderHeaderShipToAddressIdList == null && this.AddressId != null)
                {
					var where = new SqlWhereClause("WHERE SalesOrderHeader.ShipToAddressID = @ShipToAddressID",
					    "@ShipToAddressID", this.AddressId);
                    _SalesOrderHeaderShipToAddressIdList = ((AdvEntityManager)this.Manager).GetSalesOrderHeaderList(where);
                }
				if (_SalesOrderHeaderShipToAddressIdList == null)
				{
					_SalesOrderHeaderShipToAddressIdList = new SalesOrderHeaderList();
				}
                return _SalesOrderHeaderShipToAddressIdList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private SalesOrderHeaderList _SalesOrderHeaderShipToAddressIdList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.AddressFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Address"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // Address

	#endregion

	#region Entity-List

    /// <summary>
    /// Address / AddressList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class AddressList
        : WebEntityList<Address>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Address"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// Address - Address - Factory 
    /// </summary>
    public partial class AddressFactory
        : WebEntityFactory<Address, AddressList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property AddressId of Db-Field AddressID</summary>
        public static string Prop_AddressId = "AddressId";
        ///<summary>Property AddressLine1 of Db-Field AddressLine1</summary>
        public static string Prop_AddressLine1 = "AddressLine1";
        ///<summary>Property AddressLine2 of Db-Field AddressLine2</summary>
        public static string Prop_AddressLine2 = "AddressLine2";
        ///<summary>Property City of Db-Field City</summary>
        public static string Prop_City = "City";
        ///<summary>Property StateProvinceId of Db-Field StateProvinceID</summary>
        public static string Prop_StateProvinceId = "StateProvinceId";
        ///<summary>Property PostalCode of Db-Field PostalCode</summary>
        public static string Prop_PostalCode = "PostalCode";
        ///<summary>Property SpatialLocation of Db-Field SpatialLocation</summary>
        public static string Prop_SpatialLocation = "SpatialLocation";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field AddressID of Property AddressId</summary>
        public static string Field_AddressId = "AddressID";
        ///<summary>Db-Field AddressLine1 of Property AddressLine1</summary>
        public static string Field_AddressLine1 = "AddressLine1";
        ///<summary>Db-Field AddressLine2 of Property AddressLine2</summary>
        public static string Field_AddressLine2 = "AddressLine2";
        ///<summary>Db-Field City of Property City</summary>
        public static string Field_City = "City";
        ///<summary>Db-Field StateProvinceID of Property StateProvinceId</summary>
        public static string Field_StateProvinceId = "StateProvinceID";
        ///<summary>Db-Field PostalCode of Property PostalCode</summary>
        public static string Field_PostalCode = "PostalCode";
        ///<summary>Db-Field SpatialLocation of Property SpatialLocation</summary>
        public static string Field_SpatialLocation = "SpatialLocation";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = Address, 
		/// Fields       = "AddressID"
		/// Query        = ...
        /// </summary>
        protected AddressFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Person";
            this.TableName = "Address";
            this.Fields = new string[]
            {
                "AddressID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("AddressId", "int?", "AddressID", "int?", "", null);
			this.Properties.Add("AddressLine1", "string", "AddressLine1", "string", "", null);
			this.Properties.Add("AddressLine2", "string", "AddressLine2", "string", "", null);
			this.Properties.Add("City", "string", "City", "string", "", null);
			this.Properties.Add("StateProvinceId", "int?", "StateProvinceID", "int?", "", "StateProvince");
			this.Properties.Add("PostalCode", "string", "PostalCode", "string", "", null);
			this.Properties.Add("SpatialLocation", "string", "SpatialLocation", "string", "", null);
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "Address"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "AddressList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "AddressFactory"; }
            set { }
        }

		#endregion

		internal static AddressFactory CreateFactory(EntityManager manager)
		{
		    return new AddressFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of Address. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo Address</returns>
        public override Address CreateEntity()
		{
			var item = new Address();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(Address item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity StateProvince / StateProvince
            // Foreign Key FK_Address_StateProvince_StateProvinceID
            if (parent is StateProvince)
            {
                item.StateProvince = (StateProvince)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public Address GetItem(int? addressId)
        {
            return this.GetEntity(0, addressId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public Address GetItem(DbConnector conn, int? addressId)
        {
            return this.GetEntity(conn, addressId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(Address).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to AddressFactory / Address / Address.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// AddressFactory to Address / Address.
        /// </summary>
        public AddressFactory AddressFactory
		{
			get
			{
				if (_AddressFactory == null)
				{
					_AddressFactory = global::AdventureWorks.AddressFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_AddressFactory, typeof(Address));
				}
				return _AddressFactory;
			}
		}
		private AddressFactory _AddressFactory = null;
	
        /// <summary>
        /// GetAddress to Address / Address
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public Address GetAddress(int? addressId)
        {
            return this.AddressFactory.GetEntity(0, addressId);
        }
	
        /// <summary>
        /// GetAddress to Address / Address
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Address GetAddress(DbConnector conn, int? addressId)
        {
            return this.AddressFactory.GetEntity(conn, addressId);
        }
	
		/// <summary>
        /// GetAddressList to Address / Address
		/// Getting a list of Address using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public AddressList GetAddressList(SqlWhereClause where)
        {
            return this.AddressFactory.GetEntities(where);
        }

		/// <summary>
        /// GetAddressList to Address / Address
		/// Getting all entities of Address
        /// </summary>
        /// <returns>List of all found entities</returns>
        public AddressList GetAddressList()
        {
			var where = new SqlWhereClause();
            return this.AddressFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveAddress to Address / Address
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Address SaveAddress(Address item)
        {
            return this.AddressFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveAddress to Address / Address
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Address SaveAddress(DbConnector conn, Address item)
        {
            return this.AddressFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyAddress to Address / Address
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Address ApplyAddress(DbConnector conn, Address item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.AddressFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveAddress to Address / Address
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveAddress(Address item)
        {
            return this.AddressFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveAddress to Address / Address
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveAddress(DbConnector conn, Address item)
        {
            return this.AddressFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities AddressList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveAddressList(AddressList items)
        {
			return this.AddressFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
