﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// AddressType / AddressType - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class AddressType
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for AddressType
        /// </summary>
	    public AddressType()
		{
		}

		///// <summary>
        ///// Creates a new instance of AddressType
        ///// </summary>
	    //internal AddressType CreateEntity()
		//{
		//    return new AddressType();
		//}

		#region Members

		
        /// <summary>
        /// AddressTypeId / AddressType.AddressTypeID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("AddressTypeID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? AddressTypeId
        {
            get
            {
                return (int?)this["AddressTypeID"];
            }
            set
            {
                this.Add("AddressTypeID", value, typeof(int?));
            }
        }

        /// <summary>
        /// Name / AddressType.Name
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Name"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Name
        {
            get
            {
                return (string)this["Name"];
            }
            set
            {
                this.Add("Name", value, typeof(string));
            }
        }

        /// <summary>
        /// Rowguid / AddressType.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / AddressType.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		

		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from BusinessEntityAddress

        /// <summary>
        /// List of sub entities BusinessEntityAddress / BusinessEntityAddress (AddressTypeID)
		/// Foreign Key FK_BusinessEntityAddress_AddressType_AddressTypeID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual BusinessEntityAddressList BusinessEntityAddressList
        {
            get
            {
			    // Lazy Loading
                if (_BusinessEntityAddressList == null && this.AddressTypeId != null)
                {
					var where = new SqlWhereClause("WHERE BusinessEntityAddress.AddressTypeID = @AddressTypeID",
					    "@AddressTypeID", this.AddressTypeId);
                    _BusinessEntityAddressList = ((AdvEntityManager)this.Manager).GetBusinessEntityAddressList(where);
                }
				if (_BusinessEntityAddressList == null)
				{
					_BusinessEntityAddressList = new BusinessEntityAddressList();
				}
                return _BusinessEntityAddressList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private BusinessEntityAddressList _BusinessEntityAddressList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.AddressTypeFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "AddressType"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // AddressType

	#endregion

	#region Entity-List

    /// <summary>
    /// AddressType / AddressTypeList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class AddressTypeList
        : WebEntityList<AddressType>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "AddressType"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// AddressType - AddressType - Factory 
    /// </summary>
    public partial class AddressTypeFactory
        : WebEntityFactory<AddressType, AddressTypeList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property AddressTypeId of Db-Field AddressTypeID</summary>
        public static string Prop_AddressTypeId = "AddressTypeId";
        ///<summary>Property Name of Db-Field Name</summary>
        public static string Prop_Name = "Name";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field AddressTypeID of Property AddressTypeId</summary>
        public static string Field_AddressTypeId = "AddressTypeID";
        ///<summary>Db-Field Name of Property Name</summary>
        public static string Field_Name = "Name";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = AddressType, 
		/// Fields       = "AddressTypeID"
		/// Query        = ...
        /// </summary>
        protected AddressTypeFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Person";
            this.TableName = "AddressType";
            this.Fields = new string[]
            {
                "AddressTypeID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("AddressTypeId", "int?", "AddressTypeID", "int?", "", null);
			this.Properties.Add("Name", "string", "Name", "string", "", null);
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "AddressType"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "AddressTypeList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "AddressTypeFactory"; }
            set { }
        }

		#endregion

		internal static AddressTypeFactory CreateFactory(EntityManager manager)
		{
		    return new AddressTypeFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of AddressType. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo AddressType</returns>
        public override AddressType CreateEntity()
		{
			var item = new AddressType();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}



		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public AddressType GetItem(int? addressTypeId)
        {
            return this.GetEntity(0, addressTypeId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public AddressType GetItem(DbConnector conn, int? addressTypeId)
        {
            return this.GetEntity(conn, addressTypeId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(AddressType).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to AddressTypeFactory / AddressType / AddressType.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// AddressTypeFactory to AddressType / AddressType.
        /// </summary>
        public AddressTypeFactory AddressTypeFactory
		{
			get
			{
				if (_AddressTypeFactory == null)
				{
					_AddressTypeFactory = global::AdventureWorks.AddressTypeFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_AddressTypeFactory, typeof(AddressType));
				}
				return _AddressTypeFactory;
			}
		}
		private AddressTypeFactory _AddressTypeFactory = null;
	
        /// <summary>
        /// GetAddressType to AddressType / AddressType
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public AddressType GetAddressType(int? addressTypeId)
        {
            return this.AddressTypeFactory.GetEntity(0, addressTypeId);
        }
	
        /// <summary>
        /// GetAddressType to AddressType / AddressType
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public AddressType GetAddressType(DbConnector conn, int? addressTypeId)
        {
            return this.AddressTypeFactory.GetEntity(conn, addressTypeId);
        }
	
		/// <summary>
        /// GetAddressTypeList to AddressType / AddressType
		/// Getting a list of AddressType using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public AddressTypeList GetAddressTypeList(SqlWhereClause where)
        {
            return this.AddressTypeFactory.GetEntities(where);
        }

		/// <summary>
        /// GetAddressTypeList to AddressType / AddressType
		/// Getting all entities of AddressType
        /// </summary>
        /// <returns>List of all found entities</returns>
        public AddressTypeList GetAddressTypeList()
        {
			var where = new SqlWhereClause();
            return this.AddressTypeFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveAddressType to AddressType / AddressType
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public AddressType SaveAddressType(AddressType item)
        {
            return this.AddressTypeFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveAddressType to AddressType / AddressType
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public AddressType SaveAddressType(DbConnector conn, AddressType item)
        {
            return this.AddressTypeFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyAddressType to AddressType / AddressType
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public AddressType ApplyAddressType(DbConnector conn, AddressType item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.AddressTypeFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveAddressType to AddressType / AddressType
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveAddressType(AddressType item)
        {
            return this.AddressTypeFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveAddressType to AddressType / AddressType
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveAddressType(DbConnector conn, AddressType item)
        {
            return this.AddressTypeFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities AddressTypeList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveAddressTypeList(AddressTypeList items)
        {
			return this.AddressTypeFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
