﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// BillOfMaterials / BillOfMaterials - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class BillOfMaterials
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for BillOfMaterials
        /// </summary>
	    public BillOfMaterials()
		{
		}

		///// <summary>
        ///// Creates a new instance of BillOfMaterials
        ///// </summary>
	    //internal BillOfMaterials CreateEntity()
		//{
		//    return new BillOfMaterials();
		//}

		#region Members

		
        /// <summary>
        /// BillOfMaterialsId / BillOfMaterials.BillOfMaterialsID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("BillOfMaterialsID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? BillOfMaterialsId
        {
            get
            {
                return (int?)this["BillOfMaterialsID"];
            }
            set
            {
                this.Add("BillOfMaterialsID", value, typeof(int?));
            }
        }

        /// <summary>
        /// ProductAssemblyId / BillOfMaterials.ProductAssemblyID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductAssemblyID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Product")]
        public virtual int? ProductAssemblyId
        {
            get
            {
                return (int?)this["ProductAssemblyID"];
            }
            set
            {
                this.Add("ProductAssemblyID", value, typeof(int?));
            }
        }

        /// <summary>
        /// ComponentId / BillOfMaterials.ComponentID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ComponentID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Product")]
        public virtual int? ComponentId
        {
            get
            {
                return (int?)this["ComponentID"];
            }
            set
            {
                this.Add("ComponentID", value, typeof(int?));
            }
        }

        /// <summary>
        /// StartDate / BillOfMaterials.StartDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("StartDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? StartDate
        {
            get
            {
                return (DateTime?)this["StartDate"];
            }
            set
            {
                this.Add("StartDate", value, typeof(DateTime?));
            }
        }

        /// <summary>
        /// EndDate / BillOfMaterials.EndDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("EndDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? EndDate
        {
            get
            {
                return (DateTime?)this["EndDate"];
            }
            set
            {
                this.Add("EndDate", value, typeof(DateTime?));
            }
        }

        /// <summary>
        /// UnitMeasureCode / BillOfMaterials.UnitMeasureCode
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("UnitMeasureCode"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity("UnitMeasure")]
        public virtual string UnitMeasureCode
        {
            get
            {
                return (string)this["UnitMeasureCode"];
            }
            set
            {
                this.Add("UnitMeasureCode", value, typeof(string));
            }
        }

        /// <summary>
        /// BomlEvel / BillOfMaterials.BOMLevel
        /// </summary>
        /// <returns>short?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("BOMLevel"), FieldOrder(0), TypeName("short?"), FieldTypeName("short?"), ForeignEntity(null)]
        public virtual short? BomlEvel
        {
            get
            {
                return (short?)this["BOMLevel"];
            }
            set
            {
                this.Add("BOMLevel", value, typeof(short?));
            }
        }

        /// <summary>
        /// PerAssemblyQty / BillOfMaterials.PerAssemblyQty
        /// </summary>
        /// <returns>decimal?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("PerAssemblyQty"), FieldOrder(0), TypeName("decimal?"), FieldTypeName("decimal?"), ForeignEntity(null)]
        public virtual decimal? PerAssemblyQty
        {
            get
            {
                return (decimal?)this["PerAssemblyQty"];
            }
            set
            {
                this.Add("PerAssemblyQty", value, typeof(decimal?));
            }
        }

        /// <summary>
        /// ModifiedDate / BillOfMaterials.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Product

        /// <summary>
        /// Link to parent/super Entity Product / Product (this.ComponentId)
		/// Foreign key FK_BillOfMaterials_Product_ComponentID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Product Product
        {
            get
            {
			    // Lazy loading
                if (this._Product == null && this.ComponentId != null)
                {
                    this._Product = ((AdvEntityManager)this.Manager).GetProduct(this.ComponentId);
                    if (! _Product.ResultInfo.IsValid)
                    {
						this._Product = null; // reset value
                        throw new Exception("wrong/missed constraint from BillOfMaterials to Product.");
                    }
                }
                return this._Product;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ComponentId = (value != null ? value.ProductId : null);


				// set foreign table
                this._Product = value;
            }
        }
        private Product _Product = null;

        #endregion

        #region foreign constraint (parent entity) to Product

        /// <summary>
        /// Link to parent/super Entity Product / Product (this.ProductAssemblyId)
		/// Foreign key FK_BillOfMaterials_Product_ProductAssemblyID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Product ProductProductAssemblyId
        {
            get
            {
			    // Lazy loading
                if (this._ProductProductAssemblyId == null && this.ProductAssemblyId != null)
                {
                    this._ProductProductAssemblyId = ((AdvEntityManager)this.Manager).GetProduct(this.ProductAssemblyId);
                    if (! _ProductProductAssemblyId.ResultInfo.IsValid)
                    {
						this._ProductProductAssemblyId = null; // reset value
                        throw new Exception("wrong/missed constraint from BillOfMaterials to Product.");
                    }
                }
                return this._ProductProductAssemblyId;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ProductAssemblyId = (value != null ? value.ProductId : null);


				// set foreign table
                this._ProductProductAssemblyId = value;
            }
        }
        private Product _ProductProductAssemblyId = null;

        #endregion

        #region foreign constraint (parent entity) to UnitMeasure

        /// <summary>
        /// Link to parent/super Entity UnitMeasure / UnitMeasure (this.UnitMeasureCode)
		/// Foreign key FK_BillOfMaterials_UnitMeasure_UnitMeasureCode
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual UnitMeasure UnitMeasure
        {
            get
            {
			    // Lazy loading
                if (this._UnitMeasure == null && this.UnitMeasureCode != null)
                {
                    this._UnitMeasure = ((AdvEntityManager)this.Manager).GetUnitMeasure(this.UnitMeasureCode);
                    if (! _UnitMeasure.ResultInfo.IsValid)
                    {
						this._UnitMeasure = null; // reset value
                        throw new Exception("wrong/missed constraint from BillOfMaterials to UnitMeasure.");
                    }
                }
                return this._UnitMeasure;
            }
            set
            {
                // reassign foreign key values from setter value
                this.UnitMeasureCode = (value != null ? value.UnitMeasureCode : null);


				// set foreign table
                this._UnitMeasure = value;
            }
        }
        private UnitMeasure _UnitMeasure = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.BillOfMaterialsFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "BillOfMaterials"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // BillOfMaterials

	#endregion

	#region Entity-List

    /// <summary>
    /// BillOfMaterials / BillOfMaterialsList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class BillOfMaterialsList
        : WebEntityList<BillOfMaterials>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "BillOfMaterials"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// BillOfMaterials - BillOfMaterials - Factory 
    /// </summary>
    public partial class BillOfMaterialsFactory
        : WebEntityFactory<BillOfMaterials, BillOfMaterialsList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property BillOfMaterialsId of Db-Field BillOfMaterialsID</summary>
        public static string Prop_BillOfMaterialsId = "BillOfMaterialsId";
        ///<summary>Property ProductAssemblyId of Db-Field ProductAssemblyID</summary>
        public static string Prop_ProductAssemblyId = "ProductAssemblyId";
        ///<summary>Property ComponentId of Db-Field ComponentID</summary>
        public static string Prop_ComponentId = "ComponentId";
        ///<summary>Property StartDate of Db-Field StartDate</summary>
        public static string Prop_StartDate = "StartDate";
        ///<summary>Property EndDate of Db-Field EndDate</summary>
        public static string Prop_EndDate = "EndDate";
        ///<summary>Property UnitMeasureCode of Db-Field UnitMeasureCode</summary>
        public static string Prop_UnitMeasureCode = "UnitMeasureCode";
        ///<summary>Property BomlEvel of Db-Field BOMLevel</summary>
        public static string Prop_BomlEvel = "BomlEvel";
        ///<summary>Property PerAssemblyQty of Db-Field PerAssemblyQty</summary>
        public static string Prop_PerAssemblyQty = "PerAssemblyQty";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field BillOfMaterialsID of Property BillOfMaterialsId</summary>
        public static string Field_BillOfMaterialsId = "BillOfMaterialsID";
        ///<summary>Db-Field ProductAssemblyID of Property ProductAssemblyId</summary>
        public static string Field_ProductAssemblyId = "ProductAssemblyID";
        ///<summary>Db-Field ComponentID of Property ComponentId</summary>
        public static string Field_ComponentId = "ComponentID";
        ///<summary>Db-Field StartDate of Property StartDate</summary>
        public static string Field_StartDate = "StartDate";
        ///<summary>Db-Field EndDate of Property EndDate</summary>
        public static string Field_EndDate = "EndDate";
        ///<summary>Db-Field UnitMeasureCode of Property UnitMeasureCode</summary>
        public static string Field_UnitMeasureCode = "UnitMeasureCode";
        ///<summary>Db-Field BOMLevel of Property BomlEvel</summary>
        public static string Field_BomlEvel = "BOMLevel";
        ///<summary>Db-Field PerAssemblyQty of Property PerAssemblyQty</summary>
        public static string Field_PerAssemblyQty = "PerAssemblyQty";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = BillOfMaterials, 
		/// Fields       = "BillOfMaterialsID"
		/// Query        = ...
        /// </summary>
        protected BillOfMaterialsFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "BillOfMaterials";
            this.Fields = new string[]
            {
                "BillOfMaterialsID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("BillOfMaterialsId", "int?", "BillOfMaterialsID", "int?", "", null);
			this.Properties.Add("ProductAssemblyId", "int?", "ProductAssemblyID", "int?", "", "Product");
			this.Properties.Add("ComponentId", "int?", "ComponentID", "int?", "", "Product");
			this.Properties.Add("StartDate", "DateTime?", "StartDate", "DateTime?", "", null);
			this.Properties.Add("EndDate", "DateTime?", "EndDate", "DateTime?", "", null);
			this.Properties.Add("UnitMeasureCode", "string", "UnitMeasureCode", "string", "", "UnitMeasure");
			this.Properties.Add("BomlEvel", "short?", "BOMLevel", "short?", "", null);
			this.Properties.Add("PerAssemblyQty", "decimal?", "PerAssemblyQty", "decimal?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "BillOfMaterials"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "BillOfMaterialsList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "BillOfMaterialsFactory"; }
            set { }
        }

		#endregion

		internal static BillOfMaterialsFactory CreateFactory(EntityManager manager)
		{
		    return new BillOfMaterialsFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of BillOfMaterials. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo BillOfMaterials</returns>
        public override BillOfMaterials CreateEntity()
		{
			var item = new BillOfMaterials();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(BillOfMaterials item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Product / Product
            // Foreign Key FK_BillOfMaterials_Product_ComponentID
            if (parent is Product)
            {
                item.Product = (Product)parent;
                return;
            }

            // make relation to parent/super Entity Product / Product
            // Foreign Key FK_BillOfMaterials_Product_ProductAssemblyID
            if (parent is Product)
            {
                item.Product = (Product)parent;
                return;
            }

            // make relation to parent/super Entity UnitMeasure / UnitMeasure
            // Foreign Key FK_BillOfMaterials_UnitMeasure_UnitMeasureCode
            if (parent is UnitMeasure)
            {
                item.UnitMeasure = (UnitMeasure)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public BillOfMaterials GetItem(int? billOfMaterialsId)
        {
            return this.GetEntity(0, billOfMaterialsId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public BillOfMaterials GetItem(DbConnector conn, int? billOfMaterialsId)
        {
            return this.GetEntity(conn, billOfMaterialsId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(BillOfMaterials).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to BillOfMaterialsFactory / BillOfMaterials / BillOfMaterials.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// BillOfMaterialsFactory to BillOfMaterials / BillOfMaterials.
        /// </summary>
        public BillOfMaterialsFactory BillOfMaterialsFactory
		{
			get
			{
				if (_BillOfMaterialsFactory == null)
				{
					_BillOfMaterialsFactory = global::AdventureWorks.BillOfMaterialsFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_BillOfMaterialsFactory, typeof(BillOfMaterials));
				}
				return _BillOfMaterialsFactory;
			}
		}
		private BillOfMaterialsFactory _BillOfMaterialsFactory = null;
	
        /// <summary>
        /// GetBillOfMaterials to BillOfMaterials / BillOfMaterials
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public BillOfMaterials GetBillOfMaterials(int? billOfMaterialsId)
        {
            return this.BillOfMaterialsFactory.GetEntity(0, billOfMaterialsId);
        }
	
        /// <summary>
        /// GetBillOfMaterials to BillOfMaterials / BillOfMaterials
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public BillOfMaterials GetBillOfMaterials(DbConnector conn, int? billOfMaterialsId)
        {
            return this.BillOfMaterialsFactory.GetEntity(conn, billOfMaterialsId);
        }
	
		/// <summary>
        /// GetBillOfMaterialsList to BillOfMaterials / BillOfMaterials
		/// Getting a list of BillOfMaterials using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public BillOfMaterialsList GetBillOfMaterialsList(SqlWhereClause where)
        {
            return this.BillOfMaterialsFactory.GetEntities(where);
        }

		/// <summary>
        /// GetBillOfMaterialsList to BillOfMaterials / BillOfMaterials
		/// Getting all entities of BillOfMaterials
        /// </summary>
        /// <returns>List of all found entities</returns>
        public BillOfMaterialsList GetBillOfMaterialsList()
        {
			var where = new SqlWhereClause();
            return this.BillOfMaterialsFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveBillOfMaterials to BillOfMaterials / BillOfMaterials
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public BillOfMaterials SaveBillOfMaterials(BillOfMaterials item)
        {
            return this.BillOfMaterialsFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveBillOfMaterials to BillOfMaterials / BillOfMaterials
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public BillOfMaterials SaveBillOfMaterials(DbConnector conn, BillOfMaterials item)
        {
            return this.BillOfMaterialsFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyBillOfMaterials to BillOfMaterials / BillOfMaterials
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public BillOfMaterials ApplyBillOfMaterials(DbConnector conn, BillOfMaterials item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.BillOfMaterialsFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveBillOfMaterials to BillOfMaterials / BillOfMaterials
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveBillOfMaterials(BillOfMaterials item)
        {
            return this.BillOfMaterialsFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveBillOfMaterials to BillOfMaterials / BillOfMaterials
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveBillOfMaterials(DbConnector conn, BillOfMaterials item)
        {
            return this.BillOfMaterialsFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities BillOfMaterialsList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveBillOfMaterialsList(BillOfMaterialsList items)
        {
			return this.BillOfMaterialsFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
