﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// BusinessEntityContact / BusinessEntityContact - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class BusinessEntityContact
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for BusinessEntityContact
        /// </summary>
	    public BusinessEntityContact()
		{
		}

		///// <summary>
        ///// Creates a new instance of BusinessEntityContact
        ///// </summary>
	    //internal BusinessEntityContact CreateEntity()
		//{
		//    return new BusinessEntityContact();
		//}

		#region Members

		
        /// <summary>
        /// BusinessEntityId / BusinessEntityContact.BusinessEntityID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("BusinessEntityID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("BusinessEntity")]
        public virtual int? BusinessEntityId
        {
            get
            {
                return (int?)this["BusinessEntityID"];
            }
            set
            {
                this.Add("BusinessEntityID", value, typeof(int?));
            }
        }

        /// <summary>
        /// PersonId / BusinessEntityContact.PersonID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("PersonID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Person")]
        public virtual int? PersonId
        {
            get
            {
                return (int?)this["PersonID"];
            }
            set
            {
                this.Add("PersonID", value, typeof(int?));
            }
        }

        /// <summary>
        /// ContactTypeId / BusinessEntityContact.ContactTypeID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ContactTypeID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("ContactType")]
        public virtual int? ContactTypeId
        {
            get
            {
                return (int?)this["ContactTypeID"];
            }
            set
            {
                this.Add("ContactTypeID", value, typeof(int?));
            }
        }

        /// <summary>
        /// Rowguid / BusinessEntityContact.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / BusinessEntityContact.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to BusinessEntity

        /// <summary>
        /// Link to parent/super Entity BusinessEntity / BusinessEntity (this.BusinessEntityId)
		/// Foreign key FK_BusinessEntityContact_BusinessEntity_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual BusinessEntity BusinessEntity
        {
            get
            {
			    // Lazy loading
                if (this._BusinessEntity == null && this.BusinessEntityId != null)
                {
                    this._BusinessEntity = ((AdvEntityManager)this.Manager).GetBusinessEntity(this.BusinessEntityId);
                    if (! _BusinessEntity.ResultInfo.IsValid)
                    {
						this._BusinessEntity = null; // reset value
                        throw new Exception("wrong/missed constraint from BusinessEntityContact to BusinessEntity.");
                    }
                }
                return this._BusinessEntity;
            }
            set
            {
                // reassign foreign key values from setter value
                this.BusinessEntityId = (value != null ? value.BusinessEntityId : null);


				// set foreign table
                this._BusinessEntity = value;
            }
        }
        private BusinessEntity _BusinessEntity = null;

        #endregion

        #region foreign constraint (parent entity) to ContactType

        /// <summary>
        /// Link to parent/super Entity ContactType / ContactType (this.ContactTypeId)
		/// Foreign key FK_BusinessEntityContact_ContactType_ContactTypeID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ContactType ContactType
        {
            get
            {
			    // Lazy loading
                if (this._ContactType == null && this.ContactTypeId != null)
                {
                    this._ContactType = ((AdvEntityManager)this.Manager).GetContactType(this.ContactTypeId);
                    if (! _ContactType.ResultInfo.IsValid)
                    {
						this._ContactType = null; // reset value
                        throw new Exception("wrong/missed constraint from BusinessEntityContact to ContactType.");
                    }
                }
                return this._ContactType;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ContactTypeId = (value != null ? value.ContactTypeId : null);


				// set foreign table
                this._ContactType = value;
            }
        }
        private ContactType _ContactType = null;

        #endregion

        #region foreign constraint (parent entity) to Person

        /// <summary>
        /// Link to parent/super Entity Person / Person (this.PersonId)
		/// Foreign key FK_BusinessEntityContact_Person_PersonID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Person Person
        {
            get
            {
			    // Lazy loading
                if (this._Person == null && this.PersonId != null)
                {
                    this._Person = ((AdvEntityManager)this.Manager).GetPerson(this.PersonId);
                    if (! _Person.ResultInfo.IsValid)
                    {
						this._Person = null; // reset value
                        throw new Exception("wrong/missed constraint from BusinessEntityContact to Person.");
                    }
                }
                return this._Person;
            }
            set
            {
                // reassign foreign key values from setter value
                this.PersonId = (value != null ? value.BusinessEntityId : null);


				// set foreign table
                this._Person = value;
            }
        }
        private Person _Person = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.BusinessEntityContactFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "BusinessEntityContact"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // BusinessEntityContact

	#endregion

	#region Entity-List

    /// <summary>
    /// BusinessEntityContact / BusinessEntityContactList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class BusinessEntityContactList
        : WebEntityList<BusinessEntityContact>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "BusinessEntityContact"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// BusinessEntityContact - BusinessEntityContact - Factory 
    /// </summary>
    public partial class BusinessEntityContactFactory
        : WebEntityFactory<BusinessEntityContact, BusinessEntityContactList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property BusinessEntityId of Db-Field BusinessEntityID</summary>
        public static string Prop_BusinessEntityId = "BusinessEntityId";
        ///<summary>Property PersonId of Db-Field PersonID</summary>
        public static string Prop_PersonId = "PersonId";
        ///<summary>Property ContactTypeId of Db-Field ContactTypeID</summary>
        public static string Prop_ContactTypeId = "ContactTypeId";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field BusinessEntityID of Property BusinessEntityId</summary>
        public static string Field_BusinessEntityId = "BusinessEntityID";
        ///<summary>Db-Field PersonID of Property PersonId</summary>
        public static string Field_PersonId = "PersonID";
        ///<summary>Db-Field ContactTypeID of Property ContactTypeId</summary>
        public static string Field_ContactTypeId = "ContactTypeID";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = BusinessEntityContact, 
		/// Fields       = "BusinessEntityID", "PersonID", "ContactTypeID"
		/// Query        = ...
        /// </summary>
        protected BusinessEntityContactFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Person";
            this.TableName = "BusinessEntityContact";
            this.Fields = new string[]
            {
                "BusinessEntityID", "PersonID", "ContactTypeID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("BusinessEntityId", "int?", "BusinessEntityID", "int?", "", "BusinessEntity");
			this.Properties.Add("PersonId", "int?", "PersonID", "int?", "", "Person");
			this.Properties.Add("ContactTypeId", "int?", "ContactTypeID", "int?", "", "ContactType");
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "BusinessEntityContact"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "BusinessEntityContactList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "BusinessEntityContactFactory"; }
            set { }
        }

		#endregion

		internal static BusinessEntityContactFactory CreateFactory(EntityManager manager)
		{
		    return new BusinessEntityContactFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of BusinessEntityContact. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo BusinessEntityContact</returns>
        public override BusinessEntityContact CreateEntity()
		{
			var item = new BusinessEntityContact();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(BusinessEntityContact item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity BusinessEntity / BusinessEntity
            // Foreign Key FK_BusinessEntityContact_BusinessEntity_BusinessEntityID
            if (parent is BusinessEntity)
            {
                item.BusinessEntity = (BusinessEntity)parent;
                return;
            }

            // make relation to parent/super Entity ContactType / ContactType
            // Foreign Key FK_BusinessEntityContact_ContactType_ContactTypeID
            if (parent is ContactType)
            {
                item.ContactType = (ContactType)parent;
                return;
            }

            // make relation to parent/super Entity Person / Person
            // Foreign Key FK_BusinessEntityContact_Person_PersonID
            if (parent is Person)
            {
                item.Person = (Person)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public BusinessEntityContact GetItem(int? businessEntityId, int? personId, int? contactTypeId)
        {
            return this.GetEntity(0, businessEntityId, personId, contactTypeId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public BusinessEntityContact GetItem(DbConnector conn, int? businessEntityId, int? personId, int? contactTypeId)
        {
            return this.GetEntity(conn, businessEntityId, personId, contactTypeId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(BusinessEntityContact).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to BusinessEntityContactFactory / BusinessEntityContact / BusinessEntityContact.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// BusinessEntityContactFactory to BusinessEntityContact / BusinessEntityContact.
        /// </summary>
        public BusinessEntityContactFactory BusinessEntityContactFactory
		{
			get
			{
				if (_BusinessEntityContactFactory == null)
				{
					_BusinessEntityContactFactory = global::AdventureWorks.BusinessEntityContactFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_BusinessEntityContactFactory, typeof(BusinessEntityContact));
				}
				return _BusinessEntityContactFactory;
			}
		}
		private BusinessEntityContactFactory _BusinessEntityContactFactory = null;
	
        /// <summary>
        /// GetBusinessEntityContact to BusinessEntityContact / BusinessEntityContact
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public BusinessEntityContact GetBusinessEntityContact(int? businessEntityId, int? personId, int? contactTypeId)
        {
            return this.BusinessEntityContactFactory.GetEntity(0, businessEntityId, personId, contactTypeId);
        }
	
        /// <summary>
        /// GetBusinessEntityContact to BusinessEntityContact / BusinessEntityContact
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public BusinessEntityContact GetBusinessEntityContact(DbConnector conn, int? businessEntityId, int? personId, int? contactTypeId)
        {
            return this.BusinessEntityContactFactory.GetEntity(conn, businessEntityId, personId, contactTypeId);
        }
	
		/// <summary>
        /// GetBusinessEntityContactList to BusinessEntityContact / BusinessEntityContact
		/// Getting a list of BusinessEntityContact using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public BusinessEntityContactList GetBusinessEntityContactList(SqlWhereClause where)
        {
            return this.BusinessEntityContactFactory.GetEntities(where);
        }

		/// <summary>
        /// GetBusinessEntityContactList to BusinessEntityContact / BusinessEntityContact
		/// Getting all entities of BusinessEntityContact
        /// </summary>
        /// <returns>List of all found entities</returns>
        public BusinessEntityContactList GetBusinessEntityContactList()
        {
			var where = new SqlWhereClause();
            return this.BusinessEntityContactFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveBusinessEntityContact to BusinessEntityContact / BusinessEntityContact
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public BusinessEntityContact SaveBusinessEntityContact(BusinessEntityContact item)
        {
            return this.BusinessEntityContactFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveBusinessEntityContact to BusinessEntityContact / BusinessEntityContact
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public BusinessEntityContact SaveBusinessEntityContact(DbConnector conn, BusinessEntityContact item)
        {
            return this.BusinessEntityContactFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyBusinessEntityContact to BusinessEntityContact / BusinessEntityContact
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public BusinessEntityContact ApplyBusinessEntityContact(DbConnector conn, BusinessEntityContact item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.BusinessEntityContactFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveBusinessEntityContact to BusinessEntityContact / BusinessEntityContact
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveBusinessEntityContact(BusinessEntityContact item)
        {
            return this.BusinessEntityContactFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveBusinessEntityContact to BusinessEntityContact / BusinessEntityContact
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveBusinessEntityContact(DbConnector conn, BusinessEntityContact item)
        {
            return this.BusinessEntityContactFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities BusinessEntityContactList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveBusinessEntityContactList(BusinessEntityContactList items)
        {
			return this.BusinessEntityContactFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
