﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// Culture / Culture - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class Culture
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for Culture
        /// </summary>
	    public Culture()
		{
		}

		///// <summary>
        ///// Creates a new instance of Culture
        ///// </summary>
	    //internal Culture CreateEntity()
		//{
		//    return new Culture();
		//}

		#region Members

		
        /// <summary>
        /// CultureId / Culture.CultureID
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("CultureID"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string CultureId
        {
            get
            {
                return (string)this["CultureID"];
            }
            set
            {
                this.Add("CultureID", value, typeof(string));
            }
        }

        /// <summary>
        /// Name / Culture.Name
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Name"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Name
        {
            get
            {
                return (string)this["Name"];
            }
            set
            {
                this.Add("Name", value, typeof(string));
            }
        }

        /// <summary>
        /// ModifiedDate / Culture.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		

		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from ProductModelProductDescriptionCulture

        /// <summary>
        /// List of sub entities ProductModelProductDescriptionCulture / ProductModelProductDescriptionCulture (CultureID)
		/// Foreign Key FK_ProductModelProductDescriptionCulture_Culture_CultureID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductModelProductDescriptionCultureList ProductModelProductDescriptionCultureList
        {
            get
            {
			    // Lazy Loading
                if (_ProductModelProductDescriptionCultureList == null && this.CultureId != null)
                {
					var where = new SqlWhereClause("WHERE ProductModelProductDescriptionCulture.CultureID = @CultureID",
					    "@CultureID", this.CultureId);
                    _ProductModelProductDescriptionCultureList = ((AdvEntityManager)this.Manager).GetProductModelProductDescriptionCultureList(where);
                }
				if (_ProductModelProductDescriptionCultureList == null)
				{
					_ProductModelProductDescriptionCultureList = new ProductModelProductDescriptionCultureList();
				}
                return _ProductModelProductDescriptionCultureList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductModelProductDescriptionCultureList _ProductModelProductDescriptionCultureList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.CultureFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Culture"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // Culture

	#endregion

	#region Entity-List

    /// <summary>
    /// Culture / CultureList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class CultureList
        : WebEntityList<Culture>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Culture"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// Culture - Culture - Factory 
    /// </summary>
    public partial class CultureFactory
        : WebEntityFactory<Culture, CultureList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property CultureId of Db-Field CultureID</summary>
        public static string Prop_CultureId = "CultureId";
        ///<summary>Property Name of Db-Field Name</summary>
        public static string Prop_Name = "Name";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field CultureID of Property CultureId</summary>
        public static string Field_CultureId = "CultureID";
        ///<summary>Db-Field Name of Property Name</summary>
        public static string Field_Name = "Name";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = Culture, 
		/// Fields       = "CultureID"
		/// Query        = ...
        /// </summary>
        protected CultureFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "Culture";
            this.Fields = new string[]
            {
                "CultureID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("CultureId", "string", "CultureID", "string", "", null);
			this.Properties.Add("Name", "string", "Name", "string", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "Culture"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "CultureList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "CultureFactory"; }
            set { }
        }

		#endregion

		internal static CultureFactory CreateFactory(EntityManager manager)
		{
		    return new CultureFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of Culture. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo Culture</returns>
        public override Culture CreateEntity()
		{
			var item = new Culture();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}



		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public Culture GetItem(string cultureId)
        {
            return this.GetEntity(0, cultureId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public Culture GetItem(DbConnector conn, string cultureId)
        {
            return this.GetEntity(conn, cultureId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(Culture).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to CultureFactory / Culture / Culture.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// CultureFactory to Culture / Culture.
        /// </summary>
        public CultureFactory CultureFactory
		{
			get
			{
				if (_CultureFactory == null)
				{
					_CultureFactory = global::AdventureWorks.CultureFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_CultureFactory, typeof(Culture));
				}
				return _CultureFactory;
			}
		}
		private CultureFactory _CultureFactory = null;
	
        /// <summary>
        /// GetCulture to Culture / Culture
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public Culture GetCulture(string cultureId)
        {
            return this.CultureFactory.GetEntity(0, cultureId);
        }
	
        /// <summary>
        /// GetCulture to Culture / Culture
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Culture GetCulture(DbConnector conn, string cultureId)
        {
            return this.CultureFactory.GetEntity(conn, cultureId);
        }
	
		/// <summary>
        /// GetCultureList to Culture / Culture
		/// Getting a list of Culture using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public CultureList GetCultureList(SqlWhereClause where)
        {
            return this.CultureFactory.GetEntities(where);
        }

		/// <summary>
        /// GetCultureList to Culture / Culture
		/// Getting all entities of Culture
        /// </summary>
        /// <returns>List of all found entities</returns>
        public CultureList GetCultureList()
        {
			var where = new SqlWhereClause();
            return this.CultureFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveCulture to Culture / Culture
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Culture SaveCulture(Culture item)
        {
            return this.CultureFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveCulture to Culture / Culture
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Culture SaveCulture(DbConnector conn, Culture item)
        {
            return this.CultureFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyCulture to Culture / Culture
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Culture ApplyCulture(DbConnector conn, Culture item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.CultureFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveCulture to Culture / Culture
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveCulture(Culture item)
        {
            return this.CultureFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveCulture to Culture / Culture
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveCulture(DbConnector conn, Culture item)
        {
            return this.CultureFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities CultureList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveCultureList(CultureList items)
        {
			return this.CultureFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
