﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// Currency / Currency - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class Currency
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for Currency
        /// </summary>
	    public Currency()
		{
		}

		///// <summary>
        ///// Creates a new instance of Currency
        ///// </summary>
	    //internal Currency CreateEntity()
		//{
		//    return new Currency();
		//}

		#region Members

		
        /// <summary>
        /// CurrencyCode / Currency.CurrencyCode
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("CurrencyCode"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string CurrencyCode
        {
            get
            {
                return (string)this["CurrencyCode"];
            }
            set
            {
                this.Add("CurrencyCode", value, typeof(string));
            }
        }

        /// <summary>
        /// Name / Currency.Name
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Name"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Name
        {
            get
            {
                return (string)this["Name"];
            }
            set
            {
                this.Add("Name", value, typeof(string));
            }
        }

        /// <summary>
        /// ModifiedDate / Currency.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		

		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from CountryRegionCurrency

        /// <summary>
        /// List of sub entities CountryRegionCurrency / CountryRegionCurrency (CurrencyCode)
		/// Foreign Key FK_CountryRegionCurrency_Currency_CurrencyCode
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual CountryRegionCurrencyList CountryRegionCurrencyList
        {
            get
            {
			    // Lazy Loading
                if (_CountryRegionCurrencyList == null && this.CurrencyCode != null)
                {
					var where = new SqlWhereClause("WHERE CountryRegionCurrency.CurrencyCode = @CurrencyCode",
					    "@CurrencyCode", this.CurrencyCode);
                    _CountryRegionCurrencyList = ((AdvEntityManager)this.Manager).GetCountryRegionCurrencyList(where);
                }
				if (_CountryRegionCurrencyList == null)
				{
					_CountryRegionCurrencyList = new CountryRegionCurrencyList();
				}
                return _CountryRegionCurrencyList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private CountryRegionCurrencyList _CountryRegionCurrencyList = null;

        #endregion

        #region Sub Entites from CurrencyRate

        /// <summary>
        /// List of sub entities CurrencyRate / CurrencyRate (FromCurrencyCode)
		/// Foreign Key FK_CurrencyRate_Currency_FromCurrencyCode
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual CurrencyRateList CurrencyRateList
        {
            get
            {
			    // Lazy Loading
                if (_CurrencyRateList == null && this.CurrencyCode != null)
                {
					var where = new SqlWhereClause("WHERE CurrencyRate.FromCurrencyCode = @FromCurrencyCode",
					    "@FromCurrencyCode", this.CurrencyCode);
                    _CurrencyRateList = ((AdvEntityManager)this.Manager).GetCurrencyRateList(where);
                }
				if (_CurrencyRateList == null)
				{
					_CurrencyRateList = new CurrencyRateList();
				}
                return _CurrencyRateList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private CurrencyRateList _CurrencyRateList = null;

        #endregion

        #region Sub Entites from CurrencyRate

        /// <summary>
        /// List of sub entities CurrencyRate / CurrencyRate (ToCurrencyCode)
		/// Foreign Key FK_CurrencyRate_Currency_ToCurrencyCode
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual CurrencyRateList CurrencyRateToCurrencyCodeList
        {
            get
            {
			    // Lazy Loading
                if (_CurrencyRateToCurrencyCodeList == null && this.CurrencyCode != null)
                {
					var where = new SqlWhereClause("WHERE CurrencyRate.ToCurrencyCode = @ToCurrencyCode",
					    "@ToCurrencyCode", this.CurrencyCode);
                    _CurrencyRateToCurrencyCodeList = ((AdvEntityManager)this.Manager).GetCurrencyRateList(where);
                }
				if (_CurrencyRateToCurrencyCodeList == null)
				{
					_CurrencyRateToCurrencyCodeList = new CurrencyRateList();
				}
                return _CurrencyRateToCurrencyCodeList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private CurrencyRateList _CurrencyRateToCurrencyCodeList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.CurrencyFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Currency"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // Currency

	#endregion

	#region Entity-List

    /// <summary>
    /// Currency / CurrencyList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class CurrencyList
        : WebEntityList<Currency>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Currency"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// Currency - Currency - Factory 
    /// </summary>
    public partial class CurrencyFactory
        : WebEntityFactory<Currency, CurrencyList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property CurrencyCode of Db-Field CurrencyCode</summary>
        public static string Prop_CurrencyCode = "CurrencyCode";
        ///<summary>Property Name of Db-Field Name</summary>
        public static string Prop_Name = "Name";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field CurrencyCode of Property CurrencyCode</summary>
        public static string Field_CurrencyCode = "CurrencyCode";
        ///<summary>Db-Field Name of Property Name</summary>
        public static string Field_Name = "Name";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = Currency, 
		/// Fields       = "CurrencyCode"
		/// Query        = ...
        /// </summary>
        protected CurrencyFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Sales";
            this.TableName = "Currency";
            this.Fields = new string[]
            {
                "CurrencyCode"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("CurrencyCode", "string", "CurrencyCode", "string", "", null);
			this.Properties.Add("Name", "string", "Name", "string", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "Currency"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "CurrencyList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "CurrencyFactory"; }
            set { }
        }

		#endregion

		internal static CurrencyFactory CreateFactory(EntityManager manager)
		{
		    return new CurrencyFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of Currency. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo Currency</returns>
        public override Currency CreateEntity()
		{
			var item = new Currency();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}



		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public Currency GetItem(string currencyCode)
        {
            return this.GetEntity(0, currencyCode);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public Currency GetItem(DbConnector conn, string currencyCode)
        {
            return this.GetEntity(conn, currencyCode);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(Currency).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to CurrencyFactory / Currency / Currency.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// CurrencyFactory to Currency / Currency.
        /// </summary>
        public CurrencyFactory CurrencyFactory
		{
			get
			{
				if (_CurrencyFactory == null)
				{
					_CurrencyFactory = global::AdventureWorks.CurrencyFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_CurrencyFactory, typeof(Currency));
				}
				return _CurrencyFactory;
			}
		}
		private CurrencyFactory _CurrencyFactory = null;
	
        /// <summary>
        /// GetCurrency to Currency / Currency
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public Currency GetCurrency(string currencyCode)
        {
            return this.CurrencyFactory.GetEntity(0, currencyCode);
        }
	
        /// <summary>
        /// GetCurrency to Currency / Currency
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Currency GetCurrency(DbConnector conn, string currencyCode)
        {
            return this.CurrencyFactory.GetEntity(conn, currencyCode);
        }
	
		/// <summary>
        /// GetCurrencyList to Currency / Currency
		/// Getting a list of Currency using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public CurrencyList GetCurrencyList(SqlWhereClause where)
        {
            return this.CurrencyFactory.GetEntities(where);
        }

		/// <summary>
        /// GetCurrencyList to Currency / Currency
		/// Getting all entities of Currency
        /// </summary>
        /// <returns>List of all found entities</returns>
        public CurrencyList GetCurrencyList()
        {
			var where = new SqlWhereClause();
            return this.CurrencyFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveCurrency to Currency / Currency
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Currency SaveCurrency(Currency item)
        {
            return this.CurrencyFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveCurrency to Currency / Currency
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Currency SaveCurrency(DbConnector conn, Currency item)
        {
            return this.CurrencyFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyCurrency to Currency / Currency
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Currency ApplyCurrency(DbConnector conn, Currency item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.CurrencyFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveCurrency to Currency / Currency
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveCurrency(Currency item)
        {
            return this.CurrencyFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveCurrency to Currency / Currency
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveCurrency(DbConnector conn, Currency item)
        {
            return this.CurrencyFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities CurrencyList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveCurrencyList(CurrencyList items)
        {
			return this.CurrencyFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
