﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
	#region Entity and listing

    /// <summary>
    /// DatabaseLog / DatabaseLog - user defined part of the entity
    /// </summary>
    public partial class DatabaseLog
    {
        #region user defined attributes



		#endregion
    }

    /// <summary>
    /// DatabaseLogList / DatabaseLog - defined part of entity list
    /// </summary>
    public partial class DatabaseLogList
    {
        #region user defined attributes and methods



		#endregion
    }

	#endregion

	#region Factory

	/// <summary>
    /// DatabaseLog / DatabaseLog - Factory - overriding and user defined part
    /// </summary>
    public partial class DatabaseLogFactory
    {
	    #region Overloading

        /// <summary>
        /// user defined code executed after an entity has been loaded
        /// </summary>
        /// <returns></returns>
        public override void OnGetEntity(DbConnector conn, DatabaseLog item)
        {
		    #region Overloading OnGetEntity

            ;

			#endregion
        }

        /// <summary>
        /// tells if an entity instance is new or exists
        /// </summary>
        /// <returns>true, if Entity is new</returns>
        public override bool IsNew(DbConnector conn, DatabaseLog item)
        {
			#region Overloading IsNew

            return (item.EntityState == EntityState.New || item.DatabaseLogId == null);

			#endregion
        }

		#endregion

		#region user defined functions and methods

		// user defined code

		#endregion
    }

	#endregion

}
