﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// Department / Department - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class Department
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for Department
        /// </summary>
	    public Department()
		{
		}

		///// <summary>
        ///// Creates a new instance of Department
        ///// </summary>
	    //internal Department CreateEntity()
		//{
		//    return new Department();
		//}

		#region Members

		
        /// <summary>
        /// DepartmentId / Department.DepartmentID
        /// </summary>
        /// <returns>short?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("DepartmentID"), FieldOrder(0), TypeName("short?"), FieldTypeName("short?"), ForeignEntity(null)]
        public virtual short? DepartmentId
        {
            get
            {
                return (short?)this["DepartmentID"];
            }
            set
            {
                this.Add("DepartmentID", value, typeof(short?));
            }
        }

        /// <summary>
        /// Name / Department.Name
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Name"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Name
        {
            get
            {
                return (string)this["Name"];
            }
            set
            {
                this.Add("Name", value, typeof(string));
            }
        }

        /// <summary>
        /// GroupName / Department.GroupName
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("GroupName"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string GroupName
        {
            get
            {
                return (string)this["GroupName"];
            }
            set
            {
                this.Add("GroupName", value, typeof(string));
            }
        }

        /// <summary>
        /// ModifiedDate / Department.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		

		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from EmployeeDepartmentHistory

        /// <summary>
        /// List of sub entities EmployeeDepartmentHistory / EmployeeDepartmentHistory (DepartmentID)
		/// Foreign Key FK_EmployeeDepartmentHistory_Department_DepartmentID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual EmployeeDepartmentHistoryList EmployeeDepartmentHistoryList
        {
            get
            {
			    // Lazy Loading
                if (_EmployeeDepartmentHistoryList == null && this.DepartmentId != null)
                {
					var where = new SqlWhereClause("WHERE EmployeeDepartmentHistory.DepartmentID = @DepartmentID",
					    "@DepartmentID", this.DepartmentId);
                    _EmployeeDepartmentHistoryList = ((AdvEntityManager)this.Manager).GetEmployeeDepartmentHistoryList(where);
                }
				if (_EmployeeDepartmentHistoryList == null)
				{
					_EmployeeDepartmentHistoryList = new EmployeeDepartmentHistoryList();
				}
                return _EmployeeDepartmentHistoryList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private EmployeeDepartmentHistoryList _EmployeeDepartmentHistoryList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.DepartmentFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Department"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // Department

	#endregion

	#region Entity-List

    /// <summary>
    /// Department / DepartmentList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class DepartmentList
        : WebEntityList<Department>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Department"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// Department - Department - Factory 
    /// </summary>
    public partial class DepartmentFactory
        : WebEntityFactory<Department, DepartmentList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property DepartmentId of Db-Field DepartmentID</summary>
        public static string Prop_DepartmentId = "DepartmentId";
        ///<summary>Property Name of Db-Field Name</summary>
        public static string Prop_Name = "Name";
        ///<summary>Property GroupName of Db-Field GroupName</summary>
        public static string Prop_GroupName = "GroupName";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field DepartmentID of Property DepartmentId</summary>
        public static string Field_DepartmentId = "DepartmentID";
        ///<summary>Db-Field Name of Property Name</summary>
        public static string Field_Name = "Name";
        ///<summary>Db-Field GroupName of Property GroupName</summary>
        public static string Field_GroupName = "GroupName";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = Department, 
		/// Fields       = "DepartmentID"
		/// Query        = ...
        /// </summary>
        protected DepartmentFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "HumanResources";
            this.TableName = "Department";
            this.Fields = new string[]
            {
                "DepartmentID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("DepartmentId", "short?", "DepartmentID", "short?", "", null);
			this.Properties.Add("Name", "string", "Name", "string", "", null);
			this.Properties.Add("GroupName", "string", "GroupName", "string", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "Department"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "DepartmentList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "DepartmentFactory"; }
            set { }
        }

		#endregion

		internal static DepartmentFactory CreateFactory(EntityManager manager)
		{
		    return new DepartmentFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of Department. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo Department</returns>
        public override Department CreateEntity()
		{
			var item = new Department();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}



		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public Department GetItem(short? departmentId)
        {
            return this.GetEntity(0, departmentId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public Department GetItem(DbConnector conn, short? departmentId)
        {
            return this.GetEntity(conn, departmentId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(Department).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to DepartmentFactory / Department / Department.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// DepartmentFactory to Department / Department.
        /// </summary>
        public DepartmentFactory DepartmentFactory
		{
			get
			{
				if (_DepartmentFactory == null)
				{
					_DepartmentFactory = global::AdventureWorks.DepartmentFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_DepartmentFactory, typeof(Department));
				}
				return _DepartmentFactory;
			}
		}
		private DepartmentFactory _DepartmentFactory = null;
	
        /// <summary>
        /// GetDepartment to Department / Department
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public Department GetDepartment(short? departmentId)
        {
            return this.DepartmentFactory.GetEntity(0, departmentId);
        }
	
        /// <summary>
        /// GetDepartment to Department / Department
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Department GetDepartment(DbConnector conn, short? departmentId)
        {
            return this.DepartmentFactory.GetEntity(conn, departmentId);
        }
	
		/// <summary>
        /// GetDepartmentList to Department / Department
		/// Getting a list of Department using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public DepartmentList GetDepartmentList(SqlWhereClause where)
        {
            return this.DepartmentFactory.GetEntities(where);
        }

		/// <summary>
        /// GetDepartmentList to Department / Department
		/// Getting all entities of Department
        /// </summary>
        /// <returns>List of all found entities</returns>
        public DepartmentList GetDepartmentList()
        {
			var where = new SqlWhereClause();
            return this.DepartmentFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveDepartment to Department / Department
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Department SaveDepartment(Department item)
        {
            return this.DepartmentFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveDepartment to Department / Department
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Department SaveDepartment(DbConnector conn, Department item)
        {
            return this.DepartmentFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyDepartment to Department / Department
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Department ApplyDepartment(DbConnector conn, Department item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.DepartmentFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveDepartment to Department / Department
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveDepartment(Department item)
        {
            return this.DepartmentFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveDepartment to Department / Department
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveDepartment(DbConnector conn, Department item)
        {
            return this.DepartmentFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities DepartmentList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveDepartmentList(DepartmentList items)
        {
			return this.DepartmentFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
