﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// Document / Document - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class Document
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for Document
        /// </summary>
	    public Document()
		{
		}

		///// <summary>
        ///// Creates a new instance of Document
        ///// </summary>
	    //internal Document CreateEntity()
		//{
		//    return new Document();
		//}

		#region Members

		
        /// <summary>
        /// DocumentNode / Document.DocumentNode
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("DocumentNode"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string DocumentNode
        {
            get
            {
                return (string)this["DocumentNode"];
            }
            set
            {
                this.Add("DocumentNode", value, typeof(string));
            }
        }

        /// <summary>
        /// DocumentLevel / Document.DocumentLevel
        /// </summary>
        /// <returns>short?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("DocumentLevel"), FieldOrder(0), TypeName("short?"), FieldTypeName("short?"), ForeignEntity(null)]
        public virtual short? DocumentLevel
        {
            get
            {
                return (short?)this["DocumentLevel"];
            }
            set
            {
                this.Add("DocumentLevel", value, typeof(short?));
            }
        }

        /// <summary>
        /// Title / Document.Title
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Title"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Title
        {
            get
            {
                return (string)this["Title"];
            }
            set
            {
                this.Add("Title", value, typeof(string));
            }
        }

        /// <summary>
        /// Owner / Document.Owner
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Owner"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Employee")]
        public virtual int? Owner
        {
            get
            {
                return (int?)this["Owner"];
            }
            set
            {
                this.Add("Owner", value, typeof(int?));
            }
        }

        /// <summary>
        /// FolderFlag / Document.FolderFlag
        /// </summary>
        /// <returns>bool?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("FolderFlag"), FieldOrder(0), TypeName("bool?"), FieldTypeName("bool?"), ForeignEntity(null)]
        public virtual bool? FolderFlag
        {
            get
            {
                return (bool?)this["FolderFlag"];
            }
            set
            {
                this.Add("FolderFlag", value, typeof(bool?));
            }
        }

        /// <summary>
        /// FileName / Document.FileName
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("FileName"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string FileName
        {
            get
            {
                return (string)this["FileName"];
            }
            set
            {
                this.Add("FileName", value, typeof(string));
            }
        }

        /// <summary>
        /// FileExtension / Document.FileExtension
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("FileExtension"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string FileExtension
        {
            get
            {
                return (string)this["FileExtension"];
            }
            set
            {
                this.Add("FileExtension", value, typeof(string));
            }
        }

        /// <summary>
        /// Revision / Document.Revision
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Revision"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Revision
        {
            get
            {
                return (string)this["Revision"];
            }
            set
            {
                this.Add("Revision", value, typeof(string));
            }
        }

        /// <summary>
        /// ChangeNumber / Document.ChangeNumber
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ChangeNumber"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? ChangeNumber
        {
            get
            {
                return (int?)this["ChangeNumber"];
            }
            set
            {
                this.Add("ChangeNumber", value, typeof(int?));
            }
        }

        /// <summary>
        /// Status / Document.Status
        /// </summary>
        /// <returns>byte?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Status"), FieldOrder(0), TypeName("byte?"), FieldTypeName("byte?"), ForeignEntity(null)]
        public virtual byte? Status
        {
            get
            {
                return (byte?)this["Status"];
            }
            set
            {
                this.Add("Status", value, typeof(byte?));
            }
        }

        /// <summary>
        /// DocumentSummary / Document.DocumentSummary
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("DocumentSummary"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string DocumentSummary
        {
            get
            {
                return (string)this["DocumentSummary"];
            }
            set
            {
                this.Add("DocumentSummary", value, typeof(string));
            }
        }

        /// <summary>
        /// DocumentProp / Document.Document
        /// </summary>
        /// <returns>byte[]</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Document"), FieldOrder(0), TypeName("byte[]"), FieldTypeName("byte[]"), ForeignEntity(null)]
        public virtual byte[] DocumentProp
        {
            get
            {
                return (byte[])this["Document"];
            }
            set
            {
                this.Add("Document", value, typeof(byte[]));
            }
        }

        /// <summary>
        /// Rowguid / Document.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / Document.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Employee

        /// <summary>
        /// Link to parent/super Entity Employee / Employee (this.Owner)
		/// Foreign key FK_Document_Employee_Owner
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Employee Employee
        {
            get
            {
			    // Lazy loading
                if (this._Employee == null && this.Owner != null)
                {
                    this._Employee = ((AdvEntityManager)this.Manager).GetEmployee(this.Owner);
                    if (! _Employee.ResultInfo.IsValid)
                    {
						this._Employee = null; // reset value
                        throw new Exception("wrong/missed constraint from Document to Employee.");
                    }
                }
                return this._Employee;
            }
            set
            {
                // reassign foreign key values from setter value
                this.Owner = (value != null ? value.BusinessEntityId : null);


				// set foreign table
                this._Employee = value;
            }
        }
        private Employee _Employee = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from ProductDocument

        /// <summary>
        /// List of sub entities ProductDocument / ProductDocument (DocumentNode)
		/// Foreign Key FK_ProductDocument_Document_DocumentNode
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductDocumentList ProductDocumentList
        {
            get
            {
			    // Lazy Loading
                if (_ProductDocumentList == null && this.DocumentNode != null)
                {
					var where = new SqlWhereClause("WHERE ProductDocument.DocumentNode = @DocumentNode",
					    "@DocumentNode", this.DocumentNode);
                    _ProductDocumentList = ((AdvEntityManager)this.Manager).GetProductDocumentList(where);
                }
				if (_ProductDocumentList == null)
				{
					_ProductDocumentList = new ProductDocumentList();
				}
                return _ProductDocumentList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductDocumentList _ProductDocumentList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		
        /// <summary>
        /// Document_ / Document.Document
		/// origin database field to DocumentProp
		/// <see cref="DocumentProp" />
        /// </summary>
        /// <returns>byte[]</returns>
        [IgnoreDataMember]
		[BackwardCompatibility] // mark property as backward property (deprecated)
        public byte[] Document_
        {
            get
            {
                return this.DocumentProp; 
            }
            set
            {
                this.DocumentProp = value;
            }
        }


		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.DocumentFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Document"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // Document

	#endregion

	#region Entity-List

    /// <summary>
    /// Document / DocumentList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class DocumentList
        : WebEntityList<Document>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Document"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// Document - Document - Factory 
    /// </summary>
    public partial class DocumentFactory
        : WebEntityFactory<Document, DocumentList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property DocumentNode of Db-Field DocumentNode</summary>
        public static string Prop_DocumentNode = "DocumentNode";
        ///<summary>Property DocumentLevel of Db-Field DocumentLevel</summary>
        public static string Prop_DocumentLevel = "DocumentLevel";
        ///<summary>Property Title of Db-Field Title</summary>
        public static string Prop_Title = "Title";
        ///<summary>Property Owner of Db-Field Owner</summary>
        public static string Prop_Owner = "Owner";
        ///<summary>Property FolderFlag of Db-Field FolderFlag</summary>
        public static string Prop_FolderFlag = "FolderFlag";
        ///<summary>Property FileName of Db-Field FileName</summary>
        public static string Prop_FileName = "FileName";
        ///<summary>Property FileExtension of Db-Field FileExtension</summary>
        public static string Prop_FileExtension = "FileExtension";
        ///<summary>Property Revision of Db-Field Revision</summary>
        public static string Prop_Revision = "Revision";
        ///<summary>Property ChangeNumber of Db-Field ChangeNumber</summary>
        public static string Prop_ChangeNumber = "ChangeNumber";
        ///<summary>Property Status of Db-Field Status</summary>
        public static string Prop_Status = "Status";
        ///<summary>Property DocumentSummary of Db-Field DocumentSummary</summary>
        public static string Prop_DocumentSummary = "DocumentSummary";
        ///<summary>Property DocumentProp of Db-Field Document</summary>
        public static string Prop_DocumentProp = "DocumentProp";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field DocumentNode of Property DocumentNode</summary>
        public static string Field_DocumentNode = "DocumentNode";
        ///<summary>Db-Field DocumentLevel of Property DocumentLevel</summary>
        public static string Field_DocumentLevel = "DocumentLevel";
        ///<summary>Db-Field Title of Property Title</summary>
        public static string Field_Title = "Title";
        ///<summary>Db-Field Owner of Property Owner</summary>
        public static string Field_Owner = "Owner";
        ///<summary>Db-Field FolderFlag of Property FolderFlag</summary>
        public static string Field_FolderFlag = "FolderFlag";
        ///<summary>Db-Field FileName of Property FileName</summary>
        public static string Field_FileName = "FileName";
        ///<summary>Db-Field FileExtension of Property FileExtension</summary>
        public static string Field_FileExtension = "FileExtension";
        ///<summary>Db-Field Revision of Property Revision</summary>
        public static string Field_Revision = "Revision";
        ///<summary>Db-Field ChangeNumber of Property ChangeNumber</summary>
        public static string Field_ChangeNumber = "ChangeNumber";
        ///<summary>Db-Field Status of Property Status</summary>
        public static string Field_Status = "Status";
        ///<summary>Db-Field DocumentSummary of Property DocumentSummary</summary>
        public static string Field_DocumentSummary = "DocumentSummary";
        ///<summary>Db-Field Document of Property DocumentProp</summary>
        public static string Field_DocumentProp = "Document";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = Document, 
		/// Fields       = "DocumentNode"
		/// Query        = ...
        /// </summary>
        protected DocumentFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "Document";
            this.Fields = new string[]
            {
                "DocumentNode"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("DocumentNode", "string", "DocumentNode", "string", "", null);
			this.Properties.Add("DocumentLevel", "short?", "DocumentLevel", "short?", "", null);
			this.Properties.Add("Title", "string", "Title", "string", "", null);
			this.Properties.Add("Owner", "int?", "Owner", "int?", "", "Employee");
			this.Properties.Add("FolderFlag", "bool?", "FolderFlag", "bool?", "", null);
			this.Properties.Add("FileName", "string", "FileName", "string", "", null);
			this.Properties.Add("FileExtension", "string", "FileExtension", "string", "", null);
			this.Properties.Add("Revision", "string", "Revision", "string", "", null);
			this.Properties.Add("ChangeNumber", "int?", "ChangeNumber", "int?", "", null);
			this.Properties.Add("Status", "byte?", "Status", "byte?", "", null);
			this.Properties.Add("DocumentSummary", "string", "DocumentSummary", "string", "", null);
			this.Properties.Add("DocumentProp", "byte[]", "Document", "byte[]", "", null);
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "Document"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "DocumentList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "DocumentFactory"; }
            set { }
        }

		#endregion

		internal static DocumentFactory CreateFactory(EntityManager manager)
		{
		    return new DocumentFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of Document. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo Document</returns>
        public override Document CreateEntity()
		{
			var item = new Document();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(Document item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Employee / Employee
            // Foreign Key FK_Document_Employee_Owner
            if (parent is Employee)
            {
                item.Employee = (Employee)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public Document GetItem(string documentNode)
        {
            return this.GetEntity(0, documentNode);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public Document GetItem(DbConnector conn, string documentNode)
        {
            return this.GetEntity(conn, documentNode);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(Document).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to DocumentFactory / Document / Document.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// DocumentFactory to Document / Document.
        /// </summary>
        public DocumentFactory DocumentFactory
		{
			get
			{
				if (_DocumentFactory == null)
				{
					_DocumentFactory = global::AdventureWorks.DocumentFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_DocumentFactory, typeof(Document));
				}
				return _DocumentFactory;
			}
		}
		private DocumentFactory _DocumentFactory = null;
	
        /// <summary>
        /// GetDocument to Document / Document
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public Document GetDocument(string documentNode)
        {
            return this.DocumentFactory.GetEntity(0, documentNode);
        }
	
        /// <summary>
        /// GetDocument to Document / Document
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Document GetDocument(DbConnector conn, string documentNode)
        {
            return this.DocumentFactory.GetEntity(conn, documentNode);
        }
	
		/// <summary>
        /// GetDocumentList to Document / Document
		/// Getting a list of Document using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public DocumentList GetDocumentList(SqlWhereClause where)
        {
            return this.DocumentFactory.GetEntities(where);
        }

		/// <summary>
        /// GetDocumentList to Document / Document
		/// Getting all entities of Document
        /// </summary>
        /// <returns>List of all found entities</returns>
        public DocumentList GetDocumentList()
        {
			var where = new SqlWhereClause();
            return this.DocumentFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveDocument to Document / Document
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Document SaveDocument(Document item)
        {
            return this.DocumentFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveDocument to Document / Document
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Document SaveDocument(DbConnector conn, Document item)
        {
            return this.DocumentFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyDocument to Document / Document
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Document ApplyDocument(DbConnector conn, Document item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.DocumentFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveDocument to Document / Document
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveDocument(Document item)
        {
            return this.DocumentFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveDocument to Document / Document
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveDocument(DbConnector conn, Document item)
        {
            return this.DocumentFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities DocumentList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveDocumentList(DocumentList items)
        {
			return this.DocumentFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
