﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// EmployeeDepartmentHistory / EmployeeDepartmentHistory - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class EmployeeDepartmentHistory
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for EmployeeDepartmentHistory
        /// </summary>
	    public EmployeeDepartmentHistory()
		{
		}

		///// <summary>
        ///// Creates a new instance of EmployeeDepartmentHistory
        ///// </summary>
	    //internal EmployeeDepartmentHistory CreateEntity()
		//{
		//    return new EmployeeDepartmentHistory();
		//}

		#region Members

		
        /// <summary>
        /// BusinessEntityId / EmployeeDepartmentHistory.BusinessEntityID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("BusinessEntityID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Employee")]
        public virtual int? BusinessEntityId
        {
            get
            {
                return (int?)this["BusinessEntityID"];
            }
            set
            {
                this.Add("BusinessEntityID", value, typeof(int?));
            }
        }

        /// <summary>
        /// DepartmentId / EmployeeDepartmentHistory.DepartmentID
        /// </summary>
        /// <returns>short?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("DepartmentID"), FieldOrder(0), TypeName("short?"), FieldTypeName("short?"), ForeignEntity("Department")]
        public virtual short? DepartmentId
        {
            get
            {
                return (short?)this["DepartmentID"];
            }
            set
            {
                this.Add("DepartmentID", value, typeof(short?));
            }
        }

        /// <summary>
        /// ShiftId / EmployeeDepartmentHistory.ShiftID
        /// </summary>
        /// <returns>byte?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ShiftID"), FieldOrder(0), TypeName("byte?"), FieldTypeName("byte?"), ForeignEntity("Shift")]
        public virtual byte? ShiftId
        {
            get
            {
                return (byte?)this["ShiftID"];
            }
            set
            {
                this.Add("ShiftID", value, typeof(byte?));
            }
        }

        /// <summary>
        /// StartDate / EmployeeDepartmentHistory.StartDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("StartDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? StartDate
        {
            get
            {
                return (DateTime?)this["StartDate"];
            }
            set
            {
                this.Add("StartDate", value, typeof(DateTime?));
            }
        }

        /// <summary>
        /// EndDate / EmployeeDepartmentHistory.EndDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("EndDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? EndDate
        {
            get
            {
                return (DateTime?)this["EndDate"];
            }
            set
            {
                this.Add("EndDate", value, typeof(DateTime?));
            }
        }

        /// <summary>
        /// ModifiedDate / EmployeeDepartmentHistory.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Department

        /// <summary>
        /// Link to parent/super Entity Department / Department (this.DepartmentId)
		/// Foreign key FK_EmployeeDepartmentHistory_Department_DepartmentID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Department Department
        {
            get
            {
			    // Lazy loading
                if (this._Department == null && this.DepartmentId != null)
                {
                    this._Department = ((AdvEntityManager)this.Manager).GetDepartment(this.DepartmentId);
                    if (! _Department.ResultInfo.IsValid)
                    {
						this._Department = null; // reset value
                        throw new Exception("wrong/missed constraint from EmployeeDepartmentHistory to Department.");
                    }
                }
                return this._Department;
            }
            set
            {
                // reassign foreign key values from setter value
                this.DepartmentId = (value != null ? value.DepartmentId : null);


				// set foreign table
                this._Department = value;
            }
        }
        private Department _Department = null;

        #endregion

        #region foreign constraint (parent entity) to Employee

        /// <summary>
        /// Link to parent/super Entity Employee / Employee (this.BusinessEntityId)
		/// Foreign key FK_EmployeeDepartmentHistory_Employee_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Employee Employee
        {
            get
            {
			    // Lazy loading
                if (this._Employee == null && this.BusinessEntityId != null)
                {
                    this._Employee = ((AdvEntityManager)this.Manager).GetEmployee(this.BusinessEntityId);
                    if (! _Employee.ResultInfo.IsValid)
                    {
						this._Employee = null; // reset value
                        throw new Exception("wrong/missed constraint from EmployeeDepartmentHistory to Employee.");
                    }
                }
                return this._Employee;
            }
            set
            {
                // reassign foreign key values from setter value
                this.BusinessEntityId = (value != null ? value.BusinessEntityId : null);


				// set foreign table
                this._Employee = value;
            }
        }
        private Employee _Employee = null;

        #endregion

        #region foreign constraint (parent entity) to Shift

        /// <summary>
        /// Link to parent/super Entity Shift / Shift (this.ShiftId)
		/// Foreign key FK_EmployeeDepartmentHistory_Shift_ShiftID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Shift Shift
        {
            get
            {
			    // Lazy loading
                if (this._Shift == null && this.ShiftId != null)
                {
                    this._Shift = ((AdvEntityManager)this.Manager).GetShift(this.ShiftId);
                    if (! _Shift.ResultInfo.IsValid)
                    {
						this._Shift = null; // reset value
                        throw new Exception("wrong/missed constraint from EmployeeDepartmentHistory to Shift.");
                    }
                }
                return this._Shift;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ShiftId = (value != null ? value.ShiftId : null);


				// set foreign table
                this._Shift = value;
            }
        }
        private Shift _Shift = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.EmployeeDepartmentHistoryFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "EmployeeDepartmentHistory"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // EmployeeDepartmentHistory

	#endregion

	#region Entity-List

    /// <summary>
    /// EmployeeDepartmentHistory / EmployeeDepartmentHistoryList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class EmployeeDepartmentHistoryList
        : WebEntityList<EmployeeDepartmentHistory>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "EmployeeDepartmentHistory"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// EmployeeDepartmentHistory - EmployeeDepartmentHistory - Factory 
    /// </summary>
    public partial class EmployeeDepartmentHistoryFactory
        : WebEntityFactory<EmployeeDepartmentHistory, EmployeeDepartmentHistoryList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property BusinessEntityId of Db-Field BusinessEntityID</summary>
        public static string Prop_BusinessEntityId = "BusinessEntityId";
        ///<summary>Property DepartmentId of Db-Field DepartmentID</summary>
        public static string Prop_DepartmentId = "DepartmentId";
        ///<summary>Property ShiftId of Db-Field ShiftID</summary>
        public static string Prop_ShiftId = "ShiftId";
        ///<summary>Property StartDate of Db-Field StartDate</summary>
        public static string Prop_StartDate = "StartDate";
        ///<summary>Property EndDate of Db-Field EndDate</summary>
        public static string Prop_EndDate = "EndDate";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field BusinessEntityID of Property BusinessEntityId</summary>
        public static string Field_BusinessEntityId = "BusinessEntityID";
        ///<summary>Db-Field DepartmentID of Property DepartmentId</summary>
        public static string Field_DepartmentId = "DepartmentID";
        ///<summary>Db-Field ShiftID of Property ShiftId</summary>
        public static string Field_ShiftId = "ShiftID";
        ///<summary>Db-Field StartDate of Property StartDate</summary>
        public static string Field_StartDate = "StartDate";
        ///<summary>Db-Field EndDate of Property EndDate</summary>
        public static string Field_EndDate = "EndDate";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = EmployeeDepartmentHistory, 
		/// Fields       = "BusinessEntityID", "StartDate", "DepartmentID", "ShiftID"
		/// Query        = ...
        /// </summary>
        protected EmployeeDepartmentHistoryFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "HumanResources";
            this.TableName = "EmployeeDepartmentHistory";
            this.Fields = new string[]
            {
                "BusinessEntityID", "StartDate", "DepartmentID", "ShiftID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("BusinessEntityId", "int?", "BusinessEntityID", "int?", "", "Employee");
			this.Properties.Add("DepartmentId", "short?", "DepartmentID", "short?", "", "Department");
			this.Properties.Add("ShiftId", "byte?", "ShiftID", "byte?", "", "Shift");
			this.Properties.Add("StartDate", "DateTime?", "StartDate", "DateTime?", "", null);
			this.Properties.Add("EndDate", "DateTime?", "EndDate", "DateTime?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "EmployeeDepartmentHistory"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "EmployeeDepartmentHistoryList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "EmployeeDepartmentHistoryFactory"; }
            set { }
        }

		#endregion

		internal static EmployeeDepartmentHistoryFactory CreateFactory(EntityManager manager)
		{
		    return new EmployeeDepartmentHistoryFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of EmployeeDepartmentHistory. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo EmployeeDepartmentHistory</returns>
        public override EmployeeDepartmentHistory CreateEntity()
		{
			var item = new EmployeeDepartmentHistory();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(EmployeeDepartmentHistory item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Department / Department
            // Foreign Key FK_EmployeeDepartmentHistory_Department_DepartmentID
            if (parent is Department)
            {
                item.Department = (Department)parent;
                return;
            }

            // make relation to parent/super Entity Employee / Employee
            // Foreign Key FK_EmployeeDepartmentHistory_Employee_BusinessEntityID
            if (parent is Employee)
            {
                item.Employee = (Employee)parent;
                return;
            }

            // make relation to parent/super Entity Shift / Shift
            // Foreign Key FK_EmployeeDepartmentHistory_Shift_ShiftID
            if (parent is Shift)
            {
                item.Shift = (Shift)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public EmployeeDepartmentHistory GetItem(int? businessEntityId, DateTime? startDate, short? departmentId, byte? shiftId)
        {
            return this.GetEntity(0, businessEntityId, startDate, departmentId, shiftId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public EmployeeDepartmentHistory GetItem(DbConnector conn, int? businessEntityId, DateTime? startDate, short? departmentId, byte? shiftId)
        {
            return this.GetEntity(conn, businessEntityId, startDate, departmentId, shiftId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(EmployeeDepartmentHistory).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to EmployeeDepartmentHistoryFactory / EmployeeDepartmentHistory / EmployeeDepartmentHistory.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// EmployeeDepartmentHistoryFactory to EmployeeDepartmentHistory / EmployeeDepartmentHistory.
        /// </summary>
        public EmployeeDepartmentHistoryFactory EmployeeDepartmentHistoryFactory
		{
			get
			{
				if (_EmployeeDepartmentHistoryFactory == null)
				{
					_EmployeeDepartmentHistoryFactory = global::AdventureWorks.EmployeeDepartmentHistoryFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_EmployeeDepartmentHistoryFactory, typeof(EmployeeDepartmentHistory));
				}
				return _EmployeeDepartmentHistoryFactory;
			}
		}
		private EmployeeDepartmentHistoryFactory _EmployeeDepartmentHistoryFactory = null;
	
        /// <summary>
        /// GetEmployeeDepartmentHistory to EmployeeDepartmentHistory / EmployeeDepartmentHistory
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public EmployeeDepartmentHistory GetEmployeeDepartmentHistory(int? businessEntityId, DateTime? startDate, short? departmentId, byte? shiftId)
        {
            return this.EmployeeDepartmentHistoryFactory.GetEntity(0, businessEntityId, startDate, departmentId, shiftId);
        }
	
        /// <summary>
        /// GetEmployeeDepartmentHistory to EmployeeDepartmentHistory / EmployeeDepartmentHistory
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public EmployeeDepartmentHistory GetEmployeeDepartmentHistory(DbConnector conn, int? businessEntityId, DateTime? startDate, short? departmentId, byte? shiftId)
        {
            return this.EmployeeDepartmentHistoryFactory.GetEntity(conn, businessEntityId, startDate, departmentId, shiftId);
        }
	
		/// <summary>
        /// GetEmployeeDepartmentHistoryList to EmployeeDepartmentHistory / EmployeeDepartmentHistory
		/// Getting a list of EmployeeDepartmentHistory using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public EmployeeDepartmentHistoryList GetEmployeeDepartmentHistoryList(SqlWhereClause where)
        {
            return this.EmployeeDepartmentHistoryFactory.GetEntities(where);
        }

		/// <summary>
        /// GetEmployeeDepartmentHistoryList to EmployeeDepartmentHistory / EmployeeDepartmentHistory
		/// Getting all entities of EmployeeDepartmentHistory
        /// </summary>
        /// <returns>List of all found entities</returns>
        public EmployeeDepartmentHistoryList GetEmployeeDepartmentHistoryList()
        {
			var where = new SqlWhereClause();
            return this.EmployeeDepartmentHistoryFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveEmployeeDepartmentHistory to EmployeeDepartmentHistory / EmployeeDepartmentHistory
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public EmployeeDepartmentHistory SaveEmployeeDepartmentHistory(EmployeeDepartmentHistory item)
        {
            return this.EmployeeDepartmentHistoryFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveEmployeeDepartmentHistory to EmployeeDepartmentHistory / EmployeeDepartmentHistory
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public EmployeeDepartmentHistory SaveEmployeeDepartmentHistory(DbConnector conn, EmployeeDepartmentHistory item)
        {
            return this.EmployeeDepartmentHistoryFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyEmployeeDepartmentHistory to EmployeeDepartmentHistory / EmployeeDepartmentHistory
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public EmployeeDepartmentHistory ApplyEmployeeDepartmentHistory(DbConnector conn, EmployeeDepartmentHistory item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.EmployeeDepartmentHistoryFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveEmployeeDepartmentHistory to EmployeeDepartmentHistory / EmployeeDepartmentHistory
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveEmployeeDepartmentHistory(EmployeeDepartmentHistory item)
        {
            return this.EmployeeDepartmentHistoryFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveEmployeeDepartmentHistory to EmployeeDepartmentHistory / EmployeeDepartmentHistory
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveEmployeeDepartmentHistory(DbConnector conn, EmployeeDepartmentHistory item)
        {
            return this.EmployeeDepartmentHistoryFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities EmployeeDepartmentHistoryList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveEmployeeDepartmentHistoryList(EmployeeDepartmentHistoryList items)
        {
			return this.EmployeeDepartmentHistoryFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
