﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// Illustration / Illustration - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class Illustration
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for Illustration
        /// </summary>
	    public Illustration()
		{
		}

		///// <summary>
        ///// Creates a new instance of Illustration
        ///// </summary>
	    //internal Illustration CreateEntity()
		//{
		//    return new Illustration();
		//}

		#region Members

		
        /// <summary>
        /// IllustrationId / Illustration.IllustrationID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("IllustrationID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? IllustrationId
        {
            get
            {
                return (int?)this["IllustrationID"];
            }
            set
            {
                this.Add("IllustrationID", value, typeof(int?));
            }
        }

        /// <summary>
        /// Diagram / Illustration.Diagram
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Diagram"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Diagram
        {
            get
            {
                return (string)this["Diagram"];
            }
            set
            {
                this.Add("Diagram", value, typeof(string));
            }
        }

        /// <summary>
        /// ModifiedDate / Illustration.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		

		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from ProductModelIllustration

        /// <summary>
        /// List of sub entities ProductModelIllustration / ProductModelIllustration (IllustrationID)
		/// Foreign Key FK_ProductModelIllustration_Illustration_IllustrationID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductModelIllustrationList ProductModelIllustrationList
        {
            get
            {
			    // Lazy Loading
                if (_ProductModelIllustrationList == null && this.IllustrationId != null)
                {
					var where = new SqlWhereClause("WHERE ProductModelIllustration.IllustrationID = @IllustrationID",
					    "@IllustrationID", this.IllustrationId);
                    _ProductModelIllustrationList = ((AdvEntityManager)this.Manager).GetProductModelIllustrationList(where);
                }
				if (_ProductModelIllustrationList == null)
				{
					_ProductModelIllustrationList = new ProductModelIllustrationList();
				}
                return _ProductModelIllustrationList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductModelIllustrationList _ProductModelIllustrationList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.IllustrationFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Illustration"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // Illustration

	#endregion

	#region Entity-List

    /// <summary>
    /// Illustration / IllustrationList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class IllustrationList
        : WebEntityList<Illustration>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Illustration"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// Illustration - Illustration - Factory 
    /// </summary>
    public partial class IllustrationFactory
        : WebEntityFactory<Illustration, IllustrationList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property IllustrationId of Db-Field IllustrationID</summary>
        public static string Prop_IllustrationId = "IllustrationId";
        ///<summary>Property Diagram of Db-Field Diagram</summary>
        public static string Prop_Diagram = "Diagram";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field IllustrationID of Property IllustrationId</summary>
        public static string Field_IllustrationId = "IllustrationID";
        ///<summary>Db-Field Diagram of Property Diagram</summary>
        public static string Field_Diagram = "Diagram";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = Illustration, 
		/// Fields       = "IllustrationID"
		/// Query        = ...
        /// </summary>
        protected IllustrationFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "Illustration";
            this.Fields = new string[]
            {
                "IllustrationID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("IllustrationId", "int?", "IllustrationID", "int?", "", null);
			this.Properties.Add("Diagram", "string", "Diagram", "string", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "Illustration"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "IllustrationList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "IllustrationFactory"; }
            set { }
        }

		#endregion

		internal static IllustrationFactory CreateFactory(EntityManager manager)
		{
		    return new IllustrationFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of Illustration. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo Illustration</returns>
        public override Illustration CreateEntity()
		{
			var item = new Illustration();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}



		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public Illustration GetItem(int? illustrationId)
        {
            return this.GetEntity(0, illustrationId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public Illustration GetItem(DbConnector conn, int? illustrationId)
        {
            return this.GetEntity(conn, illustrationId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(Illustration).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to IllustrationFactory / Illustration / Illustration.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// IllustrationFactory to Illustration / Illustration.
        /// </summary>
        public IllustrationFactory IllustrationFactory
		{
			get
			{
				if (_IllustrationFactory == null)
				{
					_IllustrationFactory = global::AdventureWorks.IllustrationFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_IllustrationFactory, typeof(Illustration));
				}
				return _IllustrationFactory;
			}
		}
		private IllustrationFactory _IllustrationFactory = null;
	
        /// <summary>
        /// GetIllustration to Illustration / Illustration
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public Illustration GetIllustration(int? illustrationId)
        {
            return this.IllustrationFactory.GetEntity(0, illustrationId);
        }
	
        /// <summary>
        /// GetIllustration to Illustration / Illustration
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Illustration GetIllustration(DbConnector conn, int? illustrationId)
        {
            return this.IllustrationFactory.GetEntity(conn, illustrationId);
        }
	
		/// <summary>
        /// GetIllustrationList to Illustration / Illustration
		/// Getting a list of Illustration using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public IllustrationList GetIllustrationList(SqlWhereClause where)
        {
            return this.IllustrationFactory.GetEntities(where);
        }

		/// <summary>
        /// GetIllustrationList to Illustration / Illustration
		/// Getting all entities of Illustration
        /// </summary>
        /// <returns>List of all found entities</returns>
        public IllustrationList GetIllustrationList()
        {
			var where = new SqlWhereClause();
            return this.IllustrationFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveIllustration to Illustration / Illustration
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Illustration SaveIllustration(Illustration item)
        {
            return this.IllustrationFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveIllustration to Illustration / Illustration
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Illustration SaveIllustration(DbConnector conn, Illustration item)
        {
            return this.IllustrationFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyIllustration to Illustration / Illustration
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Illustration ApplyIllustration(DbConnector conn, Illustration item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.IllustrationFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveIllustration to Illustration / Illustration
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveIllustration(Illustration item)
        {
            return this.IllustrationFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveIllustration to Illustration / Illustration
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveIllustration(DbConnector conn, Illustration item)
        {
            return this.IllustrationFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities IllustrationList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveIllustrationList(IllustrationList items)
        {
			return this.IllustrationFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
