﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// JobCandidate / JobCandidate - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class JobCandidate
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for JobCandidate
        /// </summary>
	    public JobCandidate()
		{
		}

		///// <summary>
        ///// Creates a new instance of JobCandidate
        ///// </summary>
	    //internal JobCandidate CreateEntity()
		//{
		//    return new JobCandidate();
		//}

		#region Members

		
        /// <summary>
        /// JobCandidateId / JobCandidate.JobCandidateID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("JobCandidateID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? JobCandidateId
        {
            get
            {
                return (int?)this["JobCandidateID"];
            }
            set
            {
                this.Add("JobCandidateID", value, typeof(int?));
            }
        }

        /// <summary>
        /// BusinessEntityId / JobCandidate.BusinessEntityID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("BusinessEntityID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Employee")]
        public virtual int? BusinessEntityId
        {
            get
            {
                return (int?)this["BusinessEntityID"];
            }
            set
            {
                this.Add("BusinessEntityID", value, typeof(int?));
            }
        }

        /// <summary>
        /// Resume / JobCandidate.Resume
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Resume"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Resume
        {
            get
            {
                return (string)this["Resume"];
            }
            set
            {
                this.Add("Resume", value, typeof(string));
            }
        }

        /// <summary>
        /// ModifiedDate / JobCandidate.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Employee

        /// <summary>
        /// Link to parent/super Entity Employee / Employee (this.BusinessEntityId)
		/// Foreign key FK_JobCandidate_Employee_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Employee Employee
        {
            get
            {
			    // Lazy loading
                if (this._Employee == null && this.BusinessEntityId != null)
                {
                    this._Employee = ((AdvEntityManager)this.Manager).GetEmployee(this.BusinessEntityId);
                    if (! _Employee.ResultInfo.IsValid)
                    {
						this._Employee = null; // reset value
                        throw new Exception("wrong/missed constraint from JobCandidate to Employee.");
                    }
                }
                return this._Employee;
            }
            set
            {
                // reassign foreign key values from setter value
                this.BusinessEntityId = (value != null ? value.BusinessEntityId : null);


				// set foreign table
                this._Employee = value;
            }
        }
        private Employee _Employee = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.JobCandidateFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "JobCandidate"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // JobCandidate

	#endregion

	#region Entity-List

    /// <summary>
    /// JobCandidate / JobCandidateList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class JobCandidateList
        : WebEntityList<JobCandidate>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "JobCandidate"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// JobCandidate - JobCandidate - Factory 
    /// </summary>
    public partial class JobCandidateFactory
        : WebEntityFactory<JobCandidate, JobCandidateList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property JobCandidateId of Db-Field JobCandidateID</summary>
        public static string Prop_JobCandidateId = "JobCandidateId";
        ///<summary>Property BusinessEntityId of Db-Field BusinessEntityID</summary>
        public static string Prop_BusinessEntityId = "BusinessEntityId";
        ///<summary>Property Resume of Db-Field Resume</summary>
        public static string Prop_Resume = "Resume";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field JobCandidateID of Property JobCandidateId</summary>
        public static string Field_JobCandidateId = "JobCandidateID";
        ///<summary>Db-Field BusinessEntityID of Property BusinessEntityId</summary>
        public static string Field_BusinessEntityId = "BusinessEntityID";
        ///<summary>Db-Field Resume of Property Resume</summary>
        public static string Field_Resume = "Resume";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = JobCandidate, 
		/// Fields       = "JobCandidateID"
		/// Query        = ...
        /// </summary>
        protected JobCandidateFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "HumanResources";
            this.TableName = "JobCandidate";
            this.Fields = new string[]
            {
                "JobCandidateID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("JobCandidateId", "int?", "JobCandidateID", "int?", "", null);
			this.Properties.Add("BusinessEntityId", "int?", "BusinessEntityID", "int?", "", "Employee");
			this.Properties.Add("Resume", "string", "Resume", "string", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "JobCandidate"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "JobCandidateList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "JobCandidateFactory"; }
            set { }
        }

		#endregion

		internal static JobCandidateFactory CreateFactory(EntityManager manager)
		{
		    return new JobCandidateFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of JobCandidate. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo JobCandidate</returns>
        public override JobCandidate CreateEntity()
		{
			var item = new JobCandidate();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(JobCandidate item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Employee / Employee
            // Foreign Key FK_JobCandidate_Employee_BusinessEntityID
            if (parent is Employee)
            {
                item.Employee = (Employee)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public JobCandidate GetItem(int? jobCandidateId)
        {
            return this.GetEntity(0, jobCandidateId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public JobCandidate GetItem(DbConnector conn, int? jobCandidateId)
        {
            return this.GetEntity(conn, jobCandidateId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(JobCandidate).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to JobCandidateFactory / JobCandidate / JobCandidate.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// JobCandidateFactory to JobCandidate / JobCandidate.
        /// </summary>
        public JobCandidateFactory JobCandidateFactory
		{
			get
			{
				if (_JobCandidateFactory == null)
				{
					_JobCandidateFactory = global::AdventureWorks.JobCandidateFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_JobCandidateFactory, typeof(JobCandidate));
				}
				return _JobCandidateFactory;
			}
		}
		private JobCandidateFactory _JobCandidateFactory = null;
	
        /// <summary>
        /// GetJobCandidate to JobCandidate / JobCandidate
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public JobCandidate GetJobCandidate(int? jobCandidateId)
        {
            return this.JobCandidateFactory.GetEntity(0, jobCandidateId);
        }
	
        /// <summary>
        /// GetJobCandidate to JobCandidate / JobCandidate
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public JobCandidate GetJobCandidate(DbConnector conn, int? jobCandidateId)
        {
            return this.JobCandidateFactory.GetEntity(conn, jobCandidateId);
        }
	
		/// <summary>
        /// GetJobCandidateList to JobCandidate / JobCandidate
		/// Getting a list of JobCandidate using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public JobCandidateList GetJobCandidateList(SqlWhereClause where)
        {
            return this.JobCandidateFactory.GetEntities(where);
        }

		/// <summary>
        /// GetJobCandidateList to JobCandidate / JobCandidate
		/// Getting all entities of JobCandidate
        /// </summary>
        /// <returns>List of all found entities</returns>
        public JobCandidateList GetJobCandidateList()
        {
			var where = new SqlWhereClause();
            return this.JobCandidateFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveJobCandidate to JobCandidate / JobCandidate
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public JobCandidate SaveJobCandidate(JobCandidate item)
        {
            return this.JobCandidateFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveJobCandidate to JobCandidate / JobCandidate
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public JobCandidate SaveJobCandidate(DbConnector conn, JobCandidate item)
        {
            return this.JobCandidateFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyJobCandidate to JobCandidate / JobCandidate
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public JobCandidate ApplyJobCandidate(DbConnector conn, JobCandidate item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.JobCandidateFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveJobCandidate to JobCandidate / JobCandidate
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveJobCandidate(JobCandidate item)
        {
            return this.JobCandidateFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveJobCandidate to JobCandidate / JobCandidate
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveJobCandidate(DbConnector conn, JobCandidate item)
        {
            return this.JobCandidateFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities JobCandidateList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveJobCandidateList(JobCandidateList items)
        {
			return this.JobCandidateFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
