﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// Location / Location - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class Location
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for Location
        /// </summary>
	    public Location()
		{
		}

		///// <summary>
        ///// Creates a new instance of Location
        ///// </summary>
	    //internal Location CreateEntity()
		//{
		//    return new Location();
		//}

		#region Members

		
        /// <summary>
        /// LocationId / Location.LocationID
        /// </summary>
        /// <returns>short?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("LocationID"), FieldOrder(0), TypeName("short?"), FieldTypeName("short?"), ForeignEntity(null)]
        public virtual short? LocationId
        {
            get
            {
                return (short?)this["LocationID"];
            }
            set
            {
                this.Add("LocationID", value, typeof(short?));
            }
        }

        /// <summary>
        /// Name / Location.Name
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Name"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Name
        {
            get
            {
                return (string)this["Name"];
            }
            set
            {
                this.Add("Name", value, typeof(string));
            }
        }

        /// <summary>
        /// CostRate / Location.CostRate
        /// </summary>
        /// <returns>decimal?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("CostRate"), FieldOrder(0), TypeName("decimal?"), FieldTypeName("decimal?"), ForeignEntity(null)]
        public virtual decimal? CostRate
        {
            get
            {
                return (decimal?)this["CostRate"];
            }
            set
            {
                this.Add("CostRate", value, typeof(decimal?));
            }
        }

        /// <summary>
        /// Availability / Location.Availability
        /// </summary>
        /// <returns>decimal?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Availability"), FieldOrder(0), TypeName("decimal?"), FieldTypeName("decimal?"), ForeignEntity(null)]
        public virtual decimal? Availability
        {
            get
            {
                return (decimal?)this["Availability"];
            }
            set
            {
                this.Add("Availability", value, typeof(decimal?));
            }
        }

        /// <summary>
        /// ModifiedDate / Location.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		

		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from ProductInventory

        /// <summary>
        /// List of sub entities ProductInventory / ProductInventory (LocationID)
		/// Foreign Key FK_ProductInventory_Location_LocationID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductInventoryList ProductInventoryList
        {
            get
            {
			    // Lazy Loading
                if (_ProductInventoryList == null && this.LocationId != null)
                {
					var where = new SqlWhereClause("WHERE ProductInventory.LocationID = @LocationID",
					    "@LocationID", this.LocationId);
                    _ProductInventoryList = ((AdvEntityManager)this.Manager).GetProductInventoryList(where);
                }
				if (_ProductInventoryList == null)
				{
					_ProductInventoryList = new ProductInventoryList();
				}
                return _ProductInventoryList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductInventoryList _ProductInventoryList = null;

        #endregion

        #region Sub Entites from WorkOrderRouting

        /// <summary>
        /// List of sub entities WorkOrderRouting / WorkOrderRouting (LocationID)
		/// Foreign Key FK_WorkOrderRouting_Location_LocationID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual WorkOrderRoutingList WorkOrderRoutingList
        {
            get
            {
			    // Lazy Loading
                if (_WorkOrderRoutingList == null && this.LocationId != null)
                {
					var where = new SqlWhereClause("WHERE WorkOrderRouting.LocationID = @LocationID",
					    "@LocationID", this.LocationId);
                    _WorkOrderRoutingList = ((AdvEntityManager)this.Manager).GetWorkOrderRoutingList(where);
                }
				if (_WorkOrderRoutingList == null)
				{
					_WorkOrderRoutingList = new WorkOrderRoutingList();
				}
                return _WorkOrderRoutingList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private WorkOrderRoutingList _WorkOrderRoutingList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.LocationFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Location"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // Location

	#endregion

	#region Entity-List

    /// <summary>
    /// Location / LocationList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class LocationList
        : WebEntityList<Location>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Location"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// Location - Location - Factory 
    /// </summary>
    public partial class LocationFactory
        : WebEntityFactory<Location, LocationList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property LocationId of Db-Field LocationID</summary>
        public static string Prop_LocationId = "LocationId";
        ///<summary>Property Name of Db-Field Name</summary>
        public static string Prop_Name = "Name";
        ///<summary>Property CostRate of Db-Field CostRate</summary>
        public static string Prop_CostRate = "CostRate";
        ///<summary>Property Availability of Db-Field Availability</summary>
        public static string Prop_Availability = "Availability";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field LocationID of Property LocationId</summary>
        public static string Field_LocationId = "LocationID";
        ///<summary>Db-Field Name of Property Name</summary>
        public static string Field_Name = "Name";
        ///<summary>Db-Field CostRate of Property CostRate</summary>
        public static string Field_CostRate = "CostRate";
        ///<summary>Db-Field Availability of Property Availability</summary>
        public static string Field_Availability = "Availability";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = Location, 
		/// Fields       = "LocationID"
		/// Query        = ...
        /// </summary>
        protected LocationFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "Location";
            this.Fields = new string[]
            {
                "LocationID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("LocationId", "short?", "LocationID", "short?", "", null);
			this.Properties.Add("Name", "string", "Name", "string", "", null);
			this.Properties.Add("CostRate", "decimal?", "CostRate", "decimal?", "", null);
			this.Properties.Add("Availability", "decimal?", "Availability", "decimal?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "Location"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "LocationList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "LocationFactory"; }
            set { }
        }

		#endregion

		internal static LocationFactory CreateFactory(EntityManager manager)
		{
		    return new LocationFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of Location. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo Location</returns>
        public override Location CreateEntity()
		{
			var item = new Location();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}



		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public Location GetItem(short? locationId)
        {
            return this.GetEntity(0, locationId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public Location GetItem(DbConnector conn, short? locationId)
        {
            return this.GetEntity(conn, locationId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(Location).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to LocationFactory / Location / Location.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// LocationFactory to Location / Location.
        /// </summary>
        public LocationFactory LocationFactory
		{
			get
			{
				if (_LocationFactory == null)
				{
					_LocationFactory = global::AdventureWorks.LocationFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_LocationFactory, typeof(Location));
				}
				return _LocationFactory;
			}
		}
		private LocationFactory _LocationFactory = null;
	
        /// <summary>
        /// GetLocation to Location / Location
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public Location GetLocation(short? locationId)
        {
            return this.LocationFactory.GetEntity(0, locationId);
        }
	
        /// <summary>
        /// GetLocation to Location / Location
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Location GetLocation(DbConnector conn, short? locationId)
        {
            return this.LocationFactory.GetEntity(conn, locationId);
        }
	
		/// <summary>
        /// GetLocationList to Location / Location
		/// Getting a list of Location using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public LocationList GetLocationList(SqlWhereClause where)
        {
            return this.LocationFactory.GetEntities(where);
        }

		/// <summary>
        /// GetLocationList to Location / Location
		/// Getting all entities of Location
        /// </summary>
        /// <returns>List of all found entities</returns>
        public LocationList GetLocationList()
        {
			var where = new SqlWhereClause();
            return this.LocationFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveLocation to Location / Location
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Location SaveLocation(Location item)
        {
            return this.LocationFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveLocation to Location / Location
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Location SaveLocation(DbConnector conn, Location item)
        {
            return this.LocationFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyLocation to Location / Location
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Location ApplyLocation(DbConnector conn, Location item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.LocationFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveLocation to Location / Location
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveLocation(Location item)
        {
            return this.LocationFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveLocation to Location / Location
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveLocation(DbConnector conn, Location item)
        {
            return this.LocationFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities LocationList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveLocationList(LocationList items)
        {
			return this.LocationFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
