﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// PersonCreditCard / PersonCreditCard - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class PersonCreditCard
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for PersonCreditCard
        /// </summary>
	    public PersonCreditCard()
		{
		}

		///// <summary>
        ///// Creates a new instance of PersonCreditCard
        ///// </summary>
	    //internal PersonCreditCard CreateEntity()
		//{
		//    return new PersonCreditCard();
		//}

		#region Members

		
        /// <summary>
        /// BusinessEntityId / PersonCreditCard.BusinessEntityID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("BusinessEntityID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Person")]
        public virtual int? BusinessEntityId
        {
            get
            {
                return (int?)this["BusinessEntityID"];
            }
            set
            {
                this.Add("BusinessEntityID", value, typeof(int?));
            }
        }

        /// <summary>
        /// CreditCardId / PersonCreditCard.CreditCardID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("CreditCardID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("CreditCard")]
        public virtual int? CreditCardId
        {
            get
            {
                return (int?)this["CreditCardID"];
            }
            set
            {
                this.Add("CreditCardID", value, typeof(int?));
            }
        }

        /// <summary>
        /// ModifiedDate / PersonCreditCard.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to CreditCard

        /// <summary>
        /// Link to parent/super Entity CreditCard / CreditCard (this.CreditCardId)
		/// Foreign key FK_PersonCreditCard_CreditCard_CreditCardID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual CreditCard CreditCard
        {
            get
            {
			    // Lazy loading
                if (this._CreditCard == null && this.CreditCardId != null)
                {
                    this._CreditCard = ((AdvEntityManager)this.Manager).GetCreditCard(this.CreditCardId);
                    if (! _CreditCard.ResultInfo.IsValid)
                    {
						this._CreditCard = null; // reset value
                        throw new Exception("wrong/missed constraint from PersonCreditCard to CreditCard.");
                    }
                }
                return this._CreditCard;
            }
            set
            {
                // reassign foreign key values from setter value
                this.CreditCardId = (value != null ? value.CreditCardId : null);


				// set foreign table
                this._CreditCard = value;
            }
        }
        private CreditCard _CreditCard = null;

        #endregion

        #region foreign constraint (parent entity) to Person

        /// <summary>
        /// Link to parent/super Entity Person / Person (this.BusinessEntityId)
		/// Foreign key FK_PersonCreditCard_Person_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Person Person
        {
            get
            {
			    // Lazy loading
                if (this._Person == null && this.BusinessEntityId != null)
                {
                    this._Person = ((AdvEntityManager)this.Manager).GetPerson(this.BusinessEntityId);
                    if (! _Person.ResultInfo.IsValid)
                    {
						this._Person = null; // reset value
                        throw new Exception("wrong/missed constraint from PersonCreditCard to Person.");
                    }
                }
                return this._Person;
            }
            set
            {
                // reassign foreign key values from setter value
                this.BusinessEntityId = (value != null ? value.BusinessEntityId : null);


				// set foreign table
                this._Person = value;
            }
        }
        private Person _Person = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.PersonCreditCardFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "PersonCreditCard"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // PersonCreditCard

	#endregion

	#region Entity-List

    /// <summary>
    /// PersonCreditCard / PersonCreditCardList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class PersonCreditCardList
        : WebEntityList<PersonCreditCard>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "PersonCreditCard"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// PersonCreditCard - PersonCreditCard - Factory 
    /// </summary>
    public partial class PersonCreditCardFactory
        : WebEntityFactory<PersonCreditCard, PersonCreditCardList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property BusinessEntityId of Db-Field BusinessEntityID</summary>
        public static string Prop_BusinessEntityId = "BusinessEntityId";
        ///<summary>Property CreditCardId of Db-Field CreditCardID</summary>
        public static string Prop_CreditCardId = "CreditCardId";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field BusinessEntityID of Property BusinessEntityId</summary>
        public static string Field_BusinessEntityId = "BusinessEntityID";
        ///<summary>Db-Field CreditCardID of Property CreditCardId</summary>
        public static string Field_CreditCardId = "CreditCardID";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = PersonCreditCard, 
		/// Fields       = "BusinessEntityID", "CreditCardID"
		/// Query        = ...
        /// </summary>
        protected PersonCreditCardFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Sales";
            this.TableName = "PersonCreditCard";
            this.Fields = new string[]
            {
                "BusinessEntityID", "CreditCardID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("BusinessEntityId", "int?", "BusinessEntityID", "int?", "", "Person");
			this.Properties.Add("CreditCardId", "int?", "CreditCardID", "int?", "", "CreditCard");
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "PersonCreditCard"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "PersonCreditCardList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "PersonCreditCardFactory"; }
            set { }
        }

		#endregion

		internal static PersonCreditCardFactory CreateFactory(EntityManager manager)
		{
		    return new PersonCreditCardFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of PersonCreditCard. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo PersonCreditCard</returns>
        public override PersonCreditCard CreateEntity()
		{
			var item = new PersonCreditCard();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(PersonCreditCard item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity CreditCard / CreditCard
            // Foreign Key FK_PersonCreditCard_CreditCard_CreditCardID
            if (parent is CreditCard)
            {
                item.CreditCard = (CreditCard)parent;
                return;
            }

            // make relation to parent/super Entity Person / Person
            // Foreign Key FK_PersonCreditCard_Person_BusinessEntityID
            if (parent is Person)
            {
                item.Person = (Person)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public PersonCreditCard GetItem(int? businessEntityId, int? creditCardId)
        {
            return this.GetEntity(0, businessEntityId, creditCardId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public PersonCreditCard GetItem(DbConnector conn, int? businessEntityId, int? creditCardId)
        {
            return this.GetEntity(conn, businessEntityId, creditCardId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(PersonCreditCard).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to PersonCreditCardFactory / PersonCreditCard / PersonCreditCard.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// PersonCreditCardFactory to PersonCreditCard / PersonCreditCard.
        /// </summary>
        public PersonCreditCardFactory PersonCreditCardFactory
		{
			get
			{
				if (_PersonCreditCardFactory == null)
				{
					_PersonCreditCardFactory = global::AdventureWorks.PersonCreditCardFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_PersonCreditCardFactory, typeof(PersonCreditCard));
				}
				return _PersonCreditCardFactory;
			}
		}
		private PersonCreditCardFactory _PersonCreditCardFactory = null;
	
        /// <summary>
        /// GetPersonCreditCard to PersonCreditCard / PersonCreditCard
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public PersonCreditCard GetPersonCreditCard(int? businessEntityId, int? creditCardId)
        {
            return this.PersonCreditCardFactory.GetEntity(0, businessEntityId, creditCardId);
        }
	
        /// <summary>
        /// GetPersonCreditCard to PersonCreditCard / PersonCreditCard
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public PersonCreditCard GetPersonCreditCard(DbConnector conn, int? businessEntityId, int? creditCardId)
        {
            return this.PersonCreditCardFactory.GetEntity(conn, businessEntityId, creditCardId);
        }
	
		/// <summary>
        /// GetPersonCreditCardList to PersonCreditCard / PersonCreditCard
		/// Getting a list of PersonCreditCard using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public PersonCreditCardList GetPersonCreditCardList(SqlWhereClause where)
        {
            return this.PersonCreditCardFactory.GetEntities(where);
        }

		/// <summary>
        /// GetPersonCreditCardList to PersonCreditCard / PersonCreditCard
		/// Getting all entities of PersonCreditCard
        /// </summary>
        /// <returns>List of all found entities</returns>
        public PersonCreditCardList GetPersonCreditCardList()
        {
			var where = new SqlWhereClause();
            return this.PersonCreditCardFactory.GetEntities(where);
        }

        /// <summary>
        /// SavePersonCreditCard to PersonCreditCard / PersonCreditCard
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public PersonCreditCard SavePersonCreditCard(PersonCreditCard item)
        {
            return this.PersonCreditCardFactory.SaveEntity(item);
        }

        /// <summary>
        /// SavePersonCreditCard to PersonCreditCard / PersonCreditCard
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public PersonCreditCard SavePersonCreditCard(DbConnector conn, PersonCreditCard item)
        {
            return this.PersonCreditCardFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyPersonCreditCard to PersonCreditCard / PersonCreditCard
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public PersonCreditCard ApplyPersonCreditCard(DbConnector conn, PersonCreditCard item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.PersonCreditCardFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemovePersonCreditCard to PersonCreditCard / PersonCreditCard
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemovePersonCreditCard(PersonCreditCard item)
        {
            return this.PersonCreditCardFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemovePersonCreditCard to PersonCreditCard / PersonCreditCard
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemovePersonCreditCard(DbConnector conn, PersonCreditCard item)
        {
            return this.PersonCreditCardFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities PersonCreditCardList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SavePersonCreditCardList(PersonCreditCardList items)
        {
			return this.PersonCreditCardFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
