﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// PersonPhone / PersonPhone - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class PersonPhone
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for PersonPhone
        /// </summary>
	    public PersonPhone()
		{
		}

		///// <summary>
        ///// Creates a new instance of PersonPhone
        ///// </summary>
	    //internal PersonPhone CreateEntity()
		//{
		//    return new PersonPhone();
		//}

		#region Members

		
        /// <summary>
        /// BusinessEntityId / PersonPhone.BusinessEntityID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("BusinessEntityID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Person")]
        public virtual int? BusinessEntityId
        {
            get
            {
                return (int?)this["BusinessEntityID"];
            }
            set
            {
                this.Add("BusinessEntityID", value, typeof(int?));
            }
        }

        /// <summary>
        /// PhoneNumber / PersonPhone.PhoneNumber
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("PhoneNumber"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string PhoneNumber
        {
            get
            {
                return (string)this["PhoneNumber"];
            }
            set
            {
                this.Add("PhoneNumber", value, typeof(string));
            }
        }

        /// <summary>
        /// PhoneNumberTypeId / PersonPhone.PhoneNumberTypeID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("PhoneNumberTypeID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("PhoneNumberType")]
        public virtual int? PhoneNumberTypeId
        {
            get
            {
                return (int?)this["PhoneNumberTypeID"];
            }
            set
            {
                this.Add("PhoneNumberTypeID", value, typeof(int?));
            }
        }

        /// <summary>
        /// ModifiedDate / PersonPhone.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Person

        /// <summary>
        /// Link to parent/super Entity Person / Person (this.BusinessEntityId)
		/// Foreign key FK_PersonPhone_Person_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Person Person
        {
            get
            {
			    // Lazy loading
                if (this._Person == null && this.BusinessEntityId != null)
                {
                    this._Person = ((AdvEntityManager)this.Manager).GetPerson(this.BusinessEntityId);
                    if (! _Person.ResultInfo.IsValid)
                    {
						this._Person = null; // reset value
                        throw new Exception("wrong/missed constraint from PersonPhone to Person.");
                    }
                }
                return this._Person;
            }
            set
            {
                // reassign foreign key values from setter value
                this.BusinessEntityId = (value != null ? value.BusinessEntityId : null);


				// set foreign table
                this._Person = value;
            }
        }
        private Person _Person = null;

        #endregion

        #region foreign constraint (parent entity) to PhoneNumberType

        /// <summary>
        /// Link to parent/super Entity PhoneNumberType / PhoneNumberType (this.PhoneNumberTypeId)
		/// Foreign key FK_PersonPhone_PhoneNumberType_PhoneNumberTypeID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual PhoneNumberType PhoneNumberType
        {
            get
            {
			    // Lazy loading
                if (this._PhoneNumberType == null && this.PhoneNumberTypeId != null)
                {
                    this._PhoneNumberType = ((AdvEntityManager)this.Manager).GetPhoneNumberType(this.PhoneNumberTypeId);
                    if (! _PhoneNumberType.ResultInfo.IsValid)
                    {
						this._PhoneNumberType = null; // reset value
                        throw new Exception("wrong/missed constraint from PersonPhone to PhoneNumberType.");
                    }
                }
                return this._PhoneNumberType;
            }
            set
            {
                // reassign foreign key values from setter value
                this.PhoneNumberTypeId = (value != null ? value.PhoneNumberTypeId : null);


				// set foreign table
                this._PhoneNumberType = value;
            }
        }
        private PhoneNumberType _PhoneNumberType = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.PersonPhoneFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "PersonPhone"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // PersonPhone

	#endregion

	#region Entity-List

    /// <summary>
    /// PersonPhone / PersonPhoneList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class PersonPhoneList
        : WebEntityList<PersonPhone>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "PersonPhone"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// PersonPhone - PersonPhone - Factory 
    /// </summary>
    public partial class PersonPhoneFactory
        : WebEntityFactory<PersonPhone, PersonPhoneList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property BusinessEntityId of Db-Field BusinessEntityID</summary>
        public static string Prop_BusinessEntityId = "BusinessEntityId";
        ///<summary>Property PhoneNumber of Db-Field PhoneNumber</summary>
        public static string Prop_PhoneNumber = "PhoneNumber";
        ///<summary>Property PhoneNumberTypeId of Db-Field PhoneNumberTypeID</summary>
        public static string Prop_PhoneNumberTypeId = "PhoneNumberTypeId";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field BusinessEntityID of Property BusinessEntityId</summary>
        public static string Field_BusinessEntityId = "BusinessEntityID";
        ///<summary>Db-Field PhoneNumber of Property PhoneNumber</summary>
        public static string Field_PhoneNumber = "PhoneNumber";
        ///<summary>Db-Field PhoneNumberTypeID of Property PhoneNumberTypeId</summary>
        public static string Field_PhoneNumberTypeId = "PhoneNumberTypeID";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = PersonPhone, 
		/// Fields       = "BusinessEntityID", "PhoneNumber", "PhoneNumberTypeID"
		/// Query        = ...
        /// </summary>
        protected PersonPhoneFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Person";
            this.TableName = "PersonPhone";
            this.Fields = new string[]
            {
                "BusinessEntityID", "PhoneNumber", "PhoneNumberTypeID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("BusinessEntityId", "int?", "BusinessEntityID", "int?", "", "Person");
			this.Properties.Add("PhoneNumber", "string", "PhoneNumber", "string", "", null);
			this.Properties.Add("PhoneNumberTypeId", "int?", "PhoneNumberTypeID", "int?", "", "PhoneNumberType");
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "PersonPhone"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "PersonPhoneList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "PersonPhoneFactory"; }
            set { }
        }

		#endregion

		internal static PersonPhoneFactory CreateFactory(EntityManager manager)
		{
		    return new PersonPhoneFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of PersonPhone. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo PersonPhone</returns>
        public override PersonPhone CreateEntity()
		{
			var item = new PersonPhone();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(PersonPhone item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Person / Person
            // Foreign Key FK_PersonPhone_Person_BusinessEntityID
            if (parent is Person)
            {
                item.Person = (Person)parent;
                return;
            }

            // make relation to parent/super Entity PhoneNumberType / PhoneNumberType
            // Foreign Key FK_PersonPhone_PhoneNumberType_PhoneNumberTypeID
            if (parent is PhoneNumberType)
            {
                item.PhoneNumberType = (PhoneNumberType)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public PersonPhone GetItem(int? businessEntityId, string phoneNumber, int? phoneNumberTypeId)
        {
            return this.GetEntity(0, businessEntityId, phoneNumber, phoneNumberTypeId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public PersonPhone GetItem(DbConnector conn, int? businessEntityId, string phoneNumber, int? phoneNumberTypeId)
        {
            return this.GetEntity(conn, businessEntityId, phoneNumber, phoneNumberTypeId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(PersonPhone).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to PersonPhoneFactory / PersonPhone / PersonPhone.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// PersonPhoneFactory to PersonPhone / PersonPhone.
        /// </summary>
        public PersonPhoneFactory PersonPhoneFactory
		{
			get
			{
				if (_PersonPhoneFactory == null)
				{
					_PersonPhoneFactory = global::AdventureWorks.PersonPhoneFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_PersonPhoneFactory, typeof(PersonPhone));
				}
				return _PersonPhoneFactory;
			}
		}
		private PersonPhoneFactory _PersonPhoneFactory = null;
	
        /// <summary>
        /// GetPersonPhone to PersonPhone / PersonPhone
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public PersonPhone GetPersonPhone(int? businessEntityId, string phoneNumber, int? phoneNumberTypeId)
        {
            return this.PersonPhoneFactory.GetEntity(0, businessEntityId, phoneNumber, phoneNumberTypeId);
        }
	
        /// <summary>
        /// GetPersonPhone to PersonPhone / PersonPhone
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public PersonPhone GetPersonPhone(DbConnector conn, int? businessEntityId, string phoneNumber, int? phoneNumberTypeId)
        {
            return this.PersonPhoneFactory.GetEntity(conn, businessEntityId, phoneNumber, phoneNumberTypeId);
        }
	
		/// <summary>
        /// GetPersonPhoneList to PersonPhone / PersonPhone
		/// Getting a list of PersonPhone using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public PersonPhoneList GetPersonPhoneList(SqlWhereClause where)
        {
            return this.PersonPhoneFactory.GetEntities(where);
        }

		/// <summary>
        /// GetPersonPhoneList to PersonPhone / PersonPhone
		/// Getting all entities of PersonPhone
        /// </summary>
        /// <returns>List of all found entities</returns>
        public PersonPhoneList GetPersonPhoneList()
        {
			var where = new SqlWhereClause();
            return this.PersonPhoneFactory.GetEntities(where);
        }

        /// <summary>
        /// SavePersonPhone to PersonPhone / PersonPhone
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public PersonPhone SavePersonPhone(PersonPhone item)
        {
            return this.PersonPhoneFactory.SaveEntity(item);
        }

        /// <summary>
        /// SavePersonPhone to PersonPhone / PersonPhone
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public PersonPhone SavePersonPhone(DbConnector conn, PersonPhone item)
        {
            return this.PersonPhoneFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyPersonPhone to PersonPhone / PersonPhone
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public PersonPhone ApplyPersonPhone(DbConnector conn, PersonPhone item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.PersonPhoneFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemovePersonPhone to PersonPhone / PersonPhone
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemovePersonPhone(PersonPhone item)
        {
            return this.PersonPhoneFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemovePersonPhone to PersonPhone / PersonPhone
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemovePersonPhone(DbConnector conn, PersonPhone item)
        {
            return this.PersonPhoneFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities PersonPhoneList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SavePersonPhoneList(PersonPhoneList items)
        {
			return this.PersonPhoneFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
