﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// PhoneNumberType / PhoneNumberType - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class PhoneNumberType
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for PhoneNumberType
        /// </summary>
	    public PhoneNumberType()
		{
		}

		///// <summary>
        ///// Creates a new instance of PhoneNumberType
        ///// </summary>
	    //internal PhoneNumberType CreateEntity()
		//{
		//    return new PhoneNumberType();
		//}

		#region Members

		
        /// <summary>
        /// PhoneNumberTypeId / PhoneNumberType.PhoneNumberTypeID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("PhoneNumberTypeID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? PhoneNumberTypeId
        {
            get
            {
                return (int?)this["PhoneNumberTypeID"];
            }
            set
            {
                this.Add("PhoneNumberTypeID", value, typeof(int?));
            }
        }

        /// <summary>
        /// Name / PhoneNumberType.Name
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Name"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Name
        {
            get
            {
                return (string)this["Name"];
            }
            set
            {
                this.Add("Name", value, typeof(string));
            }
        }

        /// <summary>
        /// ModifiedDate / PhoneNumberType.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		

		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from PersonPhone

        /// <summary>
        /// List of sub entities PersonPhone / PersonPhone (PhoneNumberTypeID)
		/// Foreign Key FK_PersonPhone_PhoneNumberType_PhoneNumberTypeID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual PersonPhoneList PersonPhoneList
        {
            get
            {
			    // Lazy Loading
                if (_PersonPhoneList == null && this.PhoneNumberTypeId != null)
                {
					var where = new SqlWhereClause("WHERE PersonPhone.PhoneNumberTypeID = @PhoneNumberTypeID",
					    "@PhoneNumberTypeID", this.PhoneNumberTypeId);
                    _PersonPhoneList = ((AdvEntityManager)this.Manager).GetPersonPhoneList(where);
                }
				if (_PersonPhoneList == null)
				{
					_PersonPhoneList = new PersonPhoneList();
				}
                return _PersonPhoneList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private PersonPhoneList _PersonPhoneList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.PhoneNumberTypeFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "PhoneNumberType"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // PhoneNumberType

	#endregion

	#region Entity-List

    /// <summary>
    /// PhoneNumberType / PhoneNumberTypeList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class PhoneNumberTypeList
        : WebEntityList<PhoneNumberType>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "PhoneNumberType"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// PhoneNumberType - PhoneNumberType - Factory 
    /// </summary>
    public partial class PhoneNumberTypeFactory
        : WebEntityFactory<PhoneNumberType, PhoneNumberTypeList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property PhoneNumberTypeId of Db-Field PhoneNumberTypeID</summary>
        public static string Prop_PhoneNumberTypeId = "PhoneNumberTypeId";
        ///<summary>Property Name of Db-Field Name</summary>
        public static string Prop_Name = "Name";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field PhoneNumberTypeID of Property PhoneNumberTypeId</summary>
        public static string Field_PhoneNumberTypeId = "PhoneNumberTypeID";
        ///<summary>Db-Field Name of Property Name</summary>
        public static string Field_Name = "Name";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = PhoneNumberType, 
		/// Fields       = "PhoneNumberTypeID"
		/// Query        = ...
        /// </summary>
        protected PhoneNumberTypeFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Person";
            this.TableName = "PhoneNumberType";
            this.Fields = new string[]
            {
                "PhoneNumberTypeID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("PhoneNumberTypeId", "int?", "PhoneNumberTypeID", "int?", "", null);
			this.Properties.Add("Name", "string", "Name", "string", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "PhoneNumberType"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "PhoneNumberTypeList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "PhoneNumberTypeFactory"; }
            set { }
        }

		#endregion

		internal static PhoneNumberTypeFactory CreateFactory(EntityManager manager)
		{
		    return new PhoneNumberTypeFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of PhoneNumberType. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo PhoneNumberType</returns>
        public override PhoneNumberType CreateEntity()
		{
			var item = new PhoneNumberType();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}



		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public PhoneNumberType GetItem(int? phoneNumberTypeId)
        {
            return this.GetEntity(0, phoneNumberTypeId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public PhoneNumberType GetItem(DbConnector conn, int? phoneNumberTypeId)
        {
            return this.GetEntity(conn, phoneNumberTypeId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(PhoneNumberType).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to PhoneNumberTypeFactory / PhoneNumberType / PhoneNumberType.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// PhoneNumberTypeFactory to PhoneNumberType / PhoneNumberType.
        /// </summary>
        public PhoneNumberTypeFactory PhoneNumberTypeFactory
		{
			get
			{
				if (_PhoneNumberTypeFactory == null)
				{
					_PhoneNumberTypeFactory = global::AdventureWorks.PhoneNumberTypeFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_PhoneNumberTypeFactory, typeof(PhoneNumberType));
				}
				return _PhoneNumberTypeFactory;
			}
		}
		private PhoneNumberTypeFactory _PhoneNumberTypeFactory = null;
	
        /// <summary>
        /// GetPhoneNumberType to PhoneNumberType / PhoneNumberType
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public PhoneNumberType GetPhoneNumberType(int? phoneNumberTypeId)
        {
            return this.PhoneNumberTypeFactory.GetEntity(0, phoneNumberTypeId);
        }
	
        /// <summary>
        /// GetPhoneNumberType to PhoneNumberType / PhoneNumberType
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public PhoneNumberType GetPhoneNumberType(DbConnector conn, int? phoneNumberTypeId)
        {
            return this.PhoneNumberTypeFactory.GetEntity(conn, phoneNumberTypeId);
        }
	
		/// <summary>
        /// GetPhoneNumberTypeList to PhoneNumberType / PhoneNumberType
		/// Getting a list of PhoneNumberType using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public PhoneNumberTypeList GetPhoneNumberTypeList(SqlWhereClause where)
        {
            return this.PhoneNumberTypeFactory.GetEntities(where);
        }

		/// <summary>
        /// GetPhoneNumberTypeList to PhoneNumberType / PhoneNumberType
		/// Getting all entities of PhoneNumberType
        /// </summary>
        /// <returns>List of all found entities</returns>
        public PhoneNumberTypeList GetPhoneNumberTypeList()
        {
			var where = new SqlWhereClause();
            return this.PhoneNumberTypeFactory.GetEntities(where);
        }

        /// <summary>
        /// SavePhoneNumberType to PhoneNumberType / PhoneNumberType
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public PhoneNumberType SavePhoneNumberType(PhoneNumberType item)
        {
            return this.PhoneNumberTypeFactory.SaveEntity(item);
        }

        /// <summary>
        /// SavePhoneNumberType to PhoneNumberType / PhoneNumberType
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public PhoneNumberType SavePhoneNumberType(DbConnector conn, PhoneNumberType item)
        {
            return this.PhoneNumberTypeFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyPhoneNumberType to PhoneNumberType / PhoneNumberType
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public PhoneNumberType ApplyPhoneNumberType(DbConnector conn, PhoneNumberType item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.PhoneNumberTypeFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemovePhoneNumberType to PhoneNumberType / PhoneNumberType
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemovePhoneNumberType(PhoneNumberType item)
        {
            return this.PhoneNumberTypeFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemovePhoneNumberType to PhoneNumberType / PhoneNumberType
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemovePhoneNumberType(DbConnector conn, PhoneNumberType item)
        {
            return this.PhoneNumberTypeFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities PhoneNumberTypeList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SavePhoneNumberTypeList(PhoneNumberTypeList items)
        {
			return this.PhoneNumberTypeFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
