﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// Product / Product - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class Product
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for Product
        /// </summary>
	    public Product()
		{
		}

		///// <summary>
        ///// Creates a new instance of Product
        ///// </summary>
	    //internal Product CreateEntity()
		//{
		//    return new Product();
		//}

		#region Members

		
        /// <summary>
        /// ProductId / Product.ProductID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? ProductId
        {
            get
            {
                return (int?)this["ProductID"];
            }
            set
            {
                this.Add("ProductID", value, typeof(int?));
            }
        }

        /// <summary>
        /// Name / Product.Name
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Name"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Name
        {
            get
            {
                return (string)this["Name"];
            }
            set
            {
                this.Add("Name", value, typeof(string));
            }
        }

        /// <summary>
        /// ProductNumber / Product.ProductNumber
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductNumber"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string ProductNumber
        {
            get
            {
                return (string)this["ProductNumber"];
            }
            set
            {
                this.Add("ProductNumber", value, typeof(string));
            }
        }

        /// <summary>
        /// MakeFlag / Product.MakeFlag
        /// </summary>
        /// <returns>bool?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("MakeFlag"), FieldOrder(0), TypeName("bool?"), FieldTypeName("bool?"), ForeignEntity(null)]
        public virtual bool? MakeFlag
        {
            get
            {
                return (bool?)this["MakeFlag"];
            }
            set
            {
                this.Add("MakeFlag", value, typeof(bool?));
            }
        }

        /// <summary>
        /// FinishedGoodsFlag / Product.FinishedGoodsFlag
        /// </summary>
        /// <returns>bool?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("FinishedGoodsFlag"), FieldOrder(0), TypeName("bool?"), FieldTypeName("bool?"), ForeignEntity(null)]
        public virtual bool? FinishedGoodsFlag
        {
            get
            {
                return (bool?)this["FinishedGoodsFlag"];
            }
            set
            {
                this.Add("FinishedGoodsFlag", value, typeof(bool?));
            }
        }

        /// <summary>
        /// Color / Product.Color
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Color"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Color
        {
            get
            {
                return (string)this["Color"];
            }
            set
            {
                this.Add("Color", value, typeof(string));
            }
        }

        /// <summary>
        /// SafetyStockLevel / Product.SafetyStockLevel
        /// </summary>
        /// <returns>short?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("SafetyStockLevel"), FieldOrder(0), TypeName("short?"), FieldTypeName("short?"), ForeignEntity(null)]
        public virtual short? SafetyStockLevel
        {
            get
            {
                return (short?)this["SafetyStockLevel"];
            }
            set
            {
                this.Add("SafetyStockLevel", value, typeof(short?));
            }
        }

        /// <summary>
        /// ReorderPoint / Product.ReorderPoint
        /// </summary>
        /// <returns>short?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ReorderPoint"), FieldOrder(0), TypeName("short?"), FieldTypeName("short?"), ForeignEntity(null)]
        public virtual short? ReorderPoint
        {
            get
            {
                return (short?)this["ReorderPoint"];
            }
            set
            {
                this.Add("ReorderPoint", value, typeof(short?));
            }
        }

        /// <summary>
        /// StandardCost / Product.StandardCost
        /// </summary>
        /// <returns>decimal?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("StandardCost"), FieldOrder(0), TypeName("decimal?"), FieldTypeName("decimal?"), ForeignEntity(null)]
        public virtual decimal? StandardCost
        {
            get
            {
                return (decimal?)this["StandardCost"];
            }
            set
            {
                this.Add("StandardCost", value, typeof(decimal?));
            }
        }

        /// <summary>
        /// ListPrice / Product.ListPrice
        /// </summary>
        /// <returns>decimal?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ListPrice"), FieldOrder(0), TypeName("decimal?"), FieldTypeName("decimal?"), ForeignEntity(null)]
        public virtual decimal? ListPrice
        {
            get
            {
                return (decimal?)this["ListPrice"];
            }
            set
            {
                this.Add("ListPrice", value, typeof(decimal?));
            }
        }

        /// <summary>
        /// Size / Product.Size
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Size"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Size
        {
            get
            {
                return (string)this["Size"];
            }
            set
            {
                this.Add("Size", value, typeof(string));
            }
        }

        /// <summary>
        /// SizeUnitMeasureCode / Product.SizeUnitMeasureCode
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("SizeUnitMeasureCode"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity("UnitMeasure")]
        public virtual string SizeUnitMeasureCode
        {
            get
            {
                return (string)this["SizeUnitMeasureCode"];
            }
            set
            {
                this.Add("SizeUnitMeasureCode", value, typeof(string));
            }
        }

        /// <summary>
        /// WeightUnitMeasureCode / Product.WeightUnitMeasureCode
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("WeightUnitMeasureCode"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity("UnitMeasure")]
        public virtual string WeightUnitMeasureCode
        {
            get
            {
                return (string)this["WeightUnitMeasureCode"];
            }
            set
            {
                this.Add("WeightUnitMeasureCode", value, typeof(string));
            }
        }

        /// <summary>
        /// Weight / Product.Weight
        /// </summary>
        /// <returns>decimal?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Weight"), FieldOrder(0), TypeName("decimal?"), FieldTypeName("decimal?"), ForeignEntity(null)]
        public virtual decimal? Weight
        {
            get
            {
                return (decimal?)this["Weight"];
            }
            set
            {
                this.Add("Weight", value, typeof(decimal?));
            }
        }

        /// <summary>
        /// DaysToManufacture / Product.DaysToManufacture
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("DaysToManufacture"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? DaysToManufacture
        {
            get
            {
                return (int?)this["DaysToManufacture"];
            }
            set
            {
                this.Add("DaysToManufacture", value, typeof(int?));
            }
        }

        /// <summary>
        /// ProductLine / Product.ProductLine
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductLine"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string ProductLine
        {
            get
            {
                return (string)this["ProductLine"];
            }
            set
            {
                this.Add("ProductLine", value, typeof(string));
            }
        }

        /// <summary>
        /// Class / Product.Class
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Class"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Class
        {
            get
            {
                return (string)this["Class"];
            }
            set
            {
                this.Add("Class", value, typeof(string));
            }
        }

        /// <summary>
        /// Style / Product.Style
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Style"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Style
        {
            get
            {
                return (string)this["Style"];
            }
            set
            {
                this.Add("Style", value, typeof(string));
            }
        }

        /// <summary>
        /// ProductSubcategoryId / Product.ProductSubcategoryID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductSubcategoryID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("ProductSubcategory")]
        public virtual int? ProductSubcategoryId
        {
            get
            {
                return (int?)this["ProductSubcategoryID"];
            }
            set
            {
                this.Add("ProductSubcategoryID", value, typeof(int?));
            }
        }

        /// <summary>
        /// ProductModelId / Product.ProductModelID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductModelID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("ProductModel")]
        public virtual int? ProductModelId
        {
            get
            {
                return (int?)this["ProductModelID"];
            }
            set
            {
                this.Add("ProductModelID", value, typeof(int?));
            }
        }

        /// <summary>
        /// SellStartDate / Product.SellStartDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("SellStartDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? SellStartDate
        {
            get
            {
                return (DateTime?)this["SellStartDate"];
            }
            set
            {
                this.Add("SellStartDate", value, typeof(DateTime?));
            }
        }

        /// <summary>
        /// SellEndDate / Product.SellEndDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("SellEndDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? SellEndDate
        {
            get
            {
                return (DateTime?)this["SellEndDate"];
            }
            set
            {
                this.Add("SellEndDate", value, typeof(DateTime?));
            }
        }

        /// <summary>
        /// DiscontinuedDate / Product.DiscontinuedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("DiscontinuedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? DiscontinuedDate
        {
            get
            {
                return (DateTime?)this["DiscontinuedDate"];
            }
            set
            {
                this.Add("DiscontinuedDate", value, typeof(DateTime?));
            }
        }

        /// <summary>
        /// Rowguid / Product.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / Product.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to ProductModel

        /// <summary>
        /// Link to parent/super Entity ProductModel / ProductModel (this.ProductModelId)
		/// Foreign key FK_Product_ProductModel_ProductModelID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductModel ProductModel
        {
            get
            {
			    // Lazy loading
                if (this._ProductModel == null && this.ProductModelId != null)
                {
                    this._ProductModel = ((AdvEntityManager)this.Manager).GetProductModel(this.ProductModelId);
                    if (! _ProductModel.ResultInfo.IsValid)
                    {
						this._ProductModel = null; // reset value
                        throw new Exception("wrong/missed constraint from Product to ProductModel.");
                    }
                }
                return this._ProductModel;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ProductModelId = (value != null ? value.ProductModelId : null);


				// set foreign table
                this._ProductModel = value;
            }
        }
        private ProductModel _ProductModel = null;

        #endregion

        #region foreign constraint (parent entity) to ProductSubcategory

        /// <summary>
        /// Link to parent/super Entity ProductSubcategory / ProductSubcategory (this.ProductSubcategoryId)
		/// Foreign key FK_Product_ProductSubcategory_ProductSubcategoryID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductSubcategory ProductSubcategory
        {
            get
            {
			    // Lazy loading
                if (this._ProductSubcategory == null && this.ProductSubcategoryId != null)
                {
                    this._ProductSubcategory = ((AdvEntityManager)this.Manager).GetProductSubcategory(this.ProductSubcategoryId);
                    if (! _ProductSubcategory.ResultInfo.IsValid)
                    {
						this._ProductSubcategory = null; // reset value
                        throw new Exception("wrong/missed constraint from Product to ProductSubcategory.");
                    }
                }
                return this._ProductSubcategory;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ProductSubcategoryId = (value != null ? value.ProductSubcategoryId : null);


				// set foreign table
                this._ProductSubcategory = value;
            }
        }
        private ProductSubcategory _ProductSubcategory = null;

        #endregion

        #region foreign constraint (parent entity) to UnitMeasure

        /// <summary>
        /// Link to parent/super Entity UnitMeasure / UnitMeasure (this.SizeUnitMeasureCode)
		/// Foreign key FK_Product_UnitMeasure_SizeUnitMeasureCode
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual UnitMeasure UnitMeasure
        {
            get
            {
			    // Lazy loading
                if (this._UnitMeasure == null && this.SizeUnitMeasureCode != null)
                {
                    this._UnitMeasure = ((AdvEntityManager)this.Manager).GetUnitMeasure(this.SizeUnitMeasureCode);
                    if (! _UnitMeasure.ResultInfo.IsValid)
                    {
						this._UnitMeasure = null; // reset value
                        throw new Exception("wrong/missed constraint from Product to UnitMeasure.");
                    }
                }
                return this._UnitMeasure;
            }
            set
            {
                // reassign foreign key values from setter value
                this.SizeUnitMeasureCode = (value != null ? value.UnitMeasureCode : null);


				// set foreign table
                this._UnitMeasure = value;
            }
        }
        private UnitMeasure _UnitMeasure = null;

        #endregion

        #region foreign constraint (parent entity) to UnitMeasure

        /// <summary>
        /// Link to parent/super Entity UnitMeasure / UnitMeasure (this.WeightUnitMeasureCode)
		/// Foreign key FK_Product_UnitMeasure_WeightUnitMeasureCode
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual UnitMeasure UnitMeasureWeightUnitMeasureCode
        {
            get
            {
			    // Lazy loading
                if (this._UnitMeasureWeightUnitMeasureCode == null && this.WeightUnitMeasureCode != null)
                {
                    this._UnitMeasureWeightUnitMeasureCode = ((AdvEntityManager)this.Manager).GetUnitMeasure(this.WeightUnitMeasureCode);
                    if (! _UnitMeasureWeightUnitMeasureCode.ResultInfo.IsValid)
                    {
						this._UnitMeasureWeightUnitMeasureCode = null; // reset value
                        throw new Exception("wrong/missed constraint from Product to UnitMeasure.");
                    }
                }
                return this._UnitMeasureWeightUnitMeasureCode;
            }
            set
            {
                // reassign foreign key values from setter value
                this.WeightUnitMeasureCode = (value != null ? value.UnitMeasureCode : null);


				// set foreign table
                this._UnitMeasureWeightUnitMeasureCode = value;
            }
        }
        private UnitMeasure _UnitMeasureWeightUnitMeasureCode = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from BillOfMaterials

        /// <summary>
        /// List of sub entities BillOfMaterials / BillOfMaterials (ComponentID)
		/// Foreign Key FK_BillOfMaterials_Product_ComponentID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual BillOfMaterialsList BillOfMaterialsList
        {
            get
            {
			    // Lazy Loading
                if (_BillOfMaterialsList == null && this.ProductId != null)
                {
					var where = new SqlWhereClause("WHERE BillOfMaterials.ComponentID = @ComponentID",
					    "@ComponentID", this.ProductId);
                    _BillOfMaterialsList = ((AdvEntityManager)this.Manager).GetBillOfMaterialsList(where);
                }
				if (_BillOfMaterialsList == null)
				{
					_BillOfMaterialsList = new BillOfMaterialsList();
				}
                return _BillOfMaterialsList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private BillOfMaterialsList _BillOfMaterialsList = null;

        #endregion

        #region Sub Entites from BillOfMaterials

        /// <summary>
        /// List of sub entities BillOfMaterials / BillOfMaterials (ProductAssemblyID)
		/// Foreign Key FK_BillOfMaterials_Product_ProductAssemblyID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual BillOfMaterialsList BillOfMaterialsProductAssemblyIdList
        {
            get
            {
			    // Lazy Loading
                if (_BillOfMaterialsProductAssemblyIdList == null && this.ProductId != null)
                {
					var where = new SqlWhereClause("WHERE BillOfMaterials.ProductAssemblyID = @ProductAssemblyID",
					    "@ProductAssemblyID", this.ProductId);
                    _BillOfMaterialsProductAssemblyIdList = ((AdvEntityManager)this.Manager).GetBillOfMaterialsList(where);
                }
				if (_BillOfMaterialsProductAssemblyIdList == null)
				{
					_BillOfMaterialsProductAssemblyIdList = new BillOfMaterialsList();
				}
                return _BillOfMaterialsProductAssemblyIdList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private BillOfMaterialsList _BillOfMaterialsProductAssemblyIdList = null;

        #endregion

        #region Sub Entites from ProductCostHistory

        /// <summary>
        /// List of sub entities ProductCostHistory / ProductCostHistory (ProductID)
		/// Foreign Key FK_ProductCostHistory_Product_ProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductCostHistoryList ProductCostHistoryList
        {
            get
            {
			    // Lazy Loading
                if (_ProductCostHistoryList == null && this.ProductId != null)
                {
					var where = new SqlWhereClause("WHERE ProductCostHistory.ProductID = @ProductID",
					    "@ProductID", this.ProductId);
                    _ProductCostHistoryList = ((AdvEntityManager)this.Manager).GetProductCostHistoryList(where);
                }
				if (_ProductCostHistoryList == null)
				{
					_ProductCostHistoryList = new ProductCostHistoryList();
				}
                return _ProductCostHistoryList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductCostHistoryList _ProductCostHistoryList = null;

        #endregion

        #region Sub Entites from ProductDocument

        /// <summary>
        /// List of sub entities ProductDocument / ProductDocument (ProductID)
		/// Foreign Key FK_ProductDocument_Product_ProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductDocumentList ProductDocumentList
        {
            get
            {
			    // Lazy Loading
                if (_ProductDocumentList == null && this.ProductId != null)
                {
					var where = new SqlWhereClause("WHERE ProductDocument.ProductID = @ProductID",
					    "@ProductID", this.ProductId);
                    _ProductDocumentList = ((AdvEntityManager)this.Manager).GetProductDocumentList(where);
                }
				if (_ProductDocumentList == null)
				{
					_ProductDocumentList = new ProductDocumentList();
				}
                return _ProductDocumentList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductDocumentList _ProductDocumentList = null;

        #endregion

        #region Sub Entites from ProductInventory

        /// <summary>
        /// List of sub entities ProductInventory / ProductInventory (ProductID)
		/// Foreign Key FK_ProductInventory_Product_ProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductInventoryList ProductInventoryList
        {
            get
            {
			    // Lazy Loading
                if (_ProductInventoryList == null && this.ProductId != null)
                {
					var where = new SqlWhereClause("WHERE ProductInventory.ProductID = @ProductID",
					    "@ProductID", this.ProductId);
                    _ProductInventoryList = ((AdvEntityManager)this.Manager).GetProductInventoryList(where);
                }
				if (_ProductInventoryList == null)
				{
					_ProductInventoryList = new ProductInventoryList();
				}
                return _ProductInventoryList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductInventoryList _ProductInventoryList = null;

        #endregion

        #region Sub Entites from ProductListPriceHistory

        /// <summary>
        /// List of sub entities ProductListPriceHistory / ProductListPriceHistory (ProductID)
		/// Foreign Key FK_ProductListPriceHistory_Product_ProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductListPriceHistoryList ProductListPriceHistoryList
        {
            get
            {
			    // Lazy Loading
                if (_ProductListPriceHistoryList == null && this.ProductId != null)
                {
					var where = new SqlWhereClause("WHERE ProductListPriceHistory.ProductID = @ProductID",
					    "@ProductID", this.ProductId);
                    _ProductListPriceHistoryList = ((AdvEntityManager)this.Manager).GetProductListPriceHistoryList(where);
                }
				if (_ProductListPriceHistoryList == null)
				{
					_ProductListPriceHistoryList = new ProductListPriceHistoryList();
				}
                return _ProductListPriceHistoryList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductListPriceHistoryList _ProductListPriceHistoryList = null;

        #endregion

        #region Sub Entites from ProductProductPhoto

        /// <summary>
        /// List of sub entities ProductProductPhoto / ProductProductPhoto (ProductID)
		/// Foreign Key FK_ProductProductPhoto_Product_ProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductProductPhotoList ProductProductPhotoList
        {
            get
            {
			    // Lazy Loading
                if (_ProductProductPhotoList == null && this.ProductId != null)
                {
					var where = new SqlWhereClause("WHERE ProductProductPhoto.ProductID = @ProductID",
					    "@ProductID", this.ProductId);
                    _ProductProductPhotoList = ((AdvEntityManager)this.Manager).GetProductProductPhotoList(where);
                }
				if (_ProductProductPhotoList == null)
				{
					_ProductProductPhotoList = new ProductProductPhotoList();
				}
                return _ProductProductPhotoList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductProductPhotoList _ProductProductPhotoList = null;

        #endregion

        #region Sub Entites from ProductReview

        /// <summary>
        /// List of sub entities ProductReview / ProductReview (ProductID)
		/// Foreign Key FK_ProductReview_Product_ProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductReviewList ProductReviewList
        {
            get
            {
			    // Lazy Loading
                if (_ProductReviewList == null && this.ProductId != null)
                {
					var where = new SqlWhereClause("WHERE ProductReview.ProductID = @ProductID",
					    "@ProductID", this.ProductId);
                    _ProductReviewList = ((AdvEntityManager)this.Manager).GetProductReviewList(where);
                }
				if (_ProductReviewList == null)
				{
					_ProductReviewList = new ProductReviewList();
				}
                return _ProductReviewList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductReviewList _ProductReviewList = null;

        #endregion

        #region Sub Entites from ProductVendor

        /// <summary>
        /// List of sub entities ProductVendor / ProductVendor (ProductID)
		/// Foreign Key FK_ProductVendor_Product_ProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductVendorList ProductVendorList
        {
            get
            {
			    // Lazy Loading
                if (_ProductVendorList == null && this.ProductId != null)
                {
					var where = new SqlWhereClause("WHERE ProductVendor.ProductID = @ProductID",
					    "@ProductID", this.ProductId);
                    _ProductVendorList = ((AdvEntityManager)this.Manager).GetProductVendorList(where);
                }
				if (_ProductVendorList == null)
				{
					_ProductVendorList = new ProductVendorList();
				}
                return _ProductVendorList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductVendorList _ProductVendorList = null;

        #endregion

        #region Sub Entites from PurchaseOrderDetail

        /// <summary>
        /// List of sub entities PurchaseOrderDetail / PurchaseOrderDetail (ProductID)
		/// Foreign Key FK_PurchaseOrderDetail_Product_ProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual PurchaseOrderDetailList PurchaseOrderDetailList
        {
            get
            {
			    // Lazy Loading
                if (_PurchaseOrderDetailList == null && this.ProductId != null)
                {
					var where = new SqlWhereClause("WHERE PurchaseOrderDetail.ProductID = @ProductID",
					    "@ProductID", this.ProductId);
                    _PurchaseOrderDetailList = ((AdvEntityManager)this.Manager).GetPurchaseOrderDetailList(where);
                }
				if (_PurchaseOrderDetailList == null)
				{
					_PurchaseOrderDetailList = new PurchaseOrderDetailList();
				}
                return _PurchaseOrderDetailList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private PurchaseOrderDetailList _PurchaseOrderDetailList = null;

        #endregion

        #region Sub Entites from ShoppingCartItem

        /// <summary>
        /// List of sub entities ShoppingCartItem / ShoppingCartItem (ProductID)
		/// Foreign Key FK_ShoppingCartItem_Product_ProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ShoppingCartItemList ShoppingCartItemList
        {
            get
            {
			    // Lazy Loading
                if (_ShoppingCartItemList == null && this.ProductId != null)
                {
					var where = new SqlWhereClause("WHERE ShoppingCartItem.ProductID = @ProductID",
					    "@ProductID", this.ProductId);
                    _ShoppingCartItemList = ((AdvEntityManager)this.Manager).GetShoppingCartItemList(where);
                }
				if (_ShoppingCartItemList == null)
				{
					_ShoppingCartItemList = new ShoppingCartItemList();
				}
                return _ShoppingCartItemList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ShoppingCartItemList _ShoppingCartItemList = null;

        #endregion

        #region Sub Entites from SpecialOfferProduct

        /// <summary>
        /// List of sub entities SpecialOfferProduct / SpecialOfferProduct (ProductID)
		/// Foreign Key FK_SpecialOfferProduct_Product_ProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SpecialOfferProductList SpecialOfferProductList
        {
            get
            {
			    // Lazy Loading
                if (_SpecialOfferProductList == null && this.ProductId != null)
                {
					var where = new SqlWhereClause("WHERE SpecialOfferProduct.ProductID = @ProductID",
					    "@ProductID", this.ProductId);
                    _SpecialOfferProductList = ((AdvEntityManager)this.Manager).GetSpecialOfferProductList(where);
                }
				if (_SpecialOfferProductList == null)
				{
					_SpecialOfferProductList = new SpecialOfferProductList();
				}
                return _SpecialOfferProductList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private SpecialOfferProductList _SpecialOfferProductList = null;

        #endregion

        #region Sub Entites from TransactionHistory

        /// <summary>
        /// List of sub entities TransactionHistory / TransactionHistory (ProductID)
		/// Foreign Key FK_TransactionHistory_Product_ProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual TransactionHistoryList TransactionHistoryList
        {
            get
            {
			    // Lazy Loading
                if (_TransactionHistoryList == null && this.ProductId != null)
                {
					var where = new SqlWhereClause("WHERE TransactionHistory.ProductID = @ProductID",
					    "@ProductID", this.ProductId);
                    _TransactionHistoryList = ((AdvEntityManager)this.Manager).GetTransactionHistoryList(where);
                }
				if (_TransactionHistoryList == null)
				{
					_TransactionHistoryList = new TransactionHistoryList();
				}
                return _TransactionHistoryList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private TransactionHistoryList _TransactionHistoryList = null;

        #endregion

        #region Sub Entites from WorkOrder

        /// <summary>
        /// List of sub entities WorkOrder / WorkOrder (ProductID)
		/// Foreign Key FK_WorkOrder_Product_ProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual WorkOrderList WorkOrderList
        {
            get
            {
			    // Lazy Loading
                if (_WorkOrderList == null && this.ProductId != null)
                {
					var where = new SqlWhereClause("WHERE WorkOrder.ProductID = @ProductID",
					    "@ProductID", this.ProductId);
                    _WorkOrderList = ((AdvEntityManager)this.Manager).GetWorkOrderList(where);
                }
				if (_WorkOrderList == null)
				{
					_WorkOrderList = new WorkOrderList();
				}
                return _WorkOrderList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private WorkOrderList _WorkOrderList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.ProductFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Product"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // Product

	#endregion

	#region Entity-List

    /// <summary>
    /// Product / ProductList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductList
        : WebEntityList<Product>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Product"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// Product - Product - Factory 
    /// </summary>
    public partial class ProductFactory
        : WebEntityFactory<Product, ProductList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property ProductId of Db-Field ProductID</summary>
        public static string Prop_ProductId = "ProductId";
        ///<summary>Property Name of Db-Field Name</summary>
        public static string Prop_Name = "Name";
        ///<summary>Property ProductNumber of Db-Field ProductNumber</summary>
        public static string Prop_ProductNumber = "ProductNumber";
        ///<summary>Property MakeFlag of Db-Field MakeFlag</summary>
        public static string Prop_MakeFlag = "MakeFlag";
        ///<summary>Property FinishedGoodsFlag of Db-Field FinishedGoodsFlag</summary>
        public static string Prop_FinishedGoodsFlag = "FinishedGoodsFlag";
        ///<summary>Property Color of Db-Field Color</summary>
        public static string Prop_Color = "Color";
        ///<summary>Property SafetyStockLevel of Db-Field SafetyStockLevel</summary>
        public static string Prop_SafetyStockLevel = "SafetyStockLevel";
        ///<summary>Property ReorderPoint of Db-Field ReorderPoint</summary>
        public static string Prop_ReorderPoint = "ReorderPoint";
        ///<summary>Property StandardCost of Db-Field StandardCost</summary>
        public static string Prop_StandardCost = "StandardCost";
        ///<summary>Property ListPrice of Db-Field ListPrice</summary>
        public static string Prop_ListPrice = "ListPrice";
        ///<summary>Property Size of Db-Field Size</summary>
        public static string Prop_Size = "Size";
        ///<summary>Property SizeUnitMeasureCode of Db-Field SizeUnitMeasureCode</summary>
        public static string Prop_SizeUnitMeasureCode = "SizeUnitMeasureCode";
        ///<summary>Property WeightUnitMeasureCode of Db-Field WeightUnitMeasureCode</summary>
        public static string Prop_WeightUnitMeasureCode = "WeightUnitMeasureCode";
        ///<summary>Property Weight of Db-Field Weight</summary>
        public static string Prop_Weight = "Weight";
        ///<summary>Property DaysToManufacture of Db-Field DaysToManufacture</summary>
        public static string Prop_DaysToManufacture = "DaysToManufacture";
        ///<summary>Property ProductLine of Db-Field ProductLine</summary>
        public static string Prop_ProductLine = "ProductLine";
        ///<summary>Property Class of Db-Field Class</summary>
        public static string Prop_Class = "Class";
        ///<summary>Property Style of Db-Field Style</summary>
        public static string Prop_Style = "Style";
        ///<summary>Property ProductSubcategoryId of Db-Field ProductSubcategoryID</summary>
        public static string Prop_ProductSubcategoryId = "ProductSubcategoryId";
        ///<summary>Property ProductModelId of Db-Field ProductModelID</summary>
        public static string Prop_ProductModelId = "ProductModelId";
        ///<summary>Property SellStartDate of Db-Field SellStartDate</summary>
        public static string Prop_SellStartDate = "SellStartDate";
        ///<summary>Property SellEndDate of Db-Field SellEndDate</summary>
        public static string Prop_SellEndDate = "SellEndDate";
        ///<summary>Property DiscontinuedDate of Db-Field DiscontinuedDate</summary>
        public static string Prop_DiscontinuedDate = "DiscontinuedDate";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field ProductID of Property ProductId</summary>
        public static string Field_ProductId = "ProductID";
        ///<summary>Db-Field Name of Property Name</summary>
        public static string Field_Name = "Name";
        ///<summary>Db-Field ProductNumber of Property ProductNumber</summary>
        public static string Field_ProductNumber = "ProductNumber";
        ///<summary>Db-Field MakeFlag of Property MakeFlag</summary>
        public static string Field_MakeFlag = "MakeFlag";
        ///<summary>Db-Field FinishedGoodsFlag of Property FinishedGoodsFlag</summary>
        public static string Field_FinishedGoodsFlag = "FinishedGoodsFlag";
        ///<summary>Db-Field Color of Property Color</summary>
        public static string Field_Color = "Color";
        ///<summary>Db-Field SafetyStockLevel of Property SafetyStockLevel</summary>
        public static string Field_SafetyStockLevel = "SafetyStockLevel";
        ///<summary>Db-Field ReorderPoint of Property ReorderPoint</summary>
        public static string Field_ReorderPoint = "ReorderPoint";
        ///<summary>Db-Field StandardCost of Property StandardCost</summary>
        public static string Field_StandardCost = "StandardCost";
        ///<summary>Db-Field ListPrice of Property ListPrice</summary>
        public static string Field_ListPrice = "ListPrice";
        ///<summary>Db-Field Size of Property Size</summary>
        public static string Field_Size = "Size";
        ///<summary>Db-Field SizeUnitMeasureCode of Property SizeUnitMeasureCode</summary>
        public static string Field_SizeUnitMeasureCode = "SizeUnitMeasureCode";
        ///<summary>Db-Field WeightUnitMeasureCode of Property WeightUnitMeasureCode</summary>
        public static string Field_WeightUnitMeasureCode = "WeightUnitMeasureCode";
        ///<summary>Db-Field Weight of Property Weight</summary>
        public static string Field_Weight = "Weight";
        ///<summary>Db-Field DaysToManufacture of Property DaysToManufacture</summary>
        public static string Field_DaysToManufacture = "DaysToManufacture";
        ///<summary>Db-Field ProductLine of Property ProductLine</summary>
        public static string Field_ProductLine = "ProductLine";
        ///<summary>Db-Field Class of Property Class</summary>
        public static string Field_Class = "Class";
        ///<summary>Db-Field Style of Property Style</summary>
        public static string Field_Style = "Style";
        ///<summary>Db-Field ProductSubcategoryID of Property ProductSubcategoryId</summary>
        public static string Field_ProductSubcategoryId = "ProductSubcategoryID";
        ///<summary>Db-Field ProductModelID of Property ProductModelId</summary>
        public static string Field_ProductModelId = "ProductModelID";
        ///<summary>Db-Field SellStartDate of Property SellStartDate</summary>
        public static string Field_SellStartDate = "SellStartDate";
        ///<summary>Db-Field SellEndDate of Property SellEndDate</summary>
        public static string Field_SellEndDate = "SellEndDate";
        ///<summary>Db-Field DiscontinuedDate of Property DiscontinuedDate</summary>
        public static string Field_DiscontinuedDate = "DiscontinuedDate";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = Product, 
		/// Fields       = "ProductID"
		/// Query        = ...
        /// </summary>
        protected ProductFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "Product";
            this.Fields = new string[]
            {
                "ProductID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("ProductId", "int?", "ProductID", "int?", "", null);
			this.Properties.Add("Name", "string", "Name", "string", "", null);
			this.Properties.Add("ProductNumber", "string", "ProductNumber", "string", "", null);
			this.Properties.Add("MakeFlag", "bool?", "MakeFlag", "bool?", "", null);
			this.Properties.Add("FinishedGoodsFlag", "bool?", "FinishedGoodsFlag", "bool?", "", null);
			this.Properties.Add("Color", "string", "Color", "string", "", null);
			this.Properties.Add("SafetyStockLevel", "short?", "SafetyStockLevel", "short?", "", null);
			this.Properties.Add("ReorderPoint", "short?", "ReorderPoint", "short?", "", null);
			this.Properties.Add("StandardCost", "decimal?", "StandardCost", "decimal?", "", null);
			this.Properties.Add("ListPrice", "decimal?", "ListPrice", "decimal?", "", null);
			this.Properties.Add("Size", "string", "Size", "string", "", null);
			this.Properties.Add("SizeUnitMeasureCode", "string", "SizeUnitMeasureCode", "string", "", "UnitMeasure");
			this.Properties.Add("WeightUnitMeasureCode", "string", "WeightUnitMeasureCode", "string", "", "UnitMeasure");
			this.Properties.Add("Weight", "decimal?", "Weight", "decimal?", "", null);
			this.Properties.Add("DaysToManufacture", "int?", "DaysToManufacture", "int?", "", null);
			this.Properties.Add("ProductLine", "string", "ProductLine", "string", "", null);
			this.Properties.Add("Class", "string", "Class", "string", "", null);
			this.Properties.Add("Style", "string", "Style", "string", "", null);
			this.Properties.Add("ProductSubcategoryId", "int?", "ProductSubcategoryID", "int?", "", "ProductSubcategory");
			this.Properties.Add("ProductModelId", "int?", "ProductModelID", "int?", "", "ProductModel");
			this.Properties.Add("SellStartDate", "DateTime?", "SellStartDate", "DateTime?", "", null);
			this.Properties.Add("SellEndDate", "DateTime?", "SellEndDate", "DateTime?", "", null);
			this.Properties.Add("DiscontinuedDate", "DateTime?", "DiscontinuedDate", "DateTime?", "", null);
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "Product"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "ProductList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "ProductFactory"; }
            set { }
        }

		#endregion

		internal static ProductFactory CreateFactory(EntityManager manager)
		{
		    return new ProductFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of Product. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo Product</returns>
        public override Product CreateEntity()
		{
			var item = new Product();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(Product item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity ProductModel / ProductModel
            // Foreign Key FK_Product_ProductModel_ProductModelID
            if (parent is ProductModel)
            {
                item.ProductModel = (ProductModel)parent;
                return;
            }

            // make relation to parent/super Entity ProductSubcategory / ProductSubcategory
            // Foreign Key FK_Product_ProductSubcategory_ProductSubcategoryID
            if (parent is ProductSubcategory)
            {
                item.ProductSubcategory = (ProductSubcategory)parent;
                return;
            }

            // make relation to parent/super Entity UnitMeasure / UnitMeasure
            // Foreign Key FK_Product_UnitMeasure_SizeUnitMeasureCode
            if (parent is UnitMeasure)
            {
                item.UnitMeasure = (UnitMeasure)parent;
                return;
            }

            // make relation to parent/super Entity UnitMeasure / UnitMeasure
            // Foreign Key FK_Product_UnitMeasure_WeightUnitMeasureCode
            if (parent is UnitMeasure)
            {
                item.UnitMeasure = (UnitMeasure)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public Product GetItem(int? productId)
        {
            return this.GetEntity(0, productId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public Product GetItem(DbConnector conn, int? productId)
        {
            return this.GetEntity(conn, productId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(Product).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to ProductFactory / Product / Product.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// ProductFactory to Product / Product.
        /// </summary>
        public ProductFactory ProductFactory
		{
			get
			{
				if (_ProductFactory == null)
				{
					_ProductFactory = global::AdventureWorks.ProductFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_ProductFactory, typeof(Product));
				}
				return _ProductFactory;
			}
		}
		private ProductFactory _ProductFactory = null;
	
        /// <summary>
        /// GetProduct to Product / Product
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public Product GetProduct(int? productId)
        {
            return this.ProductFactory.GetEntity(0, productId);
        }
	
        /// <summary>
        /// GetProduct to Product / Product
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Product GetProduct(DbConnector conn, int? productId)
        {
            return this.ProductFactory.GetEntity(conn, productId);
        }
	
		/// <summary>
        /// GetProductList to Product / Product
		/// Getting a list of Product using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public ProductList GetProductList(SqlWhereClause where)
        {
            return this.ProductFactory.GetEntities(where);
        }

		/// <summary>
        /// GetProductList to Product / Product
		/// Getting all entities of Product
        /// </summary>
        /// <returns>List of all found entities</returns>
        public ProductList GetProductList()
        {
			var where = new SqlWhereClause();
            return this.ProductFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveProduct to Product / Product
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Product SaveProduct(Product item)
        {
            return this.ProductFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveProduct to Product / Product
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Product SaveProduct(DbConnector conn, Product item)
        {
            return this.ProductFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyProduct to Product / Product
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Product ApplyProduct(DbConnector conn, Product item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.ProductFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveProduct to Product / Product
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProduct(Product item)
        {
            return this.ProductFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveProduct to Product / Product
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProduct(DbConnector conn, Product item)
        {
            return this.ProductFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities ProductList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveProductList(ProductList items)
        {
			return this.ProductFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
