﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// ProductDocument / ProductDocument - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductDocument
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for ProductDocument
        /// </summary>
	    public ProductDocument()
		{
		}

		///// <summary>
        ///// Creates a new instance of ProductDocument
        ///// </summary>
	    //internal ProductDocument CreateEntity()
		//{
		//    return new ProductDocument();
		//}

		#region Members

		
        /// <summary>
        /// ProductId / ProductDocument.ProductID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Product")]
        public virtual int? ProductId
        {
            get
            {
                return (int?)this["ProductID"];
            }
            set
            {
                this.Add("ProductID", value, typeof(int?));
            }
        }

        /// <summary>
        /// DocumentNode / ProductDocument.DocumentNode
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("DocumentNode"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity("Document")]
        public virtual string DocumentNode
        {
            get
            {
                return (string)this["DocumentNode"];
            }
            set
            {
                this.Add("DocumentNode", value, typeof(string));
            }
        }

        /// <summary>
        /// ModifiedDate / ProductDocument.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Document

        /// <summary>
        /// Link to parent/super Entity Document / Document (this.DocumentNode)
		/// Foreign key FK_ProductDocument_Document_DocumentNode
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Document Document
        {
            get
            {
			    // Lazy loading
                if (this._Document == null && this.DocumentNode != null)
                {
                    this._Document = ((AdvEntityManager)this.Manager).GetDocument(this.DocumentNode);
                    if (! _Document.ResultInfo.IsValid)
                    {
						this._Document = null; // reset value
                        throw new Exception("wrong/missed constraint from ProductDocument to Document.");
                    }
                }
                return this._Document;
            }
            set
            {
                // reassign foreign key values from setter value
                this.DocumentNode = (value != null ? value.DocumentNode : null);


				// set foreign table
                this._Document = value;
            }
        }
        private Document _Document = null;

        #endregion

        #region foreign constraint (parent entity) to Product

        /// <summary>
        /// Link to parent/super Entity Product / Product (this.ProductId)
		/// Foreign key FK_ProductDocument_Product_ProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Product Product
        {
            get
            {
			    // Lazy loading
                if (this._Product == null && this.ProductId != null)
                {
                    this._Product = ((AdvEntityManager)this.Manager).GetProduct(this.ProductId);
                    if (! _Product.ResultInfo.IsValid)
                    {
						this._Product = null; // reset value
                        throw new Exception("wrong/missed constraint from ProductDocument to Product.");
                    }
                }
                return this._Product;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ProductId = (value != null ? value.ProductId : null);


				// set foreign table
                this._Product = value;
            }
        }
        private Product _Product = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.ProductDocumentFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductDocument"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // ProductDocument

	#endregion

	#region Entity-List

    /// <summary>
    /// ProductDocument / ProductDocumentList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductDocumentList
        : WebEntityList<ProductDocument>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductDocument"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// ProductDocument - ProductDocument - Factory 
    /// </summary>
    public partial class ProductDocumentFactory
        : WebEntityFactory<ProductDocument, ProductDocumentList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property ProductId of Db-Field ProductID</summary>
        public static string Prop_ProductId = "ProductId";
        ///<summary>Property DocumentNode of Db-Field DocumentNode</summary>
        public static string Prop_DocumentNode = "DocumentNode";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field ProductID of Property ProductId</summary>
        public static string Field_ProductId = "ProductID";
        ///<summary>Db-Field DocumentNode of Property DocumentNode</summary>
        public static string Field_DocumentNode = "DocumentNode";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = ProductDocument, 
		/// Fields       = "ProductID", "DocumentNode"
		/// Query        = ...
        /// </summary>
        protected ProductDocumentFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "ProductDocument";
            this.Fields = new string[]
            {
                "ProductID", "DocumentNode"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("ProductId", "int?", "ProductID", "int?", "", "Product");
			this.Properties.Add("DocumentNode", "string", "DocumentNode", "string", "", "Document");
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "ProductDocument"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "ProductDocumentList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "ProductDocumentFactory"; }
            set { }
        }

		#endregion

		internal static ProductDocumentFactory CreateFactory(EntityManager manager)
		{
		    return new ProductDocumentFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of ProductDocument. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo ProductDocument</returns>
        public override ProductDocument CreateEntity()
		{
			var item = new ProductDocument();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(ProductDocument item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Document / Document
            // Foreign Key FK_ProductDocument_Document_DocumentNode
            if (parent is Document)
            {
                item.Document = (Document)parent;
                return;
            }

            // make relation to parent/super Entity Product / Product
            // Foreign Key FK_ProductDocument_Product_ProductID
            if (parent is Product)
            {
                item.Product = (Product)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public ProductDocument GetItem(int? productId, string documentNode)
        {
            return this.GetEntity(0, productId, documentNode);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public ProductDocument GetItem(DbConnector conn, int? productId, string documentNode)
        {
            return this.GetEntity(conn, productId, documentNode);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(ProductDocument).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to ProductDocumentFactory / ProductDocument / ProductDocument.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// ProductDocumentFactory to ProductDocument / ProductDocument.
        /// </summary>
        public ProductDocumentFactory ProductDocumentFactory
		{
			get
			{
				if (_ProductDocumentFactory == null)
				{
					_ProductDocumentFactory = global::AdventureWorks.ProductDocumentFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_ProductDocumentFactory, typeof(ProductDocument));
				}
				return _ProductDocumentFactory;
			}
		}
		private ProductDocumentFactory _ProductDocumentFactory = null;
	
        /// <summary>
        /// GetProductDocument to ProductDocument / ProductDocument
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductDocument GetProductDocument(int? productId, string documentNode)
        {
            return this.ProductDocumentFactory.GetEntity(0, productId, documentNode);
        }
	
        /// <summary>
        /// GetProductDocument to ProductDocument / ProductDocument
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductDocument GetProductDocument(DbConnector conn, int? productId, string documentNode)
        {
            return this.ProductDocumentFactory.GetEntity(conn, productId, documentNode);
        }
	
		/// <summary>
        /// GetProductDocumentList to ProductDocument / ProductDocument
		/// Getting a list of ProductDocument using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public ProductDocumentList GetProductDocumentList(SqlWhereClause where)
        {
            return this.ProductDocumentFactory.GetEntities(where);
        }

		/// <summary>
        /// GetProductDocumentList to ProductDocument / ProductDocument
		/// Getting all entities of ProductDocument
        /// </summary>
        /// <returns>List of all found entities</returns>
        public ProductDocumentList GetProductDocumentList()
        {
			var where = new SqlWhereClause();
            return this.ProductDocumentFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveProductDocument to ProductDocument / ProductDocument
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductDocument SaveProductDocument(ProductDocument item)
        {
            return this.ProductDocumentFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveProductDocument to ProductDocument / ProductDocument
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductDocument SaveProductDocument(DbConnector conn, ProductDocument item)
        {
            return this.ProductDocumentFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyProductDocument to ProductDocument / ProductDocument
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductDocument ApplyProductDocument(DbConnector conn, ProductDocument item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.ProductDocumentFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveProductDocument to ProductDocument / ProductDocument
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductDocument(ProductDocument item)
        {
            return this.ProductDocumentFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveProductDocument to ProductDocument / ProductDocument
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductDocument(DbConnector conn, ProductDocument item)
        {
            return this.ProductDocumentFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities ProductDocumentList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveProductDocumentList(ProductDocumentList items)
        {
			return this.ProductDocumentFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
