﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// ProductInventory / ProductInventory - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductInventory
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for ProductInventory
        /// </summary>
	    public ProductInventory()
		{
		}

		///// <summary>
        ///// Creates a new instance of ProductInventory
        ///// </summary>
	    //internal ProductInventory CreateEntity()
		//{
		//    return new ProductInventory();
		//}

		#region Members

		
        /// <summary>
        /// ProductId / ProductInventory.ProductID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Product")]
        public virtual int? ProductId
        {
            get
            {
                return (int?)this["ProductID"];
            }
            set
            {
                this.Add("ProductID", value, typeof(int?));
            }
        }

        /// <summary>
        /// LocationId / ProductInventory.LocationID
        /// </summary>
        /// <returns>short?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("LocationID"), FieldOrder(0), TypeName("short?"), FieldTypeName("short?"), ForeignEntity("Location")]
        public virtual short? LocationId
        {
            get
            {
                return (short?)this["LocationID"];
            }
            set
            {
                this.Add("LocationID", value, typeof(short?));
            }
        }

        /// <summary>
        /// Shelf / ProductInventory.Shelf
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Shelf"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Shelf
        {
            get
            {
                return (string)this["Shelf"];
            }
            set
            {
                this.Add("Shelf", value, typeof(string));
            }
        }

        /// <summary>
        /// Bin / ProductInventory.Bin
        /// </summary>
        /// <returns>byte?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Bin"), FieldOrder(0), TypeName("byte?"), FieldTypeName("byte?"), ForeignEntity(null)]
        public virtual byte? Bin
        {
            get
            {
                return (byte?)this["Bin"];
            }
            set
            {
                this.Add("Bin", value, typeof(byte?));
            }
        }

        /// <summary>
        /// Quantity / ProductInventory.Quantity
        /// </summary>
        /// <returns>short?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Quantity"), FieldOrder(0), TypeName("short?"), FieldTypeName("short?"), ForeignEntity(null)]
        public virtual short? Quantity
        {
            get
            {
                return (short?)this["Quantity"];
            }
            set
            {
                this.Add("Quantity", value, typeof(short?));
            }
        }

        /// <summary>
        /// Rowguid / ProductInventory.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / ProductInventory.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Location

        /// <summary>
        /// Link to parent/super Entity Location / Location (this.LocationId)
		/// Foreign key FK_ProductInventory_Location_LocationID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Location Location
        {
            get
            {
			    // Lazy loading
                if (this._Location == null && this.LocationId != null)
                {
                    this._Location = ((AdvEntityManager)this.Manager).GetLocation(this.LocationId);
                    if (! _Location.ResultInfo.IsValid)
                    {
						this._Location = null; // reset value
                        throw new Exception("wrong/missed constraint from ProductInventory to Location.");
                    }
                }
                return this._Location;
            }
            set
            {
                // reassign foreign key values from setter value
                this.LocationId = (value != null ? value.LocationId : null);


				// set foreign table
                this._Location = value;
            }
        }
        private Location _Location = null;

        #endregion

        #region foreign constraint (parent entity) to Product

        /// <summary>
        /// Link to parent/super Entity Product / Product (this.ProductId)
		/// Foreign key FK_ProductInventory_Product_ProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Product Product
        {
            get
            {
			    // Lazy loading
                if (this._Product == null && this.ProductId != null)
                {
                    this._Product = ((AdvEntityManager)this.Manager).GetProduct(this.ProductId);
                    if (! _Product.ResultInfo.IsValid)
                    {
						this._Product = null; // reset value
                        throw new Exception("wrong/missed constraint from ProductInventory to Product.");
                    }
                }
                return this._Product;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ProductId = (value != null ? value.ProductId : null);


				// set foreign table
                this._Product = value;
            }
        }
        private Product _Product = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.ProductInventoryFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductInventory"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // ProductInventory

	#endregion

	#region Entity-List

    /// <summary>
    /// ProductInventory / ProductInventoryList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductInventoryList
        : WebEntityList<ProductInventory>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductInventory"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// ProductInventory - ProductInventory - Factory 
    /// </summary>
    public partial class ProductInventoryFactory
        : WebEntityFactory<ProductInventory, ProductInventoryList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property ProductId of Db-Field ProductID</summary>
        public static string Prop_ProductId = "ProductId";
        ///<summary>Property LocationId of Db-Field LocationID</summary>
        public static string Prop_LocationId = "LocationId";
        ///<summary>Property Shelf of Db-Field Shelf</summary>
        public static string Prop_Shelf = "Shelf";
        ///<summary>Property Bin of Db-Field Bin</summary>
        public static string Prop_Bin = "Bin";
        ///<summary>Property Quantity of Db-Field Quantity</summary>
        public static string Prop_Quantity = "Quantity";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field ProductID of Property ProductId</summary>
        public static string Field_ProductId = "ProductID";
        ///<summary>Db-Field LocationID of Property LocationId</summary>
        public static string Field_LocationId = "LocationID";
        ///<summary>Db-Field Shelf of Property Shelf</summary>
        public static string Field_Shelf = "Shelf";
        ///<summary>Db-Field Bin of Property Bin</summary>
        public static string Field_Bin = "Bin";
        ///<summary>Db-Field Quantity of Property Quantity</summary>
        public static string Field_Quantity = "Quantity";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = ProductInventory, 
		/// Fields       = "ProductID", "LocationID"
		/// Query        = ...
        /// </summary>
        protected ProductInventoryFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "ProductInventory";
            this.Fields = new string[]
            {
                "ProductID", "LocationID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("ProductId", "int?", "ProductID", "int?", "", "Product");
			this.Properties.Add("LocationId", "short?", "LocationID", "short?", "", "Location");
			this.Properties.Add("Shelf", "string", "Shelf", "string", "", null);
			this.Properties.Add("Bin", "byte?", "Bin", "byte?", "", null);
			this.Properties.Add("Quantity", "short?", "Quantity", "short?", "", null);
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "ProductInventory"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "ProductInventoryList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "ProductInventoryFactory"; }
            set { }
        }

		#endregion

		internal static ProductInventoryFactory CreateFactory(EntityManager manager)
		{
		    return new ProductInventoryFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of ProductInventory. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo ProductInventory</returns>
        public override ProductInventory CreateEntity()
		{
			var item = new ProductInventory();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(ProductInventory item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Location / Location
            // Foreign Key FK_ProductInventory_Location_LocationID
            if (parent is Location)
            {
                item.Location = (Location)parent;
                return;
            }

            // make relation to parent/super Entity Product / Product
            // Foreign Key FK_ProductInventory_Product_ProductID
            if (parent is Product)
            {
                item.Product = (Product)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public ProductInventory GetItem(int? productId, short? locationId)
        {
            return this.GetEntity(0, productId, locationId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public ProductInventory GetItem(DbConnector conn, int? productId, short? locationId)
        {
            return this.GetEntity(conn, productId, locationId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(ProductInventory).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to ProductInventoryFactory / ProductInventory / ProductInventory.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// ProductInventoryFactory to ProductInventory / ProductInventory.
        /// </summary>
        public ProductInventoryFactory ProductInventoryFactory
		{
			get
			{
				if (_ProductInventoryFactory == null)
				{
					_ProductInventoryFactory = global::AdventureWorks.ProductInventoryFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_ProductInventoryFactory, typeof(ProductInventory));
				}
				return _ProductInventoryFactory;
			}
		}
		private ProductInventoryFactory _ProductInventoryFactory = null;
	
        /// <summary>
        /// GetProductInventory to ProductInventory / ProductInventory
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductInventory GetProductInventory(int? productId, short? locationId)
        {
            return this.ProductInventoryFactory.GetEntity(0, productId, locationId);
        }
	
        /// <summary>
        /// GetProductInventory to ProductInventory / ProductInventory
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductInventory GetProductInventory(DbConnector conn, int? productId, short? locationId)
        {
            return this.ProductInventoryFactory.GetEntity(conn, productId, locationId);
        }
	
		/// <summary>
        /// GetProductInventoryList to ProductInventory / ProductInventory
		/// Getting a list of ProductInventory using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public ProductInventoryList GetProductInventoryList(SqlWhereClause where)
        {
            return this.ProductInventoryFactory.GetEntities(where);
        }

		/// <summary>
        /// GetProductInventoryList to ProductInventory / ProductInventory
		/// Getting all entities of ProductInventory
        /// </summary>
        /// <returns>List of all found entities</returns>
        public ProductInventoryList GetProductInventoryList()
        {
			var where = new SqlWhereClause();
            return this.ProductInventoryFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveProductInventory to ProductInventory / ProductInventory
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductInventory SaveProductInventory(ProductInventory item)
        {
            return this.ProductInventoryFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveProductInventory to ProductInventory / ProductInventory
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductInventory SaveProductInventory(DbConnector conn, ProductInventory item)
        {
            return this.ProductInventoryFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyProductInventory to ProductInventory / ProductInventory
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductInventory ApplyProductInventory(DbConnector conn, ProductInventory item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.ProductInventoryFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveProductInventory to ProductInventory / ProductInventory
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductInventory(ProductInventory item)
        {
            return this.ProductInventoryFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveProductInventory to ProductInventory / ProductInventory
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductInventory(DbConnector conn, ProductInventory item)
        {
            return this.ProductInventoryFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities ProductInventoryList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveProductInventoryList(ProductInventoryList items)
        {
			return this.ProductInventoryFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
