﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// ProductListPriceHistory / ProductListPriceHistory - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductListPriceHistory
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for ProductListPriceHistory
        /// </summary>
	    public ProductListPriceHistory()
		{
		}

		///// <summary>
        ///// Creates a new instance of ProductListPriceHistory
        ///// </summary>
	    //internal ProductListPriceHistory CreateEntity()
		//{
		//    return new ProductListPriceHistory();
		//}

		#region Members

		
        /// <summary>
        /// ProductId / ProductListPriceHistory.ProductID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Product")]
        public virtual int? ProductId
        {
            get
            {
                return (int?)this["ProductID"];
            }
            set
            {
                this.Add("ProductID", value, typeof(int?));
            }
        }

        /// <summary>
        /// StartDate / ProductListPriceHistory.StartDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("StartDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? StartDate
        {
            get
            {
                return (DateTime?)this["StartDate"];
            }
            set
            {
                this.Add("StartDate", value, typeof(DateTime?));
            }
        }

        /// <summary>
        /// EndDate / ProductListPriceHistory.EndDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("EndDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? EndDate
        {
            get
            {
                return (DateTime?)this["EndDate"];
            }
            set
            {
                this.Add("EndDate", value, typeof(DateTime?));
            }
        }

        /// <summary>
        /// ListPrice / ProductListPriceHistory.ListPrice
        /// </summary>
        /// <returns>decimal?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ListPrice"), FieldOrder(0), TypeName("decimal?"), FieldTypeName("decimal?"), ForeignEntity(null)]
        public virtual decimal? ListPrice
        {
            get
            {
                return (decimal?)this["ListPrice"];
            }
            set
            {
                this.Add("ListPrice", value, typeof(decimal?));
            }
        }

        /// <summary>
        /// ModifiedDate / ProductListPriceHistory.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Product

        /// <summary>
        /// Link to parent/super Entity Product / Product (this.ProductId)
		/// Foreign key FK_ProductListPriceHistory_Product_ProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Product Product
        {
            get
            {
			    // Lazy loading
                if (this._Product == null && this.ProductId != null)
                {
                    this._Product = ((AdvEntityManager)this.Manager).GetProduct(this.ProductId);
                    if (! _Product.ResultInfo.IsValid)
                    {
						this._Product = null; // reset value
                        throw new Exception("wrong/missed constraint from ProductListPriceHistory to Product.");
                    }
                }
                return this._Product;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ProductId = (value != null ? value.ProductId : null);


				// set foreign table
                this._Product = value;
            }
        }
        private Product _Product = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.ProductListPriceHistoryFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductListPriceHistory"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // ProductListPriceHistory

	#endregion

	#region Entity-List

    /// <summary>
    /// ProductListPriceHistory / ProductListPriceHistoryList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductListPriceHistoryList
        : WebEntityList<ProductListPriceHistory>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductListPriceHistory"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// ProductListPriceHistory - ProductListPriceHistory - Factory 
    /// </summary>
    public partial class ProductListPriceHistoryFactory
        : WebEntityFactory<ProductListPriceHistory, ProductListPriceHistoryList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property ProductId of Db-Field ProductID</summary>
        public static string Prop_ProductId = "ProductId";
        ///<summary>Property StartDate of Db-Field StartDate</summary>
        public static string Prop_StartDate = "StartDate";
        ///<summary>Property EndDate of Db-Field EndDate</summary>
        public static string Prop_EndDate = "EndDate";
        ///<summary>Property ListPrice of Db-Field ListPrice</summary>
        public static string Prop_ListPrice = "ListPrice";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field ProductID of Property ProductId</summary>
        public static string Field_ProductId = "ProductID";
        ///<summary>Db-Field StartDate of Property StartDate</summary>
        public static string Field_StartDate = "StartDate";
        ///<summary>Db-Field EndDate of Property EndDate</summary>
        public static string Field_EndDate = "EndDate";
        ///<summary>Db-Field ListPrice of Property ListPrice</summary>
        public static string Field_ListPrice = "ListPrice";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = ProductListPriceHistory, 
		/// Fields       = "ProductID", "StartDate"
		/// Query        = ...
        /// </summary>
        protected ProductListPriceHistoryFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "ProductListPriceHistory";
            this.Fields = new string[]
            {
                "ProductID", "StartDate"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("ProductId", "int?", "ProductID", "int?", "", "Product");
			this.Properties.Add("StartDate", "DateTime?", "StartDate", "DateTime?", "", null);
			this.Properties.Add("EndDate", "DateTime?", "EndDate", "DateTime?", "", null);
			this.Properties.Add("ListPrice", "decimal?", "ListPrice", "decimal?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "ProductListPriceHistory"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "ProductListPriceHistoryList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "ProductListPriceHistoryFactory"; }
            set { }
        }

		#endregion

		internal static ProductListPriceHistoryFactory CreateFactory(EntityManager manager)
		{
		    return new ProductListPriceHistoryFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of ProductListPriceHistory. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo ProductListPriceHistory</returns>
        public override ProductListPriceHistory CreateEntity()
		{
			var item = new ProductListPriceHistory();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(ProductListPriceHistory item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Product / Product
            // Foreign Key FK_ProductListPriceHistory_Product_ProductID
            if (parent is Product)
            {
                item.Product = (Product)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public ProductListPriceHistory GetItem(int? productId, DateTime? startDate)
        {
            return this.GetEntity(0, productId, startDate);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public ProductListPriceHistory GetItem(DbConnector conn, int? productId, DateTime? startDate)
        {
            return this.GetEntity(conn, productId, startDate);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(ProductListPriceHistory).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to ProductListPriceHistoryFactory / ProductListPriceHistory / ProductListPriceHistory.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// ProductListPriceHistoryFactory to ProductListPriceHistory / ProductListPriceHistory.
        /// </summary>
        public ProductListPriceHistoryFactory ProductListPriceHistoryFactory
		{
			get
			{
				if (_ProductListPriceHistoryFactory == null)
				{
					_ProductListPriceHistoryFactory = global::AdventureWorks.ProductListPriceHistoryFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_ProductListPriceHistoryFactory, typeof(ProductListPriceHistory));
				}
				return _ProductListPriceHistoryFactory;
			}
		}
		private ProductListPriceHistoryFactory _ProductListPriceHistoryFactory = null;
	
        /// <summary>
        /// GetProductListPriceHistory to ProductListPriceHistory / ProductListPriceHistory
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductListPriceHistory GetProductListPriceHistory(int? productId, DateTime? startDate)
        {
            return this.ProductListPriceHistoryFactory.GetEntity(0, productId, startDate);
        }
	
        /// <summary>
        /// GetProductListPriceHistory to ProductListPriceHistory / ProductListPriceHistory
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductListPriceHistory GetProductListPriceHistory(DbConnector conn, int? productId, DateTime? startDate)
        {
            return this.ProductListPriceHistoryFactory.GetEntity(conn, productId, startDate);
        }
	
		/// <summary>
        /// GetProductListPriceHistoryList to ProductListPriceHistory / ProductListPriceHistory
		/// Getting a list of ProductListPriceHistory using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public ProductListPriceHistoryList GetProductListPriceHistoryList(SqlWhereClause where)
        {
            return this.ProductListPriceHistoryFactory.GetEntities(where);
        }

		/// <summary>
        /// GetProductListPriceHistoryList to ProductListPriceHistory / ProductListPriceHistory
		/// Getting all entities of ProductListPriceHistory
        /// </summary>
        /// <returns>List of all found entities</returns>
        public ProductListPriceHistoryList GetProductListPriceHistoryList()
        {
			var where = new SqlWhereClause();
            return this.ProductListPriceHistoryFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveProductListPriceHistory to ProductListPriceHistory / ProductListPriceHistory
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductListPriceHistory SaveProductListPriceHistory(ProductListPriceHistory item)
        {
            return this.ProductListPriceHistoryFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveProductListPriceHistory to ProductListPriceHistory / ProductListPriceHistory
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductListPriceHistory SaveProductListPriceHistory(DbConnector conn, ProductListPriceHistory item)
        {
            return this.ProductListPriceHistoryFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyProductListPriceHistory to ProductListPriceHistory / ProductListPriceHistory
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductListPriceHistory ApplyProductListPriceHistory(DbConnector conn, ProductListPriceHistory item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.ProductListPriceHistoryFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveProductListPriceHistory to ProductListPriceHistory / ProductListPriceHistory
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductListPriceHistory(ProductListPriceHistory item)
        {
            return this.ProductListPriceHistoryFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveProductListPriceHistory to ProductListPriceHistory / ProductListPriceHistory
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductListPriceHistory(DbConnector conn, ProductListPriceHistory item)
        {
            return this.ProductListPriceHistoryFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities ProductListPriceHistoryList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveProductListPriceHistoryList(ProductListPriceHistoryList items)
        {
			return this.ProductListPriceHistoryFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
