﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// ProductPhoto / ProductPhoto - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductPhoto
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for ProductPhoto
        /// </summary>
	    public ProductPhoto()
		{
		}

		///// <summary>
        ///// Creates a new instance of ProductPhoto
        ///// </summary>
	    //internal ProductPhoto CreateEntity()
		//{
		//    return new ProductPhoto();
		//}

		#region Members

		
        /// <summary>
        /// ProductPhotoId / ProductPhoto.ProductPhotoID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductPhotoID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? ProductPhotoId
        {
            get
            {
                return (int?)this["ProductPhotoID"];
            }
            set
            {
                this.Add("ProductPhotoID", value, typeof(int?));
            }
        }

        /// <summary>
        /// ThumbNailPhoto / ProductPhoto.ThumbNailPhoto
        /// </summary>
        /// <returns>byte[]</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ThumbNailPhoto"), FieldOrder(0), TypeName("byte[]"), FieldTypeName("byte[]"), ForeignEntity(null)]
        public virtual byte[] ThumbNailPhoto
        {
            get
            {
                return (byte[])this["ThumbNailPhoto"];
            }
            set
            {
                this.Add("ThumbNailPhoto", value, typeof(byte[]));
            }
        }

        /// <summary>
        /// ThumbnailPhotoFileName / ProductPhoto.ThumbnailPhotoFileName
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ThumbnailPhotoFileName"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string ThumbnailPhotoFileName
        {
            get
            {
                return (string)this["ThumbnailPhotoFileName"];
            }
            set
            {
                this.Add("ThumbnailPhotoFileName", value, typeof(string));
            }
        }

        /// <summary>
        /// LargePhoto / ProductPhoto.LargePhoto
        /// </summary>
        /// <returns>byte[]</returns>
        [DataMember]
        [FieldGroup(""), FieldName("LargePhoto"), FieldOrder(0), TypeName("byte[]"), FieldTypeName("byte[]"), ForeignEntity(null)]
        public virtual byte[] LargePhoto
        {
            get
            {
                return (byte[])this["LargePhoto"];
            }
            set
            {
                this.Add("LargePhoto", value, typeof(byte[]));
            }
        }

        /// <summary>
        /// LargePhotoFileName / ProductPhoto.LargePhotoFileName
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("LargePhotoFileName"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string LargePhotoFileName
        {
            get
            {
                return (string)this["LargePhotoFileName"];
            }
            set
            {
                this.Add("LargePhotoFileName", value, typeof(string));
            }
        }

        /// <summary>
        /// ModifiedDate / ProductPhoto.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		

		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from ProductProductPhoto

        /// <summary>
        /// List of sub entities ProductProductPhoto / ProductProductPhoto (ProductPhotoID)
		/// Foreign Key FK_ProductProductPhoto_ProductPhoto_ProductPhotoID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductProductPhotoList ProductProductPhotoList
        {
            get
            {
			    // Lazy Loading
                if (_ProductProductPhotoList == null && this.ProductPhotoId != null)
                {
					var where = new SqlWhereClause("WHERE ProductProductPhoto.ProductPhotoID = @ProductPhotoID",
					    "@ProductPhotoID", this.ProductPhotoId);
                    _ProductProductPhotoList = ((AdvEntityManager)this.Manager).GetProductProductPhotoList(where);
                }
				if (_ProductProductPhotoList == null)
				{
					_ProductProductPhotoList = new ProductProductPhotoList();
				}
                return _ProductProductPhotoList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductProductPhotoList _ProductProductPhotoList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.ProductPhotoFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductPhoto"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // ProductPhoto

	#endregion

	#region Entity-List

    /// <summary>
    /// ProductPhoto / ProductPhotoList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductPhotoList
        : WebEntityList<ProductPhoto>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductPhoto"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// ProductPhoto - ProductPhoto - Factory 
    /// </summary>
    public partial class ProductPhotoFactory
        : WebEntityFactory<ProductPhoto, ProductPhotoList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property ProductPhotoId of Db-Field ProductPhotoID</summary>
        public static string Prop_ProductPhotoId = "ProductPhotoId";
        ///<summary>Property ThumbNailPhoto of Db-Field ThumbNailPhoto</summary>
        public static string Prop_ThumbNailPhoto = "ThumbNailPhoto";
        ///<summary>Property ThumbnailPhotoFileName of Db-Field ThumbnailPhotoFileName</summary>
        public static string Prop_ThumbnailPhotoFileName = "ThumbnailPhotoFileName";
        ///<summary>Property LargePhoto of Db-Field LargePhoto</summary>
        public static string Prop_LargePhoto = "LargePhoto";
        ///<summary>Property LargePhotoFileName of Db-Field LargePhotoFileName</summary>
        public static string Prop_LargePhotoFileName = "LargePhotoFileName";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field ProductPhotoID of Property ProductPhotoId</summary>
        public static string Field_ProductPhotoId = "ProductPhotoID";
        ///<summary>Db-Field ThumbNailPhoto of Property ThumbNailPhoto</summary>
        public static string Field_ThumbNailPhoto = "ThumbNailPhoto";
        ///<summary>Db-Field ThumbnailPhotoFileName of Property ThumbnailPhotoFileName</summary>
        public static string Field_ThumbnailPhotoFileName = "ThumbnailPhotoFileName";
        ///<summary>Db-Field LargePhoto of Property LargePhoto</summary>
        public static string Field_LargePhoto = "LargePhoto";
        ///<summary>Db-Field LargePhotoFileName of Property LargePhotoFileName</summary>
        public static string Field_LargePhotoFileName = "LargePhotoFileName";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = ProductPhoto, 
		/// Fields       = "ProductPhotoID"
		/// Query        = ...
        /// </summary>
        protected ProductPhotoFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "ProductPhoto";
            this.Fields = new string[]
            {
                "ProductPhotoID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("ProductPhotoId", "int?", "ProductPhotoID", "int?", "", null);
			this.Properties.Add("ThumbNailPhoto", "byte[]", "ThumbNailPhoto", "byte[]", "", null);
			this.Properties.Add("ThumbnailPhotoFileName", "string", "ThumbnailPhotoFileName", "string", "", null);
			this.Properties.Add("LargePhoto", "byte[]", "LargePhoto", "byte[]", "", null);
			this.Properties.Add("LargePhotoFileName", "string", "LargePhotoFileName", "string", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "ProductPhoto"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "ProductPhotoList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "ProductPhotoFactory"; }
            set { }
        }

		#endregion

		internal static ProductPhotoFactory CreateFactory(EntityManager manager)
		{
		    return new ProductPhotoFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of ProductPhoto. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo ProductPhoto</returns>
        public override ProductPhoto CreateEntity()
		{
			var item = new ProductPhoto();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}



		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public ProductPhoto GetItem(int? productPhotoId)
        {
            return this.GetEntity(0, productPhotoId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public ProductPhoto GetItem(DbConnector conn, int? productPhotoId)
        {
            return this.GetEntity(conn, productPhotoId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(ProductPhoto).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to ProductPhotoFactory / ProductPhoto / ProductPhoto.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// ProductPhotoFactory to ProductPhoto / ProductPhoto.
        /// </summary>
        public ProductPhotoFactory ProductPhotoFactory
		{
			get
			{
				if (_ProductPhotoFactory == null)
				{
					_ProductPhotoFactory = global::AdventureWorks.ProductPhotoFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_ProductPhotoFactory, typeof(ProductPhoto));
				}
				return _ProductPhotoFactory;
			}
		}
		private ProductPhotoFactory _ProductPhotoFactory = null;
	
        /// <summary>
        /// GetProductPhoto to ProductPhoto / ProductPhoto
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductPhoto GetProductPhoto(int? productPhotoId)
        {
            return this.ProductPhotoFactory.GetEntity(0, productPhotoId);
        }
	
        /// <summary>
        /// GetProductPhoto to ProductPhoto / ProductPhoto
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductPhoto GetProductPhoto(DbConnector conn, int? productPhotoId)
        {
            return this.ProductPhotoFactory.GetEntity(conn, productPhotoId);
        }
	
		/// <summary>
        /// GetProductPhotoList to ProductPhoto / ProductPhoto
		/// Getting a list of ProductPhoto using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public ProductPhotoList GetProductPhotoList(SqlWhereClause where)
        {
            return this.ProductPhotoFactory.GetEntities(where);
        }

		/// <summary>
        /// GetProductPhotoList to ProductPhoto / ProductPhoto
		/// Getting all entities of ProductPhoto
        /// </summary>
        /// <returns>List of all found entities</returns>
        public ProductPhotoList GetProductPhotoList()
        {
			var where = new SqlWhereClause();
            return this.ProductPhotoFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveProductPhoto to ProductPhoto / ProductPhoto
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductPhoto SaveProductPhoto(ProductPhoto item)
        {
            return this.ProductPhotoFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveProductPhoto to ProductPhoto / ProductPhoto
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductPhoto SaveProductPhoto(DbConnector conn, ProductPhoto item)
        {
            return this.ProductPhotoFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyProductPhoto to ProductPhoto / ProductPhoto
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductPhoto ApplyProductPhoto(DbConnector conn, ProductPhoto item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.ProductPhotoFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveProductPhoto to ProductPhoto / ProductPhoto
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductPhoto(ProductPhoto item)
        {
            return this.ProductPhotoFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveProductPhoto to ProductPhoto / ProductPhoto
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductPhoto(DbConnector conn, ProductPhoto item)
        {
            return this.ProductPhotoFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities ProductPhotoList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveProductPhotoList(ProductPhotoList items)
        {
			return this.ProductPhotoFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
