﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// ProductProductPhoto / ProductProductPhoto - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductProductPhoto
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for ProductProductPhoto
        /// </summary>
	    public ProductProductPhoto()
		{
		}

		///// <summary>
        ///// Creates a new instance of ProductProductPhoto
        ///// </summary>
	    //internal ProductProductPhoto CreateEntity()
		//{
		//    return new ProductProductPhoto();
		//}

		#region Members

		
        /// <summary>
        /// ProductId / ProductProductPhoto.ProductID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Product")]
        public virtual int? ProductId
        {
            get
            {
                return (int?)this["ProductID"];
            }
            set
            {
                this.Add("ProductID", value, typeof(int?));
            }
        }

        /// <summary>
        /// ProductPhotoId / ProductProductPhoto.ProductPhotoID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductPhotoID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("ProductPhoto")]
        public virtual int? ProductPhotoId
        {
            get
            {
                return (int?)this["ProductPhotoID"];
            }
            set
            {
                this.Add("ProductPhotoID", value, typeof(int?));
            }
        }

        /// <summary>
        /// Primary / ProductProductPhoto.Primary
        /// </summary>
        /// <returns>bool?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Primary"), FieldOrder(0), TypeName("bool?"), FieldTypeName("bool?"), ForeignEntity(null)]
        public virtual bool? Primary
        {
            get
            {
                return (bool?)this["Primary"];
            }
            set
            {
                this.Add("Primary", value, typeof(bool?));
            }
        }

        /// <summary>
        /// ModifiedDate / ProductProductPhoto.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Product

        /// <summary>
        /// Link to parent/super Entity Product / Product (this.ProductId)
		/// Foreign key FK_ProductProductPhoto_Product_ProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Product Product
        {
            get
            {
			    // Lazy loading
                if (this._Product == null && this.ProductId != null)
                {
                    this._Product = ((AdvEntityManager)this.Manager).GetProduct(this.ProductId);
                    if (! _Product.ResultInfo.IsValid)
                    {
						this._Product = null; // reset value
                        throw new Exception("wrong/missed constraint from ProductProductPhoto to Product.");
                    }
                }
                return this._Product;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ProductId = (value != null ? value.ProductId : null);


				// set foreign table
                this._Product = value;
            }
        }
        private Product _Product = null;

        #endregion

        #region foreign constraint (parent entity) to ProductPhoto

        /// <summary>
        /// Link to parent/super Entity ProductPhoto / ProductPhoto (this.ProductPhotoId)
		/// Foreign key FK_ProductProductPhoto_ProductPhoto_ProductPhotoID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductPhoto ProductPhoto
        {
            get
            {
			    // Lazy loading
                if (this._ProductPhoto == null && this.ProductPhotoId != null)
                {
                    this._ProductPhoto = ((AdvEntityManager)this.Manager).GetProductPhoto(this.ProductPhotoId);
                    if (! _ProductPhoto.ResultInfo.IsValid)
                    {
						this._ProductPhoto = null; // reset value
                        throw new Exception("wrong/missed constraint from ProductProductPhoto to ProductPhoto.");
                    }
                }
                return this._ProductPhoto;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ProductPhotoId = (value != null ? value.ProductPhotoId : null);


				// set foreign table
                this._ProductPhoto = value;
            }
        }
        private ProductPhoto _ProductPhoto = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.ProductProductPhotoFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductProductPhoto"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // ProductProductPhoto

	#endregion

	#region Entity-List

    /// <summary>
    /// ProductProductPhoto / ProductProductPhotoList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductProductPhotoList
        : WebEntityList<ProductProductPhoto>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductProductPhoto"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// ProductProductPhoto - ProductProductPhoto - Factory 
    /// </summary>
    public partial class ProductProductPhotoFactory
        : WebEntityFactory<ProductProductPhoto, ProductProductPhotoList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property ProductId of Db-Field ProductID</summary>
        public static string Prop_ProductId = "ProductId";
        ///<summary>Property ProductPhotoId of Db-Field ProductPhotoID</summary>
        public static string Prop_ProductPhotoId = "ProductPhotoId";
        ///<summary>Property Primary of Db-Field Primary</summary>
        public static string Prop_Primary = "Primary";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field ProductID of Property ProductId</summary>
        public static string Field_ProductId = "ProductID";
        ///<summary>Db-Field ProductPhotoID of Property ProductPhotoId</summary>
        public static string Field_ProductPhotoId = "ProductPhotoID";
        ///<summary>Db-Field Primary of Property Primary</summary>
        public static string Field_Primary = "Primary";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = ProductProductPhoto, 
		/// Fields       = "ProductID", "ProductPhotoID"
		/// Query        = ...
        /// </summary>
        protected ProductProductPhotoFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "ProductProductPhoto";
            this.Fields = new string[]
            {
                "ProductID", "ProductPhotoID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("ProductId", "int?", "ProductID", "int?", "", "Product");
			this.Properties.Add("ProductPhotoId", "int?", "ProductPhotoID", "int?", "", "ProductPhoto");
			this.Properties.Add("Primary", "bool?", "Primary", "bool?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "ProductProductPhoto"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "ProductProductPhotoList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "ProductProductPhotoFactory"; }
            set { }
        }

		#endregion

		internal static ProductProductPhotoFactory CreateFactory(EntityManager manager)
		{
		    return new ProductProductPhotoFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of ProductProductPhoto. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo ProductProductPhoto</returns>
        public override ProductProductPhoto CreateEntity()
		{
			var item = new ProductProductPhoto();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(ProductProductPhoto item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Product / Product
            // Foreign Key FK_ProductProductPhoto_Product_ProductID
            if (parent is Product)
            {
                item.Product = (Product)parent;
                return;
            }

            // make relation to parent/super Entity ProductPhoto / ProductPhoto
            // Foreign Key FK_ProductProductPhoto_ProductPhoto_ProductPhotoID
            if (parent is ProductPhoto)
            {
                item.ProductPhoto = (ProductPhoto)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public ProductProductPhoto GetItem(int? productId, int? productPhotoId)
        {
            return this.GetEntity(0, productId, productPhotoId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public ProductProductPhoto GetItem(DbConnector conn, int? productId, int? productPhotoId)
        {
            return this.GetEntity(conn, productId, productPhotoId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(ProductProductPhoto).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to ProductProductPhotoFactory / ProductProductPhoto / ProductProductPhoto.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// ProductProductPhotoFactory to ProductProductPhoto / ProductProductPhoto.
        /// </summary>
        public ProductProductPhotoFactory ProductProductPhotoFactory
		{
			get
			{
				if (_ProductProductPhotoFactory == null)
				{
					_ProductProductPhotoFactory = global::AdventureWorks.ProductProductPhotoFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_ProductProductPhotoFactory, typeof(ProductProductPhoto));
				}
				return _ProductProductPhotoFactory;
			}
		}
		private ProductProductPhotoFactory _ProductProductPhotoFactory = null;
	
        /// <summary>
        /// GetProductProductPhoto to ProductProductPhoto / ProductProductPhoto
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductProductPhoto GetProductProductPhoto(int? productId, int? productPhotoId)
        {
            return this.ProductProductPhotoFactory.GetEntity(0, productId, productPhotoId);
        }
	
        /// <summary>
        /// GetProductProductPhoto to ProductProductPhoto / ProductProductPhoto
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductProductPhoto GetProductProductPhoto(DbConnector conn, int? productId, int? productPhotoId)
        {
            return this.ProductProductPhotoFactory.GetEntity(conn, productId, productPhotoId);
        }
	
		/// <summary>
        /// GetProductProductPhotoList to ProductProductPhoto / ProductProductPhoto
		/// Getting a list of ProductProductPhoto using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public ProductProductPhotoList GetProductProductPhotoList(SqlWhereClause where)
        {
            return this.ProductProductPhotoFactory.GetEntities(where);
        }

		/// <summary>
        /// GetProductProductPhotoList to ProductProductPhoto / ProductProductPhoto
		/// Getting all entities of ProductProductPhoto
        /// </summary>
        /// <returns>List of all found entities</returns>
        public ProductProductPhotoList GetProductProductPhotoList()
        {
			var where = new SqlWhereClause();
            return this.ProductProductPhotoFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveProductProductPhoto to ProductProductPhoto / ProductProductPhoto
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductProductPhoto SaveProductProductPhoto(ProductProductPhoto item)
        {
            return this.ProductProductPhotoFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveProductProductPhoto to ProductProductPhoto / ProductProductPhoto
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductProductPhoto SaveProductProductPhoto(DbConnector conn, ProductProductPhoto item)
        {
            return this.ProductProductPhotoFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyProductProductPhoto to ProductProductPhoto / ProductProductPhoto
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductProductPhoto ApplyProductProductPhoto(DbConnector conn, ProductProductPhoto item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.ProductProductPhotoFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveProductProductPhoto to ProductProductPhoto / ProductProductPhoto
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductProductPhoto(ProductProductPhoto item)
        {
            return this.ProductProductPhotoFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveProductProductPhoto to ProductProductPhoto / ProductProductPhoto
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductProductPhoto(DbConnector conn, ProductProductPhoto item)
        {
            return this.ProductProductPhotoFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities ProductProductPhotoList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveProductProductPhotoList(ProductProductPhotoList items)
        {
			return this.ProductProductPhotoFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
