﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// ProductReview / ProductReview - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductReview
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for ProductReview
        /// </summary>
	    public ProductReview()
		{
		}

		///// <summary>
        ///// Creates a new instance of ProductReview
        ///// </summary>
	    //internal ProductReview CreateEntity()
		//{
		//    return new ProductReview();
		//}

		#region Members

		
        /// <summary>
        /// ProductReviewId / ProductReview.ProductReviewID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductReviewID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? ProductReviewId
        {
            get
            {
                return (int?)this["ProductReviewID"];
            }
            set
            {
                this.Add("ProductReviewID", value, typeof(int?));
            }
        }

        /// <summary>
        /// ProductId / ProductReview.ProductID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Product")]
        public virtual int? ProductId
        {
            get
            {
                return (int?)this["ProductID"];
            }
            set
            {
                this.Add("ProductID", value, typeof(int?));
            }
        }

        /// <summary>
        /// ReviewerName / ProductReview.ReviewerName
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ReviewerName"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string ReviewerName
        {
            get
            {
                return (string)this["ReviewerName"];
            }
            set
            {
                this.Add("ReviewerName", value, typeof(string));
            }
        }

        /// <summary>
        /// ReviewDate / ProductReview.ReviewDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ReviewDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ReviewDate
        {
            get
            {
                return (DateTime?)this["ReviewDate"];
            }
            set
            {
                this.Add("ReviewDate", value, typeof(DateTime?));
            }
        }

        /// <summary>
        /// EmailAddress / ProductReview.EmailAddress
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("EmailAddress"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string EmailAddress
        {
            get
            {
                return (string)this["EmailAddress"];
            }
            set
            {
                this.Add("EmailAddress", value, typeof(string));
            }
        }

        /// <summary>
        /// Rating / ProductReview.Rating
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Rating"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? Rating
        {
            get
            {
                return (int?)this["Rating"];
            }
            set
            {
                this.Add("Rating", value, typeof(int?));
            }
        }

        /// <summary>
        /// Comments / ProductReview.Comments
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Comments"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Comments
        {
            get
            {
                return (string)this["Comments"];
            }
            set
            {
                this.Add("Comments", value, typeof(string));
            }
        }

        /// <summary>
        /// ModifiedDate / ProductReview.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Product

        /// <summary>
        /// Link to parent/super Entity Product / Product (this.ProductId)
		/// Foreign key FK_ProductReview_Product_ProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Product Product
        {
            get
            {
			    // Lazy loading
                if (this._Product == null && this.ProductId != null)
                {
                    this._Product = ((AdvEntityManager)this.Manager).GetProduct(this.ProductId);
                    if (! _Product.ResultInfo.IsValid)
                    {
						this._Product = null; // reset value
                        throw new Exception("wrong/missed constraint from ProductReview to Product.");
                    }
                }
                return this._Product;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ProductId = (value != null ? value.ProductId : null);


				// set foreign table
                this._Product = value;
            }
        }
        private Product _Product = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.ProductReviewFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductReview"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // ProductReview

	#endregion

	#region Entity-List

    /// <summary>
    /// ProductReview / ProductReviewList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductReviewList
        : WebEntityList<ProductReview>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductReview"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// ProductReview - ProductReview - Factory 
    /// </summary>
    public partial class ProductReviewFactory
        : WebEntityFactory<ProductReview, ProductReviewList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property ProductReviewId of Db-Field ProductReviewID</summary>
        public static string Prop_ProductReviewId = "ProductReviewId";
        ///<summary>Property ProductId of Db-Field ProductID</summary>
        public static string Prop_ProductId = "ProductId";
        ///<summary>Property ReviewerName of Db-Field ReviewerName</summary>
        public static string Prop_ReviewerName = "ReviewerName";
        ///<summary>Property ReviewDate of Db-Field ReviewDate</summary>
        public static string Prop_ReviewDate = "ReviewDate";
        ///<summary>Property EmailAddress of Db-Field EmailAddress</summary>
        public static string Prop_EmailAddress = "EmailAddress";
        ///<summary>Property Rating of Db-Field Rating</summary>
        public static string Prop_Rating = "Rating";
        ///<summary>Property Comments of Db-Field Comments</summary>
        public static string Prop_Comments = "Comments";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field ProductReviewID of Property ProductReviewId</summary>
        public static string Field_ProductReviewId = "ProductReviewID";
        ///<summary>Db-Field ProductID of Property ProductId</summary>
        public static string Field_ProductId = "ProductID";
        ///<summary>Db-Field ReviewerName of Property ReviewerName</summary>
        public static string Field_ReviewerName = "ReviewerName";
        ///<summary>Db-Field ReviewDate of Property ReviewDate</summary>
        public static string Field_ReviewDate = "ReviewDate";
        ///<summary>Db-Field EmailAddress of Property EmailAddress</summary>
        public static string Field_EmailAddress = "EmailAddress";
        ///<summary>Db-Field Rating of Property Rating</summary>
        public static string Field_Rating = "Rating";
        ///<summary>Db-Field Comments of Property Comments</summary>
        public static string Field_Comments = "Comments";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = ProductReview, 
		/// Fields       = "ProductReviewID"
		/// Query        = ...
        /// </summary>
        protected ProductReviewFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "ProductReview";
            this.Fields = new string[]
            {
                "ProductReviewID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("ProductReviewId", "int?", "ProductReviewID", "int?", "", null);
			this.Properties.Add("ProductId", "int?", "ProductID", "int?", "", "Product");
			this.Properties.Add("ReviewerName", "string", "ReviewerName", "string", "", null);
			this.Properties.Add("ReviewDate", "DateTime?", "ReviewDate", "DateTime?", "", null);
			this.Properties.Add("EmailAddress", "string", "EmailAddress", "string", "", null);
			this.Properties.Add("Rating", "int?", "Rating", "int?", "", null);
			this.Properties.Add("Comments", "string", "Comments", "string", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "ProductReview"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "ProductReviewList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "ProductReviewFactory"; }
            set { }
        }

		#endregion

		internal static ProductReviewFactory CreateFactory(EntityManager manager)
		{
		    return new ProductReviewFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of ProductReview. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo ProductReview</returns>
        public override ProductReview CreateEntity()
		{
			var item = new ProductReview();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(ProductReview item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Product / Product
            // Foreign Key FK_ProductReview_Product_ProductID
            if (parent is Product)
            {
                item.Product = (Product)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public ProductReview GetItem(int? productReviewId)
        {
            return this.GetEntity(0, productReviewId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public ProductReview GetItem(DbConnector conn, int? productReviewId)
        {
            return this.GetEntity(conn, productReviewId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(ProductReview).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to ProductReviewFactory / ProductReview / ProductReview.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// ProductReviewFactory to ProductReview / ProductReview.
        /// </summary>
        public ProductReviewFactory ProductReviewFactory
		{
			get
			{
				if (_ProductReviewFactory == null)
				{
					_ProductReviewFactory = global::AdventureWorks.ProductReviewFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_ProductReviewFactory, typeof(ProductReview));
				}
				return _ProductReviewFactory;
			}
		}
		private ProductReviewFactory _ProductReviewFactory = null;
	
        /// <summary>
        /// GetProductReview to ProductReview / ProductReview
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductReview GetProductReview(int? productReviewId)
        {
            return this.ProductReviewFactory.GetEntity(0, productReviewId);
        }
	
        /// <summary>
        /// GetProductReview to ProductReview / ProductReview
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductReview GetProductReview(DbConnector conn, int? productReviewId)
        {
            return this.ProductReviewFactory.GetEntity(conn, productReviewId);
        }
	
		/// <summary>
        /// GetProductReviewList to ProductReview / ProductReview
		/// Getting a list of ProductReview using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public ProductReviewList GetProductReviewList(SqlWhereClause where)
        {
            return this.ProductReviewFactory.GetEntities(where);
        }

		/// <summary>
        /// GetProductReviewList to ProductReview / ProductReview
		/// Getting all entities of ProductReview
        /// </summary>
        /// <returns>List of all found entities</returns>
        public ProductReviewList GetProductReviewList()
        {
			var where = new SqlWhereClause();
            return this.ProductReviewFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveProductReview to ProductReview / ProductReview
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductReview SaveProductReview(ProductReview item)
        {
            return this.ProductReviewFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveProductReview to ProductReview / ProductReview
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductReview SaveProductReview(DbConnector conn, ProductReview item)
        {
            return this.ProductReviewFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyProductReview to ProductReview / ProductReview
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductReview ApplyProductReview(DbConnector conn, ProductReview item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.ProductReviewFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveProductReview to ProductReview / ProductReview
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductReview(ProductReview item)
        {
            return this.ProductReviewFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveProductReview to ProductReview / ProductReview
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductReview(DbConnector conn, ProductReview item)
        {
            return this.ProductReviewFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities ProductReviewList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveProductReviewList(ProductReviewList items)
        {
			return this.ProductReviewFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
