﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// ProductSubcategory / ProductSubcategory - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductSubcategory
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for ProductSubcategory
        /// </summary>
	    public ProductSubcategory()
		{
		}

		///// <summary>
        ///// Creates a new instance of ProductSubcategory
        ///// </summary>
	    //internal ProductSubcategory CreateEntity()
		//{
		//    return new ProductSubcategory();
		//}

		#region Members

		
        /// <summary>
        /// ProductSubcategoryId / ProductSubcategory.ProductSubcategoryID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductSubcategoryID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? ProductSubcategoryId
        {
            get
            {
                return (int?)this["ProductSubcategoryID"];
            }
            set
            {
                this.Add("ProductSubcategoryID", value, typeof(int?));
            }
        }

        /// <summary>
        /// ProductCategoryId / ProductSubcategory.ProductCategoryID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductCategoryID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("ProductCategory")]
        public virtual int? ProductCategoryId
        {
            get
            {
                return (int?)this["ProductCategoryID"];
            }
            set
            {
                this.Add("ProductCategoryID", value, typeof(int?));
            }
        }

        /// <summary>
        /// Name / ProductSubcategory.Name
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Name"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Name
        {
            get
            {
                return (string)this["Name"];
            }
            set
            {
                this.Add("Name", value, typeof(string));
            }
        }

        /// <summary>
        /// Rowguid / ProductSubcategory.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / ProductSubcategory.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to ProductCategory

        /// <summary>
        /// Link to parent/super Entity ProductCategory / ProductCategory (this.ProductCategoryId)
		/// Foreign key FK_ProductSubcategory_ProductCategory_ProductCategoryID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductCategory ProductCategory
        {
            get
            {
			    // Lazy loading
                if (this._ProductCategory == null && this.ProductCategoryId != null)
                {
                    this._ProductCategory = ((AdvEntityManager)this.Manager).GetProductCategory(this.ProductCategoryId);
                    if (! _ProductCategory.ResultInfo.IsValid)
                    {
						this._ProductCategory = null; // reset value
                        throw new Exception("wrong/missed constraint from ProductSubcategory to ProductCategory.");
                    }
                }
                return this._ProductCategory;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ProductCategoryId = (value != null ? value.ProductCategoryId : null);


				// set foreign table
                this._ProductCategory = value;
            }
        }
        private ProductCategory _ProductCategory = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from Product

        /// <summary>
        /// List of sub entities Product / Product (ProductSubcategoryID)
		/// Foreign Key FK_Product_ProductSubcategory_ProductSubcategoryID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductList ProductList
        {
            get
            {
			    // Lazy Loading
                if (_ProductList == null && this.ProductSubcategoryId != null)
                {
					var where = new SqlWhereClause("WHERE Product.ProductSubcategoryID = @ProductSubcategoryID",
					    "@ProductSubcategoryID", this.ProductSubcategoryId);
                    _ProductList = ((AdvEntityManager)this.Manager).GetProductList(where);
                }
				if (_ProductList == null)
				{
					_ProductList = new ProductList();
				}
                return _ProductList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductList _ProductList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.ProductSubcategoryFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductSubcategory"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // ProductSubcategory

	#endregion

	#region Entity-List

    /// <summary>
    /// ProductSubcategory / ProductSubcategoryList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductSubcategoryList
        : WebEntityList<ProductSubcategory>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductSubcategory"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// ProductSubcategory - ProductSubcategory - Factory 
    /// </summary>
    public partial class ProductSubcategoryFactory
        : WebEntityFactory<ProductSubcategory, ProductSubcategoryList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property ProductSubcategoryId of Db-Field ProductSubcategoryID</summary>
        public static string Prop_ProductSubcategoryId = "ProductSubcategoryId";
        ///<summary>Property ProductCategoryId of Db-Field ProductCategoryID</summary>
        public static string Prop_ProductCategoryId = "ProductCategoryId";
        ///<summary>Property Name of Db-Field Name</summary>
        public static string Prop_Name = "Name";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field ProductSubcategoryID of Property ProductSubcategoryId</summary>
        public static string Field_ProductSubcategoryId = "ProductSubcategoryID";
        ///<summary>Db-Field ProductCategoryID of Property ProductCategoryId</summary>
        public static string Field_ProductCategoryId = "ProductCategoryID";
        ///<summary>Db-Field Name of Property Name</summary>
        public static string Field_Name = "Name";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = ProductSubcategory, 
		/// Fields       = "ProductSubcategoryID"
		/// Query        = ...
        /// </summary>
        protected ProductSubcategoryFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "ProductSubcategory";
            this.Fields = new string[]
            {
                "ProductSubcategoryID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("ProductSubcategoryId", "int?", "ProductSubcategoryID", "int?", "", null);
			this.Properties.Add("ProductCategoryId", "int?", "ProductCategoryID", "int?", "", "ProductCategory");
			this.Properties.Add("Name", "string", "Name", "string", "", null);
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "ProductSubcategory"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "ProductSubcategoryList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "ProductSubcategoryFactory"; }
            set { }
        }

		#endregion

		internal static ProductSubcategoryFactory CreateFactory(EntityManager manager)
		{
		    return new ProductSubcategoryFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of ProductSubcategory. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo ProductSubcategory</returns>
        public override ProductSubcategory CreateEntity()
		{
			var item = new ProductSubcategory();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(ProductSubcategory item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity ProductCategory / ProductCategory
            // Foreign Key FK_ProductSubcategory_ProductCategory_ProductCategoryID
            if (parent is ProductCategory)
            {
                item.ProductCategory = (ProductCategory)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public ProductSubcategory GetItem(int? productSubcategoryId)
        {
            return this.GetEntity(0, productSubcategoryId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public ProductSubcategory GetItem(DbConnector conn, int? productSubcategoryId)
        {
            return this.GetEntity(conn, productSubcategoryId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(ProductSubcategory).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to ProductSubcategoryFactory / ProductSubcategory / ProductSubcategory.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// ProductSubcategoryFactory to ProductSubcategory / ProductSubcategory.
        /// </summary>
        public ProductSubcategoryFactory ProductSubcategoryFactory
		{
			get
			{
				if (_ProductSubcategoryFactory == null)
				{
					_ProductSubcategoryFactory = global::AdventureWorks.ProductSubcategoryFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_ProductSubcategoryFactory, typeof(ProductSubcategory));
				}
				return _ProductSubcategoryFactory;
			}
		}
		private ProductSubcategoryFactory _ProductSubcategoryFactory = null;
	
        /// <summary>
        /// GetProductSubcategory to ProductSubcategory / ProductSubcategory
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductSubcategory GetProductSubcategory(int? productSubcategoryId)
        {
            return this.ProductSubcategoryFactory.GetEntity(0, productSubcategoryId);
        }
	
        /// <summary>
        /// GetProductSubcategory to ProductSubcategory / ProductSubcategory
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductSubcategory GetProductSubcategory(DbConnector conn, int? productSubcategoryId)
        {
            return this.ProductSubcategoryFactory.GetEntity(conn, productSubcategoryId);
        }
	
		/// <summary>
        /// GetProductSubcategoryList to ProductSubcategory / ProductSubcategory
		/// Getting a list of ProductSubcategory using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public ProductSubcategoryList GetProductSubcategoryList(SqlWhereClause where)
        {
            return this.ProductSubcategoryFactory.GetEntities(where);
        }

		/// <summary>
        /// GetProductSubcategoryList to ProductSubcategory / ProductSubcategory
		/// Getting all entities of ProductSubcategory
        /// </summary>
        /// <returns>List of all found entities</returns>
        public ProductSubcategoryList GetProductSubcategoryList()
        {
			var where = new SqlWhereClause();
            return this.ProductSubcategoryFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveProductSubcategory to ProductSubcategory / ProductSubcategory
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductSubcategory SaveProductSubcategory(ProductSubcategory item)
        {
            return this.ProductSubcategoryFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveProductSubcategory to ProductSubcategory / ProductSubcategory
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductSubcategory SaveProductSubcategory(DbConnector conn, ProductSubcategory item)
        {
            return this.ProductSubcategoryFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyProductSubcategory to ProductSubcategory / ProductSubcategory
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductSubcategory ApplyProductSubcategory(DbConnector conn, ProductSubcategory item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.ProductSubcategoryFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveProductSubcategory to ProductSubcategory / ProductSubcategory
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductSubcategory(ProductSubcategory item)
        {
            return this.ProductSubcategoryFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveProductSubcategory to ProductSubcategory / ProductSubcategory
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductSubcategory(DbConnector conn, ProductSubcategory item)
        {
            return this.ProductSubcategoryFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities ProductSubcategoryList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveProductSubcategoryList(ProductSubcategoryList items)
        {
			return this.ProductSubcategoryFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
