﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// SalesOrderHeaderSalesReason / SalesOrderHeaderSalesReason - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class SalesOrderHeaderSalesReason
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for SalesOrderHeaderSalesReason
        /// </summary>
	    public SalesOrderHeaderSalesReason()
		{
		}

		///// <summary>
        ///// Creates a new instance of SalesOrderHeaderSalesReason
        ///// </summary>
	    //internal SalesOrderHeaderSalesReason CreateEntity()
		//{
		//    return new SalesOrderHeaderSalesReason();
		//}

		#region Members

		
        /// <summary>
        /// SalesOrderId / SalesOrderHeaderSalesReason.SalesOrderID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("SalesOrderID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("SalesOrderHeader")]
        public virtual int? SalesOrderId
        {
            get
            {
                return (int?)this["SalesOrderID"];
            }
            set
            {
                this.Add("SalesOrderID", value, typeof(int?));
            }
        }

        /// <summary>
        /// SalesReasonId / SalesOrderHeaderSalesReason.SalesReasonID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("SalesReasonID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("SalesReason")]
        public virtual int? SalesReasonId
        {
            get
            {
                return (int?)this["SalesReasonID"];
            }
            set
            {
                this.Add("SalesReasonID", value, typeof(int?));
            }
        }

        /// <summary>
        /// ModifiedDate / SalesOrderHeaderSalesReason.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to SalesOrderHeader

        /// <summary>
        /// Link to parent/super Entity SalesOrderHeader / SalesOrderHeader (this.SalesOrderId)
		/// Foreign key FK_SalesOrderHeaderSalesReason_SalesOrderHeader_SalesOrderID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesOrderHeader SalesOrderHeader
        {
            get
            {
			    // Lazy loading
                if (this._SalesOrderHeader == null && this.SalesOrderId != null)
                {
                    this._SalesOrderHeader = ((AdvEntityManager)this.Manager).GetSalesOrderHeader(this.SalesOrderId);
                    if (! _SalesOrderHeader.ResultInfo.IsValid)
                    {
						this._SalesOrderHeader = null; // reset value
                        throw new Exception("wrong/missed constraint from SalesOrderHeaderSalesReason to SalesOrderHeader.");
                    }
                }
                return this._SalesOrderHeader;
            }
            set
            {
                // reassign foreign key values from setter value
                this.SalesOrderId = (value != null ? value.SalesOrderId : null);


				// set foreign table
                this._SalesOrderHeader = value;
            }
        }
        private SalesOrderHeader _SalesOrderHeader = null;

        #endregion

        #region foreign constraint (parent entity) to SalesReason

        /// <summary>
        /// Link to parent/super Entity SalesReason / SalesReason (this.SalesReasonId)
		/// Foreign key FK_SalesOrderHeaderSalesReason_SalesReason_SalesReasonID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesReason SalesReason
        {
            get
            {
			    // Lazy loading
                if (this._SalesReason == null && this.SalesReasonId != null)
                {
                    this._SalesReason = ((AdvEntityManager)this.Manager).GetSalesReason(this.SalesReasonId);
                    if (! _SalesReason.ResultInfo.IsValid)
                    {
						this._SalesReason = null; // reset value
                        throw new Exception("wrong/missed constraint from SalesOrderHeaderSalesReason to SalesReason.");
                    }
                }
                return this._SalesReason;
            }
            set
            {
                // reassign foreign key values from setter value
                this.SalesReasonId = (value != null ? value.SalesReasonId : null);


				// set foreign table
                this._SalesReason = value;
            }
        }
        private SalesReason _SalesReason = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.SalesOrderHeaderSalesReasonFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "SalesOrderHeaderSalesReason"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // SalesOrderHeaderSalesReason

	#endregion

	#region Entity-List

    /// <summary>
    /// SalesOrderHeaderSalesReason / SalesOrderHeaderSalesReasonList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class SalesOrderHeaderSalesReasonList
        : WebEntityList<SalesOrderHeaderSalesReason>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "SalesOrderHeaderSalesReason"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// SalesOrderHeaderSalesReason - SalesOrderHeaderSalesReason - Factory 
    /// </summary>
    public partial class SalesOrderHeaderSalesReasonFactory
        : WebEntityFactory<SalesOrderHeaderSalesReason, SalesOrderHeaderSalesReasonList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property SalesOrderId of Db-Field SalesOrderID</summary>
        public static string Prop_SalesOrderId = "SalesOrderId";
        ///<summary>Property SalesReasonId of Db-Field SalesReasonID</summary>
        public static string Prop_SalesReasonId = "SalesReasonId";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field SalesOrderID of Property SalesOrderId</summary>
        public static string Field_SalesOrderId = "SalesOrderID";
        ///<summary>Db-Field SalesReasonID of Property SalesReasonId</summary>
        public static string Field_SalesReasonId = "SalesReasonID";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = SalesOrderHeaderSalesReason, 
		/// Fields       = "SalesOrderID", "SalesReasonID"
		/// Query        = ...
        /// </summary>
        protected SalesOrderHeaderSalesReasonFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Sales";
            this.TableName = "SalesOrderHeaderSalesReason";
            this.Fields = new string[]
            {
                "SalesOrderID", "SalesReasonID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("SalesOrderId", "int?", "SalesOrderID", "int?", "", "SalesOrderHeader");
			this.Properties.Add("SalesReasonId", "int?", "SalesReasonID", "int?", "", "SalesReason");
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "SalesOrderHeaderSalesReason"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "SalesOrderHeaderSalesReasonList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "SalesOrderHeaderSalesReasonFactory"; }
            set { }
        }

		#endregion

		internal static SalesOrderHeaderSalesReasonFactory CreateFactory(EntityManager manager)
		{
		    return new SalesOrderHeaderSalesReasonFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of SalesOrderHeaderSalesReason. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo SalesOrderHeaderSalesReason</returns>
        public override SalesOrderHeaderSalesReason CreateEntity()
		{
			var item = new SalesOrderHeaderSalesReason();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(SalesOrderHeaderSalesReason item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity SalesOrderHeader / SalesOrderHeader
            // Foreign Key FK_SalesOrderHeaderSalesReason_SalesOrderHeader_SalesOrderID
            if (parent is SalesOrderHeader)
            {
                item.SalesOrderHeader = (SalesOrderHeader)parent;
                return;
            }

            // make relation to parent/super Entity SalesReason / SalesReason
            // Foreign Key FK_SalesOrderHeaderSalesReason_SalesReason_SalesReasonID
            if (parent is SalesReason)
            {
                item.SalesReason = (SalesReason)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public SalesOrderHeaderSalesReason GetItem(int? salesOrderId, int? salesReasonId)
        {
            return this.GetEntity(0, salesOrderId, salesReasonId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public SalesOrderHeaderSalesReason GetItem(DbConnector conn, int? salesOrderId, int? salesReasonId)
        {
            return this.GetEntity(conn, salesOrderId, salesReasonId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(SalesOrderHeaderSalesReason).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to SalesOrderHeaderSalesReasonFactory / SalesOrderHeaderSalesReason / SalesOrderHeaderSalesReason.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// SalesOrderHeaderSalesReasonFactory to SalesOrderHeaderSalesReason / SalesOrderHeaderSalesReason.
        /// </summary>
        public SalesOrderHeaderSalesReasonFactory SalesOrderHeaderSalesReasonFactory
		{
			get
			{
				if (_SalesOrderHeaderSalesReasonFactory == null)
				{
					_SalesOrderHeaderSalesReasonFactory = global::AdventureWorks.SalesOrderHeaderSalesReasonFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_SalesOrderHeaderSalesReasonFactory, typeof(SalesOrderHeaderSalesReason));
				}
				return _SalesOrderHeaderSalesReasonFactory;
			}
		}
		private SalesOrderHeaderSalesReasonFactory _SalesOrderHeaderSalesReasonFactory = null;
	
        /// <summary>
        /// GetSalesOrderHeaderSalesReason to SalesOrderHeaderSalesReason / SalesOrderHeaderSalesReason
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesOrderHeaderSalesReason GetSalesOrderHeaderSalesReason(int? salesOrderId, int? salesReasonId)
        {
            return this.SalesOrderHeaderSalesReasonFactory.GetEntity(0, salesOrderId, salesReasonId);
        }
	
        /// <summary>
        /// GetSalesOrderHeaderSalesReason to SalesOrderHeaderSalesReason / SalesOrderHeaderSalesReason
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesOrderHeaderSalesReason GetSalesOrderHeaderSalesReason(DbConnector conn, int? salesOrderId, int? salesReasonId)
        {
            return this.SalesOrderHeaderSalesReasonFactory.GetEntity(conn, salesOrderId, salesReasonId);
        }
	
		/// <summary>
        /// GetSalesOrderHeaderSalesReasonList to SalesOrderHeaderSalesReason / SalesOrderHeaderSalesReason
		/// Getting a list of SalesOrderHeaderSalesReason using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public SalesOrderHeaderSalesReasonList GetSalesOrderHeaderSalesReasonList(SqlWhereClause where)
        {
            return this.SalesOrderHeaderSalesReasonFactory.GetEntities(where);
        }

		/// <summary>
        /// GetSalesOrderHeaderSalesReasonList to SalesOrderHeaderSalesReason / SalesOrderHeaderSalesReason
		/// Getting all entities of SalesOrderHeaderSalesReason
        /// </summary>
        /// <returns>List of all found entities</returns>
        public SalesOrderHeaderSalesReasonList GetSalesOrderHeaderSalesReasonList()
        {
			var where = new SqlWhereClause();
            return this.SalesOrderHeaderSalesReasonFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveSalesOrderHeaderSalesReason to SalesOrderHeaderSalesReason / SalesOrderHeaderSalesReason
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesOrderHeaderSalesReason SaveSalesOrderHeaderSalesReason(SalesOrderHeaderSalesReason item)
        {
            return this.SalesOrderHeaderSalesReasonFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveSalesOrderHeaderSalesReason to SalesOrderHeaderSalesReason / SalesOrderHeaderSalesReason
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesOrderHeaderSalesReason SaveSalesOrderHeaderSalesReason(DbConnector conn, SalesOrderHeaderSalesReason item)
        {
            return this.SalesOrderHeaderSalesReasonFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplySalesOrderHeaderSalesReason to SalesOrderHeaderSalesReason / SalesOrderHeaderSalesReason
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesOrderHeaderSalesReason ApplySalesOrderHeaderSalesReason(DbConnector conn, SalesOrderHeaderSalesReason item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.SalesOrderHeaderSalesReasonFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveSalesOrderHeaderSalesReason to SalesOrderHeaderSalesReason / SalesOrderHeaderSalesReason
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveSalesOrderHeaderSalesReason(SalesOrderHeaderSalesReason item)
        {
            return this.SalesOrderHeaderSalesReasonFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveSalesOrderHeaderSalesReason to SalesOrderHeaderSalesReason / SalesOrderHeaderSalesReason
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveSalesOrderHeaderSalesReason(DbConnector conn, SalesOrderHeaderSalesReason item)
        {
            return this.SalesOrderHeaderSalesReasonFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities SalesOrderHeaderSalesReasonList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveSalesOrderHeaderSalesReasonList(SalesOrderHeaderSalesReasonList items)
        {
			return this.SalesOrderHeaderSalesReasonFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
