﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// SalesPerson / SalesPerson - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class SalesPerson
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for SalesPerson
        /// </summary>
	    public SalesPerson()
		{
		}

		///// <summary>
        ///// Creates a new instance of SalesPerson
        ///// </summary>
	    //internal SalesPerson CreateEntity()
		//{
		//    return new SalesPerson();
		//}

		#region Members

		
        /// <summary>
        /// BusinessEntityId / SalesPerson.BusinessEntityID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("BusinessEntityID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Employee")]
        public virtual int? BusinessEntityId
        {
            get
            {
                return (int?)this["BusinessEntityID"];
            }
            set
            {
                this.Add("BusinessEntityID", value, typeof(int?));
            }
        }

        /// <summary>
        /// TerritoryId / SalesPerson.TerritoryID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("TerritoryID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("SalesTerritory")]
        public virtual int? TerritoryId
        {
            get
            {
                return (int?)this["TerritoryID"];
            }
            set
            {
                this.Add("TerritoryID", value, typeof(int?));
            }
        }

        /// <summary>
        /// SalesQuota / SalesPerson.SalesQuota
        /// </summary>
        /// <returns>decimal?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("SalesQuota"), FieldOrder(0), TypeName("decimal?"), FieldTypeName("decimal?"), ForeignEntity(null)]
        public virtual decimal? SalesQuota
        {
            get
            {
                return (decimal?)this["SalesQuota"];
            }
            set
            {
                this.Add("SalesQuota", value, typeof(decimal?));
            }
        }

        /// <summary>
        /// Bonus / SalesPerson.Bonus
        /// </summary>
        /// <returns>decimal?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Bonus"), FieldOrder(0), TypeName("decimal?"), FieldTypeName("decimal?"), ForeignEntity(null)]
        public virtual decimal? Bonus
        {
            get
            {
                return (decimal?)this["Bonus"];
            }
            set
            {
                this.Add("Bonus", value, typeof(decimal?));
            }
        }

        /// <summary>
        /// CommissionPct / SalesPerson.CommissionPct
        /// </summary>
        /// <returns>decimal?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("CommissionPct"), FieldOrder(0), TypeName("decimal?"), FieldTypeName("decimal?"), ForeignEntity(null)]
        public virtual decimal? CommissionPct
        {
            get
            {
                return (decimal?)this["CommissionPct"];
            }
            set
            {
                this.Add("CommissionPct", value, typeof(decimal?));
            }
        }

        /// <summary>
        /// SalesYtd / SalesPerson.SalesYTD
        /// </summary>
        /// <returns>decimal?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("SalesYTD"), FieldOrder(0), TypeName("decimal?"), FieldTypeName("decimal?"), ForeignEntity(null)]
        public virtual decimal? SalesYtd
        {
            get
            {
                return (decimal?)this["SalesYTD"];
            }
            set
            {
                this.Add("SalesYTD", value, typeof(decimal?));
            }
        }

        /// <summary>
        /// SalesLastYear / SalesPerson.SalesLastYear
        /// </summary>
        /// <returns>decimal?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("SalesLastYear"), FieldOrder(0), TypeName("decimal?"), FieldTypeName("decimal?"), ForeignEntity(null)]
        public virtual decimal? SalesLastYear
        {
            get
            {
                return (decimal?)this["SalesLastYear"];
            }
            set
            {
                this.Add("SalesLastYear", value, typeof(decimal?));
            }
        }

        /// <summary>
        /// Rowguid / SalesPerson.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / SalesPerson.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Employee

        /// <summary>
        /// Link to parent/super Entity Employee / Employee (this.BusinessEntityId)
		/// Foreign key FK_SalesPerson_Employee_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Employee Employee
        {
            get
            {
			    // Lazy loading
                if (this._Employee == null && this.BusinessEntityId != null)
                {
                    this._Employee = ((AdvEntityManager)this.Manager).GetEmployee(this.BusinessEntityId);
                    if (! _Employee.ResultInfo.IsValid)
                    {
						this._Employee = null; // reset value
                        throw new Exception("wrong/missed constraint from SalesPerson to Employee.");
                    }
                }
                return this._Employee;
            }
            set
            {
                // reassign foreign key values from setter value
                this.BusinessEntityId = (value != null ? value.BusinessEntityId : null);


				// set foreign table
                this._Employee = value;
            }
        }
        private Employee _Employee = null;

        #endregion

        #region foreign constraint (parent entity) to SalesTerritory

        /// <summary>
        /// Link to parent/super Entity SalesTerritory / SalesTerritory (this.TerritoryId)
		/// Foreign key FK_SalesPerson_SalesTerritory_TerritoryID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesTerritory SalesTerritory
        {
            get
            {
			    // Lazy loading
                if (this._SalesTerritory == null && this.TerritoryId != null)
                {
                    this._SalesTerritory = ((AdvEntityManager)this.Manager).GetSalesTerritory(this.TerritoryId);
                    if (! _SalesTerritory.ResultInfo.IsValid)
                    {
						this._SalesTerritory = null; // reset value
                        throw new Exception("wrong/missed constraint from SalesPerson to SalesTerritory.");
                    }
                }
                return this._SalesTerritory;
            }
            set
            {
                // reassign foreign key values from setter value
                this.TerritoryId = (value != null ? value.TerritoryId : null);


				// set foreign table
                this._SalesTerritory = value;
            }
        }
        private SalesTerritory _SalesTerritory = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from SalesOrderHeader

        /// <summary>
        /// List of sub entities SalesOrderHeader / SalesOrderHeader (SalesPersonID)
		/// Foreign Key FK_SalesOrderHeader_SalesPerson_SalesPersonID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesOrderHeaderList SalesOrderHeaderList
        {
            get
            {
			    // Lazy Loading
                if (_SalesOrderHeaderList == null && this.BusinessEntityId != null)
                {
					var where = new SqlWhereClause("WHERE SalesOrderHeader.SalesPersonID = @SalesPersonID",
					    "@SalesPersonID", this.BusinessEntityId);
                    _SalesOrderHeaderList = ((AdvEntityManager)this.Manager).GetSalesOrderHeaderList(where);
                }
				if (_SalesOrderHeaderList == null)
				{
					_SalesOrderHeaderList = new SalesOrderHeaderList();
				}
                return _SalesOrderHeaderList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private SalesOrderHeaderList _SalesOrderHeaderList = null;

        #endregion

        #region Sub Entites from SalesPersonQuotaHistory

        /// <summary>
        /// List of sub entities SalesPersonQuotaHistory / SalesPersonQuotaHistory (BusinessEntityID)
		/// Foreign Key FK_SalesPersonQuotaHistory_SalesPerson_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesPersonQuotaHistoryList SalesPersonQuotaHistoryList
        {
            get
            {
			    // Lazy Loading
                if (_SalesPersonQuotaHistoryList == null && this.BusinessEntityId != null)
                {
					var where = new SqlWhereClause("WHERE SalesPersonQuotaHistory.BusinessEntityID = @BusinessEntityID",
					    "@BusinessEntityID", this.BusinessEntityId);
                    _SalesPersonQuotaHistoryList = ((AdvEntityManager)this.Manager).GetSalesPersonQuotaHistoryList(where);
                }
				if (_SalesPersonQuotaHistoryList == null)
				{
					_SalesPersonQuotaHistoryList = new SalesPersonQuotaHistoryList();
				}
                return _SalesPersonQuotaHistoryList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private SalesPersonQuotaHistoryList _SalesPersonQuotaHistoryList = null;

        #endregion

        #region Sub Entites from SalesTerritoryHistory

        /// <summary>
        /// List of sub entities SalesTerritoryHistory / SalesTerritoryHistory (BusinessEntityID)
		/// Foreign Key FK_SalesTerritoryHistory_SalesPerson_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesTerritoryHistoryList SalesTerritoryHistoryList
        {
            get
            {
			    // Lazy Loading
                if (_SalesTerritoryHistoryList == null && this.BusinessEntityId != null)
                {
					var where = new SqlWhereClause("WHERE SalesTerritoryHistory.BusinessEntityID = @BusinessEntityID",
					    "@BusinessEntityID", this.BusinessEntityId);
                    _SalesTerritoryHistoryList = ((AdvEntityManager)this.Manager).GetSalesTerritoryHistoryList(where);
                }
				if (_SalesTerritoryHistoryList == null)
				{
					_SalesTerritoryHistoryList = new SalesTerritoryHistoryList();
				}
                return _SalesTerritoryHistoryList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private SalesTerritoryHistoryList _SalesTerritoryHistoryList = null;

        #endregion

        #region Sub Entites from Store

        /// <summary>
        /// List of sub entities Store / Store (SalesPersonID)
		/// Foreign Key FK_Store_SalesPerson_SalesPersonID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual StoreList StoreList
        {
            get
            {
			    // Lazy Loading
                if (_StoreList == null && this.BusinessEntityId != null)
                {
					var where = new SqlWhereClause("WHERE Store.SalesPersonID = @SalesPersonID",
					    "@SalesPersonID", this.BusinessEntityId);
                    _StoreList = ((AdvEntityManager)this.Manager).GetStoreList(where);
                }
				if (_StoreList == null)
				{
					_StoreList = new StoreList();
				}
                return _StoreList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private StoreList _StoreList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.SalesPersonFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "SalesPerson"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // SalesPerson

	#endregion

	#region Entity-List

    /// <summary>
    /// SalesPerson / SalesPersonList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class SalesPersonList
        : WebEntityList<SalesPerson>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "SalesPerson"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// SalesPerson - SalesPerson - Factory 
    /// </summary>
    public partial class SalesPersonFactory
        : WebEntityFactory<SalesPerson, SalesPersonList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property BusinessEntityId of Db-Field BusinessEntityID</summary>
        public static string Prop_BusinessEntityId = "BusinessEntityId";
        ///<summary>Property TerritoryId of Db-Field TerritoryID</summary>
        public static string Prop_TerritoryId = "TerritoryId";
        ///<summary>Property SalesQuota of Db-Field SalesQuota</summary>
        public static string Prop_SalesQuota = "SalesQuota";
        ///<summary>Property Bonus of Db-Field Bonus</summary>
        public static string Prop_Bonus = "Bonus";
        ///<summary>Property CommissionPct of Db-Field CommissionPct</summary>
        public static string Prop_CommissionPct = "CommissionPct";
        ///<summary>Property SalesYtd of Db-Field SalesYTD</summary>
        public static string Prop_SalesYtd = "SalesYtd";
        ///<summary>Property SalesLastYear of Db-Field SalesLastYear</summary>
        public static string Prop_SalesLastYear = "SalesLastYear";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field BusinessEntityID of Property BusinessEntityId</summary>
        public static string Field_BusinessEntityId = "BusinessEntityID";
        ///<summary>Db-Field TerritoryID of Property TerritoryId</summary>
        public static string Field_TerritoryId = "TerritoryID";
        ///<summary>Db-Field SalesQuota of Property SalesQuota</summary>
        public static string Field_SalesQuota = "SalesQuota";
        ///<summary>Db-Field Bonus of Property Bonus</summary>
        public static string Field_Bonus = "Bonus";
        ///<summary>Db-Field CommissionPct of Property CommissionPct</summary>
        public static string Field_CommissionPct = "CommissionPct";
        ///<summary>Db-Field SalesYTD of Property SalesYtd</summary>
        public static string Field_SalesYtd = "SalesYTD";
        ///<summary>Db-Field SalesLastYear of Property SalesLastYear</summary>
        public static string Field_SalesLastYear = "SalesLastYear";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = SalesPerson, 
		/// Fields       = "BusinessEntityID"
		/// Query        = ...
        /// </summary>
        protected SalesPersonFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Sales";
            this.TableName = "SalesPerson";
            this.Fields = new string[]
            {
                "BusinessEntityID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("BusinessEntityId", "int?", "BusinessEntityID", "int?", "", "Employee");
			this.Properties.Add("TerritoryId", "int?", "TerritoryID", "int?", "", "SalesTerritory");
			this.Properties.Add("SalesQuota", "decimal?", "SalesQuota", "decimal?", "", null);
			this.Properties.Add("Bonus", "decimal?", "Bonus", "decimal?", "", null);
			this.Properties.Add("CommissionPct", "decimal?", "CommissionPct", "decimal?", "", null);
			this.Properties.Add("SalesYtd", "decimal?", "SalesYTD", "decimal?", "", null);
			this.Properties.Add("SalesLastYear", "decimal?", "SalesLastYear", "decimal?", "", null);
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "SalesPerson"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "SalesPersonList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "SalesPersonFactory"; }
            set { }
        }

		#endregion

		internal static SalesPersonFactory CreateFactory(EntityManager manager)
		{
		    return new SalesPersonFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of SalesPerson. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo SalesPerson</returns>
        public override SalesPerson CreateEntity()
		{
			var item = new SalesPerson();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(SalesPerson item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Employee / Employee
            // Foreign Key FK_SalesPerson_Employee_BusinessEntityID
            if (parent is Employee)
            {
                item.Employee = (Employee)parent;
                return;
            }

            // make relation to parent/super Entity SalesTerritory / SalesTerritory
            // Foreign Key FK_SalesPerson_SalesTerritory_TerritoryID
            if (parent is SalesTerritory)
            {
                item.SalesTerritory = (SalesTerritory)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public SalesPerson GetItem(int? businessEntityId)
        {
            return this.GetEntity(0, businessEntityId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public SalesPerson GetItem(DbConnector conn, int? businessEntityId)
        {
            return this.GetEntity(conn, businessEntityId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(SalesPerson).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to SalesPersonFactory / SalesPerson / SalesPerson.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// SalesPersonFactory to SalesPerson / SalesPerson.
        /// </summary>
        public SalesPersonFactory SalesPersonFactory
		{
			get
			{
				if (_SalesPersonFactory == null)
				{
					_SalesPersonFactory = global::AdventureWorks.SalesPersonFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_SalesPersonFactory, typeof(SalesPerson));
				}
				return _SalesPersonFactory;
			}
		}
		private SalesPersonFactory _SalesPersonFactory = null;
	
        /// <summary>
        /// GetSalesPerson to SalesPerson / SalesPerson
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesPerson GetSalesPerson(int? businessEntityId)
        {
            return this.SalesPersonFactory.GetEntity(0, businessEntityId);
        }
	
        /// <summary>
        /// GetSalesPerson to SalesPerson / SalesPerson
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesPerson GetSalesPerson(DbConnector conn, int? businessEntityId)
        {
            return this.SalesPersonFactory.GetEntity(conn, businessEntityId);
        }
	
		/// <summary>
        /// GetSalesPersonList to SalesPerson / SalesPerson
		/// Getting a list of SalesPerson using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public SalesPersonList GetSalesPersonList(SqlWhereClause where)
        {
            return this.SalesPersonFactory.GetEntities(where);
        }

		/// <summary>
        /// GetSalesPersonList to SalesPerson / SalesPerson
		/// Getting all entities of SalesPerson
        /// </summary>
        /// <returns>List of all found entities</returns>
        public SalesPersonList GetSalesPersonList()
        {
			var where = new SqlWhereClause();
            return this.SalesPersonFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveSalesPerson to SalesPerson / SalesPerson
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesPerson SaveSalesPerson(SalesPerson item)
        {
            return this.SalesPersonFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveSalesPerson to SalesPerson / SalesPerson
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesPerson SaveSalesPerson(DbConnector conn, SalesPerson item)
        {
            return this.SalesPersonFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplySalesPerson to SalesPerson / SalesPerson
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesPerson ApplySalesPerson(DbConnector conn, SalesPerson item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.SalesPersonFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveSalesPerson to SalesPerson / SalesPerson
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveSalesPerson(SalesPerson item)
        {
            return this.SalesPersonFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveSalesPerson to SalesPerson / SalesPerson
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveSalesPerson(DbConnector conn, SalesPerson item)
        {
            return this.SalesPersonFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities SalesPersonList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveSalesPersonList(SalesPersonList items)
        {
			return this.SalesPersonFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
