﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// SalesReason / SalesReason - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class SalesReason
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for SalesReason
        /// </summary>
	    public SalesReason()
		{
		}

		///// <summary>
        ///// Creates a new instance of SalesReason
        ///// </summary>
	    //internal SalesReason CreateEntity()
		//{
		//    return new SalesReason();
		//}

		#region Members

		
        /// <summary>
        /// SalesReasonId / SalesReason.SalesReasonID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("SalesReasonID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? SalesReasonId
        {
            get
            {
                return (int?)this["SalesReasonID"];
            }
            set
            {
                this.Add("SalesReasonID", value, typeof(int?));
            }
        }

        /// <summary>
        /// Name / SalesReason.Name
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Name"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Name
        {
            get
            {
                return (string)this["Name"];
            }
            set
            {
                this.Add("Name", value, typeof(string));
            }
        }

        /// <summary>
        /// ReasonType / SalesReason.ReasonType
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ReasonType"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string ReasonType
        {
            get
            {
                return (string)this["ReasonType"];
            }
            set
            {
                this.Add("ReasonType", value, typeof(string));
            }
        }

        /// <summary>
        /// ModifiedDate / SalesReason.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		

		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from SalesOrderHeaderSalesReason

        /// <summary>
        /// List of sub entities SalesOrderHeaderSalesReason / SalesOrderHeaderSalesReason (SalesReasonID)
		/// Foreign Key FK_SalesOrderHeaderSalesReason_SalesReason_SalesReasonID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesOrderHeaderSalesReasonList SalesOrderHeaderSalesReasonList
        {
            get
            {
			    // Lazy Loading
                if (_SalesOrderHeaderSalesReasonList == null && this.SalesReasonId != null)
                {
					var where = new SqlWhereClause("WHERE SalesOrderHeaderSalesReason.SalesReasonID = @SalesReasonID",
					    "@SalesReasonID", this.SalesReasonId);
                    _SalesOrderHeaderSalesReasonList = ((AdvEntityManager)this.Manager).GetSalesOrderHeaderSalesReasonList(where);
                }
				if (_SalesOrderHeaderSalesReasonList == null)
				{
					_SalesOrderHeaderSalesReasonList = new SalesOrderHeaderSalesReasonList();
				}
                return _SalesOrderHeaderSalesReasonList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private SalesOrderHeaderSalesReasonList _SalesOrderHeaderSalesReasonList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.SalesReasonFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "SalesReason"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // SalesReason

	#endregion

	#region Entity-List

    /// <summary>
    /// SalesReason / SalesReasonList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class SalesReasonList
        : WebEntityList<SalesReason>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "SalesReason"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// SalesReason - SalesReason - Factory 
    /// </summary>
    public partial class SalesReasonFactory
        : WebEntityFactory<SalesReason, SalesReasonList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property SalesReasonId of Db-Field SalesReasonID</summary>
        public static string Prop_SalesReasonId = "SalesReasonId";
        ///<summary>Property Name of Db-Field Name</summary>
        public static string Prop_Name = "Name";
        ///<summary>Property ReasonType of Db-Field ReasonType</summary>
        public static string Prop_ReasonType = "ReasonType";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field SalesReasonID of Property SalesReasonId</summary>
        public static string Field_SalesReasonId = "SalesReasonID";
        ///<summary>Db-Field Name of Property Name</summary>
        public static string Field_Name = "Name";
        ///<summary>Db-Field ReasonType of Property ReasonType</summary>
        public static string Field_ReasonType = "ReasonType";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = SalesReason, 
		/// Fields       = "SalesReasonID"
		/// Query        = ...
        /// </summary>
        protected SalesReasonFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Sales";
            this.TableName = "SalesReason";
            this.Fields = new string[]
            {
                "SalesReasonID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("SalesReasonId", "int?", "SalesReasonID", "int?", "", null);
			this.Properties.Add("Name", "string", "Name", "string", "", null);
			this.Properties.Add("ReasonType", "string", "ReasonType", "string", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "SalesReason"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "SalesReasonList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "SalesReasonFactory"; }
            set { }
        }

		#endregion

		internal static SalesReasonFactory CreateFactory(EntityManager manager)
		{
		    return new SalesReasonFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of SalesReason. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo SalesReason</returns>
        public override SalesReason CreateEntity()
		{
			var item = new SalesReason();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}



		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public SalesReason GetItem(int? salesReasonId)
        {
            return this.GetEntity(0, salesReasonId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public SalesReason GetItem(DbConnector conn, int? salesReasonId)
        {
            return this.GetEntity(conn, salesReasonId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(SalesReason).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to SalesReasonFactory / SalesReason / SalesReason.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// SalesReasonFactory to SalesReason / SalesReason.
        /// </summary>
        public SalesReasonFactory SalesReasonFactory
		{
			get
			{
				if (_SalesReasonFactory == null)
				{
					_SalesReasonFactory = global::AdventureWorks.SalesReasonFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_SalesReasonFactory, typeof(SalesReason));
				}
				return _SalesReasonFactory;
			}
		}
		private SalesReasonFactory _SalesReasonFactory = null;
	
        /// <summary>
        /// GetSalesReason to SalesReason / SalesReason
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesReason GetSalesReason(int? salesReasonId)
        {
            return this.SalesReasonFactory.GetEntity(0, salesReasonId);
        }
	
        /// <summary>
        /// GetSalesReason to SalesReason / SalesReason
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesReason GetSalesReason(DbConnector conn, int? salesReasonId)
        {
            return this.SalesReasonFactory.GetEntity(conn, salesReasonId);
        }
	
		/// <summary>
        /// GetSalesReasonList to SalesReason / SalesReason
		/// Getting a list of SalesReason using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public SalesReasonList GetSalesReasonList(SqlWhereClause where)
        {
            return this.SalesReasonFactory.GetEntities(where);
        }

		/// <summary>
        /// GetSalesReasonList to SalesReason / SalesReason
		/// Getting all entities of SalesReason
        /// </summary>
        /// <returns>List of all found entities</returns>
        public SalesReasonList GetSalesReasonList()
        {
			var where = new SqlWhereClause();
            return this.SalesReasonFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveSalesReason to SalesReason / SalesReason
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesReason SaveSalesReason(SalesReason item)
        {
            return this.SalesReasonFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveSalesReason to SalesReason / SalesReason
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesReason SaveSalesReason(DbConnector conn, SalesReason item)
        {
            return this.SalesReasonFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplySalesReason to SalesReason / SalesReason
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesReason ApplySalesReason(DbConnector conn, SalesReason item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.SalesReasonFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveSalesReason to SalesReason / SalesReason
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveSalesReason(SalesReason item)
        {
            return this.SalesReasonFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveSalesReason to SalesReason / SalesReason
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveSalesReason(DbConnector conn, SalesReason item)
        {
            return this.SalesReasonFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities SalesReasonList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveSalesReasonList(SalesReasonList items)
        {
			return this.SalesReasonFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
