﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// Shift / Shift - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class Shift
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for Shift
        /// </summary>
	    public Shift()
		{
		}

		///// <summary>
        ///// Creates a new instance of Shift
        ///// </summary>
	    //internal Shift CreateEntity()
		//{
		//    return new Shift();
		//}

		#region Members

		
        /// <summary>
        /// ShiftId / Shift.ShiftID
        /// </summary>
        /// <returns>byte?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ShiftID"), FieldOrder(0), TypeName("byte?"), FieldTypeName("byte?"), ForeignEntity(null)]
        public virtual byte? ShiftId
        {
            get
            {
                return (byte?)this["ShiftID"];
            }
            set
            {
                this.Add("ShiftID", value, typeof(byte?));
            }
        }

        /// <summary>
        /// Name / Shift.Name
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Name"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Name
        {
            get
            {
                return (string)this["Name"];
            }
            set
            {
                this.Add("Name", value, typeof(string));
            }
        }

        /// <summary>
        /// StartTime / Shift.StartTime
        /// </summary>
        /// <returns>TimeSpan?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("StartTime"), FieldOrder(0), TypeName("TimeSpan?"), FieldTypeName("TimeSpan?"), ForeignEntity(null)]
        public virtual TimeSpan? StartTime
        {
            get
            {
                return (TimeSpan?)this["StartTime"];
            }
            set
            {
                this.Add("StartTime", value, typeof(TimeSpan?));
            }
        }

        /// <summary>
        /// EndTime / Shift.EndTime
        /// </summary>
        /// <returns>TimeSpan?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("EndTime"), FieldOrder(0), TypeName("TimeSpan?"), FieldTypeName("TimeSpan?"), ForeignEntity(null)]
        public virtual TimeSpan? EndTime
        {
            get
            {
                return (TimeSpan?)this["EndTime"];
            }
            set
            {
                this.Add("EndTime", value, typeof(TimeSpan?));
            }
        }

        /// <summary>
        /// ModifiedDate / Shift.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		

		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from EmployeeDepartmentHistory

        /// <summary>
        /// List of sub entities EmployeeDepartmentHistory / EmployeeDepartmentHistory (ShiftID)
		/// Foreign Key FK_EmployeeDepartmentHistory_Shift_ShiftID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual EmployeeDepartmentHistoryList EmployeeDepartmentHistoryList
        {
            get
            {
			    // Lazy Loading
                if (_EmployeeDepartmentHistoryList == null && this.ShiftId != null)
                {
					var where = new SqlWhereClause("WHERE EmployeeDepartmentHistory.ShiftID = @ShiftID",
					    "@ShiftID", this.ShiftId);
                    _EmployeeDepartmentHistoryList = ((AdvEntityManager)this.Manager).GetEmployeeDepartmentHistoryList(where);
                }
				if (_EmployeeDepartmentHistoryList == null)
				{
					_EmployeeDepartmentHistoryList = new EmployeeDepartmentHistoryList();
				}
                return _EmployeeDepartmentHistoryList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private EmployeeDepartmentHistoryList _EmployeeDepartmentHistoryList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.ShiftFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Shift"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // Shift

	#endregion

	#region Entity-List

    /// <summary>
    /// Shift / ShiftList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class ShiftList
        : WebEntityList<Shift>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Shift"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// Shift - Shift - Factory 
    /// </summary>
    public partial class ShiftFactory
        : WebEntityFactory<Shift, ShiftList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property ShiftId of Db-Field ShiftID</summary>
        public static string Prop_ShiftId = "ShiftId";
        ///<summary>Property Name of Db-Field Name</summary>
        public static string Prop_Name = "Name";
        ///<summary>Property StartTime of Db-Field StartTime</summary>
        public static string Prop_StartTime = "StartTime";
        ///<summary>Property EndTime of Db-Field EndTime</summary>
        public static string Prop_EndTime = "EndTime";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field ShiftID of Property ShiftId</summary>
        public static string Field_ShiftId = "ShiftID";
        ///<summary>Db-Field Name of Property Name</summary>
        public static string Field_Name = "Name";
        ///<summary>Db-Field StartTime of Property StartTime</summary>
        public static string Field_StartTime = "StartTime";
        ///<summary>Db-Field EndTime of Property EndTime</summary>
        public static string Field_EndTime = "EndTime";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = Shift, 
		/// Fields       = "ShiftID"
		/// Query        = ...
        /// </summary>
        protected ShiftFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "HumanResources";
            this.TableName = "Shift";
            this.Fields = new string[]
            {
                "ShiftID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("ShiftId", "byte?", "ShiftID", "byte?", "", null);
			this.Properties.Add("Name", "string", "Name", "string", "", null);
			this.Properties.Add("StartTime", "TimeSpan?", "StartTime", "TimeSpan?", "", null);
			this.Properties.Add("EndTime", "TimeSpan?", "EndTime", "TimeSpan?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "Shift"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "ShiftList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "ShiftFactory"; }
            set { }
        }

		#endregion

		internal static ShiftFactory CreateFactory(EntityManager manager)
		{
		    return new ShiftFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of Shift. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo Shift</returns>
        public override Shift CreateEntity()
		{
			var item = new Shift();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}



		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public Shift GetItem(byte? shiftId)
        {
            return this.GetEntity(0, shiftId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public Shift GetItem(DbConnector conn, byte? shiftId)
        {
            return this.GetEntity(conn, shiftId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(Shift).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to ShiftFactory / Shift / Shift.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// ShiftFactory to Shift / Shift.
        /// </summary>
        public ShiftFactory ShiftFactory
		{
			get
			{
				if (_ShiftFactory == null)
				{
					_ShiftFactory = global::AdventureWorks.ShiftFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_ShiftFactory, typeof(Shift));
				}
				return _ShiftFactory;
			}
		}
		private ShiftFactory _ShiftFactory = null;
	
        /// <summary>
        /// GetShift to Shift / Shift
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public Shift GetShift(byte? shiftId)
        {
            return this.ShiftFactory.GetEntity(0, shiftId);
        }
	
        /// <summary>
        /// GetShift to Shift / Shift
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Shift GetShift(DbConnector conn, byte? shiftId)
        {
            return this.ShiftFactory.GetEntity(conn, shiftId);
        }
	
		/// <summary>
        /// GetShiftList to Shift / Shift
		/// Getting a list of Shift using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public ShiftList GetShiftList(SqlWhereClause where)
        {
            return this.ShiftFactory.GetEntities(where);
        }

		/// <summary>
        /// GetShiftList to Shift / Shift
		/// Getting all entities of Shift
        /// </summary>
        /// <returns>List of all found entities</returns>
        public ShiftList GetShiftList()
        {
			var where = new SqlWhereClause();
            return this.ShiftFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveShift to Shift / Shift
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Shift SaveShift(Shift item)
        {
            return this.ShiftFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveShift to Shift / Shift
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Shift SaveShift(DbConnector conn, Shift item)
        {
            return this.ShiftFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyShift to Shift / Shift
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Shift ApplyShift(DbConnector conn, Shift item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.ShiftFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveShift to Shift / Shift
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveShift(Shift item)
        {
            return this.ShiftFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveShift to Shift / Shift
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveShift(DbConnector conn, Shift item)
        {
            return this.ShiftFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities ShiftList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveShiftList(ShiftList items)
        {
			return this.ShiftFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
