﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// ShipMethod / ShipMethod - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class ShipMethod
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for ShipMethod
        /// </summary>
	    public ShipMethod()
		{
		}

		///// <summary>
        ///// Creates a new instance of ShipMethod
        ///// </summary>
	    //internal ShipMethod CreateEntity()
		//{
		//    return new ShipMethod();
		//}

		#region Members

		
        /// <summary>
        /// ShipMethodId / ShipMethod.ShipMethodID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ShipMethodID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? ShipMethodId
        {
            get
            {
                return (int?)this["ShipMethodID"];
            }
            set
            {
                this.Add("ShipMethodID", value, typeof(int?));
            }
        }

        /// <summary>
        /// Name / ShipMethod.Name
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Name"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Name
        {
            get
            {
                return (string)this["Name"];
            }
            set
            {
                this.Add("Name", value, typeof(string));
            }
        }

        /// <summary>
        /// ShipBase / ShipMethod.ShipBase
        /// </summary>
        /// <returns>decimal?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ShipBase"), FieldOrder(0), TypeName("decimal?"), FieldTypeName("decimal?"), ForeignEntity(null)]
        public virtual decimal? ShipBase
        {
            get
            {
                return (decimal?)this["ShipBase"];
            }
            set
            {
                this.Add("ShipBase", value, typeof(decimal?));
            }
        }

        /// <summary>
        /// ShipRate / ShipMethod.ShipRate
        /// </summary>
        /// <returns>decimal?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ShipRate"), FieldOrder(0), TypeName("decimal?"), FieldTypeName("decimal?"), ForeignEntity(null)]
        public virtual decimal? ShipRate
        {
            get
            {
                return (decimal?)this["ShipRate"];
            }
            set
            {
                this.Add("ShipRate", value, typeof(decimal?));
            }
        }

        /// <summary>
        /// Rowguid / ShipMethod.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / ShipMethod.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		

		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from PurchaseOrderHeader

        /// <summary>
        /// List of sub entities PurchaseOrderHeader / PurchaseOrderHeader (ShipMethodID)
		/// Foreign Key FK_PurchaseOrderHeader_ShipMethod_ShipMethodID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual PurchaseOrderHeaderList PurchaseOrderHeaderList
        {
            get
            {
			    // Lazy Loading
                if (_PurchaseOrderHeaderList == null && this.ShipMethodId != null)
                {
					var where = new SqlWhereClause("WHERE PurchaseOrderHeader.ShipMethodID = @ShipMethodID",
					    "@ShipMethodID", this.ShipMethodId);
                    _PurchaseOrderHeaderList = ((AdvEntityManager)this.Manager).GetPurchaseOrderHeaderList(where);
                }
				if (_PurchaseOrderHeaderList == null)
				{
					_PurchaseOrderHeaderList = new PurchaseOrderHeaderList();
				}
                return _PurchaseOrderHeaderList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private PurchaseOrderHeaderList _PurchaseOrderHeaderList = null;

        #endregion

        #region Sub Entites from SalesOrderHeader

        /// <summary>
        /// List of sub entities SalesOrderHeader / SalesOrderHeader (ShipMethodID)
		/// Foreign Key FK_SalesOrderHeader_ShipMethod_ShipMethodID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesOrderHeaderList SalesOrderHeaderList
        {
            get
            {
			    // Lazy Loading
                if (_SalesOrderHeaderList == null && this.ShipMethodId != null)
                {
					var where = new SqlWhereClause("WHERE SalesOrderHeader.ShipMethodID = @ShipMethodID",
					    "@ShipMethodID", this.ShipMethodId);
                    _SalesOrderHeaderList = ((AdvEntityManager)this.Manager).GetSalesOrderHeaderList(where);
                }
				if (_SalesOrderHeaderList == null)
				{
					_SalesOrderHeaderList = new SalesOrderHeaderList();
				}
                return _SalesOrderHeaderList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private SalesOrderHeaderList _SalesOrderHeaderList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.ShipMethodFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ShipMethod"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // ShipMethod

	#endregion

	#region Entity-List

    /// <summary>
    /// ShipMethod / ShipMethodList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class ShipMethodList
        : WebEntityList<ShipMethod>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ShipMethod"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// ShipMethod - ShipMethod - Factory 
    /// </summary>
    public partial class ShipMethodFactory
        : WebEntityFactory<ShipMethod, ShipMethodList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property ShipMethodId of Db-Field ShipMethodID</summary>
        public static string Prop_ShipMethodId = "ShipMethodId";
        ///<summary>Property Name of Db-Field Name</summary>
        public static string Prop_Name = "Name";
        ///<summary>Property ShipBase of Db-Field ShipBase</summary>
        public static string Prop_ShipBase = "ShipBase";
        ///<summary>Property ShipRate of Db-Field ShipRate</summary>
        public static string Prop_ShipRate = "ShipRate";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field ShipMethodID of Property ShipMethodId</summary>
        public static string Field_ShipMethodId = "ShipMethodID";
        ///<summary>Db-Field Name of Property Name</summary>
        public static string Field_Name = "Name";
        ///<summary>Db-Field ShipBase of Property ShipBase</summary>
        public static string Field_ShipBase = "ShipBase";
        ///<summary>Db-Field ShipRate of Property ShipRate</summary>
        public static string Field_ShipRate = "ShipRate";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = ShipMethod, 
		/// Fields       = "ShipMethodID"
		/// Query        = ...
        /// </summary>
        protected ShipMethodFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Purchasing";
            this.TableName = "ShipMethod";
            this.Fields = new string[]
            {
                "ShipMethodID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("ShipMethodId", "int?", "ShipMethodID", "int?", "", null);
			this.Properties.Add("Name", "string", "Name", "string", "", null);
			this.Properties.Add("ShipBase", "decimal?", "ShipBase", "decimal?", "", null);
			this.Properties.Add("ShipRate", "decimal?", "ShipRate", "decimal?", "", null);
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "ShipMethod"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "ShipMethodList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "ShipMethodFactory"; }
            set { }
        }

		#endregion

		internal static ShipMethodFactory CreateFactory(EntityManager manager)
		{
		    return new ShipMethodFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of ShipMethod. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo ShipMethod</returns>
        public override ShipMethod CreateEntity()
		{
			var item = new ShipMethod();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}



		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public ShipMethod GetItem(int? shipMethodId)
        {
            return this.GetEntity(0, shipMethodId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public ShipMethod GetItem(DbConnector conn, int? shipMethodId)
        {
            return this.GetEntity(conn, shipMethodId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(ShipMethod).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to ShipMethodFactory / ShipMethod / ShipMethod.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// ShipMethodFactory to ShipMethod / ShipMethod.
        /// </summary>
        public ShipMethodFactory ShipMethodFactory
		{
			get
			{
				if (_ShipMethodFactory == null)
				{
					_ShipMethodFactory = global::AdventureWorks.ShipMethodFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_ShipMethodFactory, typeof(ShipMethod));
				}
				return _ShipMethodFactory;
			}
		}
		private ShipMethodFactory _ShipMethodFactory = null;
	
        /// <summary>
        /// GetShipMethod to ShipMethod / ShipMethod
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public ShipMethod GetShipMethod(int? shipMethodId)
        {
            return this.ShipMethodFactory.GetEntity(0, shipMethodId);
        }
	
        /// <summary>
        /// GetShipMethod to ShipMethod / ShipMethod
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ShipMethod GetShipMethod(DbConnector conn, int? shipMethodId)
        {
            return this.ShipMethodFactory.GetEntity(conn, shipMethodId);
        }
	
		/// <summary>
        /// GetShipMethodList to ShipMethod / ShipMethod
		/// Getting a list of ShipMethod using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public ShipMethodList GetShipMethodList(SqlWhereClause where)
        {
            return this.ShipMethodFactory.GetEntities(where);
        }

		/// <summary>
        /// GetShipMethodList to ShipMethod / ShipMethod
		/// Getting all entities of ShipMethod
        /// </summary>
        /// <returns>List of all found entities</returns>
        public ShipMethodList GetShipMethodList()
        {
			var where = new SqlWhereClause();
            return this.ShipMethodFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveShipMethod to ShipMethod / ShipMethod
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ShipMethod SaveShipMethod(ShipMethod item)
        {
            return this.ShipMethodFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveShipMethod to ShipMethod / ShipMethod
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ShipMethod SaveShipMethod(DbConnector conn, ShipMethod item)
        {
            return this.ShipMethodFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyShipMethod to ShipMethod / ShipMethod
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ShipMethod ApplyShipMethod(DbConnector conn, ShipMethod item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.ShipMethodFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveShipMethod to ShipMethod / ShipMethod
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveShipMethod(ShipMethod item)
        {
            return this.ShipMethodFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveShipMethod to ShipMethod / ShipMethod
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveShipMethod(DbConnector conn, ShipMethod item)
        {
            return this.ShipMethodFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities ShipMethodList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveShipMethodList(ShipMethodList items)
        {
			return this.ShipMethodFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
