﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// SpecialOfferProduct / SpecialOfferProduct - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class SpecialOfferProduct
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for SpecialOfferProduct
        /// </summary>
	    public SpecialOfferProduct()
		{
		}

		///// <summary>
        ///// Creates a new instance of SpecialOfferProduct
        ///// </summary>
	    //internal SpecialOfferProduct CreateEntity()
		//{
		//    return new SpecialOfferProduct();
		//}

		#region Members

		
        /// <summary>
        /// SpecialOfferId / SpecialOfferProduct.SpecialOfferID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("SpecialOfferID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("SpecialOffer")]
        public virtual int? SpecialOfferId
        {
            get
            {
                return (int?)this["SpecialOfferID"];
            }
            set
            {
                this.Add("SpecialOfferID", value, typeof(int?));
            }
        }

        /// <summary>
        /// ProductId / SpecialOfferProduct.ProductID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Product")]
        public virtual int? ProductId
        {
            get
            {
                return (int?)this["ProductID"];
            }
            set
            {
                this.Add("ProductID", value, typeof(int?));
            }
        }

        /// <summary>
        /// Rowguid / SpecialOfferProduct.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / SpecialOfferProduct.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Product

        /// <summary>
        /// Link to parent/super Entity Product / Product (this.ProductId)
		/// Foreign key FK_SpecialOfferProduct_Product_ProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Product Product
        {
            get
            {
			    // Lazy loading
                if (this._Product == null && this.ProductId != null)
                {
                    this._Product = ((AdvEntityManager)this.Manager).GetProduct(this.ProductId);
                    if (! _Product.ResultInfo.IsValid)
                    {
						this._Product = null; // reset value
                        throw new Exception("wrong/missed constraint from SpecialOfferProduct to Product.");
                    }
                }
                return this._Product;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ProductId = (value != null ? value.ProductId : null);


				// set foreign table
                this._Product = value;
            }
        }
        private Product _Product = null;

        #endregion

        #region foreign constraint (parent entity) to SpecialOffer

        /// <summary>
        /// Link to parent/super Entity SpecialOffer / SpecialOffer (this.SpecialOfferId)
		/// Foreign key FK_SpecialOfferProduct_SpecialOffer_SpecialOfferID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SpecialOffer SpecialOffer
        {
            get
            {
			    // Lazy loading
                if (this._SpecialOffer == null && this.SpecialOfferId != null)
                {
                    this._SpecialOffer = ((AdvEntityManager)this.Manager).GetSpecialOffer(this.SpecialOfferId);
                    if (! _SpecialOffer.ResultInfo.IsValid)
                    {
						this._SpecialOffer = null; // reset value
                        throw new Exception("wrong/missed constraint from SpecialOfferProduct to SpecialOffer.");
                    }
                }
                return this._SpecialOffer;
            }
            set
            {
                // reassign foreign key values from setter value
                this.SpecialOfferId = (value != null ? value.SpecialOfferId : null);


				// set foreign table
                this._SpecialOffer = value;
            }
        }
        private SpecialOffer _SpecialOffer = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from SalesOrderDetail

        /// <summary>
        /// List of sub entities SalesOrderDetail / SalesOrderDetail (SpecialOfferID, ProductID)
		/// Foreign Key FK_SalesOrderDetail_SpecialOfferProduct_SpecialOfferIDProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesOrderDetailList SalesOrderDetailList
        {
            get
            {
			    // Lazy Loading
                if (_SalesOrderDetailList == null && this.SpecialOfferId != null)
                {
					var where = new SqlWhereClause("WHERE SalesOrderDetail.SpecialOfferID = @SpecialOfferID AND SalesOrderDetail.ProductID = @ProductID",
					    "@SpecialOfferID", this.SpecialOfferId,
					    "@ProductID", this.ProductId);
                    _SalesOrderDetailList = ((AdvEntityManager)this.Manager).GetSalesOrderDetailList(where);
                }
				if (_SalesOrderDetailList == null)
				{
					_SalesOrderDetailList = new SalesOrderDetailList();
				}
                return _SalesOrderDetailList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private SalesOrderDetailList _SalesOrderDetailList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.SpecialOfferProductFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "SpecialOfferProduct"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // SpecialOfferProduct

	#endregion

	#region Entity-List

    /// <summary>
    /// SpecialOfferProduct / SpecialOfferProductList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class SpecialOfferProductList
        : WebEntityList<SpecialOfferProduct>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "SpecialOfferProduct"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// SpecialOfferProduct - SpecialOfferProduct - Factory 
    /// </summary>
    public partial class SpecialOfferProductFactory
        : WebEntityFactory<SpecialOfferProduct, SpecialOfferProductList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property SpecialOfferId of Db-Field SpecialOfferID</summary>
        public static string Prop_SpecialOfferId = "SpecialOfferId";
        ///<summary>Property ProductId of Db-Field ProductID</summary>
        public static string Prop_ProductId = "ProductId";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field SpecialOfferID of Property SpecialOfferId</summary>
        public static string Field_SpecialOfferId = "SpecialOfferID";
        ///<summary>Db-Field ProductID of Property ProductId</summary>
        public static string Field_ProductId = "ProductID";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = SpecialOfferProduct, 
		/// Fields       = "SpecialOfferID", "ProductID"
		/// Query        = ...
        /// </summary>
        protected SpecialOfferProductFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Sales";
            this.TableName = "SpecialOfferProduct";
            this.Fields = new string[]
            {
                "SpecialOfferID", "ProductID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("SpecialOfferId", "int?", "SpecialOfferID", "int?", "", "SpecialOffer");
			this.Properties.Add("ProductId", "int?", "ProductID", "int?", "", "Product");
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "SpecialOfferProduct"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "SpecialOfferProductList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "SpecialOfferProductFactory"; }
            set { }
        }

		#endregion

		internal static SpecialOfferProductFactory CreateFactory(EntityManager manager)
		{
		    return new SpecialOfferProductFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of SpecialOfferProduct. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo SpecialOfferProduct</returns>
        public override SpecialOfferProduct CreateEntity()
		{
			var item = new SpecialOfferProduct();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(SpecialOfferProduct item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Product / Product
            // Foreign Key FK_SpecialOfferProduct_Product_ProductID
            if (parent is Product)
            {
                item.Product = (Product)parent;
                return;
            }

            // make relation to parent/super Entity SpecialOffer / SpecialOffer
            // Foreign Key FK_SpecialOfferProduct_SpecialOffer_SpecialOfferID
            if (parent is SpecialOffer)
            {
                item.SpecialOffer = (SpecialOffer)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public SpecialOfferProduct GetItem(int? specialOfferId, int? productId)
        {
            return this.GetEntity(0, specialOfferId, productId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public SpecialOfferProduct GetItem(DbConnector conn, int? specialOfferId, int? productId)
        {
            return this.GetEntity(conn, specialOfferId, productId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(SpecialOfferProduct).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to SpecialOfferProductFactory / SpecialOfferProduct / SpecialOfferProduct.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// SpecialOfferProductFactory to SpecialOfferProduct / SpecialOfferProduct.
        /// </summary>
        public SpecialOfferProductFactory SpecialOfferProductFactory
		{
			get
			{
				if (_SpecialOfferProductFactory == null)
				{
					_SpecialOfferProductFactory = global::AdventureWorks.SpecialOfferProductFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_SpecialOfferProductFactory, typeof(SpecialOfferProduct));
				}
				return _SpecialOfferProductFactory;
			}
		}
		private SpecialOfferProductFactory _SpecialOfferProductFactory = null;
	
        /// <summary>
        /// GetSpecialOfferProduct to SpecialOfferProduct / SpecialOfferProduct
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public SpecialOfferProduct GetSpecialOfferProduct(int? specialOfferId, int? productId)
        {
            return this.SpecialOfferProductFactory.GetEntity(0, specialOfferId, productId);
        }
	
        /// <summary>
        /// GetSpecialOfferProduct to SpecialOfferProduct / SpecialOfferProduct
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SpecialOfferProduct GetSpecialOfferProduct(DbConnector conn, int? specialOfferId, int? productId)
        {
            return this.SpecialOfferProductFactory.GetEntity(conn, specialOfferId, productId);
        }
	
		/// <summary>
        /// GetSpecialOfferProductList to SpecialOfferProduct / SpecialOfferProduct
		/// Getting a list of SpecialOfferProduct using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public SpecialOfferProductList GetSpecialOfferProductList(SqlWhereClause where)
        {
            return this.SpecialOfferProductFactory.GetEntities(where);
        }

		/// <summary>
        /// GetSpecialOfferProductList to SpecialOfferProduct / SpecialOfferProduct
		/// Getting all entities of SpecialOfferProduct
        /// </summary>
        /// <returns>List of all found entities</returns>
        public SpecialOfferProductList GetSpecialOfferProductList()
        {
			var where = new SqlWhereClause();
            return this.SpecialOfferProductFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveSpecialOfferProduct to SpecialOfferProduct / SpecialOfferProduct
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SpecialOfferProduct SaveSpecialOfferProduct(SpecialOfferProduct item)
        {
            return this.SpecialOfferProductFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveSpecialOfferProduct to SpecialOfferProduct / SpecialOfferProduct
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SpecialOfferProduct SaveSpecialOfferProduct(DbConnector conn, SpecialOfferProduct item)
        {
            return this.SpecialOfferProductFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplySpecialOfferProduct to SpecialOfferProduct / SpecialOfferProduct
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SpecialOfferProduct ApplySpecialOfferProduct(DbConnector conn, SpecialOfferProduct item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.SpecialOfferProductFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveSpecialOfferProduct to SpecialOfferProduct / SpecialOfferProduct
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveSpecialOfferProduct(SpecialOfferProduct item)
        {
            return this.SpecialOfferProductFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveSpecialOfferProduct to SpecialOfferProduct / SpecialOfferProduct
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveSpecialOfferProduct(DbConnector conn, SpecialOfferProduct item)
        {
            return this.SpecialOfferProductFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities SpecialOfferProductList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveSpecialOfferProductList(SpecialOfferProductList items)
        {
			return this.SpecialOfferProductFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
