﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// StateProvince / StateProvince - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class StateProvince
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for StateProvince
        /// </summary>
	    public StateProvince()
		{
		}

		///// <summary>
        ///// Creates a new instance of StateProvince
        ///// </summary>
	    //internal StateProvince CreateEntity()
		//{
		//    return new StateProvince();
		//}

		#region Members

		
        /// <summary>
        /// StateProvinceId / StateProvince.StateProvinceID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("StateProvinceID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? StateProvinceId
        {
            get
            {
                return (int?)this["StateProvinceID"];
            }
            set
            {
                this.Add("StateProvinceID", value, typeof(int?));
            }
        }

        /// <summary>
        /// StateProvinceCode / StateProvince.StateProvinceCode
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("StateProvinceCode"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string StateProvinceCode
        {
            get
            {
                return (string)this["StateProvinceCode"];
            }
            set
            {
                this.Add("StateProvinceCode", value, typeof(string));
            }
        }

        /// <summary>
        /// CountryRegionCode / StateProvince.CountryRegionCode
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("CountryRegionCode"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity("CountryRegion")]
        public virtual string CountryRegionCode
        {
            get
            {
                return (string)this["CountryRegionCode"];
            }
            set
            {
                this.Add("CountryRegionCode", value, typeof(string));
            }
        }

        /// <summary>
        /// IsOnlyStateProvinceFlag / StateProvince.IsOnlyStateProvinceFlag
        /// </summary>
        /// <returns>bool?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("IsOnlyStateProvinceFlag"), FieldOrder(0), TypeName("bool?"), FieldTypeName("bool?"), ForeignEntity(null)]
        public virtual bool? IsOnlyStateProvinceFlag
        {
            get
            {
                return (bool?)this["IsOnlyStateProvinceFlag"];
            }
            set
            {
                this.Add("IsOnlyStateProvinceFlag", value, typeof(bool?));
            }
        }

        /// <summary>
        /// Name / StateProvince.Name
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Name"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Name
        {
            get
            {
                return (string)this["Name"];
            }
            set
            {
                this.Add("Name", value, typeof(string));
            }
        }

        /// <summary>
        /// TerritoryId / StateProvince.TerritoryID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("TerritoryID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("SalesTerritory")]
        public virtual int? TerritoryId
        {
            get
            {
                return (int?)this["TerritoryID"];
            }
            set
            {
                this.Add("TerritoryID", value, typeof(int?));
            }
        }

        /// <summary>
        /// Rowguid / StateProvince.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / StateProvince.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to CountryRegion

        /// <summary>
        /// Link to parent/super Entity CountryRegion / CountryRegion (this.CountryRegionCode)
		/// Foreign key FK_StateProvince_CountryRegion_CountryRegionCode
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual CountryRegion CountryRegion
        {
            get
            {
			    // Lazy loading
                if (this._CountryRegion == null && this.CountryRegionCode != null)
                {
                    this._CountryRegion = ((AdvEntityManager)this.Manager).GetCountryRegion(this.CountryRegionCode);
                    if (! _CountryRegion.ResultInfo.IsValid)
                    {
						this._CountryRegion = null; // reset value
                        throw new Exception("wrong/missed constraint from StateProvince to CountryRegion.");
                    }
                }
                return this._CountryRegion;
            }
            set
            {
                // reassign foreign key values from setter value
                this.CountryRegionCode = (value != null ? value.CountryRegionCode : null);


				// set foreign table
                this._CountryRegion = value;
            }
        }
        private CountryRegion _CountryRegion = null;

        #endregion

        #region foreign constraint (parent entity) to SalesTerritory

        /// <summary>
        /// Link to parent/super Entity SalesTerritory / SalesTerritory (this.TerritoryId)
		/// Foreign key FK_StateProvince_SalesTerritory_TerritoryID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesTerritory SalesTerritory
        {
            get
            {
			    // Lazy loading
                if (this._SalesTerritory == null && this.TerritoryId != null)
                {
                    this._SalesTerritory = ((AdvEntityManager)this.Manager).GetSalesTerritory(this.TerritoryId);
                    if (! _SalesTerritory.ResultInfo.IsValid)
                    {
						this._SalesTerritory = null; // reset value
                        throw new Exception("wrong/missed constraint from StateProvince to SalesTerritory.");
                    }
                }
                return this._SalesTerritory;
            }
            set
            {
                // reassign foreign key values from setter value
                this.TerritoryId = (value != null ? value.TerritoryId : null);


				// set foreign table
                this._SalesTerritory = value;
            }
        }
        private SalesTerritory _SalesTerritory = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from Address

        /// <summary>
        /// List of sub entities Address / Address (StateProvinceID)
		/// Foreign Key FK_Address_StateProvince_StateProvinceID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual AddressList AddressList
        {
            get
            {
			    // Lazy Loading
                if (_AddressList == null && this.StateProvinceId != null)
                {
					var where = new SqlWhereClause("WHERE Address.StateProvinceID = @StateProvinceID",
					    "@StateProvinceID", this.StateProvinceId);
                    _AddressList = ((AdvEntityManager)this.Manager).GetAddressList(where);
                }
				if (_AddressList == null)
				{
					_AddressList = new AddressList();
				}
                return _AddressList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private AddressList _AddressList = null;

        #endregion

        #region Sub Entites from SalesTaxRate

        /// <summary>
        /// List of sub entities SalesTaxRate / SalesTaxRate (StateProvinceID)
		/// Foreign Key FK_SalesTaxRate_StateProvince_StateProvinceID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesTaxRateList SalesTaxRateList
        {
            get
            {
			    // Lazy Loading
                if (_SalesTaxRateList == null && this.StateProvinceId != null)
                {
					var where = new SqlWhereClause("WHERE SalesTaxRate.StateProvinceID = @StateProvinceID",
					    "@StateProvinceID", this.StateProvinceId);
                    _SalesTaxRateList = ((AdvEntityManager)this.Manager).GetSalesTaxRateList(where);
                }
				if (_SalesTaxRateList == null)
				{
					_SalesTaxRateList = new SalesTaxRateList();
				}
                return _SalesTaxRateList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private SalesTaxRateList _SalesTaxRateList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.StateProvinceFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "StateProvince"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // StateProvince

	#endregion

	#region Entity-List

    /// <summary>
    /// StateProvince / StateProvinceList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class StateProvinceList
        : WebEntityList<StateProvince>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "StateProvince"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// StateProvince - StateProvince - Factory 
    /// </summary>
    public partial class StateProvinceFactory
        : WebEntityFactory<StateProvince, StateProvinceList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property StateProvinceId of Db-Field StateProvinceID</summary>
        public static string Prop_StateProvinceId = "StateProvinceId";
        ///<summary>Property StateProvinceCode of Db-Field StateProvinceCode</summary>
        public static string Prop_StateProvinceCode = "StateProvinceCode";
        ///<summary>Property CountryRegionCode of Db-Field CountryRegionCode</summary>
        public static string Prop_CountryRegionCode = "CountryRegionCode";
        ///<summary>Property IsOnlyStateProvinceFlag of Db-Field IsOnlyStateProvinceFlag</summary>
        public static string Prop_IsOnlyStateProvinceFlag = "IsOnlyStateProvinceFlag";
        ///<summary>Property Name of Db-Field Name</summary>
        public static string Prop_Name = "Name";
        ///<summary>Property TerritoryId of Db-Field TerritoryID</summary>
        public static string Prop_TerritoryId = "TerritoryId";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field StateProvinceID of Property StateProvinceId</summary>
        public static string Field_StateProvinceId = "StateProvinceID";
        ///<summary>Db-Field StateProvinceCode of Property StateProvinceCode</summary>
        public static string Field_StateProvinceCode = "StateProvinceCode";
        ///<summary>Db-Field CountryRegionCode of Property CountryRegionCode</summary>
        public static string Field_CountryRegionCode = "CountryRegionCode";
        ///<summary>Db-Field IsOnlyStateProvinceFlag of Property IsOnlyStateProvinceFlag</summary>
        public static string Field_IsOnlyStateProvinceFlag = "IsOnlyStateProvinceFlag";
        ///<summary>Db-Field Name of Property Name</summary>
        public static string Field_Name = "Name";
        ///<summary>Db-Field TerritoryID of Property TerritoryId</summary>
        public static string Field_TerritoryId = "TerritoryID";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = StateProvince, 
		/// Fields       = "StateProvinceID"
		/// Query        = ...
        /// </summary>
        protected StateProvinceFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Person";
            this.TableName = "StateProvince";
            this.Fields = new string[]
            {
                "StateProvinceID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("StateProvinceId", "int?", "StateProvinceID", "int?", "", null);
			this.Properties.Add("StateProvinceCode", "string", "StateProvinceCode", "string", "", null);
			this.Properties.Add("CountryRegionCode", "string", "CountryRegionCode", "string", "", "CountryRegion");
			this.Properties.Add("IsOnlyStateProvinceFlag", "bool?", "IsOnlyStateProvinceFlag", "bool?", "", null);
			this.Properties.Add("Name", "string", "Name", "string", "", null);
			this.Properties.Add("TerritoryId", "int?", "TerritoryID", "int?", "", "SalesTerritory");
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "StateProvince"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "StateProvinceList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "StateProvinceFactory"; }
            set { }
        }

		#endregion

		internal static StateProvinceFactory CreateFactory(EntityManager manager)
		{
		    return new StateProvinceFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of StateProvince. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo StateProvince</returns>
        public override StateProvince CreateEntity()
		{
			var item = new StateProvince();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(StateProvince item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity CountryRegion / CountryRegion
            // Foreign Key FK_StateProvince_CountryRegion_CountryRegionCode
            if (parent is CountryRegion)
            {
                item.CountryRegion = (CountryRegion)parent;
                return;
            }

            // make relation to parent/super Entity SalesTerritory / SalesTerritory
            // Foreign Key FK_StateProvince_SalesTerritory_TerritoryID
            if (parent is SalesTerritory)
            {
                item.SalesTerritory = (SalesTerritory)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public StateProvince GetItem(int? stateProvinceId)
        {
            return this.GetEntity(0, stateProvinceId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public StateProvince GetItem(DbConnector conn, int? stateProvinceId)
        {
            return this.GetEntity(conn, stateProvinceId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(StateProvince).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to StateProvinceFactory / StateProvince / StateProvince.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// StateProvinceFactory to StateProvince / StateProvince.
        /// </summary>
        public StateProvinceFactory StateProvinceFactory
		{
			get
			{
				if (_StateProvinceFactory == null)
				{
					_StateProvinceFactory = global::AdventureWorks.StateProvinceFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_StateProvinceFactory, typeof(StateProvince));
				}
				return _StateProvinceFactory;
			}
		}
		private StateProvinceFactory _StateProvinceFactory = null;
	
        /// <summary>
        /// GetStateProvince to StateProvince / StateProvince
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public StateProvince GetStateProvince(int? stateProvinceId)
        {
            return this.StateProvinceFactory.GetEntity(0, stateProvinceId);
        }
	
        /// <summary>
        /// GetStateProvince to StateProvince / StateProvince
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public StateProvince GetStateProvince(DbConnector conn, int? stateProvinceId)
        {
            return this.StateProvinceFactory.GetEntity(conn, stateProvinceId);
        }
	
		/// <summary>
        /// GetStateProvinceList to StateProvince / StateProvince
		/// Getting a list of StateProvince using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public StateProvinceList GetStateProvinceList(SqlWhereClause where)
        {
            return this.StateProvinceFactory.GetEntities(where);
        }

		/// <summary>
        /// GetStateProvinceList to StateProvince / StateProvince
		/// Getting all entities of StateProvince
        /// </summary>
        /// <returns>List of all found entities</returns>
        public StateProvinceList GetStateProvinceList()
        {
			var where = new SqlWhereClause();
            return this.StateProvinceFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveStateProvince to StateProvince / StateProvince
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public StateProvince SaveStateProvince(StateProvince item)
        {
            return this.StateProvinceFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveStateProvince to StateProvince / StateProvince
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public StateProvince SaveStateProvince(DbConnector conn, StateProvince item)
        {
            return this.StateProvinceFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyStateProvince to StateProvince / StateProvince
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public StateProvince ApplyStateProvince(DbConnector conn, StateProvince item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.StateProvinceFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveStateProvince to StateProvince / StateProvince
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveStateProvince(StateProvince item)
        {
            return this.StateProvinceFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveStateProvince to StateProvince / StateProvince
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveStateProvince(DbConnector conn, StateProvince item)
        {
            return this.StateProvinceFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities StateProvinceList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveStateProvinceList(StateProvinceList items)
        {
			return this.StateProvinceFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
