﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// Store / Store - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class Store
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for Store
        /// </summary>
	    public Store()
		{
		}

		///// <summary>
        ///// Creates a new instance of Store
        ///// </summary>
	    //internal Store CreateEntity()
		//{
		//    return new Store();
		//}

		#region Members

		
        /// <summary>
        /// BusinessEntityId / Store.BusinessEntityID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("BusinessEntityID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("BusinessEntity")]
        public virtual int? BusinessEntityId
        {
            get
            {
                return (int?)this["BusinessEntityID"];
            }
            set
            {
                this.Add("BusinessEntityID", value, typeof(int?));
            }
        }

        /// <summary>
        /// Name / Store.Name
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Name"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Name
        {
            get
            {
                return (string)this["Name"];
            }
            set
            {
                this.Add("Name", value, typeof(string));
            }
        }

        /// <summary>
        /// SalesPersonId / Store.SalesPersonID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("SalesPersonID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("SalesPerson")]
        public virtual int? SalesPersonId
        {
            get
            {
                return (int?)this["SalesPersonID"];
            }
            set
            {
                this.Add("SalesPersonID", value, typeof(int?));
            }
        }

        /// <summary>
        /// Demographics / Store.Demographics
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Demographics"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Demographics
        {
            get
            {
                return (string)this["Demographics"];
            }
            set
            {
                this.Add("Demographics", value, typeof(string));
            }
        }

        /// <summary>
        /// Rowguid / Store.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / Store.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to BusinessEntity

        /// <summary>
        /// Link to parent/super Entity BusinessEntity / BusinessEntity (this.BusinessEntityId)
		/// Foreign key FK_Store_BusinessEntity_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual BusinessEntity BusinessEntity
        {
            get
            {
			    // Lazy loading
                if (this._BusinessEntity == null && this.BusinessEntityId != null)
                {
                    this._BusinessEntity = ((AdvEntityManager)this.Manager).GetBusinessEntity(this.BusinessEntityId);
                    if (! _BusinessEntity.ResultInfo.IsValid)
                    {
						this._BusinessEntity = null; // reset value
                        throw new Exception("wrong/missed constraint from Store to BusinessEntity.");
                    }
                }
                return this._BusinessEntity;
            }
            set
            {
                // reassign foreign key values from setter value
                this.BusinessEntityId = (value != null ? value.BusinessEntityId : null);


				// set foreign table
                this._BusinessEntity = value;
            }
        }
        private BusinessEntity _BusinessEntity = null;

        #endregion

        #region foreign constraint (parent entity) to SalesPerson

        /// <summary>
        /// Link to parent/super Entity SalesPerson / SalesPerson (this.SalesPersonId)
		/// Foreign key FK_Store_SalesPerson_SalesPersonID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesPerson SalesPerson
        {
            get
            {
			    // Lazy loading
                if (this._SalesPerson == null && this.SalesPersonId != null)
                {
                    this._SalesPerson = ((AdvEntityManager)this.Manager).GetSalesPerson(this.SalesPersonId);
                    if (! _SalesPerson.ResultInfo.IsValid)
                    {
						this._SalesPerson = null; // reset value
                        throw new Exception("wrong/missed constraint from Store to SalesPerson.");
                    }
                }
                return this._SalesPerson;
            }
            set
            {
                // reassign foreign key values from setter value
                this.SalesPersonId = (value != null ? value.BusinessEntityId : null);


				// set foreign table
                this._SalesPerson = value;
            }
        }
        private SalesPerson _SalesPerson = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from Customer

        /// <summary>
        /// List of sub entities Customer / Customer (StoreID)
		/// Foreign Key FK_Customer_Store_StoreID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual CustomerList CustomerList
        {
            get
            {
			    // Lazy Loading
                if (_CustomerList == null && this.BusinessEntityId != null)
                {
					var where = new SqlWhereClause("WHERE Customer.StoreID = @StoreID",
					    "@StoreID", this.BusinessEntityId);
                    _CustomerList = ((AdvEntityManager)this.Manager).GetCustomerList(where);
                }
				if (_CustomerList == null)
				{
					_CustomerList = new CustomerList();
				}
                return _CustomerList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private CustomerList _CustomerList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.StoreFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Store"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // Store

	#endregion

	#region Entity-List

    /// <summary>
    /// Store / StoreList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class StoreList
        : WebEntityList<Store>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Store"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// Store - Store - Factory 
    /// </summary>
    public partial class StoreFactory
        : WebEntityFactory<Store, StoreList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property BusinessEntityId of Db-Field BusinessEntityID</summary>
        public static string Prop_BusinessEntityId = "BusinessEntityId";
        ///<summary>Property Name of Db-Field Name</summary>
        public static string Prop_Name = "Name";
        ///<summary>Property SalesPersonId of Db-Field SalesPersonID</summary>
        public static string Prop_SalesPersonId = "SalesPersonId";
        ///<summary>Property Demographics of Db-Field Demographics</summary>
        public static string Prop_Demographics = "Demographics";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field BusinessEntityID of Property BusinessEntityId</summary>
        public static string Field_BusinessEntityId = "BusinessEntityID";
        ///<summary>Db-Field Name of Property Name</summary>
        public static string Field_Name = "Name";
        ///<summary>Db-Field SalesPersonID of Property SalesPersonId</summary>
        public static string Field_SalesPersonId = "SalesPersonID";
        ///<summary>Db-Field Demographics of Property Demographics</summary>
        public static string Field_Demographics = "Demographics";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = Store, 
		/// Fields       = "BusinessEntityID"
		/// Query        = ...
        /// </summary>
        protected StoreFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Sales";
            this.TableName = "Store";
            this.Fields = new string[]
            {
                "BusinessEntityID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("BusinessEntityId", "int?", "BusinessEntityID", "int?", "", "BusinessEntity");
			this.Properties.Add("Name", "string", "Name", "string", "", null);
			this.Properties.Add("SalesPersonId", "int?", "SalesPersonID", "int?", "", "SalesPerson");
			this.Properties.Add("Demographics", "string", "Demographics", "string", "", null);
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "Store"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "StoreList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "StoreFactory"; }
            set { }
        }

		#endregion

		internal static StoreFactory CreateFactory(EntityManager manager)
		{
		    return new StoreFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of Store. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo Store</returns>
        public override Store CreateEntity()
		{
			var item = new Store();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(Store item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity BusinessEntity / BusinessEntity
            // Foreign Key FK_Store_BusinessEntity_BusinessEntityID
            if (parent is BusinessEntity)
            {
                item.BusinessEntity = (BusinessEntity)parent;
                return;
            }

            // make relation to parent/super Entity SalesPerson / SalesPerson
            // Foreign Key FK_Store_SalesPerson_SalesPersonID
            if (parent is SalesPerson)
            {
                item.SalesPerson = (SalesPerson)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public Store GetItem(int? businessEntityId)
        {
            return this.GetEntity(0, businessEntityId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public Store GetItem(DbConnector conn, int? businessEntityId)
        {
            return this.GetEntity(conn, businessEntityId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(Store).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to StoreFactory / Store / Store.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// StoreFactory to Store / Store.
        /// </summary>
        public StoreFactory StoreFactory
		{
			get
			{
				if (_StoreFactory == null)
				{
					_StoreFactory = global::AdventureWorks.StoreFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_StoreFactory, typeof(Store));
				}
				return _StoreFactory;
			}
		}
		private StoreFactory _StoreFactory = null;
	
        /// <summary>
        /// GetStore to Store / Store
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public Store GetStore(int? businessEntityId)
        {
            return this.StoreFactory.GetEntity(0, businessEntityId);
        }
	
        /// <summary>
        /// GetStore to Store / Store
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Store GetStore(DbConnector conn, int? businessEntityId)
        {
            return this.StoreFactory.GetEntity(conn, businessEntityId);
        }
	
		/// <summary>
        /// GetStoreList to Store / Store
		/// Getting a list of Store using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public StoreList GetStoreList(SqlWhereClause where)
        {
            return this.StoreFactory.GetEntities(where);
        }

		/// <summary>
        /// GetStoreList to Store / Store
		/// Getting all entities of Store
        /// </summary>
        /// <returns>List of all found entities</returns>
        public StoreList GetStoreList()
        {
			var where = new SqlWhereClause();
            return this.StoreFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveStore to Store / Store
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Store SaveStore(Store item)
        {
            return this.StoreFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveStore to Store / Store
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Store SaveStore(DbConnector conn, Store item)
        {
            return this.StoreFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyStore to Store / Store
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Store ApplyStore(DbConnector conn, Store item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.StoreFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveStore to Store / Store
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveStore(Store item)
        {
            return this.StoreFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveStore to Store / Store
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveStore(DbConnector conn, Store item)
        {
            return this.StoreFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities StoreList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveStoreList(StoreList items)
        {
			return this.StoreFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
