﻿//
// AUTO-GENERIERT, MANUELLE ÄNDERUNGEN GEHEN VERLOREN
// Generiert durch das Tool EntityMappingGenerator 
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// Person / Person - Entity 
    /// </summary>
    [DataContract]
    public partial class Person
        : WebEntity // Derivat aus 'WebEntity' 
    {
		/// <summary>
        /// Standard-Constructor for Person
        /// </summary>
	    public Person()
		{
		}

		/// <summary>
        /// Creates a new instance of Person
        /// </summary>
	    internal Person CreateEntity()
		{
		    return new Person();
		}

		#region Members

		
        /// <summary>
        /// BusinessEntityId / Person.BusinessEntityID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        public virtual int? BusinessEntityId
        {
            get
            {
                return (int?)this["BusinessEntityID"];
            }
            set
            {
                this.Add("BusinessEntityID", value, typeof(int?));
            }
        }

        /// <summary>
        /// PersonType / Person.PersonType
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        public virtual string PersonType
        {
            get
            {
                return (string)this["PersonType"];
            }
            set
            {
                this.Add("PersonType", value, typeof(string));
            }
        }

        /// <summary>
        /// NameStyle / Person.NameStyle
        /// </summary>
        /// <returns>bool?</returns>
        [DataMember]
        public virtual bool? NameStyle
        {
            get
            {
                return (bool?)this["NameStyle"];
            }
            set
            {
                this.Add("NameStyle", value, typeof(bool?));
            }
        }

        /// <summary>
        /// Title / Person.Title
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        public virtual string Title
        {
            get
            {
                return (string)this["Title"];
            }
            set
            {
                this.Add("Title", value, typeof(string));
            }
        }

        /// <summary>
        /// FirstName / Person.FirstName
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        public virtual string FirstName
        {
            get
            {
                return (string)this["FirstName"];
            }
            set
            {
                this.Add("FirstName", value, typeof(string));
            }
        }

        /// <summary>
        /// MiddleName / Person.MiddleName
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        public virtual string MiddleName
        {
            get
            {
                return (string)this["MiddleName"];
            }
            set
            {
                this.Add("MiddleName", value, typeof(string));
            }
        }

        /// <summary>
        /// LastName / Person.LastName
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        public virtual string LastName
        {
            get
            {
                return (string)this["LastName"];
            }
            set
            {
                this.Add("LastName", value, typeof(string));
            }
        }

        /// <summary>
        /// Suffix / Person.Suffix
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        public virtual string Suffix
        {
            get
            {
                return (string)this["Suffix"];
            }
            set
            {
                this.Add("Suffix", value, typeof(string));
            }
        }

        /// <summary>
        /// EmailPromotion / Person.EmailPromotion
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        public virtual int? EmailPromotion
        {
            get
            {
                return (int?)this["EmailPromotion"];
            }
            set
            {
                this.Add("EmailPromotion", value, typeof(int?));
            }
        }

        /// <summary>
        /// AdditionalContactInfo / Person.AdditionalContactInfo
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        public virtual string AdditionalContactInfo
        {
            get
            {
                return (string)this["AdditionalContactInfo"];
            }
            set
            {
                this.Add("AdditionalContactInfo", value, typeof(string));
            }
        }

        /// <summary>
        /// Demographics / Person.Demographics
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        public virtual string Demographics
        {
            get
            {
                return (string)this["Demographics"];
            }
            set
            {
                this.Add("Demographics", value, typeof(string));
            }
        }

        /// <summary>
        /// Rowguid / Person.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / Person.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Fremdbezüge

		
        #region Fremdbezug zu BusinessEntity

        #endregion


		#endregion

		#region Untergeordnete Entities (Listen)

		#endregion

		#region Members - Rückwärts-Kompatibilität

		

		#endregion

		#region Funktionen

		/// <summary>
        /// Es gibt an, ob ein Feld als Property in einer Entity vorkommt, dann
        /// muss es nicht in der ValuePair-Liste des Webservices aufgelistet werden
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            return AdvEntityManager.Manager.PersonFactory.Properties.ContainsKey(fieldName);
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
        [DataMember]
        public override string EntityName
        {
            get { return "Person"; }
            set { }
        }

		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// angebundener Entity manager oder standard manager, falls nicht festgelegt.
        /// </summary>
        public override EntityManager Manager
        {
            get
            {
			    return base.Manager ?? AdvEntityManager.Manager;
            }
        }

		#endregion
	} // Person

	#endregion

	#region Entity-Auflistung

    /// <summary>
    /// Person / PersonList - Liste
    /// </summary>
    [DataContract]
    public partial class PersonList
        : WebEntityList<Person>
    {
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// Person - Person - Factory 
    /// </summary>
    public partial class PersonFactory
        : WebEntityFactory<Person, PersonList>
    {
        /// <summary>
        /// Factory Intialisierung. 
		/// Tabellenname = Person, 
		/// Felder       = "BusinessEntityID"
		/// Query        = ...
        /// </summary>
        private PersonFactory(EntityManager manager)
        {
			this.Manager = manager;
			this.TableSchema = "Person";
            this.TableName = "Person";
            this.Fields = new string[]
            {
                "BusinessEntityID"
            };
			this.Query = null;
            this.Database = "1";

			//
			// Db-Feld-Entity-Property Kombinationen registrieren
			//
			this.Properties.Add("BusinessEntityId", "int?", "BusinessEntityID", "int?", null, null);
			this.Properties.Add("PersonType", "string", "PersonType", "string", null, null);
			this.Properties.Add("NameStyle", "bool?", "NameStyle", "bool?", null, null);
			this.Properties.Add("Title", "string", "Title", "string", null, null);
			this.Properties.Add("FirstName", "string", "FirstName", "string", null, null);
			this.Properties.Add("MiddleName", "string", "MiddleName", "string", null, null);
			this.Properties.Add("LastName", "string", "LastName", "string", null, null);
			this.Properties.Add("Suffix", "string", "Suffix", "string", null, null);
			this.Properties.Add("EmailPromotion", "int?", "EmailPromotion", "int?", null, null);
			this.Properties.Add("AdditionalContactInfo", "string", "AdditionalContactInfo", "string", null, null);
			this.Properties.Add("Demographics", "string", "Demographics", "string", null, null);
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", null, null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", null, null);

        }

		internal static PersonFactory CreateFactory(EntityManager manager)
		{
		    return new PersonFactory(manager);
		}

		/// <summary>
        /// Erstellt eine neue instanz zu Person
        /// </summary>
        /// <returns>Neue instanz zu Person, falls erfolgreich</returns>
        public override Person CreateEntity()
		{
			var item = new Person();
			
			// Änderungen an den EntityManager melden
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

		/// <summary>
        /// statische Methode für GetEntity 
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public Person GetItem(int? businessEntityId)
        {
            return this.GetEntity(0, businessEntityId);
        }

        /// <summary>
        /// statische Methode für GetEntity mit Angabe einer Db-Connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public Person GetItem(DbConnector conn, int? businessEntityId)
        {
            return this.GetEntity(conn, 0, businessEntityId);
        }


	}

	#endregion

	#region Bisherige Klassen-Namen - Rückwärts-Kompatibilität

    //-//

	#endregion

	#region Einträge für EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Teil zu PersonFactory / Person / Person.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// PersonFactory zu Person / Person.
        /// </summary>
        public PersonFactory PersonFactory
		{
			get
			{
				if (_PersonFactory == null)
				{
					_PersonFactory = global::AdventureWorks.PersonFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_PersonFactory, typeof(Person));
				}
				return _PersonFactory;
			}
		}
		private PersonFactory _PersonFactory = null;
	
        /// <summary>
        /// GetPerson zu Person / Person
		/// Holen einer Entity über ihre Primary-Key-Felder
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public Person GetPerson(int? businessEntityId)
        {
            return this.PersonFactory.GetEntity(0, businessEntityId);
        }
	
        /// <summary>
        /// GetPerson zu Person / Person
		/// Holen einer Entity über ihre Primary-Key-Felder mit Angabe einer Db
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public Person GetPerson(DbConnector conn, int? businessEntityId)
        {
            return this.PersonFactory.GetEntity(conn, businessEntityId);
        }
	
		/// <summary>
        /// GetPersonList zu Person / Person
		/// Eine Liste von Person mit einer Where-Klausel zurückgeben
        /// </summary>
        /// <returns>Liste möglicher Entities</returns>
        public PersonList GetPersonList(SqlWhereClause where)
        {
            return this.PersonFactory.GetEntities(where);
        }

		/// <summary>
        /// GetPersonList zu Person / Person
		/// Gesamten Inhalt von Person zurückgeben
        /// </summary>
        /// <returns>Liste möglicher Entities</returns>
        public PersonList GetPersonList()
        {
			var where = new SqlWhereClause();
            return this.PersonFactory.GetEntities(where);
        }

        /// <summary>
        /// SavePerson zu Person / Person
		/// Speichern/Hinzufügen einer Entity
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public Person SavePerson(Person item)
        {
            return this.PersonFactory.SaveEntity(item);
        }

        /// <summary>
        /// SavePerson zu Person / Person
		/// Speichern/Hinzufügen einer Entity mit Angabe einer Db-Connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public Person SavePerson(DbConnector conn, Person item)
        {
            return this.PersonFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// RemovePerson zu Person / Person
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemovePerson(Person item)
        {
            return this.PersonFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemovePerson zu Person / Person
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemovePerson(DbConnector conn, Person item)
        {
            return this.PersonFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Speichert eine Auflistung von PersonList. 
        /// Als gelöscht markierte Entities werden endgültig gelöscht
        /// </summary>
        /// <param name="items"></param>
        /// <returns></returns>
        public int SavePersonList(PersonList items)
        {
			return this.PersonFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
