﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
	#region Entity und Auflistung

    /// <summary>
    /// Person / Person - Benutzerdefinierte Attribute
    /// </summary>
    public partial class Person
    {
        #region Benutzerdefinierte Attribute



		#endregion
    }

    /// <summary>
    /// PersonList / Person - Benutzerdefinierte Attribute
    /// </summary>
    public partial class PersonList
    {
        #region Benutzerdefinierte Attribute



		#endregion
    }

	#endregion

	#region Factory

	/// <summary>
    /// Person / Person - Factory - Überladungen und Benutzerdefiniertes Code
    /// </summary>
    public partial class PersonFactory
    {
	    #region Overloading

        /// <summary>
        /// Benutzerdefiniertes Code nach dem Laden einer Instanz 
        /// </summary>
        /// <returns></returns>
        public override void OnGetEntity(DbConnector conn, Person item)
        {
		    #region Overloading OnGetEntity

            ;

			#endregion
        }

        /// <summary>
        /// Gibt an, ob es sich um eine neue Entity handelt
        /// </summary>
        /// <returns>true, wenn neue Entity</returns>
        public override bool IsNew(DbConnector conn, Person item)
        {
			#region Overloading IsNew

            return (item.EntityState == EntityState.New || item.BusinessEntityId == null);

			#endregion
        }

		#endregion

		#region Benutzerdefinierte Funktionen

		// Weitere benutzerdefinierte Funktionen

		#endregion
    }

	#endregion

}
