﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// AwbUildVersion / AWBuildVersion - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class AwbUildVersion
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for AwbUildVersion
        /// </summary>
	    public AwbUildVersion()
		{
		}

		///// <summary>
        ///// Creates a new instance of AwbUildVersion
        ///// </summary>
	    //internal AwbUildVersion CreateEntity()
		//{
		//    return new AwbUildVersion();
		//}

		#region Members

		
        /// <summary>
        /// SystemInformationId / AWBuildVersion.SystemInformationID
        /// </summary>
        /// <returns>byte?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("SystemInformationID"), FieldOrder(0), TypeName("byte?"), FieldTypeName("byte?"), ForeignEntity(null)]
        public virtual byte? SystemInformationId
        {
            get
            {
                return (byte?)this["SystemInformationID"];
            }
            set
            {
                this.Add("SystemInformationID", value, typeof(byte?));
            }
        }

        /// <summary>
        /// DatabaseVersion / AWBuildVersion.Database Version
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Database Version"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string DatabaseVersion
        {
            get
            {
                return (string)this["Database Version"];
            }
            set
            {
                this.Add("Database Version", value, typeof(string));
            }
        }

        /// <summary>
        /// VersionDate / AWBuildVersion.VersionDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("VersionDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? VersionDate
        {
            get
            {
                return (DateTime?)this["VersionDate"];
            }
            set
            {
                this.Add("VersionDate", value, typeof(DateTime?));
            }
        }

        /// <summary>
        /// ModifiedDate / AWBuildVersion.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		

		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.AwbUildVersionFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "AwbUildVersion"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // AwbUildVersion

	#endregion

	#region Entity-List

    /// <summary>
    /// AwbUildVersion / AwbUildVersionList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class AwbUildVersionList
        : WebEntityList<AwbUildVersion>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "AwbUildVersion"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// AwbUildVersion - AWBuildVersion - Factory 
    /// </summary>
    public partial class AwbUildVersionFactory
        : WebEntityFactory<AwbUildVersion, AwbUildVersionList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property SystemInformationId of Db-Field SystemInformationID</summary>
        public static string Prop_SystemInformationId = "SystemInformationId";
        ///<summary>Property DatabaseVersion of Db-Field Database Version</summary>
        public static string Prop_DatabaseVersion = "DatabaseVersion";
        ///<summary>Property VersionDate of Db-Field VersionDate</summary>
        public static string Prop_VersionDate = "VersionDate";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field SystemInformationID of Property SystemInformationId</summary>
        public static string Field_SystemInformationId = "SystemInformationID";
        ///<summary>Db-Field Database Version of Property DatabaseVersion</summary>
        public static string Field_DatabaseVersion = "Database Version";
        ///<summary>Db-Field VersionDate of Property VersionDate</summary>
        public static string Field_VersionDate = "VersionDate";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = AWBuildVersion, 
		/// Fields       = "SystemInformationID"
		/// Query        = ...
        /// </summary>
        protected AwbUildVersionFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "dbo";
            this.TableName = "AWBuildVersion";
            this.Fields = new string[]
            {
                "SystemInformationID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("SystemInformationId", "byte?", "SystemInformationID", "byte?", "", null);
			this.Properties.Add("DatabaseVersion", "string", "Database Version", "string", "", null);
			this.Properties.Add("VersionDate", "DateTime?", "VersionDate", "DateTime?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "AwbUildVersion"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "AwbUildVersionList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "AwbUildVersionFactory"; }
            set { }
        }

		#endregion

		internal static AwbUildVersionFactory CreateFactory(EntityManager manager)
		{
		    return new AwbUildVersionFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of AwbUildVersion. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo AwbUildVersion</returns>
        public override AwbUildVersion CreateEntity()
		{
			var item = new AwbUildVersion();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}



		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public AwbUildVersion GetItem(byte? systemInformationId)
        {
            return this.GetEntity(0, systemInformationId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public AwbUildVersion GetItem(DbConnector conn, byte? systemInformationId)
        {
            return this.GetEntity(conn, systemInformationId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(AwbUildVersion).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to AwbUildVersionFactory / AwbUildVersion / AWBuildVersion.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// AwbUildVersionFactory to AwbUildVersion / AWBuildVersion.
        /// </summary>
        public AwbUildVersionFactory AwbUildVersionFactory
		{
			get
			{
				if (_AwbUildVersionFactory == null)
				{
					_AwbUildVersionFactory = global::AdventureWorks.AwbUildVersionFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_AwbUildVersionFactory, typeof(AwbUildVersion));
				}
				return _AwbUildVersionFactory;
			}
		}
		private AwbUildVersionFactory _AwbUildVersionFactory = null;
	
        /// <summary>
        /// GetAwbUildVersion to AwbUildVersion / AWBuildVersion
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public AwbUildVersion GetAwbUildVersion(byte? systemInformationId)
        {
            return this.AwbUildVersionFactory.GetEntity(0, systemInformationId);
        }
	
        /// <summary>
        /// GetAwbUildVersion to AwbUildVersion / AWBuildVersion
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public AwbUildVersion GetAwbUildVersion(DbConnector conn, byte? systemInformationId)
        {
            return this.AwbUildVersionFactory.GetEntity(conn, systemInformationId);
        }
	
		/// <summary>
        /// GetAwbUildVersionList to AwbUildVersion / AWBuildVersion
		/// Getting a list of AwbUildVersion using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public AwbUildVersionList GetAwbUildVersionList(SqlWhereClause where)
        {
            return this.AwbUildVersionFactory.GetEntities(where);
        }

		/// <summary>
        /// GetAwbUildVersionList to AwbUildVersion / AWBuildVersion
		/// Getting all entities of AwbUildVersion
        /// </summary>
        /// <returns>List of all found entities</returns>
        public AwbUildVersionList GetAwbUildVersionList()
        {
			var where = new SqlWhereClause();
            return this.AwbUildVersionFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveAwbUildVersion to AwbUildVersion / AWBuildVersion
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public AwbUildVersion SaveAwbUildVersion(AwbUildVersion item)
        {
            return this.AwbUildVersionFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveAwbUildVersion to AwbUildVersion / AWBuildVersion
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public AwbUildVersion SaveAwbUildVersion(DbConnector conn, AwbUildVersion item)
        {
            return this.AwbUildVersionFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyAwbUildVersion to AwbUildVersion / AWBuildVersion
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public AwbUildVersion ApplyAwbUildVersion(DbConnector conn, AwbUildVersion item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.AwbUildVersionFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveAwbUildVersion to AwbUildVersion / AWBuildVersion
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveAwbUildVersion(AwbUildVersion item)
        {
            return this.AwbUildVersionFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveAwbUildVersion to AwbUildVersion / AWBuildVersion
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveAwbUildVersion(DbConnector conn, AwbUildVersion item)
        {
            return this.AwbUildVersionFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities AwbUildVersionList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveAwbUildVersionList(AwbUildVersionList items)
        {
			return this.AwbUildVersionFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
