﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// BusinessEntity / BusinessEntity - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class BusinessEntity
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for BusinessEntity
        /// </summary>
	    public BusinessEntity()
		{
		}

		///// <summary>
        ///// Creates a new instance of BusinessEntity
        ///// </summary>
	    //internal BusinessEntity CreateEntity()
		//{
		//    return new BusinessEntity();
		//}

		#region Members

		
        /// <summary>
        /// BusinessEntityId / BusinessEntity.BusinessEntityID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("BusinessEntityID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? BusinessEntityId
        {
            get
            {
                return (int?)this["BusinessEntityID"];
            }
            set
            {
                this.Add("BusinessEntityID", value, typeof(int?));
            }
        }

        /// <summary>
        /// Rowguid / BusinessEntity.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / BusinessEntity.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		

		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from BusinessEntityAddress

        /// <summary>
        /// List of sub entities BusinessEntityAddress / BusinessEntityAddress (BusinessEntityID)
		/// Foreign Key FK_BusinessEntityAddress_BusinessEntity_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual BusinessEntityAddressList BusinessEntityAddressList
        {
            get
            {
			    // Lazy Loading
                if (_BusinessEntityAddressList == null && this.BusinessEntityId != null)
                {
					var where = new SqlWhereClause("WHERE BusinessEntityAddress.BusinessEntityID = @BusinessEntityID",
					    "@BusinessEntityID", this.BusinessEntityId);
                    _BusinessEntityAddressList = ((AdvEntityManager)this.Manager).GetBusinessEntityAddressList(where);
                }
				if (_BusinessEntityAddressList == null)
				{
					_BusinessEntityAddressList = new BusinessEntityAddressList();
				}
                return _BusinessEntityAddressList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private BusinessEntityAddressList _BusinessEntityAddressList = null;

        #endregion

        #region Sub Entites from BusinessEntityContact

        /// <summary>
        /// List of sub entities BusinessEntityContact / BusinessEntityContact (BusinessEntityID)
		/// Foreign Key FK_BusinessEntityContact_BusinessEntity_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual BusinessEntityContactList BusinessEntityContactList
        {
            get
            {
			    // Lazy Loading
                if (_BusinessEntityContactList == null && this.BusinessEntityId != null)
                {
					var where = new SqlWhereClause("WHERE BusinessEntityContact.BusinessEntityID = @BusinessEntityID",
					    "@BusinessEntityID", this.BusinessEntityId);
                    _BusinessEntityContactList = ((AdvEntityManager)this.Manager).GetBusinessEntityContactList(where);
                }
				if (_BusinessEntityContactList == null)
				{
					_BusinessEntityContactList = new BusinessEntityContactList();
				}
                return _BusinessEntityContactList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private BusinessEntityContactList _BusinessEntityContactList = null;

        #endregion

        #region Sub Entites from Person

        /// <summary>
        /// List of sub entities Person / Person (BusinessEntityID)
		/// Foreign Key FK_Person_BusinessEntity_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual PersonList PersonList
        {
            get
            {
			    // Lazy Loading
                if (_PersonList == null && this.BusinessEntityId != null)
                {
					var where = new SqlWhereClause("WHERE Person.BusinessEntityID = @BusinessEntityID",
					    "@BusinessEntityID", this.BusinessEntityId);
                    _PersonList = ((AdvEntityManager)this.Manager).GetPersonList(where);
                }
				if (_PersonList == null)
				{
					_PersonList = new PersonList();
				}
                return _PersonList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private PersonList _PersonList = null;

        #endregion

        #region Sub Entites from Store

        /// <summary>
        /// List of sub entities Store / Store (BusinessEntityID)
		/// Foreign Key FK_Store_BusinessEntity_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual StoreList StoreList
        {
            get
            {
			    // Lazy Loading
                if (_StoreList == null && this.BusinessEntityId != null)
                {
					var where = new SqlWhereClause("WHERE Store.BusinessEntityID = @BusinessEntityID",
					    "@BusinessEntityID", this.BusinessEntityId);
                    _StoreList = ((AdvEntityManager)this.Manager).GetStoreList(where);
                }
				if (_StoreList == null)
				{
					_StoreList = new StoreList();
				}
                return _StoreList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private StoreList _StoreList = null;

        #endregion

        #region Sub Entites from Vendor

        /// <summary>
        /// List of sub entities Vendor / Vendor (BusinessEntityID)
		/// Foreign Key FK_Vendor_BusinessEntity_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual VendorList VendorList
        {
            get
            {
			    // Lazy Loading
                if (_VendorList == null && this.BusinessEntityId != null)
                {
					var where = new SqlWhereClause("WHERE Vendor.BusinessEntityID = @BusinessEntityID",
					    "@BusinessEntityID", this.BusinessEntityId);
                    _VendorList = ((AdvEntityManager)this.Manager).GetVendorList(where);
                }
				if (_VendorList == null)
				{
					_VendorList = new VendorList();
				}
                return _VendorList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private VendorList _VendorList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.BusinessEntityFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "BusinessEntity"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // BusinessEntity

	#endregion

	#region Entity-List

    /// <summary>
    /// BusinessEntity / BusinessEntityList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class BusinessEntityList
        : WebEntityList<BusinessEntity>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "BusinessEntity"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// BusinessEntity - BusinessEntity - Factory 
    /// </summary>
    public partial class BusinessEntityFactory
        : WebEntityFactory<BusinessEntity, BusinessEntityList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property BusinessEntityId of Db-Field BusinessEntityID</summary>
        public static string Prop_BusinessEntityId = "BusinessEntityId";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field BusinessEntityID of Property BusinessEntityId</summary>
        public static string Field_BusinessEntityId = "BusinessEntityID";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = BusinessEntity, 
		/// Fields       = "BusinessEntityID"
		/// Query        = ...
        /// </summary>
        protected BusinessEntityFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Person";
            this.TableName = "BusinessEntity";
            this.Fields = new string[]
            {
                "BusinessEntityID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("BusinessEntityId", "int?", "BusinessEntityID", "int?", "", null);
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "BusinessEntity"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "BusinessEntityList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "BusinessEntityFactory"; }
            set { }
        }

		#endregion

		internal static BusinessEntityFactory CreateFactory(EntityManager manager)
		{
		    return new BusinessEntityFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of BusinessEntity. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo BusinessEntity</returns>
        public override BusinessEntity CreateEntity()
		{
			var item = new BusinessEntity();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}



		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public BusinessEntity GetItem(int? businessEntityId)
        {
            return this.GetEntity(0, businessEntityId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public BusinessEntity GetItem(DbConnector conn, int? businessEntityId)
        {
            return this.GetEntity(conn, businessEntityId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(BusinessEntity).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to BusinessEntityFactory / BusinessEntity / BusinessEntity.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// BusinessEntityFactory to BusinessEntity / BusinessEntity.
        /// </summary>
        public BusinessEntityFactory BusinessEntityFactory
		{
			get
			{
				if (_BusinessEntityFactory == null)
				{
					_BusinessEntityFactory = global::AdventureWorks.BusinessEntityFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_BusinessEntityFactory, typeof(BusinessEntity));
				}
				return _BusinessEntityFactory;
			}
		}
		private BusinessEntityFactory _BusinessEntityFactory = null;
	
        /// <summary>
        /// GetBusinessEntity to BusinessEntity / BusinessEntity
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public BusinessEntity GetBusinessEntity(int? businessEntityId)
        {
            return this.BusinessEntityFactory.GetEntity(0, businessEntityId);
        }
	
        /// <summary>
        /// GetBusinessEntity to BusinessEntity / BusinessEntity
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public BusinessEntity GetBusinessEntity(DbConnector conn, int? businessEntityId)
        {
            return this.BusinessEntityFactory.GetEntity(conn, businessEntityId);
        }
	
		/// <summary>
        /// GetBusinessEntityList to BusinessEntity / BusinessEntity
		/// Getting a list of BusinessEntity using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public BusinessEntityList GetBusinessEntityList(SqlWhereClause where)
        {
            return this.BusinessEntityFactory.GetEntities(where);
        }

		/// <summary>
        /// GetBusinessEntityList to BusinessEntity / BusinessEntity
		/// Getting all entities of BusinessEntity
        /// </summary>
        /// <returns>List of all found entities</returns>
        public BusinessEntityList GetBusinessEntityList()
        {
			var where = new SqlWhereClause();
            return this.BusinessEntityFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveBusinessEntity to BusinessEntity / BusinessEntity
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public BusinessEntity SaveBusinessEntity(BusinessEntity item)
        {
            return this.BusinessEntityFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveBusinessEntity to BusinessEntity / BusinessEntity
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public BusinessEntity SaveBusinessEntity(DbConnector conn, BusinessEntity item)
        {
            return this.BusinessEntityFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyBusinessEntity to BusinessEntity / BusinessEntity
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public BusinessEntity ApplyBusinessEntity(DbConnector conn, BusinessEntity item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.BusinessEntityFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveBusinessEntity to BusinessEntity / BusinessEntity
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveBusinessEntity(BusinessEntity item)
        {
            return this.BusinessEntityFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveBusinessEntity to BusinessEntity / BusinessEntity
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveBusinessEntity(DbConnector conn, BusinessEntity item)
        {
            return this.BusinessEntityFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities BusinessEntityList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveBusinessEntityList(BusinessEntityList items)
        {
			return this.BusinessEntityFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
