﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// BusinessEntityAddress / BusinessEntityAddress - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class BusinessEntityAddress
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for BusinessEntityAddress
        /// </summary>
	    public BusinessEntityAddress()
		{
		}

		///// <summary>
        ///// Creates a new instance of BusinessEntityAddress
        ///// </summary>
	    //internal BusinessEntityAddress CreateEntity()
		//{
		//    return new BusinessEntityAddress();
		//}

		#region Members

		
        /// <summary>
        /// BusinessEntityId / BusinessEntityAddress.BusinessEntityID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("BusinessEntityID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("BusinessEntity")]
        public virtual int? BusinessEntityId
        {
            get
            {
                return (int?)this["BusinessEntityID"];
            }
            set
            {
                this.Add("BusinessEntityID", value, typeof(int?));
            }
        }

        /// <summary>
        /// AddressId / BusinessEntityAddress.AddressID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("AddressID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Address")]
        public virtual int? AddressId
        {
            get
            {
                return (int?)this["AddressID"];
            }
            set
            {
                this.Add("AddressID", value, typeof(int?));
            }
        }

        /// <summary>
        /// AddressTypeId / BusinessEntityAddress.AddressTypeID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("AddressTypeID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("AddressType")]
        public virtual int? AddressTypeId
        {
            get
            {
                return (int?)this["AddressTypeID"];
            }
            set
            {
                this.Add("AddressTypeID", value, typeof(int?));
            }
        }

        /// <summary>
        /// Rowguid / BusinessEntityAddress.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / BusinessEntityAddress.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Address

        /// <summary>
        /// Link to parent/super Entity Address / Address (this.AddressId)
		/// Foreign key FK_BusinessEntityAddress_Address_AddressID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Address Address
        {
            get
            {
			    // Lazy loading
                if (this._Address == null && this.AddressId != null)
                {
                    this._Address = ((AdvEntityManager)this.Manager).GetAddress(this.AddressId);
                    if (! _Address.ResultInfo.IsValid)
                    {
						this._Address = null; // reset value
                        throw new Exception("wrong/missed constraint from BusinessEntityAddress to Address.");
                    }
                }
                return this._Address;
            }
            set
            {
                // reassign foreign key values from setter value
                this.AddressId = (value != null ? value.AddressId : null);


				// set foreign table
                this._Address = value;
            }
        }
        private Address _Address = null;

        #endregion

        #region foreign constraint (parent entity) to AddressType

        /// <summary>
        /// Link to parent/super Entity AddressType / AddressType (this.AddressTypeId)
		/// Foreign key FK_BusinessEntityAddress_AddressType_AddressTypeID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual AddressType AddressType
        {
            get
            {
			    // Lazy loading
                if (this._AddressType == null && this.AddressTypeId != null)
                {
                    this._AddressType = ((AdvEntityManager)this.Manager).GetAddressType(this.AddressTypeId);
                    if (! _AddressType.ResultInfo.IsValid)
                    {
						this._AddressType = null; // reset value
                        throw new Exception("wrong/missed constraint from BusinessEntityAddress to AddressType.");
                    }
                }
                return this._AddressType;
            }
            set
            {
                // reassign foreign key values from setter value
                this.AddressTypeId = (value != null ? value.AddressTypeId : null);


				// set foreign table
                this._AddressType = value;
            }
        }
        private AddressType _AddressType = null;

        #endregion

        #region foreign constraint (parent entity) to BusinessEntity

        /// <summary>
        /// Link to parent/super Entity BusinessEntity / BusinessEntity (this.BusinessEntityId)
		/// Foreign key FK_BusinessEntityAddress_BusinessEntity_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual BusinessEntity BusinessEntity
        {
            get
            {
			    // Lazy loading
                if (this._BusinessEntity == null && this.BusinessEntityId != null)
                {
                    this._BusinessEntity = ((AdvEntityManager)this.Manager).GetBusinessEntity(this.BusinessEntityId);
                    if (! _BusinessEntity.ResultInfo.IsValid)
                    {
						this._BusinessEntity = null; // reset value
                        throw new Exception("wrong/missed constraint from BusinessEntityAddress to BusinessEntity.");
                    }
                }
                return this._BusinessEntity;
            }
            set
            {
                // reassign foreign key values from setter value
                this.BusinessEntityId = (value != null ? value.BusinessEntityId : null);


				// set foreign table
                this._BusinessEntity = value;
            }
        }
        private BusinessEntity _BusinessEntity = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.BusinessEntityAddressFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "BusinessEntityAddress"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // BusinessEntityAddress

	#endregion

	#region Entity-List

    /// <summary>
    /// BusinessEntityAddress / BusinessEntityAddressList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class BusinessEntityAddressList
        : WebEntityList<BusinessEntityAddress>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "BusinessEntityAddress"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// BusinessEntityAddress - BusinessEntityAddress - Factory 
    /// </summary>
    public partial class BusinessEntityAddressFactory
        : WebEntityFactory<BusinessEntityAddress, BusinessEntityAddressList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property BusinessEntityId of Db-Field BusinessEntityID</summary>
        public static string Prop_BusinessEntityId = "BusinessEntityId";
        ///<summary>Property AddressId of Db-Field AddressID</summary>
        public static string Prop_AddressId = "AddressId";
        ///<summary>Property AddressTypeId of Db-Field AddressTypeID</summary>
        public static string Prop_AddressTypeId = "AddressTypeId";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field BusinessEntityID of Property BusinessEntityId</summary>
        public static string Field_BusinessEntityId = "BusinessEntityID";
        ///<summary>Db-Field AddressID of Property AddressId</summary>
        public static string Field_AddressId = "AddressID";
        ///<summary>Db-Field AddressTypeID of Property AddressTypeId</summary>
        public static string Field_AddressTypeId = "AddressTypeID";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = BusinessEntityAddress, 
		/// Fields       = "BusinessEntityID", "AddressID", "AddressTypeID"
		/// Query        = ...
        /// </summary>
        protected BusinessEntityAddressFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Person";
            this.TableName = "BusinessEntityAddress";
            this.Fields = new string[]
            {
                "BusinessEntityID", "AddressID", "AddressTypeID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("BusinessEntityId", "int?", "BusinessEntityID", "int?", "", "BusinessEntity");
			this.Properties.Add("AddressId", "int?", "AddressID", "int?", "", "Address");
			this.Properties.Add("AddressTypeId", "int?", "AddressTypeID", "int?", "", "AddressType");
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "BusinessEntityAddress"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "BusinessEntityAddressList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "BusinessEntityAddressFactory"; }
            set { }
        }

		#endregion

		internal static BusinessEntityAddressFactory CreateFactory(EntityManager manager)
		{
		    return new BusinessEntityAddressFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of BusinessEntityAddress. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo BusinessEntityAddress</returns>
        public override BusinessEntityAddress CreateEntity()
		{
			var item = new BusinessEntityAddress();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(BusinessEntityAddress item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Address / Address
            // Foreign Key FK_BusinessEntityAddress_Address_AddressID
            if (parent is Address)
            {
                item.Address = (Address)parent;
                return;
            }

            // make relation to parent/super Entity AddressType / AddressType
            // Foreign Key FK_BusinessEntityAddress_AddressType_AddressTypeID
            if (parent is AddressType)
            {
                item.AddressType = (AddressType)parent;
                return;
            }

            // make relation to parent/super Entity BusinessEntity / BusinessEntity
            // Foreign Key FK_BusinessEntityAddress_BusinessEntity_BusinessEntityID
            if (parent is BusinessEntity)
            {
                item.BusinessEntity = (BusinessEntity)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public BusinessEntityAddress GetItem(int? businessEntityId, int? addressId, int? addressTypeId)
        {
            return this.GetEntity(0, businessEntityId, addressId, addressTypeId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public BusinessEntityAddress GetItem(DbConnector conn, int? businessEntityId, int? addressId, int? addressTypeId)
        {
            return this.GetEntity(conn, businessEntityId, addressId, addressTypeId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(BusinessEntityAddress).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to BusinessEntityAddressFactory / BusinessEntityAddress / BusinessEntityAddress.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// BusinessEntityAddressFactory to BusinessEntityAddress / BusinessEntityAddress.
        /// </summary>
        public BusinessEntityAddressFactory BusinessEntityAddressFactory
		{
			get
			{
				if (_BusinessEntityAddressFactory == null)
				{
					_BusinessEntityAddressFactory = global::AdventureWorks.BusinessEntityAddressFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_BusinessEntityAddressFactory, typeof(BusinessEntityAddress));
				}
				return _BusinessEntityAddressFactory;
			}
		}
		private BusinessEntityAddressFactory _BusinessEntityAddressFactory = null;
	
        /// <summary>
        /// GetBusinessEntityAddress to BusinessEntityAddress / BusinessEntityAddress
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public BusinessEntityAddress GetBusinessEntityAddress(int? businessEntityId, int? addressId, int? addressTypeId)
        {
            return this.BusinessEntityAddressFactory.GetEntity(0, businessEntityId, addressId, addressTypeId);
        }
	
        /// <summary>
        /// GetBusinessEntityAddress to BusinessEntityAddress / BusinessEntityAddress
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public BusinessEntityAddress GetBusinessEntityAddress(DbConnector conn, int? businessEntityId, int? addressId, int? addressTypeId)
        {
            return this.BusinessEntityAddressFactory.GetEntity(conn, businessEntityId, addressId, addressTypeId);
        }
	
		/// <summary>
        /// GetBusinessEntityAddressList to BusinessEntityAddress / BusinessEntityAddress
		/// Getting a list of BusinessEntityAddress using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public BusinessEntityAddressList GetBusinessEntityAddressList(SqlWhereClause where)
        {
            return this.BusinessEntityAddressFactory.GetEntities(where);
        }

		/// <summary>
        /// GetBusinessEntityAddressList to BusinessEntityAddress / BusinessEntityAddress
		/// Getting all entities of BusinessEntityAddress
        /// </summary>
        /// <returns>List of all found entities</returns>
        public BusinessEntityAddressList GetBusinessEntityAddressList()
        {
			var where = new SqlWhereClause();
            return this.BusinessEntityAddressFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveBusinessEntityAddress to BusinessEntityAddress / BusinessEntityAddress
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public BusinessEntityAddress SaveBusinessEntityAddress(BusinessEntityAddress item)
        {
            return this.BusinessEntityAddressFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveBusinessEntityAddress to BusinessEntityAddress / BusinessEntityAddress
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public BusinessEntityAddress SaveBusinessEntityAddress(DbConnector conn, BusinessEntityAddress item)
        {
            return this.BusinessEntityAddressFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyBusinessEntityAddress to BusinessEntityAddress / BusinessEntityAddress
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public BusinessEntityAddress ApplyBusinessEntityAddress(DbConnector conn, BusinessEntityAddress item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.BusinessEntityAddressFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveBusinessEntityAddress to BusinessEntityAddress / BusinessEntityAddress
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveBusinessEntityAddress(BusinessEntityAddress item)
        {
            return this.BusinessEntityAddressFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveBusinessEntityAddress to BusinessEntityAddress / BusinessEntityAddress
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveBusinessEntityAddress(DbConnector conn, BusinessEntityAddress item)
        {
            return this.BusinessEntityAddressFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities BusinessEntityAddressList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveBusinessEntityAddressList(BusinessEntityAddressList items)
        {
			return this.BusinessEntityAddressFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
