﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// ContactType / ContactType - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class ContactType
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for ContactType
        /// </summary>
	    public ContactType()
		{
		}

		///// <summary>
        ///// Creates a new instance of ContactType
        ///// </summary>
	    //internal ContactType CreateEntity()
		//{
		//    return new ContactType();
		//}

		#region Members

		
        /// <summary>
        /// ContactTypeId / ContactType.ContactTypeID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ContactTypeID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? ContactTypeId
        {
            get
            {
                return (int?)this["ContactTypeID"];
            }
            set
            {
                this.Add("ContactTypeID", value, typeof(int?));
            }
        }

        /// <summary>
        /// Name / ContactType.Name
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Name"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Name
        {
            get
            {
                return (string)this["Name"];
            }
            set
            {
                this.Add("Name", value, typeof(string));
            }
        }

        /// <summary>
        /// ModifiedDate / ContactType.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		

		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from BusinessEntityContact

        /// <summary>
        /// List of sub entities BusinessEntityContact / BusinessEntityContact (ContactTypeID)
		/// Foreign Key FK_BusinessEntityContact_ContactType_ContactTypeID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual BusinessEntityContactList BusinessEntityContactList
        {
            get
            {
			    // Lazy Loading
                if (_BusinessEntityContactList == null && this.ContactTypeId != null)
                {
					var where = new SqlWhereClause("WHERE BusinessEntityContact.ContactTypeID = @ContactTypeID",
					    "@ContactTypeID", this.ContactTypeId);
                    _BusinessEntityContactList = ((AdvEntityManager)this.Manager).GetBusinessEntityContactList(where);
                }
				if (_BusinessEntityContactList == null)
				{
					_BusinessEntityContactList = new BusinessEntityContactList();
				}
                return _BusinessEntityContactList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private BusinessEntityContactList _BusinessEntityContactList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.ContactTypeFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ContactType"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // ContactType

	#endregion

	#region Entity-List

    /// <summary>
    /// ContactType / ContactTypeList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class ContactTypeList
        : WebEntityList<ContactType>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ContactType"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// ContactType - ContactType - Factory 
    /// </summary>
    public partial class ContactTypeFactory
        : WebEntityFactory<ContactType, ContactTypeList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property ContactTypeId of Db-Field ContactTypeID</summary>
        public static string Prop_ContactTypeId = "ContactTypeId";
        ///<summary>Property Name of Db-Field Name</summary>
        public static string Prop_Name = "Name";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field ContactTypeID of Property ContactTypeId</summary>
        public static string Field_ContactTypeId = "ContactTypeID";
        ///<summary>Db-Field Name of Property Name</summary>
        public static string Field_Name = "Name";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = ContactType, 
		/// Fields       = "ContactTypeID"
		/// Query        = ...
        /// </summary>
        protected ContactTypeFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Person";
            this.TableName = "ContactType";
            this.Fields = new string[]
            {
                "ContactTypeID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("ContactTypeId", "int?", "ContactTypeID", "int?", "", null);
			this.Properties.Add("Name", "string", "Name", "string", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "ContactType"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "ContactTypeList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "ContactTypeFactory"; }
            set { }
        }

		#endregion

		internal static ContactTypeFactory CreateFactory(EntityManager manager)
		{
		    return new ContactTypeFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of ContactType. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo ContactType</returns>
        public override ContactType CreateEntity()
		{
			var item = new ContactType();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}



		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public ContactType GetItem(int? contactTypeId)
        {
            return this.GetEntity(0, contactTypeId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public ContactType GetItem(DbConnector conn, int? contactTypeId)
        {
            return this.GetEntity(conn, contactTypeId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(ContactType).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to ContactTypeFactory / ContactType / ContactType.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// ContactTypeFactory to ContactType / ContactType.
        /// </summary>
        public ContactTypeFactory ContactTypeFactory
		{
			get
			{
				if (_ContactTypeFactory == null)
				{
					_ContactTypeFactory = global::AdventureWorks.ContactTypeFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_ContactTypeFactory, typeof(ContactType));
				}
				return _ContactTypeFactory;
			}
		}
		private ContactTypeFactory _ContactTypeFactory = null;
	
        /// <summary>
        /// GetContactType to ContactType / ContactType
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public ContactType GetContactType(int? contactTypeId)
        {
            return this.ContactTypeFactory.GetEntity(0, contactTypeId);
        }
	
        /// <summary>
        /// GetContactType to ContactType / ContactType
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ContactType GetContactType(DbConnector conn, int? contactTypeId)
        {
            return this.ContactTypeFactory.GetEntity(conn, contactTypeId);
        }
	
		/// <summary>
        /// GetContactTypeList to ContactType / ContactType
		/// Getting a list of ContactType using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public ContactTypeList GetContactTypeList(SqlWhereClause where)
        {
            return this.ContactTypeFactory.GetEntities(where);
        }

		/// <summary>
        /// GetContactTypeList to ContactType / ContactType
		/// Getting all entities of ContactType
        /// </summary>
        /// <returns>List of all found entities</returns>
        public ContactTypeList GetContactTypeList()
        {
			var where = new SqlWhereClause();
            return this.ContactTypeFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveContactType to ContactType / ContactType
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ContactType SaveContactType(ContactType item)
        {
            return this.ContactTypeFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveContactType to ContactType / ContactType
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ContactType SaveContactType(DbConnector conn, ContactType item)
        {
            return this.ContactTypeFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyContactType to ContactType / ContactType
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ContactType ApplyContactType(DbConnector conn, ContactType item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.ContactTypeFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveContactType to ContactType / ContactType
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveContactType(ContactType item)
        {
            return this.ContactTypeFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveContactType to ContactType / ContactType
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveContactType(DbConnector conn, ContactType item)
        {
            return this.ContactTypeFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities ContactTypeList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveContactTypeList(ContactTypeList items)
        {
			return this.ContactTypeFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
