﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// CountryRegion / CountryRegion - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class CountryRegion
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for CountryRegion
        /// </summary>
	    public CountryRegion()
		{
		}

		///// <summary>
        ///// Creates a new instance of CountryRegion
        ///// </summary>
	    //internal CountryRegion CreateEntity()
		//{
		//    return new CountryRegion();
		//}

		#region Members

		
        /// <summary>
        /// CountryRegionCode / CountryRegion.CountryRegionCode
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("CountryRegionCode"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string CountryRegionCode
        {
            get
            {
                return (string)this["CountryRegionCode"];
            }
            set
            {
                this.Add("CountryRegionCode", value, typeof(string));
            }
        }

        /// <summary>
        /// Name / CountryRegion.Name
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Name"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Name
        {
            get
            {
                return (string)this["Name"];
            }
            set
            {
                this.Add("Name", value, typeof(string));
            }
        }

        /// <summary>
        /// ModifiedDate / CountryRegion.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		

		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from CountryRegionCurrency

        /// <summary>
        /// List of sub entities CountryRegionCurrency / CountryRegionCurrency (CountryRegionCode)
		/// Foreign Key FK_CountryRegionCurrency_CountryRegion_CountryRegionCode
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual CountryRegionCurrencyList CountryRegionCurrencyList
        {
            get
            {
			    // Lazy Loading
                if (_CountryRegionCurrencyList == null && this.CountryRegionCode != null)
                {
					var where = new SqlWhereClause("WHERE CountryRegionCurrency.CountryRegionCode = @CountryRegionCode",
					    "@CountryRegionCode", this.CountryRegionCode);
                    _CountryRegionCurrencyList = ((AdvEntityManager)this.Manager).GetCountryRegionCurrencyList(where);
                }
				if (_CountryRegionCurrencyList == null)
				{
					_CountryRegionCurrencyList = new CountryRegionCurrencyList();
				}
                return _CountryRegionCurrencyList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private CountryRegionCurrencyList _CountryRegionCurrencyList = null;

        #endregion

        #region Sub Entites from SalesTerritory

        /// <summary>
        /// List of sub entities SalesTerritory / SalesTerritory (CountryRegionCode)
		/// Foreign Key FK_SalesTerritory_CountryRegion_CountryRegionCode
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesTerritoryList SalesTerritoryList
        {
            get
            {
			    // Lazy Loading
                if (_SalesTerritoryList == null && this.CountryRegionCode != null)
                {
					var where = new SqlWhereClause("WHERE SalesTerritory.CountryRegionCode = @CountryRegionCode",
					    "@CountryRegionCode", this.CountryRegionCode);
                    _SalesTerritoryList = ((AdvEntityManager)this.Manager).GetSalesTerritoryList(where);
                }
				if (_SalesTerritoryList == null)
				{
					_SalesTerritoryList = new SalesTerritoryList();
				}
                return _SalesTerritoryList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private SalesTerritoryList _SalesTerritoryList = null;

        #endregion

        #region Sub Entites from StateProvince

        /// <summary>
        /// List of sub entities StateProvince / StateProvince (CountryRegionCode)
		/// Foreign Key FK_StateProvince_CountryRegion_CountryRegionCode
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual StateProvinceList StateProvinceList
        {
            get
            {
			    // Lazy Loading
                if (_StateProvinceList == null && this.CountryRegionCode != null)
                {
					var where = new SqlWhereClause("WHERE StateProvince.CountryRegionCode = @CountryRegionCode",
					    "@CountryRegionCode", this.CountryRegionCode);
                    _StateProvinceList = ((AdvEntityManager)this.Manager).GetStateProvinceList(where);
                }
				if (_StateProvinceList == null)
				{
					_StateProvinceList = new StateProvinceList();
				}
                return _StateProvinceList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private StateProvinceList _StateProvinceList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.CountryRegionFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "CountryRegion"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // CountryRegion

	#endregion

	#region Entity-List

    /// <summary>
    /// CountryRegion / CountryRegionList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class CountryRegionList
        : WebEntityList<CountryRegion>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "CountryRegion"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// CountryRegion - CountryRegion - Factory 
    /// </summary>
    public partial class CountryRegionFactory
        : WebEntityFactory<CountryRegion, CountryRegionList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property CountryRegionCode of Db-Field CountryRegionCode</summary>
        public static string Prop_CountryRegionCode = "CountryRegionCode";
        ///<summary>Property Name of Db-Field Name</summary>
        public static string Prop_Name = "Name";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field CountryRegionCode of Property CountryRegionCode</summary>
        public static string Field_CountryRegionCode = "CountryRegionCode";
        ///<summary>Db-Field Name of Property Name</summary>
        public static string Field_Name = "Name";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = CountryRegion, 
		/// Fields       = "CountryRegionCode"
		/// Query        = ...
        /// </summary>
        protected CountryRegionFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Person";
            this.TableName = "CountryRegion";
            this.Fields = new string[]
            {
                "CountryRegionCode"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("CountryRegionCode", "string", "CountryRegionCode", "string", "", null);
			this.Properties.Add("Name", "string", "Name", "string", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "CountryRegion"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "CountryRegionList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "CountryRegionFactory"; }
            set { }
        }

		#endregion

		internal static CountryRegionFactory CreateFactory(EntityManager manager)
		{
		    return new CountryRegionFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of CountryRegion. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo CountryRegion</returns>
        public override CountryRegion CreateEntity()
		{
			var item = new CountryRegion();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}



		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public CountryRegion GetItem(string countryRegionCode)
        {
            return this.GetEntity(0, countryRegionCode);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public CountryRegion GetItem(DbConnector conn, string countryRegionCode)
        {
            return this.GetEntity(conn, countryRegionCode);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(CountryRegion).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to CountryRegionFactory / CountryRegion / CountryRegion.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// CountryRegionFactory to CountryRegion / CountryRegion.
        /// </summary>
        public CountryRegionFactory CountryRegionFactory
		{
			get
			{
				if (_CountryRegionFactory == null)
				{
					_CountryRegionFactory = global::AdventureWorks.CountryRegionFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_CountryRegionFactory, typeof(CountryRegion));
				}
				return _CountryRegionFactory;
			}
		}
		private CountryRegionFactory _CountryRegionFactory = null;
	
        /// <summary>
        /// GetCountryRegion to CountryRegion / CountryRegion
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public CountryRegion GetCountryRegion(string countryRegionCode)
        {
            return this.CountryRegionFactory.GetEntity(0, countryRegionCode);
        }
	
        /// <summary>
        /// GetCountryRegion to CountryRegion / CountryRegion
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public CountryRegion GetCountryRegion(DbConnector conn, string countryRegionCode)
        {
            return this.CountryRegionFactory.GetEntity(conn, countryRegionCode);
        }
	
		/// <summary>
        /// GetCountryRegionList to CountryRegion / CountryRegion
		/// Getting a list of CountryRegion using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public CountryRegionList GetCountryRegionList(SqlWhereClause where)
        {
            return this.CountryRegionFactory.GetEntities(where);
        }

		/// <summary>
        /// GetCountryRegionList to CountryRegion / CountryRegion
		/// Getting all entities of CountryRegion
        /// </summary>
        /// <returns>List of all found entities</returns>
        public CountryRegionList GetCountryRegionList()
        {
			var where = new SqlWhereClause();
            return this.CountryRegionFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveCountryRegion to CountryRegion / CountryRegion
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public CountryRegion SaveCountryRegion(CountryRegion item)
        {
            return this.CountryRegionFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveCountryRegion to CountryRegion / CountryRegion
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public CountryRegion SaveCountryRegion(DbConnector conn, CountryRegion item)
        {
            return this.CountryRegionFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyCountryRegion to CountryRegion / CountryRegion
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public CountryRegion ApplyCountryRegion(DbConnector conn, CountryRegion item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.CountryRegionFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveCountryRegion to CountryRegion / CountryRegion
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveCountryRegion(CountryRegion item)
        {
            return this.CountryRegionFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveCountryRegion to CountryRegion / CountryRegion
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveCountryRegion(DbConnector conn, CountryRegion item)
        {
            return this.CountryRegionFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities CountryRegionList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveCountryRegionList(CountryRegionList items)
        {
			return this.CountryRegionFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
