﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// CountryRegionCurrency / CountryRegionCurrency - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class CountryRegionCurrency
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for CountryRegionCurrency
        /// </summary>
	    public CountryRegionCurrency()
		{
		}

		///// <summary>
        ///// Creates a new instance of CountryRegionCurrency
        ///// </summary>
	    //internal CountryRegionCurrency CreateEntity()
		//{
		//    return new CountryRegionCurrency();
		//}

		#region Members

		
        /// <summary>
        /// CountryRegionCode / CountryRegionCurrency.CountryRegionCode
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("CountryRegionCode"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity("CountryRegion")]
        public virtual string CountryRegionCode
        {
            get
            {
                return (string)this["CountryRegionCode"];
            }
            set
            {
                this.Add("CountryRegionCode", value, typeof(string));
            }
        }

        /// <summary>
        /// CurrencyCode / CountryRegionCurrency.CurrencyCode
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("CurrencyCode"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity("Currency")]
        public virtual string CurrencyCode
        {
            get
            {
                return (string)this["CurrencyCode"];
            }
            set
            {
                this.Add("CurrencyCode", value, typeof(string));
            }
        }

        /// <summary>
        /// ModifiedDate / CountryRegionCurrency.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to CountryRegion

        /// <summary>
        /// Link to parent/super Entity CountryRegion / CountryRegion (this.CountryRegionCode)
		/// Foreign key FK_CountryRegionCurrency_CountryRegion_CountryRegionCode
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual CountryRegion CountryRegion
        {
            get
            {
			    // Lazy loading
                if (this._CountryRegion == null && this.CountryRegionCode != null)
                {
                    this._CountryRegion = ((AdvEntityManager)this.Manager).GetCountryRegion(this.CountryRegionCode);
                    if (! _CountryRegion.ResultInfo.IsValid)
                    {
						this._CountryRegion = null; // reset value
                        throw new Exception("wrong/missed constraint from CountryRegionCurrency to CountryRegion.");
                    }
                }
                return this._CountryRegion;
            }
            set
            {
                // reassign foreign key values from setter value
                this.CountryRegionCode = (value != null ? value.CountryRegionCode : null);


				// set foreign table
                this._CountryRegion = value;
            }
        }
        private CountryRegion _CountryRegion = null;

        #endregion

        #region foreign constraint (parent entity) to Currency

        /// <summary>
        /// Link to parent/super Entity Currency / Currency (this.CurrencyCode)
		/// Foreign key FK_CountryRegionCurrency_Currency_CurrencyCode
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Currency Currency
        {
            get
            {
			    // Lazy loading
                if (this._Currency == null && this.CurrencyCode != null)
                {
                    this._Currency = ((AdvEntityManager)this.Manager).GetCurrency(this.CurrencyCode);
                    if (! _Currency.ResultInfo.IsValid)
                    {
						this._Currency = null; // reset value
                        throw new Exception("wrong/missed constraint from CountryRegionCurrency to Currency.");
                    }
                }
                return this._Currency;
            }
            set
            {
                // reassign foreign key values from setter value
                this.CurrencyCode = (value != null ? value.CurrencyCode : null);


				// set foreign table
                this._Currency = value;
            }
        }
        private Currency _Currency = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.CountryRegionCurrencyFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "CountryRegionCurrency"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // CountryRegionCurrency

	#endregion

	#region Entity-List

    /// <summary>
    /// CountryRegionCurrency / CountryRegionCurrencyList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class CountryRegionCurrencyList
        : WebEntityList<CountryRegionCurrency>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "CountryRegionCurrency"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// CountryRegionCurrency - CountryRegionCurrency - Factory 
    /// </summary>
    public partial class CountryRegionCurrencyFactory
        : WebEntityFactory<CountryRegionCurrency, CountryRegionCurrencyList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property CountryRegionCode of Db-Field CountryRegionCode</summary>
        public static string Prop_CountryRegionCode = "CountryRegionCode";
        ///<summary>Property CurrencyCode of Db-Field CurrencyCode</summary>
        public static string Prop_CurrencyCode = "CurrencyCode";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field CountryRegionCode of Property CountryRegionCode</summary>
        public static string Field_CountryRegionCode = "CountryRegionCode";
        ///<summary>Db-Field CurrencyCode of Property CurrencyCode</summary>
        public static string Field_CurrencyCode = "CurrencyCode";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = CountryRegionCurrency, 
		/// Fields       = "CountryRegionCode", "CurrencyCode"
		/// Query        = ...
        /// </summary>
        protected CountryRegionCurrencyFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Sales";
            this.TableName = "CountryRegionCurrency";
            this.Fields = new string[]
            {
                "CountryRegionCode", "CurrencyCode"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("CountryRegionCode", "string", "CountryRegionCode", "string", "", "CountryRegion");
			this.Properties.Add("CurrencyCode", "string", "CurrencyCode", "string", "", "Currency");
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "CountryRegionCurrency"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "CountryRegionCurrencyList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "CountryRegionCurrencyFactory"; }
            set { }
        }

		#endregion

		internal static CountryRegionCurrencyFactory CreateFactory(EntityManager manager)
		{
		    return new CountryRegionCurrencyFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of CountryRegionCurrency. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo CountryRegionCurrency</returns>
        public override CountryRegionCurrency CreateEntity()
		{
			var item = new CountryRegionCurrency();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(CountryRegionCurrency item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity CountryRegion / CountryRegion
            // Foreign Key FK_CountryRegionCurrency_CountryRegion_CountryRegionCode
            if (parent is CountryRegion)
            {
                item.CountryRegion = (CountryRegion)parent;
                return;
            }

            // make relation to parent/super Entity Currency / Currency
            // Foreign Key FK_CountryRegionCurrency_Currency_CurrencyCode
            if (parent is Currency)
            {
                item.Currency = (Currency)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public CountryRegionCurrency GetItem(string countryRegionCode, string currencyCode)
        {
            return this.GetEntity(0, countryRegionCode, currencyCode);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public CountryRegionCurrency GetItem(DbConnector conn, string countryRegionCode, string currencyCode)
        {
            return this.GetEntity(conn, countryRegionCode, currencyCode);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(CountryRegionCurrency).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to CountryRegionCurrencyFactory / CountryRegionCurrency / CountryRegionCurrency.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// CountryRegionCurrencyFactory to CountryRegionCurrency / CountryRegionCurrency.
        /// </summary>
        public CountryRegionCurrencyFactory CountryRegionCurrencyFactory
		{
			get
			{
				if (_CountryRegionCurrencyFactory == null)
				{
					_CountryRegionCurrencyFactory = global::AdventureWorks.CountryRegionCurrencyFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_CountryRegionCurrencyFactory, typeof(CountryRegionCurrency));
				}
				return _CountryRegionCurrencyFactory;
			}
		}
		private CountryRegionCurrencyFactory _CountryRegionCurrencyFactory = null;
	
        /// <summary>
        /// GetCountryRegionCurrency to CountryRegionCurrency / CountryRegionCurrency
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public CountryRegionCurrency GetCountryRegionCurrency(string countryRegionCode, string currencyCode)
        {
            return this.CountryRegionCurrencyFactory.GetEntity(0, countryRegionCode, currencyCode);
        }
	
        /// <summary>
        /// GetCountryRegionCurrency to CountryRegionCurrency / CountryRegionCurrency
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public CountryRegionCurrency GetCountryRegionCurrency(DbConnector conn, string countryRegionCode, string currencyCode)
        {
            return this.CountryRegionCurrencyFactory.GetEntity(conn, countryRegionCode, currencyCode);
        }
	
		/// <summary>
        /// GetCountryRegionCurrencyList to CountryRegionCurrency / CountryRegionCurrency
		/// Getting a list of CountryRegionCurrency using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public CountryRegionCurrencyList GetCountryRegionCurrencyList(SqlWhereClause where)
        {
            return this.CountryRegionCurrencyFactory.GetEntities(where);
        }

		/// <summary>
        /// GetCountryRegionCurrencyList to CountryRegionCurrency / CountryRegionCurrency
		/// Getting all entities of CountryRegionCurrency
        /// </summary>
        /// <returns>List of all found entities</returns>
        public CountryRegionCurrencyList GetCountryRegionCurrencyList()
        {
			var where = new SqlWhereClause();
            return this.CountryRegionCurrencyFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveCountryRegionCurrency to CountryRegionCurrency / CountryRegionCurrency
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public CountryRegionCurrency SaveCountryRegionCurrency(CountryRegionCurrency item)
        {
            return this.CountryRegionCurrencyFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveCountryRegionCurrency to CountryRegionCurrency / CountryRegionCurrency
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public CountryRegionCurrency SaveCountryRegionCurrency(DbConnector conn, CountryRegionCurrency item)
        {
            return this.CountryRegionCurrencyFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyCountryRegionCurrency to CountryRegionCurrency / CountryRegionCurrency
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public CountryRegionCurrency ApplyCountryRegionCurrency(DbConnector conn, CountryRegionCurrency item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.CountryRegionCurrencyFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveCountryRegionCurrency to CountryRegionCurrency / CountryRegionCurrency
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveCountryRegionCurrency(CountryRegionCurrency item)
        {
            return this.CountryRegionCurrencyFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveCountryRegionCurrency to CountryRegionCurrency / CountryRegionCurrency
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveCountryRegionCurrency(DbConnector conn, CountryRegionCurrency item)
        {
            return this.CountryRegionCurrencyFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities CountryRegionCurrencyList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveCountryRegionCurrencyList(CountryRegionCurrencyList items)
        {
			return this.CountryRegionCurrencyFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
