﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// CreditCard / CreditCard - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class CreditCard
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for CreditCard
        /// </summary>
	    public CreditCard()
		{
		}

		///// <summary>
        ///// Creates a new instance of CreditCard
        ///// </summary>
	    //internal CreditCard CreateEntity()
		//{
		//    return new CreditCard();
		//}

		#region Members

		
        /// <summary>
        /// CreditCardId / CreditCard.CreditCardID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("CreditCardID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? CreditCardId
        {
            get
            {
                return (int?)this["CreditCardID"];
            }
            set
            {
                this.Add("CreditCardID", value, typeof(int?));
            }
        }

        /// <summary>
        /// CardType / CreditCard.CardType
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("CardType"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string CardType
        {
            get
            {
                return (string)this["CardType"];
            }
            set
            {
                this.Add("CardType", value, typeof(string));
            }
        }

        /// <summary>
        /// CardNumber / CreditCard.CardNumber
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("CardNumber"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string CardNumber
        {
            get
            {
                return (string)this["CardNumber"];
            }
            set
            {
                this.Add("CardNumber", value, typeof(string));
            }
        }

        /// <summary>
        /// ExpMonth / CreditCard.ExpMonth
        /// </summary>
        /// <returns>byte?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ExpMonth"), FieldOrder(0), TypeName("byte?"), FieldTypeName("byte?"), ForeignEntity(null)]
        public virtual byte? ExpMonth
        {
            get
            {
                return (byte?)this["ExpMonth"];
            }
            set
            {
                this.Add("ExpMonth", value, typeof(byte?));
            }
        }

        /// <summary>
        /// ExpYear / CreditCard.ExpYear
        /// </summary>
        /// <returns>short?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ExpYear"), FieldOrder(0), TypeName("short?"), FieldTypeName("short?"), ForeignEntity(null)]
        public virtual short? ExpYear
        {
            get
            {
                return (short?)this["ExpYear"];
            }
            set
            {
                this.Add("ExpYear", value, typeof(short?));
            }
        }

        /// <summary>
        /// ModifiedDate / CreditCard.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		

		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from PersonCreditCard

        /// <summary>
        /// List of sub entities PersonCreditCard / PersonCreditCard (CreditCardID)
		/// Foreign Key FK_PersonCreditCard_CreditCard_CreditCardID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual PersonCreditCardList PersonCreditCardList
        {
            get
            {
			    // Lazy Loading
                if (_PersonCreditCardList == null && this.CreditCardId != null)
                {
					var where = new SqlWhereClause("WHERE PersonCreditCard.CreditCardID = @CreditCardID",
					    "@CreditCardID", this.CreditCardId);
                    _PersonCreditCardList = ((AdvEntityManager)this.Manager).GetPersonCreditCardList(where);
                }
				if (_PersonCreditCardList == null)
				{
					_PersonCreditCardList = new PersonCreditCardList();
				}
                return _PersonCreditCardList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private PersonCreditCardList _PersonCreditCardList = null;

        #endregion

        #region Sub Entites from SalesOrderHeader

        /// <summary>
        /// List of sub entities SalesOrderHeader / SalesOrderHeader (CreditCardID)
		/// Foreign Key FK_SalesOrderHeader_CreditCard_CreditCardID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesOrderHeaderList SalesOrderHeaderList
        {
            get
            {
			    // Lazy Loading
                if (_SalesOrderHeaderList == null && this.CreditCardId != null)
                {
					var where = new SqlWhereClause("WHERE SalesOrderHeader.CreditCardID = @CreditCardID",
					    "@CreditCardID", this.CreditCardId);
                    _SalesOrderHeaderList = ((AdvEntityManager)this.Manager).GetSalesOrderHeaderList(where);
                }
				if (_SalesOrderHeaderList == null)
				{
					_SalesOrderHeaderList = new SalesOrderHeaderList();
				}
                return _SalesOrderHeaderList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private SalesOrderHeaderList _SalesOrderHeaderList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.CreditCardFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "CreditCard"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // CreditCard

	#endregion

	#region Entity-List

    /// <summary>
    /// CreditCard / CreditCardList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class CreditCardList
        : WebEntityList<CreditCard>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "CreditCard"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// CreditCard - CreditCard - Factory 
    /// </summary>
    public partial class CreditCardFactory
        : WebEntityFactory<CreditCard, CreditCardList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property CreditCardId of Db-Field CreditCardID</summary>
        public static string Prop_CreditCardId = "CreditCardId";
        ///<summary>Property CardType of Db-Field CardType</summary>
        public static string Prop_CardType = "CardType";
        ///<summary>Property CardNumber of Db-Field CardNumber</summary>
        public static string Prop_CardNumber = "CardNumber";
        ///<summary>Property ExpMonth of Db-Field ExpMonth</summary>
        public static string Prop_ExpMonth = "ExpMonth";
        ///<summary>Property ExpYear of Db-Field ExpYear</summary>
        public static string Prop_ExpYear = "ExpYear";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field CreditCardID of Property CreditCardId</summary>
        public static string Field_CreditCardId = "CreditCardID";
        ///<summary>Db-Field CardType of Property CardType</summary>
        public static string Field_CardType = "CardType";
        ///<summary>Db-Field CardNumber of Property CardNumber</summary>
        public static string Field_CardNumber = "CardNumber";
        ///<summary>Db-Field ExpMonth of Property ExpMonth</summary>
        public static string Field_ExpMonth = "ExpMonth";
        ///<summary>Db-Field ExpYear of Property ExpYear</summary>
        public static string Field_ExpYear = "ExpYear";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = CreditCard, 
		/// Fields       = "CreditCardID"
		/// Query        = ...
        /// </summary>
        protected CreditCardFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Sales";
            this.TableName = "CreditCard";
            this.Fields = new string[]
            {
                "CreditCardID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("CreditCardId", "int?", "CreditCardID", "int?", "", null);
			this.Properties.Add("CardType", "string", "CardType", "string", "", null);
			this.Properties.Add("CardNumber", "string", "CardNumber", "string", "", null);
			this.Properties.Add("ExpMonth", "byte?", "ExpMonth", "byte?", "", null);
			this.Properties.Add("ExpYear", "short?", "ExpYear", "short?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "CreditCard"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "CreditCardList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "CreditCardFactory"; }
            set { }
        }

		#endregion

		internal static CreditCardFactory CreateFactory(EntityManager manager)
		{
		    return new CreditCardFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of CreditCard. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo CreditCard</returns>
        public override CreditCard CreateEntity()
		{
			var item = new CreditCard();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}



		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public CreditCard GetItem(int? creditCardId)
        {
            return this.GetEntity(0, creditCardId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public CreditCard GetItem(DbConnector conn, int? creditCardId)
        {
            return this.GetEntity(conn, creditCardId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(CreditCard).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to CreditCardFactory / CreditCard / CreditCard.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// CreditCardFactory to CreditCard / CreditCard.
        /// </summary>
        public CreditCardFactory CreditCardFactory
		{
			get
			{
				if (_CreditCardFactory == null)
				{
					_CreditCardFactory = global::AdventureWorks.CreditCardFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_CreditCardFactory, typeof(CreditCard));
				}
				return _CreditCardFactory;
			}
		}
		private CreditCardFactory _CreditCardFactory = null;
	
        /// <summary>
        /// GetCreditCard to CreditCard / CreditCard
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public CreditCard GetCreditCard(int? creditCardId)
        {
            return this.CreditCardFactory.GetEntity(0, creditCardId);
        }
	
        /// <summary>
        /// GetCreditCard to CreditCard / CreditCard
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public CreditCard GetCreditCard(DbConnector conn, int? creditCardId)
        {
            return this.CreditCardFactory.GetEntity(conn, creditCardId);
        }
	
		/// <summary>
        /// GetCreditCardList to CreditCard / CreditCard
		/// Getting a list of CreditCard using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public CreditCardList GetCreditCardList(SqlWhereClause where)
        {
            return this.CreditCardFactory.GetEntities(where);
        }

		/// <summary>
        /// GetCreditCardList to CreditCard / CreditCard
		/// Getting all entities of CreditCard
        /// </summary>
        /// <returns>List of all found entities</returns>
        public CreditCardList GetCreditCardList()
        {
			var where = new SqlWhereClause();
            return this.CreditCardFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveCreditCard to CreditCard / CreditCard
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public CreditCard SaveCreditCard(CreditCard item)
        {
            return this.CreditCardFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveCreditCard to CreditCard / CreditCard
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public CreditCard SaveCreditCard(DbConnector conn, CreditCard item)
        {
            return this.CreditCardFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyCreditCard to CreditCard / CreditCard
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public CreditCard ApplyCreditCard(DbConnector conn, CreditCard item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.CreditCardFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveCreditCard to CreditCard / CreditCard
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveCreditCard(CreditCard item)
        {
            return this.CreditCardFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveCreditCard to CreditCard / CreditCard
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveCreditCard(DbConnector conn, CreditCard item)
        {
            return this.CreditCardFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities CreditCardList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveCreditCardList(CreditCardList items)
        {
			return this.CreditCardFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
