﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// CurrencyRate / CurrencyRate - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class CurrencyRate
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for CurrencyRate
        /// </summary>
	    public CurrencyRate()
		{
		}

		///// <summary>
        ///// Creates a new instance of CurrencyRate
        ///// </summary>
	    //internal CurrencyRate CreateEntity()
		//{
		//    return new CurrencyRate();
		//}

		#region Members

		
        /// <summary>
        /// CurrencyRateId / CurrencyRate.CurrencyRateID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("CurrencyRateID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? CurrencyRateId
        {
            get
            {
                return (int?)this["CurrencyRateID"];
            }
            set
            {
                this.Add("CurrencyRateID", value, typeof(int?));
            }
        }

        /// <summary>
        /// CurrencyRateDate / CurrencyRate.CurrencyRateDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("CurrencyRateDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? CurrencyRateDate
        {
            get
            {
                return (DateTime?)this["CurrencyRateDate"];
            }
            set
            {
                this.Add("CurrencyRateDate", value, typeof(DateTime?));
            }
        }

        /// <summary>
        /// FromCurrencyCode / CurrencyRate.FromCurrencyCode
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("FromCurrencyCode"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity("Currency")]
        public virtual string FromCurrencyCode
        {
            get
            {
                return (string)this["FromCurrencyCode"];
            }
            set
            {
                this.Add("FromCurrencyCode", value, typeof(string));
            }
        }

        /// <summary>
        /// ToCurrencyCode / CurrencyRate.ToCurrencyCode
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ToCurrencyCode"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity("Currency")]
        public virtual string ToCurrencyCode
        {
            get
            {
                return (string)this["ToCurrencyCode"];
            }
            set
            {
                this.Add("ToCurrencyCode", value, typeof(string));
            }
        }

        /// <summary>
        /// AverageRate / CurrencyRate.AverageRate
        /// </summary>
        /// <returns>decimal?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("AverageRate"), FieldOrder(0), TypeName("decimal?"), FieldTypeName("decimal?"), ForeignEntity(null)]
        public virtual decimal? AverageRate
        {
            get
            {
                return (decimal?)this["AverageRate"];
            }
            set
            {
                this.Add("AverageRate", value, typeof(decimal?));
            }
        }

        /// <summary>
        /// EndOfDayRate / CurrencyRate.EndOfDayRate
        /// </summary>
        /// <returns>decimal?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("EndOfDayRate"), FieldOrder(0), TypeName("decimal?"), FieldTypeName("decimal?"), ForeignEntity(null)]
        public virtual decimal? EndOfDayRate
        {
            get
            {
                return (decimal?)this["EndOfDayRate"];
            }
            set
            {
                this.Add("EndOfDayRate", value, typeof(decimal?));
            }
        }

        /// <summary>
        /// ModifiedDate / CurrencyRate.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Currency

        /// <summary>
        /// Link to parent/super Entity Currency / Currency (this.FromCurrencyCode)
		/// Foreign key FK_CurrencyRate_Currency_FromCurrencyCode
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Currency Currency
        {
            get
            {
			    // Lazy loading
                if (this._Currency == null && this.FromCurrencyCode != null)
                {
                    this._Currency = ((AdvEntityManager)this.Manager).GetCurrency(this.FromCurrencyCode);
                    if (! _Currency.ResultInfo.IsValid)
                    {
						this._Currency = null; // reset value
                        throw new Exception("wrong/missed constraint from CurrencyRate to Currency.");
                    }
                }
                return this._Currency;
            }
            set
            {
                // reassign foreign key values from setter value
                this.FromCurrencyCode = (value != null ? value.CurrencyCode : null);


				// set foreign table
                this._Currency = value;
            }
        }
        private Currency _Currency = null;

        #endregion

        #region foreign constraint (parent entity) to Currency

        /// <summary>
        /// Link to parent/super Entity Currency / Currency (this.ToCurrencyCode)
		/// Foreign key FK_CurrencyRate_Currency_ToCurrencyCode
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Currency CurrencyToCurrencyCode
        {
            get
            {
			    // Lazy loading
                if (this._CurrencyToCurrencyCode == null && this.ToCurrencyCode != null)
                {
                    this._CurrencyToCurrencyCode = ((AdvEntityManager)this.Manager).GetCurrency(this.ToCurrencyCode);
                    if (! _CurrencyToCurrencyCode.ResultInfo.IsValid)
                    {
						this._CurrencyToCurrencyCode = null; // reset value
                        throw new Exception("wrong/missed constraint from CurrencyRate to Currency.");
                    }
                }
                return this._CurrencyToCurrencyCode;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ToCurrencyCode = (value != null ? value.CurrencyCode : null);


				// set foreign table
                this._CurrencyToCurrencyCode = value;
            }
        }
        private Currency _CurrencyToCurrencyCode = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from SalesOrderHeader

        /// <summary>
        /// List of sub entities SalesOrderHeader / SalesOrderHeader (CurrencyRateID)
		/// Foreign Key FK_SalesOrderHeader_CurrencyRate_CurrencyRateID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesOrderHeaderList SalesOrderHeaderList
        {
            get
            {
			    // Lazy Loading
                if (_SalesOrderHeaderList == null && this.CurrencyRateId != null)
                {
					var where = new SqlWhereClause("WHERE SalesOrderHeader.CurrencyRateID = @CurrencyRateID",
					    "@CurrencyRateID", this.CurrencyRateId);
                    _SalesOrderHeaderList = ((AdvEntityManager)this.Manager).GetSalesOrderHeaderList(where);
                }
				if (_SalesOrderHeaderList == null)
				{
					_SalesOrderHeaderList = new SalesOrderHeaderList();
				}
                return _SalesOrderHeaderList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private SalesOrderHeaderList _SalesOrderHeaderList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.CurrencyRateFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "CurrencyRate"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // CurrencyRate

	#endregion

	#region Entity-List

    /// <summary>
    /// CurrencyRate / CurrencyRateList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class CurrencyRateList
        : WebEntityList<CurrencyRate>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "CurrencyRate"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// CurrencyRate - CurrencyRate - Factory 
    /// </summary>
    public partial class CurrencyRateFactory
        : WebEntityFactory<CurrencyRate, CurrencyRateList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property CurrencyRateId of Db-Field CurrencyRateID</summary>
        public static string Prop_CurrencyRateId = "CurrencyRateId";
        ///<summary>Property CurrencyRateDate of Db-Field CurrencyRateDate</summary>
        public static string Prop_CurrencyRateDate = "CurrencyRateDate";
        ///<summary>Property FromCurrencyCode of Db-Field FromCurrencyCode</summary>
        public static string Prop_FromCurrencyCode = "FromCurrencyCode";
        ///<summary>Property ToCurrencyCode of Db-Field ToCurrencyCode</summary>
        public static string Prop_ToCurrencyCode = "ToCurrencyCode";
        ///<summary>Property AverageRate of Db-Field AverageRate</summary>
        public static string Prop_AverageRate = "AverageRate";
        ///<summary>Property EndOfDayRate of Db-Field EndOfDayRate</summary>
        public static string Prop_EndOfDayRate = "EndOfDayRate";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field CurrencyRateID of Property CurrencyRateId</summary>
        public static string Field_CurrencyRateId = "CurrencyRateID";
        ///<summary>Db-Field CurrencyRateDate of Property CurrencyRateDate</summary>
        public static string Field_CurrencyRateDate = "CurrencyRateDate";
        ///<summary>Db-Field FromCurrencyCode of Property FromCurrencyCode</summary>
        public static string Field_FromCurrencyCode = "FromCurrencyCode";
        ///<summary>Db-Field ToCurrencyCode of Property ToCurrencyCode</summary>
        public static string Field_ToCurrencyCode = "ToCurrencyCode";
        ///<summary>Db-Field AverageRate of Property AverageRate</summary>
        public static string Field_AverageRate = "AverageRate";
        ///<summary>Db-Field EndOfDayRate of Property EndOfDayRate</summary>
        public static string Field_EndOfDayRate = "EndOfDayRate";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = CurrencyRate, 
		/// Fields       = "CurrencyRateID"
		/// Query        = ...
        /// </summary>
        protected CurrencyRateFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Sales";
            this.TableName = "CurrencyRate";
            this.Fields = new string[]
            {
                "CurrencyRateID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("CurrencyRateId", "int?", "CurrencyRateID", "int?", "", null);
			this.Properties.Add("CurrencyRateDate", "DateTime?", "CurrencyRateDate", "DateTime?", "", null);
			this.Properties.Add("FromCurrencyCode", "string", "FromCurrencyCode", "string", "", "Currency");
			this.Properties.Add("ToCurrencyCode", "string", "ToCurrencyCode", "string", "", "Currency");
			this.Properties.Add("AverageRate", "decimal?", "AverageRate", "decimal?", "", null);
			this.Properties.Add("EndOfDayRate", "decimal?", "EndOfDayRate", "decimal?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "CurrencyRate"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "CurrencyRateList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "CurrencyRateFactory"; }
            set { }
        }

		#endregion

		internal static CurrencyRateFactory CreateFactory(EntityManager manager)
		{
		    return new CurrencyRateFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of CurrencyRate. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo CurrencyRate</returns>
        public override CurrencyRate CreateEntity()
		{
			var item = new CurrencyRate();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(CurrencyRate item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Currency / Currency
            // Foreign Key FK_CurrencyRate_Currency_FromCurrencyCode
            if (parent is Currency)
            {
                item.Currency = (Currency)parent;
                return;
            }

            // make relation to parent/super Entity Currency / Currency
            // Foreign Key FK_CurrencyRate_Currency_ToCurrencyCode
            if (parent is Currency)
            {
                item.Currency = (Currency)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public CurrencyRate GetItem(int? currencyRateId)
        {
            return this.GetEntity(0, currencyRateId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public CurrencyRate GetItem(DbConnector conn, int? currencyRateId)
        {
            return this.GetEntity(conn, currencyRateId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(CurrencyRate).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to CurrencyRateFactory / CurrencyRate / CurrencyRate.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// CurrencyRateFactory to CurrencyRate / CurrencyRate.
        /// </summary>
        public CurrencyRateFactory CurrencyRateFactory
		{
			get
			{
				if (_CurrencyRateFactory == null)
				{
					_CurrencyRateFactory = global::AdventureWorks.CurrencyRateFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_CurrencyRateFactory, typeof(CurrencyRate));
				}
				return _CurrencyRateFactory;
			}
		}
		private CurrencyRateFactory _CurrencyRateFactory = null;
	
        /// <summary>
        /// GetCurrencyRate to CurrencyRate / CurrencyRate
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public CurrencyRate GetCurrencyRate(int? currencyRateId)
        {
            return this.CurrencyRateFactory.GetEntity(0, currencyRateId);
        }
	
        /// <summary>
        /// GetCurrencyRate to CurrencyRate / CurrencyRate
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public CurrencyRate GetCurrencyRate(DbConnector conn, int? currencyRateId)
        {
            return this.CurrencyRateFactory.GetEntity(conn, currencyRateId);
        }
	
		/// <summary>
        /// GetCurrencyRateList to CurrencyRate / CurrencyRate
		/// Getting a list of CurrencyRate using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public CurrencyRateList GetCurrencyRateList(SqlWhereClause where)
        {
            return this.CurrencyRateFactory.GetEntities(where);
        }

		/// <summary>
        /// GetCurrencyRateList to CurrencyRate / CurrencyRate
		/// Getting all entities of CurrencyRate
        /// </summary>
        /// <returns>List of all found entities</returns>
        public CurrencyRateList GetCurrencyRateList()
        {
			var where = new SqlWhereClause();
            return this.CurrencyRateFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveCurrencyRate to CurrencyRate / CurrencyRate
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public CurrencyRate SaveCurrencyRate(CurrencyRate item)
        {
            return this.CurrencyRateFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveCurrencyRate to CurrencyRate / CurrencyRate
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public CurrencyRate SaveCurrencyRate(DbConnector conn, CurrencyRate item)
        {
            return this.CurrencyRateFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyCurrencyRate to CurrencyRate / CurrencyRate
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public CurrencyRate ApplyCurrencyRate(DbConnector conn, CurrencyRate item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.CurrencyRateFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveCurrencyRate to CurrencyRate / CurrencyRate
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveCurrencyRate(CurrencyRate item)
        {
            return this.CurrencyRateFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveCurrencyRate to CurrencyRate / CurrencyRate
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveCurrencyRate(DbConnector conn, CurrencyRate item)
        {
            return this.CurrencyRateFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities CurrencyRateList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveCurrencyRateList(CurrencyRateList items)
        {
			return this.CurrencyRateFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
