﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// Customer / Customer - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class Customer
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for Customer
        /// </summary>
	    public Customer()
		{
		}

		///// <summary>
        ///// Creates a new instance of Customer
        ///// </summary>
	    //internal Customer CreateEntity()
		//{
		//    return new Customer();
		//}

		#region Members

		
        /// <summary>
        /// CustomerId / Customer.CustomerID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("CustomerID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? CustomerId
        {
            get
            {
                return (int?)this["CustomerID"];
            }
            set
            {
                this.Add("CustomerID", value, typeof(int?));
            }
        }

        /// <summary>
        /// PersonId / Customer.PersonID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("PersonID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Person")]
        public virtual int? PersonId
        {
            get
            {
                return (int?)this["PersonID"];
            }
            set
            {
                this.Add("PersonID", value, typeof(int?));
            }
        }

        /// <summary>
        /// StoreId / Customer.StoreID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("StoreID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Store")]
        public virtual int? StoreId
        {
            get
            {
                return (int?)this["StoreID"];
            }
            set
            {
                this.Add("StoreID", value, typeof(int?));
            }
        }

        /// <summary>
        /// TerritoryId / Customer.TerritoryID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("TerritoryID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("SalesTerritory")]
        public virtual int? TerritoryId
        {
            get
            {
                return (int?)this["TerritoryID"];
            }
            set
            {
                this.Add("TerritoryID", value, typeof(int?));
            }
        }

        /// <summary>
        /// AccountNumber / Customer.AccountNumber
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("AccountNumber"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string AccountNumber
        {
            get
            {
                return (string)this["AccountNumber"];
            }
            set
            {
                this.Add("AccountNumber", value, typeof(string));
            }
        }

        /// <summary>
        /// Rowguid / Customer.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / Customer.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Person

        /// <summary>
        /// Link to parent/super Entity Person / Person (this.PersonId)
		/// Foreign key FK_Customer_Person_PersonID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Person Person
        {
            get
            {
			    // Lazy loading
                if (this._Person == null && this.PersonId != null)
                {
                    this._Person = ((AdvEntityManager)this.Manager).GetPerson(this.PersonId);
                    if (! _Person.ResultInfo.IsValid)
                    {
						this._Person = null; // reset value
                        throw new Exception("wrong/missed constraint from Customer to Person.");
                    }
                }
                return this._Person;
            }
            set
            {
                // reassign foreign key values from setter value
                this.PersonId = (value != null ? value.BusinessEntityId : null);


				// set foreign table
                this._Person = value;
            }
        }
        private Person _Person = null;

        #endregion

        #region foreign constraint (parent entity) to SalesTerritory

        /// <summary>
        /// Link to parent/super Entity SalesTerritory / SalesTerritory (this.TerritoryId)
		/// Foreign key FK_Customer_SalesTerritory_TerritoryID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesTerritory SalesTerritory
        {
            get
            {
			    // Lazy loading
                if (this._SalesTerritory == null && this.TerritoryId != null)
                {
                    this._SalesTerritory = ((AdvEntityManager)this.Manager).GetSalesTerritory(this.TerritoryId);
                    if (! _SalesTerritory.ResultInfo.IsValid)
                    {
						this._SalesTerritory = null; // reset value
                        throw new Exception("wrong/missed constraint from Customer to SalesTerritory.");
                    }
                }
                return this._SalesTerritory;
            }
            set
            {
                // reassign foreign key values from setter value
                this.TerritoryId = (value != null ? value.TerritoryId : null);


				// set foreign table
                this._SalesTerritory = value;
            }
        }
        private SalesTerritory _SalesTerritory = null;

        #endregion

        #region foreign constraint (parent entity) to Store

        /// <summary>
        /// Link to parent/super Entity Store / Store (this.StoreId)
		/// Foreign key FK_Customer_Store_StoreID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Store Store
        {
            get
            {
			    // Lazy loading
                if (this._Store == null && this.StoreId != null)
                {
                    this._Store = ((AdvEntityManager)this.Manager).GetStore(this.StoreId);
                    if (! _Store.ResultInfo.IsValid)
                    {
						this._Store = null; // reset value
                        throw new Exception("wrong/missed constraint from Customer to Store.");
                    }
                }
                return this._Store;
            }
            set
            {
                // reassign foreign key values from setter value
                this.StoreId = (value != null ? value.BusinessEntityId : null);


				// set foreign table
                this._Store = value;
            }
        }
        private Store _Store = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from SalesOrderHeader

        /// <summary>
        /// List of sub entities SalesOrderHeader / SalesOrderHeader (CustomerID)
		/// Foreign Key FK_SalesOrderHeader_Customer_CustomerID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesOrderHeaderList SalesOrderHeaderList
        {
            get
            {
			    // Lazy Loading
                if (_SalesOrderHeaderList == null && this.CustomerId != null)
                {
					var where = new SqlWhereClause("WHERE SalesOrderHeader.CustomerID = @CustomerID",
					    "@CustomerID", this.CustomerId);
                    _SalesOrderHeaderList = ((AdvEntityManager)this.Manager).GetSalesOrderHeaderList(where);
                }
				if (_SalesOrderHeaderList == null)
				{
					_SalesOrderHeaderList = new SalesOrderHeaderList();
				}
                return _SalesOrderHeaderList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private SalesOrderHeaderList _SalesOrderHeaderList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.CustomerFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Customer"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // Customer

	#endregion

	#region Entity-List

    /// <summary>
    /// Customer / CustomerList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class CustomerList
        : WebEntityList<Customer>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Customer"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// Customer - Customer - Factory 
    /// </summary>
    public partial class CustomerFactory
        : WebEntityFactory<Customer, CustomerList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property CustomerId of Db-Field CustomerID</summary>
        public static string Prop_CustomerId = "CustomerId";
        ///<summary>Property PersonId of Db-Field PersonID</summary>
        public static string Prop_PersonId = "PersonId";
        ///<summary>Property StoreId of Db-Field StoreID</summary>
        public static string Prop_StoreId = "StoreId";
        ///<summary>Property TerritoryId of Db-Field TerritoryID</summary>
        public static string Prop_TerritoryId = "TerritoryId";
        ///<summary>Property AccountNumber of Db-Field AccountNumber</summary>
        public static string Prop_AccountNumber = "AccountNumber";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field CustomerID of Property CustomerId</summary>
        public static string Field_CustomerId = "CustomerID";
        ///<summary>Db-Field PersonID of Property PersonId</summary>
        public static string Field_PersonId = "PersonID";
        ///<summary>Db-Field StoreID of Property StoreId</summary>
        public static string Field_StoreId = "StoreID";
        ///<summary>Db-Field TerritoryID of Property TerritoryId</summary>
        public static string Field_TerritoryId = "TerritoryID";
        ///<summary>Db-Field AccountNumber of Property AccountNumber</summary>
        public static string Field_AccountNumber = "AccountNumber";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = Customer, 
		/// Fields       = "CustomerID"
		/// Query        = ...
        /// </summary>
        protected CustomerFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Sales";
            this.TableName = "Customer";
            this.Fields = new string[]
            {
                "CustomerID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("CustomerId", "int?", "CustomerID", "int?", "", null);
			this.Properties.Add("PersonId", "int?", "PersonID", "int?", "", "Person");
			this.Properties.Add("StoreId", "int?", "StoreID", "int?", "", "Store");
			this.Properties.Add("TerritoryId", "int?", "TerritoryID", "int?", "", "SalesTerritory");
			this.Properties.Add("AccountNumber", "string", "AccountNumber", "string", "", null);
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "Customer"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "CustomerList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "CustomerFactory"; }
            set { }
        }

		#endregion

		internal static CustomerFactory CreateFactory(EntityManager manager)
		{
		    return new CustomerFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of Customer. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo Customer</returns>
        public override Customer CreateEntity()
		{
			var item = new Customer();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(Customer item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Person / Person
            // Foreign Key FK_Customer_Person_PersonID
            if (parent is Person)
            {
                item.Person = (Person)parent;
                return;
            }

            // make relation to parent/super Entity SalesTerritory / SalesTerritory
            // Foreign Key FK_Customer_SalesTerritory_TerritoryID
            if (parent is SalesTerritory)
            {
                item.SalesTerritory = (SalesTerritory)parent;
                return;
            }

            // make relation to parent/super Entity Store / Store
            // Foreign Key FK_Customer_Store_StoreID
            if (parent is Store)
            {
                item.Store = (Store)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public Customer GetItem(int? customerId)
        {
            return this.GetEntity(0, customerId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public Customer GetItem(DbConnector conn, int? customerId)
        {
            return this.GetEntity(conn, customerId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(Customer).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to CustomerFactory / Customer / Customer.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// CustomerFactory to Customer / Customer.
        /// </summary>
        public CustomerFactory CustomerFactory
		{
			get
			{
				if (_CustomerFactory == null)
				{
					_CustomerFactory = global::AdventureWorks.CustomerFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_CustomerFactory, typeof(Customer));
				}
				return _CustomerFactory;
			}
		}
		private CustomerFactory _CustomerFactory = null;
	
        /// <summary>
        /// GetCustomer to Customer / Customer
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public Customer GetCustomer(int? customerId)
        {
            return this.CustomerFactory.GetEntity(0, customerId);
        }
	
        /// <summary>
        /// GetCustomer to Customer / Customer
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Customer GetCustomer(DbConnector conn, int? customerId)
        {
            return this.CustomerFactory.GetEntity(conn, customerId);
        }
	
		/// <summary>
        /// GetCustomerList to Customer / Customer
		/// Getting a list of Customer using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public CustomerList GetCustomerList(SqlWhereClause where)
        {
            return this.CustomerFactory.GetEntities(where);
        }

		/// <summary>
        /// GetCustomerList to Customer / Customer
		/// Getting all entities of Customer
        /// </summary>
        /// <returns>List of all found entities</returns>
        public CustomerList GetCustomerList()
        {
			var where = new SqlWhereClause();
            return this.CustomerFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveCustomer to Customer / Customer
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Customer SaveCustomer(Customer item)
        {
            return this.CustomerFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveCustomer to Customer / Customer
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Customer SaveCustomer(DbConnector conn, Customer item)
        {
            return this.CustomerFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyCustomer to Customer / Customer
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Customer ApplyCustomer(DbConnector conn, Customer item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.CustomerFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveCustomer to Customer / Customer
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveCustomer(Customer item)
        {
            return this.CustomerFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveCustomer to Customer / Customer
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveCustomer(DbConnector conn, Customer item)
        {
            return this.CustomerFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities CustomerList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveCustomerList(CustomerList items)
        {
			return this.CustomerFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
