﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// EmailAddress / EmailAddress - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class EmailAddress
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for EmailAddress
        /// </summary>
	    public EmailAddress()
		{
		}

		///// <summary>
        ///// Creates a new instance of EmailAddress
        ///// </summary>
	    //internal EmailAddress CreateEntity()
		//{
		//    return new EmailAddress();
		//}

		#region Members

		
        /// <summary>
        /// BusinessEntityId / EmailAddress.BusinessEntityID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("BusinessEntityID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Person")]
        public virtual int? BusinessEntityId
        {
            get
            {
                return (int?)this["BusinessEntityID"];
            }
            set
            {
                this.Add("BusinessEntityID", value, typeof(int?));
            }
        }

        /// <summary>
        /// EmailAddressId / EmailAddress.EmailAddressID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("EmailAddressID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? EmailAddressId
        {
            get
            {
                return (int?)this["EmailAddressID"];
            }
            set
            {
                this.Add("EmailAddressID", value, typeof(int?));
            }
        }

        /// <summary>
        /// EmailAddressProp / EmailAddress.EmailAddress
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("EmailAddress"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string EmailAddressProp
        {
            get
            {
                return (string)this["EmailAddress"];
            }
            set
            {
                this.Add("EmailAddress", value, typeof(string));
            }
        }

        /// <summary>
        /// Rowguid / EmailAddress.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / EmailAddress.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Person

        /// <summary>
        /// Link to parent/super Entity Person / Person (this.BusinessEntityId)
		/// Foreign key FK_EmailAddress_Person_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Person Person
        {
            get
            {
			    // Lazy loading
                if (this._Person == null && this.BusinessEntityId != null)
                {
                    this._Person = ((AdvEntityManager)this.Manager).GetPerson(this.BusinessEntityId);
                    if (! _Person.ResultInfo.IsValid)
                    {
						this._Person = null; // reset value
                        throw new Exception("wrong/missed constraint from EmailAddress to Person.");
                    }
                }
                return this._Person;
            }
            set
            {
                // reassign foreign key values from setter value
                this.BusinessEntityId = (value != null ? value.BusinessEntityId : null);


				// set foreign table
                this._Person = value;
            }
        }
        private Person _Person = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		
        /// <summary>
        /// EmailAddress_ / EmailAddress.EmailAddress
		/// origin database field to EmailAddressProp
		/// <see cref="EmailAddressProp" />
        /// </summary>
        /// <returns>string</returns>
        [IgnoreDataMember]
		[BackwardCompatibility] // mark property as backward property (deprecated)
        public string EmailAddress_
        {
            get
            {
                return this.EmailAddressProp; 
            }
            set
            {
                this.EmailAddressProp = value;
            }
        }


		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.EmailAddressFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "EmailAddress"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // EmailAddress

	#endregion

	#region Entity-List

    /// <summary>
    /// EmailAddress / EmailAddressList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class EmailAddressList
        : WebEntityList<EmailAddress>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "EmailAddress"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// EmailAddress - EmailAddress - Factory 
    /// </summary>
    public partial class EmailAddressFactory
        : WebEntityFactory<EmailAddress, EmailAddressList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property BusinessEntityId of Db-Field BusinessEntityID</summary>
        public static string Prop_BusinessEntityId = "BusinessEntityId";
        ///<summary>Property EmailAddressId of Db-Field EmailAddressID</summary>
        public static string Prop_EmailAddressId = "EmailAddressId";
        ///<summary>Property EmailAddressProp of Db-Field EmailAddress</summary>
        public static string Prop_EmailAddressProp = "EmailAddressProp";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field BusinessEntityID of Property BusinessEntityId</summary>
        public static string Field_BusinessEntityId = "BusinessEntityID";
        ///<summary>Db-Field EmailAddressID of Property EmailAddressId</summary>
        public static string Field_EmailAddressId = "EmailAddressID";
        ///<summary>Db-Field EmailAddress of Property EmailAddressProp</summary>
        public static string Field_EmailAddressProp = "EmailAddress";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = EmailAddress, 
		/// Fields       = "BusinessEntityID", "EmailAddressID"
		/// Query        = ...
        /// </summary>
        protected EmailAddressFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Person";
            this.TableName = "EmailAddress";
            this.Fields = new string[]
            {
                "BusinessEntityID", "EmailAddressID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("BusinessEntityId", "int?", "BusinessEntityID", "int?", "", "Person");
			this.Properties.Add("EmailAddressId", "int?", "EmailAddressID", "int?", "", null);
			this.Properties.Add("EmailAddressProp", "string", "EmailAddress", "string", "", null);
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "EmailAddress"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "EmailAddressList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "EmailAddressFactory"; }
            set { }
        }

		#endregion

		internal static EmailAddressFactory CreateFactory(EntityManager manager)
		{
		    return new EmailAddressFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of EmailAddress. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo EmailAddress</returns>
        public override EmailAddress CreateEntity()
		{
			var item = new EmailAddress();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(EmailAddress item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Person / Person
            // Foreign Key FK_EmailAddress_Person_BusinessEntityID
            if (parent is Person)
            {
                item.Person = (Person)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public EmailAddress GetItem(int? businessEntityId, int? emailAddressId)
        {
            return this.GetEntity(0, businessEntityId, emailAddressId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public EmailAddress GetItem(DbConnector conn, int? businessEntityId, int? emailAddressId)
        {
            return this.GetEntity(conn, businessEntityId, emailAddressId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(EmailAddress).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to EmailAddressFactory / EmailAddress / EmailAddress.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// EmailAddressFactory to EmailAddress / EmailAddress.
        /// </summary>
        public EmailAddressFactory EmailAddressFactory
		{
			get
			{
				if (_EmailAddressFactory == null)
				{
					_EmailAddressFactory = global::AdventureWorks.EmailAddressFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_EmailAddressFactory, typeof(EmailAddress));
				}
				return _EmailAddressFactory;
			}
		}
		private EmailAddressFactory _EmailAddressFactory = null;
	
        /// <summary>
        /// GetEmailAddress to EmailAddress / EmailAddress
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public EmailAddress GetEmailAddress(int? businessEntityId, int? emailAddressId)
        {
            return this.EmailAddressFactory.GetEntity(0, businessEntityId, emailAddressId);
        }
	
        /// <summary>
        /// GetEmailAddress to EmailAddress / EmailAddress
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public EmailAddress GetEmailAddress(DbConnector conn, int? businessEntityId, int? emailAddressId)
        {
            return this.EmailAddressFactory.GetEntity(conn, businessEntityId, emailAddressId);
        }
	
		/// <summary>
        /// GetEmailAddressList to EmailAddress / EmailAddress
		/// Getting a list of EmailAddress using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public EmailAddressList GetEmailAddressList(SqlWhereClause where)
        {
            return this.EmailAddressFactory.GetEntities(where);
        }

		/// <summary>
        /// GetEmailAddressList to EmailAddress / EmailAddress
		/// Getting all entities of EmailAddress
        /// </summary>
        /// <returns>List of all found entities</returns>
        public EmailAddressList GetEmailAddressList()
        {
			var where = new SqlWhereClause();
            return this.EmailAddressFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveEmailAddress to EmailAddress / EmailAddress
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public EmailAddress SaveEmailAddress(EmailAddress item)
        {
            return this.EmailAddressFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveEmailAddress to EmailAddress / EmailAddress
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public EmailAddress SaveEmailAddress(DbConnector conn, EmailAddress item)
        {
            return this.EmailAddressFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyEmailAddress to EmailAddress / EmailAddress
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public EmailAddress ApplyEmailAddress(DbConnector conn, EmailAddress item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.EmailAddressFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveEmailAddress to EmailAddress / EmailAddress
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveEmailAddress(EmailAddress item)
        {
            return this.EmailAddressFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveEmailAddress to EmailAddress / EmailAddress
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveEmailAddress(DbConnector conn, EmailAddress item)
        {
            return this.EmailAddressFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities EmailAddressList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveEmailAddressList(EmailAddressList items)
        {
			return this.EmailAddressFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
