﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// EmployeePayHistory / EmployeePayHistory - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class EmployeePayHistory
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for EmployeePayHistory
        /// </summary>
	    public EmployeePayHistory()
		{
		}

		///// <summary>
        ///// Creates a new instance of EmployeePayHistory
        ///// </summary>
	    //internal EmployeePayHistory CreateEntity()
		//{
		//    return new EmployeePayHistory();
		//}

		#region Members

		
        /// <summary>
        /// BusinessEntityId / EmployeePayHistory.BusinessEntityID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("BusinessEntityID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Employee")]
        public virtual int? BusinessEntityId
        {
            get
            {
                return (int?)this["BusinessEntityID"];
            }
            set
            {
                this.Add("BusinessEntityID", value, typeof(int?));
            }
        }

        /// <summary>
        /// RateChangeDate / EmployeePayHistory.RateChangeDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("RateChangeDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? RateChangeDate
        {
            get
            {
                return (DateTime?)this["RateChangeDate"];
            }
            set
            {
                this.Add("RateChangeDate", value, typeof(DateTime?));
            }
        }

        /// <summary>
        /// Rate / EmployeePayHistory.Rate
        /// </summary>
        /// <returns>decimal?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Rate"), FieldOrder(0), TypeName("decimal?"), FieldTypeName("decimal?"), ForeignEntity(null)]
        public virtual decimal? Rate
        {
            get
            {
                return (decimal?)this["Rate"];
            }
            set
            {
                this.Add("Rate", value, typeof(decimal?));
            }
        }

        /// <summary>
        /// PayFrequency / EmployeePayHistory.PayFrequency
        /// </summary>
        /// <returns>byte?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("PayFrequency"), FieldOrder(0), TypeName("byte?"), FieldTypeName("byte?"), ForeignEntity(null)]
        public virtual byte? PayFrequency
        {
            get
            {
                return (byte?)this["PayFrequency"];
            }
            set
            {
                this.Add("PayFrequency", value, typeof(byte?));
            }
        }

        /// <summary>
        /// ModifiedDate / EmployeePayHistory.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Employee

        /// <summary>
        /// Link to parent/super Entity Employee / Employee (this.BusinessEntityId)
		/// Foreign key FK_EmployeePayHistory_Employee_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Employee Employee
        {
            get
            {
			    // Lazy loading
                if (this._Employee == null && this.BusinessEntityId != null)
                {
                    this._Employee = ((AdvEntityManager)this.Manager).GetEmployee(this.BusinessEntityId);
                    if (! _Employee.ResultInfo.IsValid)
                    {
						this._Employee = null; // reset value
                        throw new Exception("wrong/missed constraint from EmployeePayHistory to Employee.");
                    }
                }
                return this._Employee;
            }
            set
            {
                // reassign foreign key values from setter value
                this.BusinessEntityId = (value != null ? value.BusinessEntityId : null);


				// set foreign table
                this._Employee = value;
            }
        }
        private Employee _Employee = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.EmployeePayHistoryFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "EmployeePayHistory"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // EmployeePayHistory

	#endregion

	#region Entity-List

    /// <summary>
    /// EmployeePayHistory / EmployeePayHistoryList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class EmployeePayHistoryList
        : WebEntityList<EmployeePayHistory>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "EmployeePayHistory"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// EmployeePayHistory - EmployeePayHistory - Factory 
    /// </summary>
    public partial class EmployeePayHistoryFactory
        : WebEntityFactory<EmployeePayHistory, EmployeePayHistoryList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property BusinessEntityId of Db-Field BusinessEntityID</summary>
        public static string Prop_BusinessEntityId = "BusinessEntityId";
        ///<summary>Property RateChangeDate of Db-Field RateChangeDate</summary>
        public static string Prop_RateChangeDate = "RateChangeDate";
        ///<summary>Property Rate of Db-Field Rate</summary>
        public static string Prop_Rate = "Rate";
        ///<summary>Property PayFrequency of Db-Field PayFrequency</summary>
        public static string Prop_PayFrequency = "PayFrequency";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field BusinessEntityID of Property BusinessEntityId</summary>
        public static string Field_BusinessEntityId = "BusinessEntityID";
        ///<summary>Db-Field RateChangeDate of Property RateChangeDate</summary>
        public static string Field_RateChangeDate = "RateChangeDate";
        ///<summary>Db-Field Rate of Property Rate</summary>
        public static string Field_Rate = "Rate";
        ///<summary>Db-Field PayFrequency of Property PayFrequency</summary>
        public static string Field_PayFrequency = "PayFrequency";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = EmployeePayHistory, 
		/// Fields       = "BusinessEntityID", "RateChangeDate"
		/// Query        = ...
        /// </summary>
        protected EmployeePayHistoryFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "HumanResources";
            this.TableName = "EmployeePayHistory";
            this.Fields = new string[]
            {
                "BusinessEntityID", "RateChangeDate"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("BusinessEntityId", "int?", "BusinessEntityID", "int?", "", "Employee");
			this.Properties.Add("RateChangeDate", "DateTime?", "RateChangeDate", "DateTime?", "", null);
			this.Properties.Add("Rate", "decimal?", "Rate", "decimal?", "", null);
			this.Properties.Add("PayFrequency", "byte?", "PayFrequency", "byte?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "EmployeePayHistory"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "EmployeePayHistoryList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "EmployeePayHistoryFactory"; }
            set { }
        }

		#endregion

		internal static EmployeePayHistoryFactory CreateFactory(EntityManager manager)
		{
		    return new EmployeePayHistoryFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of EmployeePayHistory. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo EmployeePayHistory</returns>
        public override EmployeePayHistory CreateEntity()
		{
			var item = new EmployeePayHistory();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(EmployeePayHistory item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Employee / Employee
            // Foreign Key FK_EmployeePayHistory_Employee_BusinessEntityID
            if (parent is Employee)
            {
                item.Employee = (Employee)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public EmployeePayHistory GetItem(int? businessEntityId, DateTime? rateChangeDate)
        {
            return this.GetEntity(0, businessEntityId, rateChangeDate);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public EmployeePayHistory GetItem(DbConnector conn, int? businessEntityId, DateTime? rateChangeDate)
        {
            return this.GetEntity(conn, businessEntityId, rateChangeDate);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(EmployeePayHistory).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to EmployeePayHistoryFactory / EmployeePayHistory / EmployeePayHistory.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// EmployeePayHistoryFactory to EmployeePayHistory / EmployeePayHistory.
        /// </summary>
        public EmployeePayHistoryFactory EmployeePayHistoryFactory
		{
			get
			{
				if (_EmployeePayHistoryFactory == null)
				{
					_EmployeePayHistoryFactory = global::AdventureWorks.EmployeePayHistoryFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_EmployeePayHistoryFactory, typeof(EmployeePayHistory));
				}
				return _EmployeePayHistoryFactory;
			}
		}
		private EmployeePayHistoryFactory _EmployeePayHistoryFactory = null;
	
        /// <summary>
        /// GetEmployeePayHistory to EmployeePayHistory / EmployeePayHistory
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public EmployeePayHistory GetEmployeePayHistory(int? businessEntityId, DateTime? rateChangeDate)
        {
            return this.EmployeePayHistoryFactory.GetEntity(0, businessEntityId, rateChangeDate);
        }
	
        /// <summary>
        /// GetEmployeePayHistory to EmployeePayHistory / EmployeePayHistory
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public EmployeePayHistory GetEmployeePayHistory(DbConnector conn, int? businessEntityId, DateTime? rateChangeDate)
        {
            return this.EmployeePayHistoryFactory.GetEntity(conn, businessEntityId, rateChangeDate);
        }
	
		/// <summary>
        /// GetEmployeePayHistoryList to EmployeePayHistory / EmployeePayHistory
		/// Getting a list of EmployeePayHistory using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public EmployeePayHistoryList GetEmployeePayHistoryList(SqlWhereClause where)
        {
            return this.EmployeePayHistoryFactory.GetEntities(where);
        }

		/// <summary>
        /// GetEmployeePayHistoryList to EmployeePayHistory / EmployeePayHistory
		/// Getting all entities of EmployeePayHistory
        /// </summary>
        /// <returns>List of all found entities</returns>
        public EmployeePayHistoryList GetEmployeePayHistoryList()
        {
			var where = new SqlWhereClause();
            return this.EmployeePayHistoryFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveEmployeePayHistory to EmployeePayHistory / EmployeePayHistory
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public EmployeePayHistory SaveEmployeePayHistory(EmployeePayHistory item)
        {
            return this.EmployeePayHistoryFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveEmployeePayHistory to EmployeePayHistory / EmployeePayHistory
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public EmployeePayHistory SaveEmployeePayHistory(DbConnector conn, EmployeePayHistory item)
        {
            return this.EmployeePayHistoryFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyEmployeePayHistory to EmployeePayHistory / EmployeePayHistory
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public EmployeePayHistory ApplyEmployeePayHistory(DbConnector conn, EmployeePayHistory item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.EmployeePayHistoryFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveEmployeePayHistory to EmployeePayHistory / EmployeePayHistory
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveEmployeePayHistory(EmployeePayHistory item)
        {
            return this.EmployeePayHistoryFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveEmployeePayHistory to EmployeePayHistory / EmployeePayHistory
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveEmployeePayHistory(DbConnector conn, EmployeePayHistory item)
        {
            return this.EmployeePayHistoryFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities EmployeePayHistoryList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveEmployeePayHistoryList(EmployeePayHistoryList items)
        {
			return this.EmployeePayHistoryFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
