﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// Password / Password - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class Password
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for Password
        /// </summary>
	    public Password()
		{
		}

		///// <summary>
        ///// Creates a new instance of Password
        ///// </summary>
	    //internal Password CreateEntity()
		//{
		//    return new Password();
		//}

		#region Members

		
        /// <summary>
        /// BusinessEntityId / Password.BusinessEntityID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("BusinessEntityID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Person")]
        public virtual int? BusinessEntityId
        {
            get
            {
                return (int?)this["BusinessEntityID"];
            }
            set
            {
                this.Add("BusinessEntityID", value, typeof(int?));
            }
        }

        /// <summary>
        /// PasswordHash / Password.PasswordHash
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("PasswordHash"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string PasswordHash
        {
            get
            {
                return (string)this["PasswordHash"];
            }
            set
            {
                this.Add("PasswordHash", value, typeof(string));
            }
        }

        /// <summary>
        /// PasswordSalt / Password.PasswordSalt
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("PasswordSalt"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string PasswordSalt
        {
            get
            {
                return (string)this["PasswordSalt"];
            }
            set
            {
                this.Add("PasswordSalt", value, typeof(string));
            }
        }

        /// <summary>
        /// Rowguid / Password.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / Password.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Person

        /// <summary>
        /// Link to parent/super Entity Person / Person (this.BusinessEntityId)
		/// Foreign key FK_Password_Person_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Person Person
        {
            get
            {
			    // Lazy loading
                if (this._Person == null && this.BusinessEntityId != null)
                {
                    this._Person = ((AdvEntityManager)this.Manager).GetPerson(this.BusinessEntityId);
                    if (! _Person.ResultInfo.IsValid)
                    {
						this._Person = null; // reset value
                        throw new Exception("wrong/missed constraint from Password to Person.");
                    }
                }
                return this._Person;
            }
            set
            {
                // reassign foreign key values from setter value
                this.BusinessEntityId = (value != null ? value.BusinessEntityId : null);


				// set foreign table
                this._Person = value;
            }
        }
        private Person _Person = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.PasswordFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Password"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // Password

	#endregion

	#region Entity-List

    /// <summary>
    /// Password / PasswordList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class PasswordList
        : WebEntityList<Password>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Password"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// Password - Password - Factory 
    /// </summary>
    public partial class PasswordFactory
        : WebEntityFactory<Password, PasswordList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property BusinessEntityId of Db-Field BusinessEntityID</summary>
        public static string Prop_BusinessEntityId = "BusinessEntityId";
        ///<summary>Property PasswordHash of Db-Field PasswordHash</summary>
        public static string Prop_PasswordHash = "PasswordHash";
        ///<summary>Property PasswordSalt of Db-Field PasswordSalt</summary>
        public static string Prop_PasswordSalt = "PasswordSalt";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field BusinessEntityID of Property BusinessEntityId</summary>
        public static string Field_BusinessEntityId = "BusinessEntityID";
        ///<summary>Db-Field PasswordHash of Property PasswordHash</summary>
        public static string Field_PasswordHash = "PasswordHash";
        ///<summary>Db-Field PasswordSalt of Property PasswordSalt</summary>
        public static string Field_PasswordSalt = "PasswordSalt";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = Password, 
		/// Fields       = "BusinessEntityID"
		/// Query        = ...
        /// </summary>
        protected PasswordFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Person";
            this.TableName = "Password";
            this.Fields = new string[]
            {
                "BusinessEntityID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("BusinessEntityId", "int?", "BusinessEntityID", "int?", "", "Person");
			this.Properties.Add("PasswordHash", "string", "PasswordHash", "string", "", null);
			this.Properties.Add("PasswordSalt", "string", "PasswordSalt", "string", "", null);
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "Password"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "PasswordList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "PasswordFactory"; }
            set { }
        }

		#endregion

		internal static PasswordFactory CreateFactory(EntityManager manager)
		{
		    return new PasswordFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of Password. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo Password</returns>
        public override Password CreateEntity()
		{
			var item = new Password();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(Password item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Person / Person
            // Foreign Key FK_Password_Person_BusinessEntityID
            if (parent is Person)
            {
                item.Person = (Person)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public Password GetItem(int? businessEntityId)
        {
            return this.GetEntity(0, businessEntityId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public Password GetItem(DbConnector conn, int? businessEntityId)
        {
            return this.GetEntity(conn, businessEntityId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(Password).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to PasswordFactory / Password / Password.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// PasswordFactory to Password / Password.
        /// </summary>
        public PasswordFactory PasswordFactory
		{
			get
			{
				if (_PasswordFactory == null)
				{
					_PasswordFactory = global::AdventureWorks.PasswordFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_PasswordFactory, typeof(Password));
				}
				return _PasswordFactory;
			}
		}
		private PasswordFactory _PasswordFactory = null;
	
        /// <summary>
        /// GetPassword to Password / Password
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public Password GetPassword(int? businessEntityId)
        {
            return this.PasswordFactory.GetEntity(0, businessEntityId);
        }
	
        /// <summary>
        /// GetPassword to Password / Password
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Password GetPassword(DbConnector conn, int? businessEntityId)
        {
            return this.PasswordFactory.GetEntity(conn, businessEntityId);
        }
	
		/// <summary>
        /// GetPasswordList to Password / Password
		/// Getting a list of Password using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public PasswordList GetPasswordList(SqlWhereClause where)
        {
            return this.PasswordFactory.GetEntities(where);
        }

		/// <summary>
        /// GetPasswordList to Password / Password
		/// Getting all entities of Password
        /// </summary>
        /// <returns>List of all found entities</returns>
        public PasswordList GetPasswordList()
        {
			var where = new SqlWhereClause();
            return this.PasswordFactory.GetEntities(where);
        }

        /// <summary>
        /// SavePassword to Password / Password
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Password SavePassword(Password item)
        {
            return this.PasswordFactory.SaveEntity(item);
        }

        /// <summary>
        /// SavePassword to Password / Password
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Password SavePassword(DbConnector conn, Password item)
        {
            return this.PasswordFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyPassword to Password / Password
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Password ApplyPassword(DbConnector conn, Password item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.PasswordFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemovePassword to Password / Password
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemovePassword(Password item)
        {
            return this.PasswordFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemovePassword to Password / Password
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemovePassword(DbConnector conn, Password item)
        {
            return this.PasswordFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities PasswordList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SavePasswordList(PasswordList items)
        {
			return this.PasswordFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
