﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// ProductCategory / ProductCategory - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductCategory
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for ProductCategory
        /// </summary>
	    public ProductCategory()
		{
		}

		///// <summary>
        ///// Creates a new instance of ProductCategory
        ///// </summary>
	    //internal ProductCategory CreateEntity()
		//{
		//    return new ProductCategory();
		//}

		#region Members

		
        /// <summary>
        /// ProductCategoryId / ProductCategory.ProductCategoryID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductCategoryID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? ProductCategoryId
        {
            get
            {
                return (int?)this["ProductCategoryID"];
            }
            set
            {
                this.Add("ProductCategoryID", value, typeof(int?));
            }
        }

        /// <summary>
        /// Name / ProductCategory.Name
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Name"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Name
        {
            get
            {
                return (string)this["Name"];
            }
            set
            {
                this.Add("Name", value, typeof(string));
            }
        }

        /// <summary>
        /// Rowguid / ProductCategory.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / ProductCategory.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		

		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from ProductSubcategory

        /// <summary>
        /// List of sub entities ProductSubcategory / ProductSubcategory (ProductCategoryID)
		/// Foreign Key FK_ProductSubcategory_ProductCategory_ProductCategoryID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductSubcategoryList ProductSubcategoryList
        {
            get
            {
			    // Lazy Loading
                if (_ProductSubcategoryList == null && this.ProductCategoryId != null)
                {
					var where = new SqlWhereClause("WHERE ProductSubcategory.ProductCategoryID = @ProductCategoryID",
					    "@ProductCategoryID", this.ProductCategoryId);
                    _ProductSubcategoryList = ((AdvEntityManager)this.Manager).GetProductSubcategoryList(where);
                }
				if (_ProductSubcategoryList == null)
				{
					_ProductSubcategoryList = new ProductSubcategoryList();
				}
                return _ProductSubcategoryList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductSubcategoryList _ProductSubcategoryList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.ProductCategoryFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductCategory"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // ProductCategory

	#endregion

	#region Entity-List

    /// <summary>
    /// ProductCategory / ProductCategoryList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductCategoryList
        : WebEntityList<ProductCategory>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductCategory"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// ProductCategory - ProductCategory - Factory 
    /// </summary>
    public partial class ProductCategoryFactory
        : WebEntityFactory<ProductCategory, ProductCategoryList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property ProductCategoryId of Db-Field ProductCategoryID</summary>
        public static string Prop_ProductCategoryId = "ProductCategoryId";
        ///<summary>Property Name of Db-Field Name</summary>
        public static string Prop_Name = "Name";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field ProductCategoryID of Property ProductCategoryId</summary>
        public static string Field_ProductCategoryId = "ProductCategoryID";
        ///<summary>Db-Field Name of Property Name</summary>
        public static string Field_Name = "Name";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = ProductCategory, 
		/// Fields       = "ProductCategoryID"
		/// Query        = ...
        /// </summary>
        protected ProductCategoryFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "ProductCategory";
            this.Fields = new string[]
            {
                "ProductCategoryID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("ProductCategoryId", "int?", "ProductCategoryID", "int?", "", null);
			this.Properties.Add("Name", "string", "Name", "string", "", null);
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "ProductCategory"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "ProductCategoryList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "ProductCategoryFactory"; }
            set { }
        }

		#endregion

		internal static ProductCategoryFactory CreateFactory(EntityManager manager)
		{
		    return new ProductCategoryFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of ProductCategory. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo ProductCategory</returns>
        public override ProductCategory CreateEntity()
		{
			var item = new ProductCategory();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}



		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public ProductCategory GetItem(int? productCategoryId)
        {
            return this.GetEntity(0, productCategoryId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public ProductCategory GetItem(DbConnector conn, int? productCategoryId)
        {
            return this.GetEntity(conn, productCategoryId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(ProductCategory).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to ProductCategoryFactory / ProductCategory / ProductCategory.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// ProductCategoryFactory to ProductCategory / ProductCategory.
        /// </summary>
        public ProductCategoryFactory ProductCategoryFactory
		{
			get
			{
				if (_ProductCategoryFactory == null)
				{
					_ProductCategoryFactory = global::AdventureWorks.ProductCategoryFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_ProductCategoryFactory, typeof(ProductCategory));
				}
				return _ProductCategoryFactory;
			}
		}
		private ProductCategoryFactory _ProductCategoryFactory = null;
	
        /// <summary>
        /// GetProductCategory to ProductCategory / ProductCategory
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductCategory GetProductCategory(int? productCategoryId)
        {
            return this.ProductCategoryFactory.GetEntity(0, productCategoryId);
        }
	
        /// <summary>
        /// GetProductCategory to ProductCategory / ProductCategory
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductCategory GetProductCategory(DbConnector conn, int? productCategoryId)
        {
            return this.ProductCategoryFactory.GetEntity(conn, productCategoryId);
        }
	
		/// <summary>
        /// GetProductCategoryList to ProductCategory / ProductCategory
		/// Getting a list of ProductCategory using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public ProductCategoryList GetProductCategoryList(SqlWhereClause where)
        {
            return this.ProductCategoryFactory.GetEntities(where);
        }

		/// <summary>
        /// GetProductCategoryList to ProductCategory / ProductCategory
		/// Getting all entities of ProductCategory
        /// </summary>
        /// <returns>List of all found entities</returns>
        public ProductCategoryList GetProductCategoryList()
        {
			var where = new SqlWhereClause();
            return this.ProductCategoryFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveProductCategory to ProductCategory / ProductCategory
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductCategory SaveProductCategory(ProductCategory item)
        {
            return this.ProductCategoryFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveProductCategory to ProductCategory / ProductCategory
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductCategory SaveProductCategory(DbConnector conn, ProductCategory item)
        {
            return this.ProductCategoryFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyProductCategory to ProductCategory / ProductCategory
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductCategory ApplyProductCategory(DbConnector conn, ProductCategory item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.ProductCategoryFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveProductCategory to ProductCategory / ProductCategory
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductCategory(ProductCategory item)
        {
            return this.ProductCategoryFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveProductCategory to ProductCategory / ProductCategory
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductCategory(DbConnector conn, ProductCategory item)
        {
            return this.ProductCategoryFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities ProductCategoryList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveProductCategoryList(ProductCategoryList items)
        {
			return this.ProductCategoryFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
