﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// ProductDescription / ProductDescription - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductDescription
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for ProductDescription
        /// </summary>
	    public ProductDescription()
		{
		}

		///// <summary>
        ///// Creates a new instance of ProductDescription
        ///// </summary>
	    //internal ProductDescription CreateEntity()
		//{
		//    return new ProductDescription();
		//}

		#region Members

		
        /// <summary>
        /// ProductDescriptionId / ProductDescription.ProductDescriptionID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductDescriptionID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? ProductDescriptionId
        {
            get
            {
                return (int?)this["ProductDescriptionID"];
            }
            set
            {
                this.Add("ProductDescriptionID", value, typeof(int?));
            }
        }

        /// <summary>
        /// Description / ProductDescription.Description
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Description"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Description
        {
            get
            {
                return (string)this["Description"];
            }
            set
            {
                this.Add("Description", value, typeof(string));
            }
        }

        /// <summary>
        /// Rowguid / ProductDescription.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / ProductDescription.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		

		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from ProductModelProductDescriptionCulture

        /// <summary>
        /// List of sub entities ProductModelProductDescriptionCulture / ProductModelProductDescriptionCulture (ProductDescriptionID)
		/// Foreign Key FK_ProductModelProductDescriptionCulture_ProductDescription_ProductDescriptionID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductModelProductDescriptionCultureList ProductModelProductDescriptionCultureList
        {
            get
            {
			    // Lazy Loading
                if (_ProductModelProductDescriptionCultureList == null && this.ProductDescriptionId != null)
                {
					var where = new SqlWhereClause("WHERE ProductModelProductDescriptionCulture.ProductDescriptionID = @ProductDescriptionID",
					    "@ProductDescriptionID", this.ProductDescriptionId);
                    _ProductModelProductDescriptionCultureList = ((AdvEntityManager)this.Manager).GetProductModelProductDescriptionCultureList(where);
                }
				if (_ProductModelProductDescriptionCultureList == null)
				{
					_ProductModelProductDescriptionCultureList = new ProductModelProductDescriptionCultureList();
				}
                return _ProductModelProductDescriptionCultureList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductModelProductDescriptionCultureList _ProductModelProductDescriptionCultureList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.ProductDescriptionFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductDescription"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // ProductDescription

	#endregion

	#region Entity-List

    /// <summary>
    /// ProductDescription / ProductDescriptionList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductDescriptionList
        : WebEntityList<ProductDescription>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductDescription"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// ProductDescription - ProductDescription - Factory 
    /// </summary>
    public partial class ProductDescriptionFactory
        : WebEntityFactory<ProductDescription, ProductDescriptionList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property ProductDescriptionId of Db-Field ProductDescriptionID</summary>
        public static string Prop_ProductDescriptionId = "ProductDescriptionId";
        ///<summary>Property Description of Db-Field Description</summary>
        public static string Prop_Description = "Description";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field ProductDescriptionID of Property ProductDescriptionId</summary>
        public static string Field_ProductDescriptionId = "ProductDescriptionID";
        ///<summary>Db-Field Description of Property Description</summary>
        public static string Field_Description = "Description";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = ProductDescription, 
		/// Fields       = "ProductDescriptionID"
		/// Query        = ...
        /// </summary>
        protected ProductDescriptionFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "ProductDescription";
            this.Fields = new string[]
            {
                "ProductDescriptionID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("ProductDescriptionId", "int?", "ProductDescriptionID", "int?", "", null);
			this.Properties.Add("Description", "string", "Description", "string", "", null);
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "ProductDescription"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "ProductDescriptionList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "ProductDescriptionFactory"; }
            set { }
        }

		#endregion

		internal static ProductDescriptionFactory CreateFactory(EntityManager manager)
		{
		    return new ProductDescriptionFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of ProductDescription. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo ProductDescription</returns>
        public override ProductDescription CreateEntity()
		{
			var item = new ProductDescription();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}



		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public ProductDescription GetItem(int? productDescriptionId)
        {
            return this.GetEntity(0, productDescriptionId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public ProductDescription GetItem(DbConnector conn, int? productDescriptionId)
        {
            return this.GetEntity(conn, productDescriptionId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(ProductDescription).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to ProductDescriptionFactory / ProductDescription / ProductDescription.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// ProductDescriptionFactory to ProductDescription / ProductDescription.
        /// </summary>
        public ProductDescriptionFactory ProductDescriptionFactory
		{
			get
			{
				if (_ProductDescriptionFactory == null)
				{
					_ProductDescriptionFactory = global::AdventureWorks.ProductDescriptionFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_ProductDescriptionFactory, typeof(ProductDescription));
				}
				return _ProductDescriptionFactory;
			}
		}
		private ProductDescriptionFactory _ProductDescriptionFactory = null;
	
        /// <summary>
        /// GetProductDescription to ProductDescription / ProductDescription
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductDescription GetProductDescription(int? productDescriptionId)
        {
            return this.ProductDescriptionFactory.GetEntity(0, productDescriptionId);
        }
	
        /// <summary>
        /// GetProductDescription to ProductDescription / ProductDescription
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductDescription GetProductDescription(DbConnector conn, int? productDescriptionId)
        {
            return this.ProductDescriptionFactory.GetEntity(conn, productDescriptionId);
        }
	
		/// <summary>
        /// GetProductDescriptionList to ProductDescription / ProductDescription
		/// Getting a list of ProductDescription using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public ProductDescriptionList GetProductDescriptionList(SqlWhereClause where)
        {
            return this.ProductDescriptionFactory.GetEntities(where);
        }

		/// <summary>
        /// GetProductDescriptionList to ProductDescription / ProductDescription
		/// Getting all entities of ProductDescription
        /// </summary>
        /// <returns>List of all found entities</returns>
        public ProductDescriptionList GetProductDescriptionList()
        {
			var where = new SqlWhereClause();
            return this.ProductDescriptionFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveProductDescription to ProductDescription / ProductDescription
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductDescription SaveProductDescription(ProductDescription item)
        {
            return this.ProductDescriptionFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveProductDescription to ProductDescription / ProductDescription
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductDescription SaveProductDescription(DbConnector conn, ProductDescription item)
        {
            return this.ProductDescriptionFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyProductDescription to ProductDescription / ProductDescription
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductDescription ApplyProductDescription(DbConnector conn, ProductDescription item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.ProductDescriptionFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveProductDescription to ProductDescription / ProductDescription
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductDescription(ProductDescription item)
        {
            return this.ProductDescriptionFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveProductDescription to ProductDescription / ProductDescription
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductDescription(DbConnector conn, ProductDescription item)
        {
            return this.ProductDescriptionFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities ProductDescriptionList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveProductDescriptionList(ProductDescriptionList items)
        {
			return this.ProductDescriptionFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
