﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// ProductModel / ProductModel - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductModel
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for ProductModel
        /// </summary>
	    public ProductModel()
		{
		}

		///// <summary>
        ///// Creates a new instance of ProductModel
        ///// </summary>
	    //internal ProductModel CreateEntity()
		//{
		//    return new ProductModel();
		//}

		#region Members

		
        /// <summary>
        /// ProductModelId / ProductModel.ProductModelID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductModelID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? ProductModelId
        {
            get
            {
                return (int?)this["ProductModelID"];
            }
            set
            {
                this.Add("ProductModelID", value, typeof(int?));
            }
        }

        /// <summary>
        /// Name / ProductModel.Name
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Name"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Name
        {
            get
            {
                return (string)this["Name"];
            }
            set
            {
                this.Add("Name", value, typeof(string));
            }
        }

        /// <summary>
        /// CatalogDescription / ProductModel.CatalogDescription
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("CatalogDescription"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string CatalogDescription
        {
            get
            {
                return (string)this["CatalogDescription"];
            }
            set
            {
                this.Add("CatalogDescription", value, typeof(string));
            }
        }

        /// <summary>
        /// Instructions / ProductModel.Instructions
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Instructions"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Instructions
        {
            get
            {
                return (string)this["Instructions"];
            }
            set
            {
                this.Add("Instructions", value, typeof(string));
            }
        }

        /// <summary>
        /// Rowguid / ProductModel.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / ProductModel.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		

		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from Product

        /// <summary>
        /// List of sub entities Product / Product (ProductModelID)
		/// Foreign Key FK_Product_ProductModel_ProductModelID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductList ProductList
        {
            get
            {
			    // Lazy Loading
                if (_ProductList == null && this.ProductModelId != null)
                {
					var where = new SqlWhereClause("WHERE Product.ProductModelID = @ProductModelID",
					    "@ProductModelID", this.ProductModelId);
                    _ProductList = ((AdvEntityManager)this.Manager).GetProductList(where);
                }
				if (_ProductList == null)
				{
					_ProductList = new ProductList();
				}
                return _ProductList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductList _ProductList = null;

        #endregion

        #region Sub Entites from ProductModelIllustration

        /// <summary>
        /// List of sub entities ProductModelIllustration / ProductModelIllustration (ProductModelID)
		/// Foreign Key FK_ProductModelIllustration_ProductModel_ProductModelID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductModelIllustrationList ProductModelIllustrationList
        {
            get
            {
			    // Lazy Loading
                if (_ProductModelIllustrationList == null && this.ProductModelId != null)
                {
					var where = new SqlWhereClause("WHERE ProductModelIllustration.ProductModelID = @ProductModelID",
					    "@ProductModelID", this.ProductModelId);
                    _ProductModelIllustrationList = ((AdvEntityManager)this.Manager).GetProductModelIllustrationList(where);
                }
				if (_ProductModelIllustrationList == null)
				{
					_ProductModelIllustrationList = new ProductModelIllustrationList();
				}
                return _ProductModelIllustrationList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductModelIllustrationList _ProductModelIllustrationList = null;

        #endregion

        #region Sub Entites from ProductModelProductDescriptionCulture

        /// <summary>
        /// List of sub entities ProductModelProductDescriptionCulture / ProductModelProductDescriptionCulture (ProductModelID)
		/// Foreign Key FK_ProductModelProductDescriptionCulture_ProductModel_ProductModelID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductModelProductDescriptionCultureList ProductModelProductDescriptionCultureList
        {
            get
            {
			    // Lazy Loading
                if (_ProductModelProductDescriptionCultureList == null && this.ProductModelId != null)
                {
					var where = new SqlWhereClause("WHERE ProductModelProductDescriptionCulture.ProductModelID = @ProductModelID",
					    "@ProductModelID", this.ProductModelId);
                    _ProductModelProductDescriptionCultureList = ((AdvEntityManager)this.Manager).GetProductModelProductDescriptionCultureList(where);
                }
				if (_ProductModelProductDescriptionCultureList == null)
				{
					_ProductModelProductDescriptionCultureList = new ProductModelProductDescriptionCultureList();
				}
                return _ProductModelProductDescriptionCultureList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductModelProductDescriptionCultureList _ProductModelProductDescriptionCultureList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.ProductModelFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductModel"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // ProductModel

	#endregion

	#region Entity-List

    /// <summary>
    /// ProductModel / ProductModelList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductModelList
        : WebEntityList<ProductModel>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductModel"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// ProductModel - ProductModel - Factory 
    /// </summary>
    public partial class ProductModelFactory
        : WebEntityFactory<ProductModel, ProductModelList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property ProductModelId of Db-Field ProductModelID</summary>
        public static string Prop_ProductModelId = "ProductModelId";
        ///<summary>Property Name of Db-Field Name</summary>
        public static string Prop_Name = "Name";
        ///<summary>Property CatalogDescription of Db-Field CatalogDescription</summary>
        public static string Prop_CatalogDescription = "CatalogDescription";
        ///<summary>Property Instructions of Db-Field Instructions</summary>
        public static string Prop_Instructions = "Instructions";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field ProductModelID of Property ProductModelId</summary>
        public static string Field_ProductModelId = "ProductModelID";
        ///<summary>Db-Field Name of Property Name</summary>
        public static string Field_Name = "Name";
        ///<summary>Db-Field CatalogDescription of Property CatalogDescription</summary>
        public static string Field_CatalogDescription = "CatalogDescription";
        ///<summary>Db-Field Instructions of Property Instructions</summary>
        public static string Field_Instructions = "Instructions";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = ProductModel, 
		/// Fields       = "ProductModelID"
		/// Query        = ...
        /// </summary>
        protected ProductModelFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "ProductModel";
            this.Fields = new string[]
            {
                "ProductModelID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("ProductModelId", "int?", "ProductModelID", "int?", "", null);
			this.Properties.Add("Name", "string", "Name", "string", "", null);
			this.Properties.Add("CatalogDescription", "string", "CatalogDescription", "string", "", null);
			this.Properties.Add("Instructions", "string", "Instructions", "string", "", null);
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "ProductModel"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "ProductModelList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "ProductModelFactory"; }
            set { }
        }

		#endregion

		internal static ProductModelFactory CreateFactory(EntityManager manager)
		{
		    return new ProductModelFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of ProductModel. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo ProductModel</returns>
        public override ProductModel CreateEntity()
		{
			var item = new ProductModel();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}



		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public ProductModel GetItem(int? productModelId)
        {
            return this.GetEntity(0, productModelId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public ProductModel GetItem(DbConnector conn, int? productModelId)
        {
            return this.GetEntity(conn, productModelId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(ProductModel).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to ProductModelFactory / ProductModel / ProductModel.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// ProductModelFactory to ProductModel / ProductModel.
        /// </summary>
        public ProductModelFactory ProductModelFactory
		{
			get
			{
				if (_ProductModelFactory == null)
				{
					_ProductModelFactory = global::AdventureWorks.ProductModelFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_ProductModelFactory, typeof(ProductModel));
				}
				return _ProductModelFactory;
			}
		}
		private ProductModelFactory _ProductModelFactory = null;
	
        /// <summary>
        /// GetProductModel to ProductModel / ProductModel
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductModel GetProductModel(int? productModelId)
        {
            return this.ProductModelFactory.GetEntity(0, productModelId);
        }
	
        /// <summary>
        /// GetProductModel to ProductModel / ProductModel
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductModel GetProductModel(DbConnector conn, int? productModelId)
        {
            return this.ProductModelFactory.GetEntity(conn, productModelId);
        }
	
		/// <summary>
        /// GetProductModelList to ProductModel / ProductModel
		/// Getting a list of ProductModel using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public ProductModelList GetProductModelList(SqlWhereClause where)
        {
            return this.ProductModelFactory.GetEntities(where);
        }

		/// <summary>
        /// GetProductModelList to ProductModel / ProductModel
		/// Getting all entities of ProductModel
        /// </summary>
        /// <returns>List of all found entities</returns>
        public ProductModelList GetProductModelList()
        {
			var where = new SqlWhereClause();
            return this.ProductModelFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveProductModel to ProductModel / ProductModel
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductModel SaveProductModel(ProductModel item)
        {
            return this.ProductModelFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveProductModel to ProductModel / ProductModel
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductModel SaveProductModel(DbConnector conn, ProductModel item)
        {
            return this.ProductModelFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyProductModel to ProductModel / ProductModel
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductModel ApplyProductModel(DbConnector conn, ProductModel item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.ProductModelFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveProductModel to ProductModel / ProductModel
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductModel(ProductModel item)
        {
            return this.ProductModelFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveProductModel to ProductModel / ProductModel
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductModel(DbConnector conn, ProductModel item)
        {
            return this.ProductModelFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities ProductModelList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveProductModelList(ProductModelList items)
        {
			return this.ProductModelFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
