﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// ProductModelIllustration / ProductModelIllustration - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductModelIllustration
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for ProductModelIllustration
        /// </summary>
	    public ProductModelIllustration()
		{
		}

		///// <summary>
        ///// Creates a new instance of ProductModelIllustration
        ///// </summary>
	    //internal ProductModelIllustration CreateEntity()
		//{
		//    return new ProductModelIllustration();
		//}

		#region Members

		
        /// <summary>
        /// ProductModelId / ProductModelIllustration.ProductModelID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductModelID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("ProductModel")]
        public virtual int? ProductModelId
        {
            get
            {
                return (int?)this["ProductModelID"];
            }
            set
            {
                this.Add("ProductModelID", value, typeof(int?));
            }
        }

        /// <summary>
        /// IllustrationId / ProductModelIllustration.IllustrationID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("IllustrationID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Illustration")]
        public virtual int? IllustrationId
        {
            get
            {
                return (int?)this["IllustrationID"];
            }
            set
            {
                this.Add("IllustrationID", value, typeof(int?));
            }
        }

        /// <summary>
        /// ModifiedDate / ProductModelIllustration.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Illustration

        /// <summary>
        /// Link to parent/super Entity Illustration / Illustration (this.IllustrationId)
		/// Foreign key FK_ProductModelIllustration_Illustration_IllustrationID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Illustration Illustration
        {
            get
            {
			    // Lazy loading
                if (this._Illustration == null && this.IllustrationId != null)
                {
                    this._Illustration = ((AdvEntityManager)this.Manager).GetIllustration(this.IllustrationId);
                    if (! _Illustration.ResultInfo.IsValid)
                    {
						this._Illustration = null; // reset value
                        throw new Exception("wrong/missed constraint from ProductModelIllustration to Illustration.");
                    }
                }
                return this._Illustration;
            }
            set
            {
                // reassign foreign key values from setter value
                this.IllustrationId = (value != null ? value.IllustrationId : null);


				// set foreign table
                this._Illustration = value;
            }
        }
        private Illustration _Illustration = null;

        #endregion

        #region foreign constraint (parent entity) to ProductModel

        /// <summary>
        /// Link to parent/super Entity ProductModel / ProductModel (this.ProductModelId)
		/// Foreign key FK_ProductModelIllustration_ProductModel_ProductModelID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductModel ProductModel
        {
            get
            {
			    // Lazy loading
                if (this._ProductModel == null && this.ProductModelId != null)
                {
                    this._ProductModel = ((AdvEntityManager)this.Manager).GetProductModel(this.ProductModelId);
                    if (! _ProductModel.ResultInfo.IsValid)
                    {
						this._ProductModel = null; // reset value
                        throw new Exception("wrong/missed constraint from ProductModelIllustration to ProductModel.");
                    }
                }
                return this._ProductModel;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ProductModelId = (value != null ? value.ProductModelId : null);


				// set foreign table
                this._ProductModel = value;
            }
        }
        private ProductModel _ProductModel = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.ProductModelIllustrationFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductModelIllustration"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // ProductModelIllustration

	#endregion

	#region Entity-List

    /// <summary>
    /// ProductModelIllustration / ProductModelIllustrationList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductModelIllustrationList
        : WebEntityList<ProductModelIllustration>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductModelIllustration"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// ProductModelIllustration - ProductModelIllustration - Factory 
    /// </summary>
    public partial class ProductModelIllustrationFactory
        : WebEntityFactory<ProductModelIllustration, ProductModelIllustrationList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property ProductModelId of Db-Field ProductModelID</summary>
        public static string Prop_ProductModelId = "ProductModelId";
        ///<summary>Property IllustrationId of Db-Field IllustrationID</summary>
        public static string Prop_IllustrationId = "IllustrationId";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field ProductModelID of Property ProductModelId</summary>
        public static string Field_ProductModelId = "ProductModelID";
        ///<summary>Db-Field IllustrationID of Property IllustrationId</summary>
        public static string Field_IllustrationId = "IllustrationID";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = ProductModelIllustration, 
		/// Fields       = "ProductModelID", "IllustrationID"
		/// Query        = ...
        /// </summary>
        protected ProductModelIllustrationFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "ProductModelIllustration";
            this.Fields = new string[]
            {
                "ProductModelID", "IllustrationID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("ProductModelId", "int?", "ProductModelID", "int?", "", "ProductModel");
			this.Properties.Add("IllustrationId", "int?", "IllustrationID", "int?", "", "Illustration");
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "ProductModelIllustration"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "ProductModelIllustrationList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "ProductModelIllustrationFactory"; }
            set { }
        }

		#endregion

		internal static ProductModelIllustrationFactory CreateFactory(EntityManager manager)
		{
		    return new ProductModelIllustrationFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of ProductModelIllustration. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo ProductModelIllustration</returns>
        public override ProductModelIllustration CreateEntity()
		{
			var item = new ProductModelIllustration();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(ProductModelIllustration item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Illustration / Illustration
            // Foreign Key FK_ProductModelIllustration_Illustration_IllustrationID
            if (parent is Illustration)
            {
                item.Illustration = (Illustration)parent;
                return;
            }

            // make relation to parent/super Entity ProductModel / ProductModel
            // Foreign Key FK_ProductModelIllustration_ProductModel_ProductModelID
            if (parent is ProductModel)
            {
                item.ProductModel = (ProductModel)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public ProductModelIllustration GetItem(int? productModelId, int? illustrationId)
        {
            return this.GetEntity(0, productModelId, illustrationId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public ProductModelIllustration GetItem(DbConnector conn, int? productModelId, int? illustrationId)
        {
            return this.GetEntity(conn, productModelId, illustrationId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(ProductModelIllustration).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to ProductModelIllustrationFactory / ProductModelIllustration / ProductModelIllustration.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// ProductModelIllustrationFactory to ProductModelIllustration / ProductModelIllustration.
        /// </summary>
        public ProductModelIllustrationFactory ProductModelIllustrationFactory
		{
			get
			{
				if (_ProductModelIllustrationFactory == null)
				{
					_ProductModelIllustrationFactory = global::AdventureWorks.ProductModelIllustrationFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_ProductModelIllustrationFactory, typeof(ProductModelIllustration));
				}
				return _ProductModelIllustrationFactory;
			}
		}
		private ProductModelIllustrationFactory _ProductModelIllustrationFactory = null;
	
        /// <summary>
        /// GetProductModelIllustration to ProductModelIllustration / ProductModelIllustration
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductModelIllustration GetProductModelIllustration(int? productModelId, int? illustrationId)
        {
            return this.ProductModelIllustrationFactory.GetEntity(0, productModelId, illustrationId);
        }
	
        /// <summary>
        /// GetProductModelIllustration to ProductModelIllustration / ProductModelIllustration
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductModelIllustration GetProductModelIllustration(DbConnector conn, int? productModelId, int? illustrationId)
        {
            return this.ProductModelIllustrationFactory.GetEntity(conn, productModelId, illustrationId);
        }
	
		/// <summary>
        /// GetProductModelIllustrationList to ProductModelIllustration / ProductModelIllustration
		/// Getting a list of ProductModelIllustration using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public ProductModelIllustrationList GetProductModelIllustrationList(SqlWhereClause where)
        {
            return this.ProductModelIllustrationFactory.GetEntities(where);
        }

		/// <summary>
        /// GetProductModelIllustrationList to ProductModelIllustration / ProductModelIllustration
		/// Getting all entities of ProductModelIllustration
        /// </summary>
        /// <returns>List of all found entities</returns>
        public ProductModelIllustrationList GetProductModelIllustrationList()
        {
			var where = new SqlWhereClause();
            return this.ProductModelIllustrationFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveProductModelIllustration to ProductModelIllustration / ProductModelIllustration
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductModelIllustration SaveProductModelIllustration(ProductModelIllustration item)
        {
            return this.ProductModelIllustrationFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveProductModelIllustration to ProductModelIllustration / ProductModelIllustration
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductModelIllustration SaveProductModelIllustration(DbConnector conn, ProductModelIllustration item)
        {
            return this.ProductModelIllustrationFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyProductModelIllustration to ProductModelIllustration / ProductModelIllustration
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductModelIllustration ApplyProductModelIllustration(DbConnector conn, ProductModelIllustration item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.ProductModelIllustrationFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveProductModelIllustration to ProductModelIllustration / ProductModelIllustration
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductModelIllustration(ProductModelIllustration item)
        {
            return this.ProductModelIllustrationFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveProductModelIllustration to ProductModelIllustration / ProductModelIllustration
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductModelIllustration(DbConnector conn, ProductModelIllustration item)
        {
            return this.ProductModelIllustrationFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities ProductModelIllustrationList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveProductModelIllustrationList(ProductModelIllustrationList items)
        {
			return this.ProductModelIllustrationFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
