﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// ProductModelProductDescriptionCulture / ProductModelProductDescriptionCulture - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductModelProductDescriptionCulture
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for ProductModelProductDescriptionCulture
        /// </summary>
	    public ProductModelProductDescriptionCulture()
		{
		}

		///// <summary>
        ///// Creates a new instance of ProductModelProductDescriptionCulture
        ///// </summary>
	    //internal ProductModelProductDescriptionCulture CreateEntity()
		//{
		//    return new ProductModelProductDescriptionCulture();
		//}

		#region Members

		
        /// <summary>
        /// ProductModelId / ProductModelProductDescriptionCulture.ProductModelID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductModelID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("ProductModel")]
        public virtual int? ProductModelId
        {
            get
            {
                return (int?)this["ProductModelID"];
            }
            set
            {
                this.Add("ProductModelID", value, typeof(int?));
            }
        }

        /// <summary>
        /// ProductDescriptionId / ProductModelProductDescriptionCulture.ProductDescriptionID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductDescriptionID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("ProductDescription")]
        public virtual int? ProductDescriptionId
        {
            get
            {
                return (int?)this["ProductDescriptionID"];
            }
            set
            {
                this.Add("ProductDescriptionID", value, typeof(int?));
            }
        }

        /// <summary>
        /// CultureId / ProductModelProductDescriptionCulture.CultureID
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("CultureID"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity("Culture")]
        public virtual string CultureId
        {
            get
            {
                return (string)this["CultureID"];
            }
            set
            {
                this.Add("CultureID", value, typeof(string));
            }
        }

        /// <summary>
        /// ModifiedDate / ProductModelProductDescriptionCulture.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Culture

        /// <summary>
        /// Link to parent/super Entity Culture / Culture (this.CultureId)
		/// Foreign key FK_ProductModelProductDescriptionCulture_Culture_CultureID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Culture Culture
        {
            get
            {
			    // Lazy loading
                if (this._Culture == null && this.CultureId != null)
                {
                    this._Culture = ((AdvEntityManager)this.Manager).GetCulture(this.CultureId);
                    if (! _Culture.ResultInfo.IsValid)
                    {
						this._Culture = null; // reset value
                        throw new Exception("wrong/missed constraint from ProductModelProductDescriptionCulture to Culture.");
                    }
                }
                return this._Culture;
            }
            set
            {
                // reassign foreign key values from setter value
                this.CultureId = (value != null ? value.CultureId : null);


				// set foreign table
                this._Culture = value;
            }
        }
        private Culture _Culture = null;

        #endregion

        #region foreign constraint (parent entity) to ProductDescription

        /// <summary>
        /// Link to parent/super Entity ProductDescription / ProductDescription (this.ProductDescriptionId)
		/// Foreign key FK_ProductModelProductDescriptionCulture_ProductDescription_ProductDescriptionID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductDescription ProductDescription
        {
            get
            {
			    // Lazy loading
                if (this._ProductDescription == null && this.ProductDescriptionId != null)
                {
                    this._ProductDescription = ((AdvEntityManager)this.Manager).GetProductDescription(this.ProductDescriptionId);
                    if (! _ProductDescription.ResultInfo.IsValid)
                    {
						this._ProductDescription = null; // reset value
                        throw new Exception("wrong/missed constraint from ProductModelProductDescriptionCulture to ProductDescription.");
                    }
                }
                return this._ProductDescription;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ProductDescriptionId = (value != null ? value.ProductDescriptionId : null);


				// set foreign table
                this._ProductDescription = value;
            }
        }
        private ProductDescription _ProductDescription = null;

        #endregion

        #region foreign constraint (parent entity) to ProductModel

        /// <summary>
        /// Link to parent/super Entity ProductModel / ProductModel (this.ProductModelId)
		/// Foreign key FK_ProductModelProductDescriptionCulture_ProductModel_ProductModelID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductModel ProductModel
        {
            get
            {
			    // Lazy loading
                if (this._ProductModel == null && this.ProductModelId != null)
                {
                    this._ProductModel = ((AdvEntityManager)this.Manager).GetProductModel(this.ProductModelId);
                    if (! _ProductModel.ResultInfo.IsValid)
                    {
						this._ProductModel = null; // reset value
                        throw new Exception("wrong/missed constraint from ProductModelProductDescriptionCulture to ProductModel.");
                    }
                }
                return this._ProductModel;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ProductModelId = (value != null ? value.ProductModelId : null);


				// set foreign table
                this._ProductModel = value;
            }
        }
        private ProductModel _ProductModel = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.ProductModelProductDescriptionCultureFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductModelProductDescriptionCulture"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // ProductModelProductDescriptionCulture

	#endregion

	#region Entity-List

    /// <summary>
    /// ProductModelProductDescriptionCulture / ProductModelProductDescriptionCultureList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class ProductModelProductDescriptionCultureList
        : WebEntityList<ProductModelProductDescriptionCulture>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ProductModelProductDescriptionCulture"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// ProductModelProductDescriptionCulture - ProductModelProductDescriptionCulture - Factory 
    /// </summary>
    public partial class ProductModelProductDescriptionCultureFactory
        : WebEntityFactory<ProductModelProductDescriptionCulture, ProductModelProductDescriptionCultureList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property ProductModelId of Db-Field ProductModelID</summary>
        public static string Prop_ProductModelId = "ProductModelId";
        ///<summary>Property ProductDescriptionId of Db-Field ProductDescriptionID</summary>
        public static string Prop_ProductDescriptionId = "ProductDescriptionId";
        ///<summary>Property CultureId of Db-Field CultureID</summary>
        public static string Prop_CultureId = "CultureId";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field ProductModelID of Property ProductModelId</summary>
        public static string Field_ProductModelId = "ProductModelID";
        ///<summary>Db-Field ProductDescriptionID of Property ProductDescriptionId</summary>
        public static string Field_ProductDescriptionId = "ProductDescriptionID";
        ///<summary>Db-Field CultureID of Property CultureId</summary>
        public static string Field_CultureId = "CultureID";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = ProductModelProductDescriptionCulture, 
		/// Fields       = "ProductModelID", "ProductDescriptionID", "CultureID"
		/// Query        = ...
        /// </summary>
        protected ProductModelProductDescriptionCultureFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "ProductModelProductDescriptionCulture";
            this.Fields = new string[]
            {
                "ProductModelID", "ProductDescriptionID", "CultureID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("ProductModelId", "int?", "ProductModelID", "int?", "", "ProductModel");
			this.Properties.Add("ProductDescriptionId", "int?", "ProductDescriptionID", "int?", "", "ProductDescription");
			this.Properties.Add("CultureId", "string", "CultureID", "string", "", "Culture");
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "ProductModelProductDescriptionCulture"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "ProductModelProductDescriptionCultureList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "ProductModelProductDescriptionCultureFactory"; }
            set { }
        }

		#endregion

		internal static ProductModelProductDescriptionCultureFactory CreateFactory(EntityManager manager)
		{
		    return new ProductModelProductDescriptionCultureFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of ProductModelProductDescriptionCulture. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo ProductModelProductDescriptionCulture</returns>
        public override ProductModelProductDescriptionCulture CreateEntity()
		{
			var item = new ProductModelProductDescriptionCulture();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(ProductModelProductDescriptionCulture item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Culture / Culture
            // Foreign Key FK_ProductModelProductDescriptionCulture_Culture_CultureID
            if (parent is Culture)
            {
                item.Culture = (Culture)parent;
                return;
            }

            // make relation to parent/super Entity ProductDescription / ProductDescription
            // Foreign Key FK_ProductModelProductDescriptionCulture_ProductDescription_ProductDescriptionID
            if (parent is ProductDescription)
            {
                item.ProductDescription = (ProductDescription)parent;
                return;
            }

            // make relation to parent/super Entity ProductModel / ProductModel
            // Foreign Key FK_ProductModelProductDescriptionCulture_ProductModel_ProductModelID
            if (parent is ProductModel)
            {
                item.ProductModel = (ProductModel)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public ProductModelProductDescriptionCulture GetItem(int? productModelId, int? productDescriptionId, string cultureId)
        {
            return this.GetEntity(0, productModelId, productDescriptionId, cultureId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public ProductModelProductDescriptionCulture GetItem(DbConnector conn, int? productModelId, int? productDescriptionId, string cultureId)
        {
            return this.GetEntity(conn, productModelId, productDescriptionId, cultureId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(ProductModelProductDescriptionCulture).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to ProductModelProductDescriptionCultureFactory / ProductModelProductDescriptionCulture / ProductModelProductDescriptionCulture.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// ProductModelProductDescriptionCultureFactory to ProductModelProductDescriptionCulture / ProductModelProductDescriptionCulture.
        /// </summary>
        public ProductModelProductDescriptionCultureFactory ProductModelProductDescriptionCultureFactory
		{
			get
			{
				if (_ProductModelProductDescriptionCultureFactory == null)
				{
					_ProductModelProductDescriptionCultureFactory = global::AdventureWorks.ProductModelProductDescriptionCultureFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_ProductModelProductDescriptionCultureFactory, typeof(ProductModelProductDescriptionCulture));
				}
				return _ProductModelProductDescriptionCultureFactory;
			}
		}
		private ProductModelProductDescriptionCultureFactory _ProductModelProductDescriptionCultureFactory = null;
	
        /// <summary>
        /// GetProductModelProductDescriptionCulture to ProductModelProductDescriptionCulture / ProductModelProductDescriptionCulture
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductModelProductDescriptionCulture GetProductModelProductDescriptionCulture(int? productModelId, int? productDescriptionId, string cultureId)
        {
            return this.ProductModelProductDescriptionCultureFactory.GetEntity(0, productModelId, productDescriptionId, cultureId);
        }
	
        /// <summary>
        /// GetProductModelProductDescriptionCulture to ProductModelProductDescriptionCulture / ProductModelProductDescriptionCulture
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductModelProductDescriptionCulture GetProductModelProductDescriptionCulture(DbConnector conn, int? productModelId, int? productDescriptionId, string cultureId)
        {
            return this.ProductModelProductDescriptionCultureFactory.GetEntity(conn, productModelId, productDescriptionId, cultureId);
        }
	
		/// <summary>
        /// GetProductModelProductDescriptionCultureList to ProductModelProductDescriptionCulture / ProductModelProductDescriptionCulture
		/// Getting a list of ProductModelProductDescriptionCulture using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public ProductModelProductDescriptionCultureList GetProductModelProductDescriptionCultureList(SqlWhereClause where)
        {
            return this.ProductModelProductDescriptionCultureFactory.GetEntities(where);
        }

		/// <summary>
        /// GetProductModelProductDescriptionCultureList to ProductModelProductDescriptionCulture / ProductModelProductDescriptionCulture
		/// Getting all entities of ProductModelProductDescriptionCulture
        /// </summary>
        /// <returns>List of all found entities</returns>
        public ProductModelProductDescriptionCultureList GetProductModelProductDescriptionCultureList()
        {
			var where = new SqlWhereClause();
            return this.ProductModelProductDescriptionCultureFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveProductModelProductDescriptionCulture to ProductModelProductDescriptionCulture / ProductModelProductDescriptionCulture
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductModelProductDescriptionCulture SaveProductModelProductDescriptionCulture(ProductModelProductDescriptionCulture item)
        {
            return this.ProductModelProductDescriptionCultureFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveProductModelProductDescriptionCulture to ProductModelProductDescriptionCulture / ProductModelProductDescriptionCulture
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductModelProductDescriptionCulture SaveProductModelProductDescriptionCulture(DbConnector conn, ProductModelProductDescriptionCulture item)
        {
            return this.ProductModelProductDescriptionCultureFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyProductModelProductDescriptionCulture to ProductModelProductDescriptionCulture / ProductModelProductDescriptionCulture
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ProductModelProductDescriptionCulture ApplyProductModelProductDescriptionCulture(DbConnector conn, ProductModelProductDescriptionCulture item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.ProductModelProductDescriptionCultureFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveProductModelProductDescriptionCulture to ProductModelProductDescriptionCulture / ProductModelProductDescriptionCulture
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductModelProductDescriptionCulture(ProductModelProductDescriptionCulture item)
        {
            return this.ProductModelProductDescriptionCultureFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveProductModelProductDescriptionCulture to ProductModelProductDescriptionCulture / ProductModelProductDescriptionCulture
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveProductModelProductDescriptionCulture(DbConnector conn, ProductModelProductDescriptionCulture item)
        {
            return this.ProductModelProductDescriptionCultureFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities ProductModelProductDescriptionCultureList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveProductModelProductDescriptionCultureList(ProductModelProductDescriptionCultureList items)
        {
			return this.ProductModelProductDescriptionCultureFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
