﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// SalesPersonQuotaHistory / SalesPersonQuotaHistory - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class SalesPersonQuotaHistory
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for SalesPersonQuotaHistory
        /// </summary>
	    public SalesPersonQuotaHistory()
		{
		}

		///// <summary>
        ///// Creates a new instance of SalesPersonQuotaHistory
        ///// </summary>
	    //internal SalesPersonQuotaHistory CreateEntity()
		//{
		//    return new SalesPersonQuotaHistory();
		//}

		#region Members

		
        /// <summary>
        /// BusinessEntityId / SalesPersonQuotaHistory.BusinessEntityID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("BusinessEntityID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("SalesPerson")]
        public virtual int? BusinessEntityId
        {
            get
            {
                return (int?)this["BusinessEntityID"];
            }
            set
            {
                this.Add("BusinessEntityID", value, typeof(int?));
            }
        }

        /// <summary>
        /// QuotaDate / SalesPersonQuotaHistory.QuotaDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("QuotaDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? QuotaDate
        {
            get
            {
                return (DateTime?)this["QuotaDate"];
            }
            set
            {
                this.Add("QuotaDate", value, typeof(DateTime?));
            }
        }

        /// <summary>
        /// SalesQuota / SalesPersonQuotaHistory.SalesQuota
        /// </summary>
        /// <returns>decimal?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("SalesQuota"), FieldOrder(0), TypeName("decimal?"), FieldTypeName("decimal?"), ForeignEntity(null)]
        public virtual decimal? SalesQuota
        {
            get
            {
                return (decimal?)this["SalesQuota"];
            }
            set
            {
                this.Add("SalesQuota", value, typeof(decimal?));
            }
        }

        /// <summary>
        /// Rowguid / SalesPersonQuotaHistory.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / SalesPersonQuotaHistory.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to SalesPerson

        /// <summary>
        /// Link to parent/super Entity SalesPerson / SalesPerson (this.BusinessEntityId)
		/// Foreign key FK_SalesPersonQuotaHistory_SalesPerson_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesPerson SalesPerson
        {
            get
            {
			    // Lazy loading
                if (this._SalesPerson == null && this.BusinessEntityId != null)
                {
                    this._SalesPerson = ((AdvEntityManager)this.Manager).GetSalesPerson(this.BusinessEntityId);
                    if (! _SalesPerson.ResultInfo.IsValid)
                    {
						this._SalesPerson = null; // reset value
                        throw new Exception("wrong/missed constraint from SalesPersonQuotaHistory to SalesPerson.");
                    }
                }
                return this._SalesPerson;
            }
            set
            {
                // reassign foreign key values from setter value
                this.BusinessEntityId = (value != null ? value.BusinessEntityId : null);


				// set foreign table
                this._SalesPerson = value;
            }
        }
        private SalesPerson _SalesPerson = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.SalesPersonQuotaHistoryFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "SalesPersonQuotaHistory"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // SalesPersonQuotaHistory

	#endregion

	#region Entity-List

    /// <summary>
    /// SalesPersonQuotaHistory / SalesPersonQuotaHistoryList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class SalesPersonQuotaHistoryList
        : WebEntityList<SalesPersonQuotaHistory>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "SalesPersonQuotaHistory"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// SalesPersonQuotaHistory - SalesPersonQuotaHistory - Factory 
    /// </summary>
    public partial class SalesPersonQuotaHistoryFactory
        : WebEntityFactory<SalesPersonQuotaHistory, SalesPersonQuotaHistoryList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property BusinessEntityId of Db-Field BusinessEntityID</summary>
        public static string Prop_BusinessEntityId = "BusinessEntityId";
        ///<summary>Property QuotaDate of Db-Field QuotaDate</summary>
        public static string Prop_QuotaDate = "QuotaDate";
        ///<summary>Property SalesQuota of Db-Field SalesQuota</summary>
        public static string Prop_SalesQuota = "SalesQuota";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field BusinessEntityID of Property BusinessEntityId</summary>
        public static string Field_BusinessEntityId = "BusinessEntityID";
        ///<summary>Db-Field QuotaDate of Property QuotaDate</summary>
        public static string Field_QuotaDate = "QuotaDate";
        ///<summary>Db-Field SalesQuota of Property SalesQuota</summary>
        public static string Field_SalesQuota = "SalesQuota";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = SalesPersonQuotaHistory, 
		/// Fields       = "BusinessEntityID", "QuotaDate"
		/// Query        = ...
        /// </summary>
        protected SalesPersonQuotaHistoryFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Sales";
            this.TableName = "SalesPersonQuotaHistory";
            this.Fields = new string[]
            {
                "BusinessEntityID", "QuotaDate"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("BusinessEntityId", "int?", "BusinessEntityID", "int?", "", "SalesPerson");
			this.Properties.Add("QuotaDate", "DateTime?", "QuotaDate", "DateTime?", "", null);
			this.Properties.Add("SalesQuota", "decimal?", "SalesQuota", "decimal?", "", null);
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "SalesPersonQuotaHistory"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "SalesPersonQuotaHistoryList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "SalesPersonQuotaHistoryFactory"; }
            set { }
        }

		#endregion

		internal static SalesPersonQuotaHistoryFactory CreateFactory(EntityManager manager)
		{
		    return new SalesPersonQuotaHistoryFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of SalesPersonQuotaHistory. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo SalesPersonQuotaHistory</returns>
        public override SalesPersonQuotaHistory CreateEntity()
		{
			var item = new SalesPersonQuotaHistory();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(SalesPersonQuotaHistory item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity SalesPerson / SalesPerson
            // Foreign Key FK_SalesPersonQuotaHistory_SalesPerson_BusinessEntityID
            if (parent is SalesPerson)
            {
                item.SalesPerson = (SalesPerson)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public SalesPersonQuotaHistory GetItem(int? businessEntityId, DateTime? quotaDate)
        {
            return this.GetEntity(0, businessEntityId, quotaDate);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public SalesPersonQuotaHistory GetItem(DbConnector conn, int? businessEntityId, DateTime? quotaDate)
        {
            return this.GetEntity(conn, businessEntityId, quotaDate);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(SalesPersonQuotaHistory).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to SalesPersonQuotaHistoryFactory / SalesPersonQuotaHistory / SalesPersonQuotaHistory.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// SalesPersonQuotaHistoryFactory to SalesPersonQuotaHistory / SalesPersonQuotaHistory.
        /// </summary>
        public SalesPersonQuotaHistoryFactory SalesPersonQuotaHistoryFactory
		{
			get
			{
				if (_SalesPersonQuotaHistoryFactory == null)
				{
					_SalesPersonQuotaHistoryFactory = global::AdventureWorks.SalesPersonQuotaHistoryFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_SalesPersonQuotaHistoryFactory, typeof(SalesPersonQuotaHistory));
				}
				return _SalesPersonQuotaHistoryFactory;
			}
		}
		private SalesPersonQuotaHistoryFactory _SalesPersonQuotaHistoryFactory = null;
	
        /// <summary>
        /// GetSalesPersonQuotaHistory to SalesPersonQuotaHistory / SalesPersonQuotaHistory
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesPersonQuotaHistory GetSalesPersonQuotaHistory(int? businessEntityId, DateTime? quotaDate)
        {
            return this.SalesPersonQuotaHistoryFactory.GetEntity(0, businessEntityId, quotaDate);
        }
	
        /// <summary>
        /// GetSalesPersonQuotaHistory to SalesPersonQuotaHistory / SalesPersonQuotaHistory
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesPersonQuotaHistory GetSalesPersonQuotaHistory(DbConnector conn, int? businessEntityId, DateTime? quotaDate)
        {
            return this.SalesPersonQuotaHistoryFactory.GetEntity(conn, businessEntityId, quotaDate);
        }
	
		/// <summary>
        /// GetSalesPersonQuotaHistoryList to SalesPersonQuotaHistory / SalesPersonQuotaHistory
		/// Getting a list of SalesPersonQuotaHistory using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public SalesPersonQuotaHistoryList GetSalesPersonQuotaHistoryList(SqlWhereClause where)
        {
            return this.SalesPersonQuotaHistoryFactory.GetEntities(where);
        }

		/// <summary>
        /// GetSalesPersonQuotaHistoryList to SalesPersonQuotaHistory / SalesPersonQuotaHistory
		/// Getting all entities of SalesPersonQuotaHistory
        /// </summary>
        /// <returns>List of all found entities</returns>
        public SalesPersonQuotaHistoryList GetSalesPersonQuotaHistoryList()
        {
			var where = new SqlWhereClause();
            return this.SalesPersonQuotaHistoryFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveSalesPersonQuotaHistory to SalesPersonQuotaHistory / SalesPersonQuotaHistory
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesPersonQuotaHistory SaveSalesPersonQuotaHistory(SalesPersonQuotaHistory item)
        {
            return this.SalesPersonQuotaHistoryFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveSalesPersonQuotaHistory to SalesPersonQuotaHistory / SalesPersonQuotaHistory
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesPersonQuotaHistory SaveSalesPersonQuotaHistory(DbConnector conn, SalesPersonQuotaHistory item)
        {
            return this.SalesPersonQuotaHistoryFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplySalesPersonQuotaHistory to SalesPersonQuotaHistory / SalesPersonQuotaHistory
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesPersonQuotaHistory ApplySalesPersonQuotaHistory(DbConnector conn, SalesPersonQuotaHistory item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.SalesPersonQuotaHistoryFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveSalesPersonQuotaHistory to SalesPersonQuotaHistory / SalesPersonQuotaHistory
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveSalesPersonQuotaHistory(SalesPersonQuotaHistory item)
        {
            return this.SalesPersonQuotaHistoryFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveSalesPersonQuotaHistory to SalesPersonQuotaHistory / SalesPersonQuotaHistory
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveSalesPersonQuotaHistory(DbConnector conn, SalesPersonQuotaHistory item)
        {
            return this.SalesPersonQuotaHistoryFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities SalesPersonQuotaHistoryList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveSalesPersonQuotaHistoryList(SalesPersonQuotaHistoryList items)
        {
			return this.SalesPersonQuotaHistoryFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
