﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// SalesTaxRate / SalesTaxRate - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class SalesTaxRate
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for SalesTaxRate
        /// </summary>
	    public SalesTaxRate()
		{
		}

		///// <summary>
        ///// Creates a new instance of SalesTaxRate
        ///// </summary>
	    //internal SalesTaxRate CreateEntity()
		//{
		//    return new SalesTaxRate();
		//}

		#region Members

		
        /// <summary>
        /// SalesTaxRateId / SalesTaxRate.SalesTaxRateID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("SalesTaxRateID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? SalesTaxRateId
        {
            get
            {
                return (int?)this["SalesTaxRateID"];
            }
            set
            {
                this.Add("SalesTaxRateID", value, typeof(int?));
            }
        }

        /// <summary>
        /// StateProvinceId / SalesTaxRate.StateProvinceID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("StateProvinceID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("StateProvince")]
        public virtual int? StateProvinceId
        {
            get
            {
                return (int?)this["StateProvinceID"];
            }
            set
            {
                this.Add("StateProvinceID", value, typeof(int?));
            }
        }

        /// <summary>
        /// TaxType / SalesTaxRate.TaxType
        /// </summary>
        /// <returns>byte?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("TaxType"), FieldOrder(0), TypeName("byte?"), FieldTypeName("byte?"), ForeignEntity(null)]
        public virtual byte? TaxType
        {
            get
            {
                return (byte?)this["TaxType"];
            }
            set
            {
                this.Add("TaxType", value, typeof(byte?));
            }
        }

        /// <summary>
        /// TaxRate / SalesTaxRate.TaxRate
        /// </summary>
        /// <returns>decimal?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("TaxRate"), FieldOrder(0), TypeName("decimal?"), FieldTypeName("decimal?"), ForeignEntity(null)]
        public virtual decimal? TaxRate
        {
            get
            {
                return (decimal?)this["TaxRate"];
            }
            set
            {
                this.Add("TaxRate", value, typeof(decimal?));
            }
        }

        /// <summary>
        /// Name / SalesTaxRate.Name
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Name"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Name
        {
            get
            {
                return (string)this["Name"];
            }
            set
            {
                this.Add("Name", value, typeof(string));
            }
        }

        /// <summary>
        /// Rowguid / SalesTaxRate.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / SalesTaxRate.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to StateProvince

        /// <summary>
        /// Link to parent/super Entity StateProvince / StateProvince (this.StateProvinceId)
		/// Foreign key FK_SalesTaxRate_StateProvince_StateProvinceID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual StateProvince StateProvince
        {
            get
            {
			    // Lazy loading
                if (this._StateProvince == null && this.StateProvinceId != null)
                {
                    this._StateProvince = ((AdvEntityManager)this.Manager).GetStateProvince(this.StateProvinceId);
                    if (! _StateProvince.ResultInfo.IsValid)
                    {
						this._StateProvince = null; // reset value
                        throw new Exception("wrong/missed constraint from SalesTaxRate to StateProvince.");
                    }
                }
                return this._StateProvince;
            }
            set
            {
                // reassign foreign key values from setter value
                this.StateProvinceId = (value != null ? value.StateProvinceId : null);


				// set foreign table
                this._StateProvince = value;
            }
        }
        private StateProvince _StateProvince = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.SalesTaxRateFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "SalesTaxRate"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // SalesTaxRate

	#endregion

	#region Entity-List

    /// <summary>
    /// SalesTaxRate / SalesTaxRateList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class SalesTaxRateList
        : WebEntityList<SalesTaxRate>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "SalesTaxRate"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// SalesTaxRate - SalesTaxRate - Factory 
    /// </summary>
    public partial class SalesTaxRateFactory
        : WebEntityFactory<SalesTaxRate, SalesTaxRateList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property SalesTaxRateId of Db-Field SalesTaxRateID</summary>
        public static string Prop_SalesTaxRateId = "SalesTaxRateId";
        ///<summary>Property StateProvinceId of Db-Field StateProvinceID</summary>
        public static string Prop_StateProvinceId = "StateProvinceId";
        ///<summary>Property TaxType of Db-Field TaxType</summary>
        public static string Prop_TaxType = "TaxType";
        ///<summary>Property TaxRate of Db-Field TaxRate</summary>
        public static string Prop_TaxRate = "TaxRate";
        ///<summary>Property Name of Db-Field Name</summary>
        public static string Prop_Name = "Name";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field SalesTaxRateID of Property SalesTaxRateId</summary>
        public static string Field_SalesTaxRateId = "SalesTaxRateID";
        ///<summary>Db-Field StateProvinceID of Property StateProvinceId</summary>
        public static string Field_StateProvinceId = "StateProvinceID";
        ///<summary>Db-Field TaxType of Property TaxType</summary>
        public static string Field_TaxType = "TaxType";
        ///<summary>Db-Field TaxRate of Property TaxRate</summary>
        public static string Field_TaxRate = "TaxRate";
        ///<summary>Db-Field Name of Property Name</summary>
        public static string Field_Name = "Name";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = SalesTaxRate, 
		/// Fields       = "SalesTaxRateID"
		/// Query        = ...
        /// </summary>
        protected SalesTaxRateFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Sales";
            this.TableName = "SalesTaxRate";
            this.Fields = new string[]
            {
                "SalesTaxRateID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("SalesTaxRateId", "int?", "SalesTaxRateID", "int?", "", null);
			this.Properties.Add("StateProvinceId", "int?", "StateProvinceID", "int?", "", "StateProvince");
			this.Properties.Add("TaxType", "byte?", "TaxType", "byte?", "", null);
			this.Properties.Add("TaxRate", "decimal?", "TaxRate", "decimal?", "", null);
			this.Properties.Add("Name", "string", "Name", "string", "", null);
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "SalesTaxRate"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "SalesTaxRateList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "SalesTaxRateFactory"; }
            set { }
        }

		#endregion

		internal static SalesTaxRateFactory CreateFactory(EntityManager manager)
		{
		    return new SalesTaxRateFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of SalesTaxRate. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo SalesTaxRate</returns>
        public override SalesTaxRate CreateEntity()
		{
			var item = new SalesTaxRate();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(SalesTaxRate item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity StateProvince / StateProvince
            // Foreign Key FK_SalesTaxRate_StateProvince_StateProvinceID
            if (parent is StateProvince)
            {
                item.StateProvince = (StateProvince)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public SalesTaxRate GetItem(int? salesTaxRateId)
        {
            return this.GetEntity(0, salesTaxRateId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public SalesTaxRate GetItem(DbConnector conn, int? salesTaxRateId)
        {
            return this.GetEntity(conn, salesTaxRateId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(SalesTaxRate).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to SalesTaxRateFactory / SalesTaxRate / SalesTaxRate.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// SalesTaxRateFactory to SalesTaxRate / SalesTaxRate.
        /// </summary>
        public SalesTaxRateFactory SalesTaxRateFactory
		{
			get
			{
				if (_SalesTaxRateFactory == null)
				{
					_SalesTaxRateFactory = global::AdventureWorks.SalesTaxRateFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_SalesTaxRateFactory, typeof(SalesTaxRate));
				}
				return _SalesTaxRateFactory;
			}
		}
		private SalesTaxRateFactory _SalesTaxRateFactory = null;
	
        /// <summary>
        /// GetSalesTaxRate to SalesTaxRate / SalesTaxRate
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesTaxRate GetSalesTaxRate(int? salesTaxRateId)
        {
            return this.SalesTaxRateFactory.GetEntity(0, salesTaxRateId);
        }
	
        /// <summary>
        /// GetSalesTaxRate to SalesTaxRate / SalesTaxRate
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesTaxRate GetSalesTaxRate(DbConnector conn, int? salesTaxRateId)
        {
            return this.SalesTaxRateFactory.GetEntity(conn, salesTaxRateId);
        }
	
		/// <summary>
        /// GetSalesTaxRateList to SalesTaxRate / SalesTaxRate
		/// Getting a list of SalesTaxRate using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public SalesTaxRateList GetSalesTaxRateList(SqlWhereClause where)
        {
            return this.SalesTaxRateFactory.GetEntities(where);
        }

		/// <summary>
        /// GetSalesTaxRateList to SalesTaxRate / SalesTaxRate
		/// Getting all entities of SalesTaxRate
        /// </summary>
        /// <returns>List of all found entities</returns>
        public SalesTaxRateList GetSalesTaxRateList()
        {
			var where = new SqlWhereClause();
            return this.SalesTaxRateFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveSalesTaxRate to SalesTaxRate / SalesTaxRate
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesTaxRate SaveSalesTaxRate(SalesTaxRate item)
        {
            return this.SalesTaxRateFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveSalesTaxRate to SalesTaxRate / SalesTaxRate
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesTaxRate SaveSalesTaxRate(DbConnector conn, SalesTaxRate item)
        {
            return this.SalesTaxRateFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplySalesTaxRate to SalesTaxRate / SalesTaxRate
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesTaxRate ApplySalesTaxRate(DbConnector conn, SalesTaxRate item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.SalesTaxRateFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveSalesTaxRate to SalesTaxRate / SalesTaxRate
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveSalesTaxRate(SalesTaxRate item)
        {
            return this.SalesTaxRateFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveSalesTaxRate to SalesTaxRate / SalesTaxRate
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveSalesTaxRate(DbConnector conn, SalesTaxRate item)
        {
            return this.SalesTaxRateFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities SalesTaxRateList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveSalesTaxRateList(SalesTaxRateList items)
        {
			return this.SalesTaxRateFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
