﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// SalesTerritoryHistory / SalesTerritoryHistory - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class SalesTerritoryHistory
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for SalesTerritoryHistory
        /// </summary>
	    public SalesTerritoryHistory()
		{
		}

		///// <summary>
        ///// Creates a new instance of SalesTerritoryHistory
        ///// </summary>
	    //internal SalesTerritoryHistory CreateEntity()
		//{
		//    return new SalesTerritoryHistory();
		//}

		#region Members

		
        /// <summary>
        /// BusinessEntityId / SalesTerritoryHistory.BusinessEntityID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("BusinessEntityID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("SalesPerson")]
        public virtual int? BusinessEntityId
        {
            get
            {
                return (int?)this["BusinessEntityID"];
            }
            set
            {
                this.Add("BusinessEntityID", value, typeof(int?));
            }
        }

        /// <summary>
        /// TerritoryId / SalesTerritoryHistory.TerritoryID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("TerritoryID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("SalesTerritory")]
        public virtual int? TerritoryId
        {
            get
            {
                return (int?)this["TerritoryID"];
            }
            set
            {
                this.Add("TerritoryID", value, typeof(int?));
            }
        }

        /// <summary>
        /// StartDate / SalesTerritoryHistory.StartDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("StartDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? StartDate
        {
            get
            {
                return (DateTime?)this["StartDate"];
            }
            set
            {
                this.Add("StartDate", value, typeof(DateTime?));
            }
        }

        /// <summary>
        /// EndDate / SalesTerritoryHistory.EndDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("EndDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? EndDate
        {
            get
            {
                return (DateTime?)this["EndDate"];
            }
            set
            {
                this.Add("EndDate", value, typeof(DateTime?));
            }
        }

        /// <summary>
        /// Rowguid / SalesTerritoryHistory.rowguid
        /// </summary>
        /// <returns>Guid?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("rowguid"), FieldOrder(0), TypeName("Guid?"), FieldTypeName("Guid?"), ForeignEntity(null)]
        public virtual Guid? Rowguid
        {
            get
            {
                return (Guid?)this["rowguid"];
            }
            set
            {
                this.Add("rowguid", value, typeof(Guid?));
            }
        }

        /// <summary>
        /// ModifiedDate / SalesTerritoryHistory.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to SalesPerson

        /// <summary>
        /// Link to parent/super Entity SalesPerson / SalesPerson (this.BusinessEntityId)
		/// Foreign key FK_SalesTerritoryHistory_SalesPerson_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesPerson SalesPerson
        {
            get
            {
			    // Lazy loading
                if (this._SalesPerson == null && this.BusinessEntityId != null)
                {
                    this._SalesPerson = ((AdvEntityManager)this.Manager).GetSalesPerson(this.BusinessEntityId);
                    if (! _SalesPerson.ResultInfo.IsValid)
                    {
						this._SalesPerson = null; // reset value
                        throw new Exception("wrong/missed constraint from SalesTerritoryHistory to SalesPerson.");
                    }
                }
                return this._SalesPerson;
            }
            set
            {
                // reassign foreign key values from setter value
                this.BusinessEntityId = (value != null ? value.BusinessEntityId : null);


				// set foreign table
                this._SalesPerson = value;
            }
        }
        private SalesPerson _SalesPerson = null;

        #endregion

        #region foreign constraint (parent entity) to SalesTerritory

        /// <summary>
        /// Link to parent/super Entity SalesTerritory / SalesTerritory (this.TerritoryId)
		/// Foreign key FK_SalesTerritoryHistory_SalesTerritory_TerritoryID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual SalesTerritory SalesTerritory
        {
            get
            {
			    // Lazy loading
                if (this._SalesTerritory == null && this.TerritoryId != null)
                {
                    this._SalesTerritory = ((AdvEntityManager)this.Manager).GetSalesTerritory(this.TerritoryId);
                    if (! _SalesTerritory.ResultInfo.IsValid)
                    {
						this._SalesTerritory = null; // reset value
                        throw new Exception("wrong/missed constraint from SalesTerritoryHistory to SalesTerritory.");
                    }
                }
                return this._SalesTerritory;
            }
            set
            {
                // reassign foreign key values from setter value
                this.TerritoryId = (value != null ? value.TerritoryId : null);


				// set foreign table
                this._SalesTerritory = value;
            }
        }
        private SalesTerritory _SalesTerritory = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.SalesTerritoryHistoryFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "SalesTerritoryHistory"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // SalesTerritoryHistory

	#endregion

	#region Entity-List

    /// <summary>
    /// SalesTerritoryHistory / SalesTerritoryHistoryList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class SalesTerritoryHistoryList
        : WebEntityList<SalesTerritoryHistory>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "SalesTerritoryHistory"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// SalesTerritoryHistory - SalesTerritoryHistory - Factory 
    /// </summary>
    public partial class SalesTerritoryHistoryFactory
        : WebEntityFactory<SalesTerritoryHistory, SalesTerritoryHistoryList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property BusinessEntityId of Db-Field BusinessEntityID</summary>
        public static string Prop_BusinessEntityId = "BusinessEntityId";
        ///<summary>Property TerritoryId of Db-Field TerritoryID</summary>
        public static string Prop_TerritoryId = "TerritoryId";
        ///<summary>Property StartDate of Db-Field StartDate</summary>
        public static string Prop_StartDate = "StartDate";
        ///<summary>Property EndDate of Db-Field EndDate</summary>
        public static string Prop_EndDate = "EndDate";
        ///<summary>Property Rowguid of Db-Field rowguid</summary>
        public static string Prop_Rowguid = "Rowguid";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field BusinessEntityID of Property BusinessEntityId</summary>
        public static string Field_BusinessEntityId = "BusinessEntityID";
        ///<summary>Db-Field TerritoryID of Property TerritoryId</summary>
        public static string Field_TerritoryId = "TerritoryID";
        ///<summary>Db-Field StartDate of Property StartDate</summary>
        public static string Field_StartDate = "StartDate";
        ///<summary>Db-Field EndDate of Property EndDate</summary>
        public static string Field_EndDate = "EndDate";
        ///<summary>Db-Field rowguid of Property Rowguid</summary>
        public static string Field_Rowguid = "rowguid";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = SalesTerritoryHistory, 
		/// Fields       = "BusinessEntityID", "StartDate", "TerritoryID"
		/// Query        = ...
        /// </summary>
        protected SalesTerritoryHistoryFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Sales";
            this.TableName = "SalesTerritoryHistory";
            this.Fields = new string[]
            {
                "BusinessEntityID", "StartDate", "TerritoryID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("BusinessEntityId", "int?", "BusinessEntityID", "int?", "", "SalesPerson");
			this.Properties.Add("TerritoryId", "int?", "TerritoryID", "int?", "", "SalesTerritory");
			this.Properties.Add("StartDate", "DateTime?", "StartDate", "DateTime?", "", null);
			this.Properties.Add("EndDate", "DateTime?", "EndDate", "DateTime?", "", null);
			this.Properties.Add("Rowguid", "Guid?", "rowguid", "Guid?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "SalesTerritoryHistory"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "SalesTerritoryHistoryList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "SalesTerritoryHistoryFactory"; }
            set { }
        }

		#endregion

		internal static SalesTerritoryHistoryFactory CreateFactory(EntityManager manager)
		{
		    return new SalesTerritoryHistoryFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of SalesTerritoryHistory. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo SalesTerritoryHistory</returns>
        public override SalesTerritoryHistory CreateEntity()
		{
			var item = new SalesTerritoryHistory();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(SalesTerritoryHistory item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity SalesPerson / SalesPerson
            // Foreign Key FK_SalesTerritoryHistory_SalesPerson_BusinessEntityID
            if (parent is SalesPerson)
            {
                item.SalesPerson = (SalesPerson)parent;
                return;
            }

            // make relation to parent/super Entity SalesTerritory / SalesTerritory
            // Foreign Key FK_SalesTerritoryHistory_SalesTerritory_TerritoryID
            if (parent is SalesTerritory)
            {
                item.SalesTerritory = (SalesTerritory)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public SalesTerritoryHistory GetItem(int? businessEntityId, DateTime? startDate, int? territoryId)
        {
            return this.GetEntity(0, businessEntityId, startDate, territoryId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public SalesTerritoryHistory GetItem(DbConnector conn, int? businessEntityId, DateTime? startDate, int? territoryId)
        {
            return this.GetEntity(conn, businessEntityId, startDate, territoryId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(SalesTerritoryHistory).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to SalesTerritoryHistoryFactory / SalesTerritoryHistory / SalesTerritoryHistory.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// SalesTerritoryHistoryFactory to SalesTerritoryHistory / SalesTerritoryHistory.
        /// </summary>
        public SalesTerritoryHistoryFactory SalesTerritoryHistoryFactory
		{
			get
			{
				if (_SalesTerritoryHistoryFactory == null)
				{
					_SalesTerritoryHistoryFactory = global::AdventureWorks.SalesTerritoryHistoryFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_SalesTerritoryHistoryFactory, typeof(SalesTerritoryHistory));
				}
				return _SalesTerritoryHistoryFactory;
			}
		}
		private SalesTerritoryHistoryFactory _SalesTerritoryHistoryFactory = null;
	
        /// <summary>
        /// GetSalesTerritoryHistory to SalesTerritoryHistory / SalesTerritoryHistory
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesTerritoryHistory GetSalesTerritoryHistory(int? businessEntityId, DateTime? startDate, int? territoryId)
        {
            return this.SalesTerritoryHistoryFactory.GetEntity(0, businessEntityId, startDate, territoryId);
        }
	
        /// <summary>
        /// GetSalesTerritoryHistory to SalesTerritoryHistory / SalesTerritoryHistory
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesTerritoryHistory GetSalesTerritoryHistory(DbConnector conn, int? businessEntityId, DateTime? startDate, int? territoryId)
        {
            return this.SalesTerritoryHistoryFactory.GetEntity(conn, businessEntityId, startDate, territoryId);
        }
	
		/// <summary>
        /// GetSalesTerritoryHistoryList to SalesTerritoryHistory / SalesTerritoryHistory
		/// Getting a list of SalesTerritoryHistory using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public SalesTerritoryHistoryList GetSalesTerritoryHistoryList(SqlWhereClause where)
        {
            return this.SalesTerritoryHistoryFactory.GetEntities(where);
        }

		/// <summary>
        /// GetSalesTerritoryHistoryList to SalesTerritoryHistory / SalesTerritoryHistory
		/// Getting all entities of SalesTerritoryHistory
        /// </summary>
        /// <returns>List of all found entities</returns>
        public SalesTerritoryHistoryList GetSalesTerritoryHistoryList()
        {
			var where = new SqlWhereClause();
            return this.SalesTerritoryHistoryFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveSalesTerritoryHistory to SalesTerritoryHistory / SalesTerritoryHistory
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesTerritoryHistory SaveSalesTerritoryHistory(SalesTerritoryHistory item)
        {
            return this.SalesTerritoryHistoryFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveSalesTerritoryHistory to SalesTerritoryHistory / SalesTerritoryHistory
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesTerritoryHistory SaveSalesTerritoryHistory(DbConnector conn, SalesTerritoryHistory item)
        {
            return this.SalesTerritoryHistoryFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplySalesTerritoryHistory to SalesTerritoryHistory / SalesTerritoryHistory
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public SalesTerritoryHistory ApplySalesTerritoryHistory(DbConnector conn, SalesTerritoryHistory item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.SalesTerritoryHistoryFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveSalesTerritoryHistory to SalesTerritoryHistory / SalesTerritoryHistory
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveSalesTerritoryHistory(SalesTerritoryHistory item)
        {
            return this.SalesTerritoryHistoryFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveSalesTerritoryHistory to SalesTerritoryHistory / SalesTerritoryHistory
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveSalesTerritoryHistory(DbConnector conn, SalesTerritoryHistory item)
        {
            return this.SalesTerritoryHistoryFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities SalesTerritoryHistoryList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveSalesTerritoryHistoryList(SalesTerritoryHistoryList items)
        {
			return this.SalesTerritoryHistoryFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
