﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// ScrapReason / ScrapReason - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class ScrapReason
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for ScrapReason
        /// </summary>
	    public ScrapReason()
		{
		}

		///// <summary>
        ///// Creates a new instance of ScrapReason
        ///// </summary>
	    //internal ScrapReason CreateEntity()
		//{
		//    return new ScrapReason();
		//}

		#region Members

		
        /// <summary>
        /// ScrapReasonId / ScrapReason.ScrapReasonID
        /// </summary>
        /// <returns>short?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ScrapReasonID"), FieldOrder(0), TypeName("short?"), FieldTypeName("short?"), ForeignEntity(null)]
        public virtual short? ScrapReasonId
        {
            get
            {
                return (short?)this["ScrapReasonID"];
            }
            set
            {
                this.Add("ScrapReasonID", value, typeof(short?));
            }
        }

        /// <summary>
        /// Name / ScrapReason.Name
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Name"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Name
        {
            get
            {
                return (string)this["Name"];
            }
            set
            {
                this.Add("Name", value, typeof(string));
            }
        }

        /// <summary>
        /// ModifiedDate / ScrapReason.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		

		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from WorkOrder

        /// <summary>
        /// List of sub entities WorkOrder / WorkOrder (ScrapReasonID)
		/// Foreign Key FK_WorkOrder_ScrapReason_ScrapReasonID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual WorkOrderList WorkOrderList
        {
            get
            {
			    // Lazy Loading
                if (_WorkOrderList == null && this.ScrapReasonId != null)
                {
					var where = new SqlWhereClause("WHERE WorkOrder.ScrapReasonID = @ScrapReasonID",
					    "@ScrapReasonID", this.ScrapReasonId);
                    _WorkOrderList = ((AdvEntityManager)this.Manager).GetWorkOrderList(where);
                }
				if (_WorkOrderList == null)
				{
					_WorkOrderList = new WorkOrderList();
				}
                return _WorkOrderList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private WorkOrderList _WorkOrderList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.ScrapReasonFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ScrapReason"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // ScrapReason

	#endregion

	#region Entity-List

    /// <summary>
    /// ScrapReason / ScrapReasonList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class ScrapReasonList
        : WebEntityList<ScrapReason>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ScrapReason"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// ScrapReason - ScrapReason - Factory 
    /// </summary>
    public partial class ScrapReasonFactory
        : WebEntityFactory<ScrapReason, ScrapReasonList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property ScrapReasonId of Db-Field ScrapReasonID</summary>
        public static string Prop_ScrapReasonId = "ScrapReasonId";
        ///<summary>Property Name of Db-Field Name</summary>
        public static string Prop_Name = "Name";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field ScrapReasonID of Property ScrapReasonId</summary>
        public static string Field_ScrapReasonId = "ScrapReasonID";
        ///<summary>Db-Field Name of Property Name</summary>
        public static string Field_Name = "Name";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = ScrapReason, 
		/// Fields       = "ScrapReasonID"
		/// Query        = ...
        /// </summary>
        protected ScrapReasonFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "ScrapReason";
            this.Fields = new string[]
            {
                "ScrapReasonID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("ScrapReasonId", "short?", "ScrapReasonID", "short?", "", null);
			this.Properties.Add("Name", "string", "Name", "string", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "ScrapReason"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "ScrapReasonList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "ScrapReasonFactory"; }
            set { }
        }

		#endregion

		internal static ScrapReasonFactory CreateFactory(EntityManager manager)
		{
		    return new ScrapReasonFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of ScrapReason. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo ScrapReason</returns>
        public override ScrapReason CreateEntity()
		{
			var item = new ScrapReason();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}



		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public ScrapReason GetItem(short? scrapReasonId)
        {
            return this.GetEntity(0, scrapReasonId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public ScrapReason GetItem(DbConnector conn, short? scrapReasonId)
        {
            return this.GetEntity(conn, scrapReasonId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(ScrapReason).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to ScrapReasonFactory / ScrapReason / ScrapReason.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// ScrapReasonFactory to ScrapReason / ScrapReason.
        /// </summary>
        public ScrapReasonFactory ScrapReasonFactory
		{
			get
			{
				if (_ScrapReasonFactory == null)
				{
					_ScrapReasonFactory = global::AdventureWorks.ScrapReasonFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_ScrapReasonFactory, typeof(ScrapReason));
				}
				return _ScrapReasonFactory;
			}
		}
		private ScrapReasonFactory _ScrapReasonFactory = null;
	
        /// <summary>
        /// GetScrapReason to ScrapReason / ScrapReason
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public ScrapReason GetScrapReason(short? scrapReasonId)
        {
            return this.ScrapReasonFactory.GetEntity(0, scrapReasonId);
        }
	
        /// <summary>
        /// GetScrapReason to ScrapReason / ScrapReason
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ScrapReason GetScrapReason(DbConnector conn, short? scrapReasonId)
        {
            return this.ScrapReasonFactory.GetEntity(conn, scrapReasonId);
        }
	
		/// <summary>
        /// GetScrapReasonList to ScrapReason / ScrapReason
		/// Getting a list of ScrapReason using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public ScrapReasonList GetScrapReasonList(SqlWhereClause where)
        {
            return this.ScrapReasonFactory.GetEntities(where);
        }

		/// <summary>
        /// GetScrapReasonList to ScrapReason / ScrapReason
		/// Getting all entities of ScrapReason
        /// </summary>
        /// <returns>List of all found entities</returns>
        public ScrapReasonList GetScrapReasonList()
        {
			var where = new SqlWhereClause();
            return this.ScrapReasonFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveScrapReason to ScrapReason / ScrapReason
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ScrapReason SaveScrapReason(ScrapReason item)
        {
            return this.ScrapReasonFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveScrapReason to ScrapReason / ScrapReason
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ScrapReason SaveScrapReason(DbConnector conn, ScrapReason item)
        {
            return this.ScrapReasonFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyScrapReason to ScrapReason / ScrapReason
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ScrapReason ApplyScrapReason(DbConnector conn, ScrapReason item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.ScrapReasonFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveScrapReason to ScrapReason / ScrapReason
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveScrapReason(ScrapReason item)
        {
            return this.ScrapReasonFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveScrapReason to ScrapReason / ScrapReason
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveScrapReason(DbConnector conn, ScrapReason item)
        {
            return this.ScrapReasonFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities ScrapReasonList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveScrapReasonList(ScrapReasonList items)
        {
			return this.ScrapReasonFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
