﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// ShoppingCartItem / ShoppingCartItem - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class ShoppingCartItem
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for ShoppingCartItem
        /// </summary>
	    public ShoppingCartItem()
		{
		}

		///// <summary>
        ///// Creates a new instance of ShoppingCartItem
        ///// </summary>
	    //internal ShoppingCartItem CreateEntity()
		//{
		//    return new ShoppingCartItem();
		//}

		#region Members

		
        /// <summary>
        /// ShoppingCartItemId / ShoppingCartItem.ShoppingCartItemID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ShoppingCartItemID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? ShoppingCartItemId
        {
            get
            {
                return (int?)this["ShoppingCartItemID"];
            }
            set
            {
                this.Add("ShoppingCartItemID", value, typeof(int?));
            }
        }

        /// <summary>
        /// ShoppingCartId / ShoppingCartItem.ShoppingCartID
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ShoppingCartID"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string ShoppingCartId
        {
            get
            {
                return (string)this["ShoppingCartID"];
            }
            set
            {
                this.Add("ShoppingCartID", value, typeof(string));
            }
        }

        /// <summary>
        /// Quantity / ShoppingCartItem.Quantity
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Quantity"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? Quantity
        {
            get
            {
                return (int?)this["Quantity"];
            }
            set
            {
                this.Add("Quantity", value, typeof(int?));
            }
        }

        /// <summary>
        /// ProductId / ShoppingCartItem.ProductID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Product")]
        public virtual int? ProductId
        {
            get
            {
                return (int?)this["ProductID"];
            }
            set
            {
                this.Add("ProductID", value, typeof(int?));
            }
        }

        /// <summary>
        /// DateCreated / ShoppingCartItem.DateCreated
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("DateCreated"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? DateCreated
        {
            get
            {
                return (DateTime?)this["DateCreated"];
            }
            set
            {
                this.Add("DateCreated", value, typeof(DateTime?));
            }
        }

        /// <summary>
        /// ModifiedDate / ShoppingCartItem.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Product

        /// <summary>
        /// Link to parent/super Entity Product / Product (this.ProductId)
		/// Foreign key FK_ShoppingCartItem_Product_ProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Product Product
        {
            get
            {
			    // Lazy loading
                if (this._Product == null && this.ProductId != null)
                {
                    this._Product = ((AdvEntityManager)this.Manager).GetProduct(this.ProductId);
                    if (! _Product.ResultInfo.IsValid)
                    {
						this._Product = null; // reset value
                        throw new Exception("wrong/missed constraint from ShoppingCartItem to Product.");
                    }
                }
                return this._Product;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ProductId = (value != null ? value.ProductId : null);


				// set foreign table
                this._Product = value;
            }
        }
        private Product _Product = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.ShoppingCartItemFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ShoppingCartItem"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // ShoppingCartItem

	#endregion

	#region Entity-List

    /// <summary>
    /// ShoppingCartItem / ShoppingCartItemList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class ShoppingCartItemList
        : WebEntityList<ShoppingCartItem>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "ShoppingCartItem"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// ShoppingCartItem - ShoppingCartItem - Factory 
    /// </summary>
    public partial class ShoppingCartItemFactory
        : WebEntityFactory<ShoppingCartItem, ShoppingCartItemList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property ShoppingCartItemId of Db-Field ShoppingCartItemID</summary>
        public static string Prop_ShoppingCartItemId = "ShoppingCartItemId";
        ///<summary>Property ShoppingCartId of Db-Field ShoppingCartID</summary>
        public static string Prop_ShoppingCartId = "ShoppingCartId";
        ///<summary>Property Quantity of Db-Field Quantity</summary>
        public static string Prop_Quantity = "Quantity";
        ///<summary>Property ProductId of Db-Field ProductID</summary>
        public static string Prop_ProductId = "ProductId";
        ///<summary>Property DateCreated of Db-Field DateCreated</summary>
        public static string Prop_DateCreated = "DateCreated";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field ShoppingCartItemID of Property ShoppingCartItemId</summary>
        public static string Field_ShoppingCartItemId = "ShoppingCartItemID";
        ///<summary>Db-Field ShoppingCartID of Property ShoppingCartId</summary>
        public static string Field_ShoppingCartId = "ShoppingCartID";
        ///<summary>Db-Field Quantity of Property Quantity</summary>
        public static string Field_Quantity = "Quantity";
        ///<summary>Db-Field ProductID of Property ProductId</summary>
        public static string Field_ProductId = "ProductID";
        ///<summary>Db-Field DateCreated of Property DateCreated</summary>
        public static string Field_DateCreated = "DateCreated";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = ShoppingCartItem, 
		/// Fields       = "ShoppingCartItemID"
		/// Query        = ...
        /// </summary>
        protected ShoppingCartItemFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Sales";
            this.TableName = "ShoppingCartItem";
            this.Fields = new string[]
            {
                "ShoppingCartItemID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("ShoppingCartItemId", "int?", "ShoppingCartItemID", "int?", "", null);
			this.Properties.Add("ShoppingCartId", "string", "ShoppingCartID", "string", "", null);
			this.Properties.Add("Quantity", "int?", "Quantity", "int?", "", null);
			this.Properties.Add("ProductId", "int?", "ProductID", "int?", "", "Product");
			this.Properties.Add("DateCreated", "DateTime?", "DateCreated", "DateTime?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "ShoppingCartItem"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "ShoppingCartItemList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "ShoppingCartItemFactory"; }
            set { }
        }

		#endregion

		internal static ShoppingCartItemFactory CreateFactory(EntityManager manager)
		{
		    return new ShoppingCartItemFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of ShoppingCartItem. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo ShoppingCartItem</returns>
        public override ShoppingCartItem CreateEntity()
		{
			var item = new ShoppingCartItem();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(ShoppingCartItem item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Product / Product
            // Foreign Key FK_ShoppingCartItem_Product_ProductID
            if (parent is Product)
            {
                item.Product = (Product)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public ShoppingCartItem GetItem(int? shoppingCartItemId)
        {
            return this.GetEntity(0, shoppingCartItemId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public ShoppingCartItem GetItem(DbConnector conn, int? shoppingCartItemId)
        {
            return this.GetEntity(conn, shoppingCartItemId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(ShoppingCartItem).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to ShoppingCartItemFactory / ShoppingCartItem / ShoppingCartItem.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// ShoppingCartItemFactory to ShoppingCartItem / ShoppingCartItem.
        /// </summary>
        public ShoppingCartItemFactory ShoppingCartItemFactory
		{
			get
			{
				if (_ShoppingCartItemFactory == null)
				{
					_ShoppingCartItemFactory = global::AdventureWorks.ShoppingCartItemFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_ShoppingCartItemFactory, typeof(ShoppingCartItem));
				}
				return _ShoppingCartItemFactory;
			}
		}
		private ShoppingCartItemFactory _ShoppingCartItemFactory = null;
	
        /// <summary>
        /// GetShoppingCartItem to ShoppingCartItem / ShoppingCartItem
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public ShoppingCartItem GetShoppingCartItem(int? shoppingCartItemId)
        {
            return this.ShoppingCartItemFactory.GetEntity(0, shoppingCartItemId);
        }
	
        /// <summary>
        /// GetShoppingCartItem to ShoppingCartItem / ShoppingCartItem
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ShoppingCartItem GetShoppingCartItem(DbConnector conn, int? shoppingCartItemId)
        {
            return this.ShoppingCartItemFactory.GetEntity(conn, shoppingCartItemId);
        }
	
		/// <summary>
        /// GetShoppingCartItemList to ShoppingCartItem / ShoppingCartItem
		/// Getting a list of ShoppingCartItem using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public ShoppingCartItemList GetShoppingCartItemList(SqlWhereClause where)
        {
            return this.ShoppingCartItemFactory.GetEntities(where);
        }

		/// <summary>
        /// GetShoppingCartItemList to ShoppingCartItem / ShoppingCartItem
		/// Getting all entities of ShoppingCartItem
        /// </summary>
        /// <returns>List of all found entities</returns>
        public ShoppingCartItemList GetShoppingCartItemList()
        {
			var where = new SqlWhereClause();
            return this.ShoppingCartItemFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveShoppingCartItem to ShoppingCartItem / ShoppingCartItem
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ShoppingCartItem SaveShoppingCartItem(ShoppingCartItem item)
        {
            return this.ShoppingCartItemFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveShoppingCartItem to ShoppingCartItem / ShoppingCartItem
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ShoppingCartItem SaveShoppingCartItem(DbConnector conn, ShoppingCartItem item)
        {
            return this.ShoppingCartItemFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyShoppingCartItem to ShoppingCartItem / ShoppingCartItem
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public ShoppingCartItem ApplyShoppingCartItem(DbConnector conn, ShoppingCartItem item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.ShoppingCartItemFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveShoppingCartItem to ShoppingCartItem / ShoppingCartItem
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveShoppingCartItem(ShoppingCartItem item)
        {
            return this.ShoppingCartItemFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveShoppingCartItem to ShoppingCartItem / ShoppingCartItem
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveShoppingCartItem(DbConnector conn, ShoppingCartItem item)
        {
            return this.ShoppingCartItemFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities ShoppingCartItemList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveShoppingCartItemList(ShoppingCartItemList items)
        {
			return this.ShoppingCartItemFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
