﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// TransactionHistory / TransactionHistory - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class TransactionHistory
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for TransactionHistory
        /// </summary>
	    public TransactionHistory()
		{
		}

		///// <summary>
        ///// Creates a new instance of TransactionHistory
        ///// </summary>
	    //internal TransactionHistory CreateEntity()
		//{
		//    return new TransactionHistory();
		//}

		#region Members

		
        /// <summary>
        /// TransactionId / TransactionHistory.TransactionID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("TransactionID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? TransactionId
        {
            get
            {
                return (int?)this["TransactionID"];
            }
            set
            {
                this.Add("TransactionID", value, typeof(int?));
            }
        }

        /// <summary>
        /// ProductId / TransactionHistory.ProductID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Product")]
        public virtual int? ProductId
        {
            get
            {
                return (int?)this["ProductID"];
            }
            set
            {
                this.Add("ProductID", value, typeof(int?));
            }
        }

        /// <summary>
        /// ReferenceOrderId / TransactionHistory.ReferenceOrderID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ReferenceOrderID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? ReferenceOrderId
        {
            get
            {
                return (int?)this["ReferenceOrderID"];
            }
            set
            {
                this.Add("ReferenceOrderID", value, typeof(int?));
            }
        }

        /// <summary>
        /// ReferenceOrderLineId / TransactionHistory.ReferenceOrderLineID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ReferenceOrderLineID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? ReferenceOrderLineId
        {
            get
            {
                return (int?)this["ReferenceOrderLineID"];
            }
            set
            {
                this.Add("ReferenceOrderLineID", value, typeof(int?));
            }
        }

        /// <summary>
        /// TransactionDate / TransactionHistory.TransactionDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("TransactionDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? TransactionDate
        {
            get
            {
                return (DateTime?)this["TransactionDate"];
            }
            set
            {
                this.Add("TransactionDate", value, typeof(DateTime?));
            }
        }

        /// <summary>
        /// TransactionType / TransactionHistory.TransactionType
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("TransactionType"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string TransactionType
        {
            get
            {
                return (string)this["TransactionType"];
            }
            set
            {
                this.Add("TransactionType", value, typeof(string));
            }
        }

        /// <summary>
        /// Quantity / TransactionHistory.Quantity
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Quantity"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? Quantity
        {
            get
            {
                return (int?)this["Quantity"];
            }
            set
            {
                this.Add("Quantity", value, typeof(int?));
            }
        }

        /// <summary>
        /// ActualCost / TransactionHistory.ActualCost
        /// </summary>
        /// <returns>decimal?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ActualCost"), FieldOrder(0), TypeName("decimal?"), FieldTypeName("decimal?"), ForeignEntity(null)]
        public virtual decimal? ActualCost
        {
            get
            {
                return (decimal?)this["ActualCost"];
            }
            set
            {
                this.Add("ActualCost", value, typeof(decimal?));
            }
        }

        /// <summary>
        /// ModifiedDate / TransactionHistory.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Product

        /// <summary>
        /// Link to parent/super Entity Product / Product (this.ProductId)
		/// Foreign key FK_TransactionHistory_Product_ProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Product Product
        {
            get
            {
			    // Lazy loading
                if (this._Product == null && this.ProductId != null)
                {
                    this._Product = ((AdvEntityManager)this.Manager).GetProduct(this.ProductId);
                    if (! _Product.ResultInfo.IsValid)
                    {
						this._Product = null; // reset value
                        throw new Exception("wrong/missed constraint from TransactionHistory to Product.");
                    }
                }
                return this._Product;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ProductId = (value != null ? value.ProductId : null);


				// set foreign table
                this._Product = value;
            }
        }
        private Product _Product = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		

		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.TransactionHistoryFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "TransactionHistory"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // TransactionHistory

	#endregion

	#region Entity-List

    /// <summary>
    /// TransactionHistory / TransactionHistoryList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class TransactionHistoryList
        : WebEntityList<TransactionHistory>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "TransactionHistory"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// TransactionHistory - TransactionHistory - Factory 
    /// </summary>
    public partial class TransactionHistoryFactory
        : WebEntityFactory<TransactionHistory, TransactionHistoryList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property TransactionId of Db-Field TransactionID</summary>
        public static string Prop_TransactionId = "TransactionId";
        ///<summary>Property ProductId of Db-Field ProductID</summary>
        public static string Prop_ProductId = "ProductId";
        ///<summary>Property ReferenceOrderId of Db-Field ReferenceOrderID</summary>
        public static string Prop_ReferenceOrderId = "ReferenceOrderId";
        ///<summary>Property ReferenceOrderLineId of Db-Field ReferenceOrderLineID</summary>
        public static string Prop_ReferenceOrderLineId = "ReferenceOrderLineId";
        ///<summary>Property TransactionDate of Db-Field TransactionDate</summary>
        public static string Prop_TransactionDate = "TransactionDate";
        ///<summary>Property TransactionType of Db-Field TransactionType</summary>
        public static string Prop_TransactionType = "TransactionType";
        ///<summary>Property Quantity of Db-Field Quantity</summary>
        public static string Prop_Quantity = "Quantity";
        ///<summary>Property ActualCost of Db-Field ActualCost</summary>
        public static string Prop_ActualCost = "ActualCost";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field TransactionID of Property TransactionId</summary>
        public static string Field_TransactionId = "TransactionID";
        ///<summary>Db-Field ProductID of Property ProductId</summary>
        public static string Field_ProductId = "ProductID";
        ///<summary>Db-Field ReferenceOrderID of Property ReferenceOrderId</summary>
        public static string Field_ReferenceOrderId = "ReferenceOrderID";
        ///<summary>Db-Field ReferenceOrderLineID of Property ReferenceOrderLineId</summary>
        public static string Field_ReferenceOrderLineId = "ReferenceOrderLineID";
        ///<summary>Db-Field TransactionDate of Property TransactionDate</summary>
        public static string Field_TransactionDate = "TransactionDate";
        ///<summary>Db-Field TransactionType of Property TransactionType</summary>
        public static string Field_TransactionType = "TransactionType";
        ///<summary>Db-Field Quantity of Property Quantity</summary>
        public static string Field_Quantity = "Quantity";
        ///<summary>Db-Field ActualCost of Property ActualCost</summary>
        public static string Field_ActualCost = "ActualCost";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = TransactionHistory, 
		/// Fields       = "TransactionID"
		/// Query        = ...
        /// </summary>
        protected TransactionHistoryFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "TransactionHistory";
            this.Fields = new string[]
            {
                "TransactionID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("TransactionId", "int?", "TransactionID", "int?", "", null);
			this.Properties.Add("ProductId", "int?", "ProductID", "int?", "", "Product");
			this.Properties.Add("ReferenceOrderId", "int?", "ReferenceOrderID", "int?", "", null);
			this.Properties.Add("ReferenceOrderLineId", "int?", "ReferenceOrderLineID", "int?", "", null);
			this.Properties.Add("TransactionDate", "DateTime?", "TransactionDate", "DateTime?", "", null);
			this.Properties.Add("TransactionType", "string", "TransactionType", "string", "", null);
			this.Properties.Add("Quantity", "int?", "Quantity", "int?", "", null);
			this.Properties.Add("ActualCost", "decimal?", "ActualCost", "decimal?", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "TransactionHistory"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "TransactionHistoryList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "TransactionHistoryFactory"; }
            set { }
        }

		#endregion

		internal static TransactionHistoryFactory CreateFactory(EntityManager manager)
		{
		    return new TransactionHistoryFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of TransactionHistory. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo TransactionHistory</returns>
        public override TransactionHistory CreateEntity()
		{
			var item = new TransactionHistory();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(TransactionHistory item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Product / Product
            // Foreign Key FK_TransactionHistory_Product_ProductID
            if (parent is Product)
            {
                item.Product = (Product)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public TransactionHistory GetItem(int? transactionId)
        {
            return this.GetEntity(0, transactionId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public TransactionHistory GetItem(DbConnector conn, int? transactionId)
        {
            return this.GetEntity(conn, transactionId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(TransactionHistory).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to TransactionHistoryFactory / TransactionHistory / TransactionHistory.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// TransactionHistoryFactory to TransactionHistory / TransactionHistory.
        /// </summary>
        public TransactionHistoryFactory TransactionHistoryFactory
		{
			get
			{
				if (_TransactionHistoryFactory == null)
				{
					_TransactionHistoryFactory = global::AdventureWorks.TransactionHistoryFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_TransactionHistoryFactory, typeof(TransactionHistory));
				}
				return _TransactionHistoryFactory;
			}
		}
		private TransactionHistoryFactory _TransactionHistoryFactory = null;
	
        /// <summary>
        /// GetTransactionHistory to TransactionHistory / TransactionHistory
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public TransactionHistory GetTransactionHistory(int? transactionId)
        {
            return this.TransactionHistoryFactory.GetEntity(0, transactionId);
        }
	
        /// <summary>
        /// GetTransactionHistory to TransactionHistory / TransactionHistory
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public TransactionHistory GetTransactionHistory(DbConnector conn, int? transactionId)
        {
            return this.TransactionHistoryFactory.GetEntity(conn, transactionId);
        }
	
		/// <summary>
        /// GetTransactionHistoryList to TransactionHistory / TransactionHistory
		/// Getting a list of TransactionHistory using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public TransactionHistoryList GetTransactionHistoryList(SqlWhereClause where)
        {
            return this.TransactionHistoryFactory.GetEntities(where);
        }

		/// <summary>
        /// GetTransactionHistoryList to TransactionHistory / TransactionHistory
		/// Getting all entities of TransactionHistory
        /// </summary>
        /// <returns>List of all found entities</returns>
        public TransactionHistoryList GetTransactionHistoryList()
        {
			var where = new SqlWhereClause();
            return this.TransactionHistoryFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveTransactionHistory to TransactionHistory / TransactionHistory
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public TransactionHistory SaveTransactionHistory(TransactionHistory item)
        {
            return this.TransactionHistoryFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveTransactionHistory to TransactionHistory / TransactionHistory
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public TransactionHistory SaveTransactionHistory(DbConnector conn, TransactionHistory item)
        {
            return this.TransactionHistoryFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyTransactionHistory to TransactionHistory / TransactionHistory
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public TransactionHistory ApplyTransactionHistory(DbConnector conn, TransactionHistory item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.TransactionHistoryFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveTransactionHistory to TransactionHistory / TransactionHistory
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveTransactionHistory(TransactionHistory item)
        {
            return this.TransactionHistoryFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveTransactionHistory to TransactionHistory / TransactionHistory
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveTransactionHistory(DbConnector conn, TransactionHistory item)
        {
            return this.TransactionHistoryFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities TransactionHistoryList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveTransactionHistoryList(TransactionHistoryList items)
        {
			return this.TransactionHistoryFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
