﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// UnitMeasure / UnitMeasure - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class UnitMeasure
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for UnitMeasure
        /// </summary>
	    public UnitMeasure()
		{
		}

		///// <summary>
        ///// Creates a new instance of UnitMeasure
        ///// </summary>
	    //internal UnitMeasure CreateEntity()
		//{
		//    return new UnitMeasure();
		//}

		#region Members

		
        /// <summary>
        /// UnitMeasureCode / UnitMeasure.UnitMeasureCode
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("UnitMeasureCode"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string UnitMeasureCode
        {
            get
            {
                return (string)this["UnitMeasureCode"];
            }
            set
            {
                this.Add("UnitMeasureCode", value, typeof(string));
            }
        }

        /// <summary>
        /// Name / UnitMeasure.Name
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Name"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Name
        {
            get
            {
                return (string)this["Name"];
            }
            set
            {
                this.Add("Name", value, typeof(string));
            }
        }

        /// <summary>
        /// ModifiedDate / UnitMeasure.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		

		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from BillOfMaterials

        /// <summary>
        /// List of sub entities BillOfMaterials / BillOfMaterials (UnitMeasureCode)
		/// Foreign Key FK_BillOfMaterials_UnitMeasure_UnitMeasureCode
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual BillOfMaterialsList BillOfMaterialsList
        {
            get
            {
			    // Lazy Loading
                if (_BillOfMaterialsList == null && this.UnitMeasureCode != null)
                {
					var where = new SqlWhereClause("WHERE BillOfMaterials.UnitMeasureCode = @UnitMeasureCode",
					    "@UnitMeasureCode", this.UnitMeasureCode);
                    _BillOfMaterialsList = ((AdvEntityManager)this.Manager).GetBillOfMaterialsList(where);
                }
				if (_BillOfMaterialsList == null)
				{
					_BillOfMaterialsList = new BillOfMaterialsList();
				}
                return _BillOfMaterialsList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private BillOfMaterialsList _BillOfMaterialsList = null;

        #endregion

        #region Sub Entites from Product

        /// <summary>
        /// List of sub entities Product / Product (SizeUnitMeasureCode)
		/// Foreign Key FK_Product_UnitMeasure_SizeUnitMeasureCode
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductList ProductList
        {
            get
            {
			    // Lazy Loading
                if (_ProductList == null && this.UnitMeasureCode != null)
                {
					var where = new SqlWhereClause("WHERE Product.SizeUnitMeasureCode = @SizeUnitMeasureCode",
					    "@SizeUnitMeasureCode", this.UnitMeasureCode);
                    _ProductList = ((AdvEntityManager)this.Manager).GetProductList(where);
                }
				if (_ProductList == null)
				{
					_ProductList = new ProductList();
				}
                return _ProductList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductList _ProductList = null;

        #endregion

        #region Sub Entites from Product

        /// <summary>
        /// List of sub entities Product / Product (WeightUnitMeasureCode)
		/// Foreign Key FK_Product_UnitMeasure_WeightUnitMeasureCode
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductList ProductWeightUnitMeasureCodeList
        {
            get
            {
			    // Lazy Loading
                if (_ProductWeightUnitMeasureCodeList == null && this.UnitMeasureCode != null)
                {
					var where = new SqlWhereClause("WHERE Product.WeightUnitMeasureCode = @WeightUnitMeasureCode",
					    "@WeightUnitMeasureCode", this.UnitMeasureCode);
                    _ProductWeightUnitMeasureCodeList = ((AdvEntityManager)this.Manager).GetProductList(where);
                }
				if (_ProductWeightUnitMeasureCodeList == null)
				{
					_ProductWeightUnitMeasureCodeList = new ProductList();
				}
                return _ProductWeightUnitMeasureCodeList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductList _ProductWeightUnitMeasureCodeList = null;

        #endregion

        #region Sub Entites from ProductVendor

        /// <summary>
        /// List of sub entities ProductVendor / ProductVendor (UnitMeasureCode)
		/// Foreign Key FK_ProductVendor_UnitMeasure_UnitMeasureCode
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductVendorList ProductVendorList
        {
            get
            {
			    // Lazy Loading
                if (_ProductVendorList == null && this.UnitMeasureCode != null)
                {
					var where = new SqlWhereClause("WHERE ProductVendor.UnitMeasureCode = @UnitMeasureCode",
					    "@UnitMeasureCode", this.UnitMeasureCode);
                    _ProductVendorList = ((AdvEntityManager)this.Manager).GetProductVendorList(where);
                }
				if (_ProductVendorList == null)
				{
					_ProductVendorList = new ProductVendorList();
				}
                return _ProductVendorList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductVendorList _ProductVendorList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.UnitMeasureFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "UnitMeasure"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // UnitMeasure

	#endregion

	#region Entity-List

    /// <summary>
    /// UnitMeasure / UnitMeasureList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class UnitMeasureList
        : WebEntityList<UnitMeasure>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "UnitMeasure"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// UnitMeasure - UnitMeasure - Factory 
    /// </summary>
    public partial class UnitMeasureFactory
        : WebEntityFactory<UnitMeasure, UnitMeasureList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property UnitMeasureCode of Db-Field UnitMeasureCode</summary>
        public static string Prop_UnitMeasureCode = "UnitMeasureCode";
        ///<summary>Property Name of Db-Field Name</summary>
        public static string Prop_Name = "Name";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field UnitMeasureCode of Property UnitMeasureCode</summary>
        public static string Field_UnitMeasureCode = "UnitMeasureCode";
        ///<summary>Db-Field Name of Property Name</summary>
        public static string Field_Name = "Name";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = UnitMeasure, 
		/// Fields       = "UnitMeasureCode"
		/// Query        = ...
        /// </summary>
        protected UnitMeasureFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "UnitMeasure";
            this.Fields = new string[]
            {
                "UnitMeasureCode"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("UnitMeasureCode", "string", "UnitMeasureCode", "string", "", null);
			this.Properties.Add("Name", "string", "Name", "string", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "UnitMeasure"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "UnitMeasureList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "UnitMeasureFactory"; }
            set { }
        }

		#endregion

		internal static UnitMeasureFactory CreateFactory(EntityManager manager)
		{
		    return new UnitMeasureFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of UnitMeasure. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo UnitMeasure</returns>
        public override UnitMeasure CreateEntity()
		{
			var item = new UnitMeasure();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}



		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public UnitMeasure GetItem(string unitMeasureCode)
        {
            return this.GetEntity(0, unitMeasureCode);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public UnitMeasure GetItem(DbConnector conn, string unitMeasureCode)
        {
            return this.GetEntity(conn, unitMeasureCode);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(UnitMeasure).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to UnitMeasureFactory / UnitMeasure / UnitMeasure.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// UnitMeasureFactory to UnitMeasure / UnitMeasure.
        /// </summary>
        public UnitMeasureFactory UnitMeasureFactory
		{
			get
			{
				if (_UnitMeasureFactory == null)
				{
					_UnitMeasureFactory = global::AdventureWorks.UnitMeasureFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_UnitMeasureFactory, typeof(UnitMeasure));
				}
				return _UnitMeasureFactory;
			}
		}
		private UnitMeasureFactory _UnitMeasureFactory = null;
	
        /// <summary>
        /// GetUnitMeasure to UnitMeasure / UnitMeasure
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public UnitMeasure GetUnitMeasure(string unitMeasureCode)
        {
            return this.UnitMeasureFactory.GetEntity(0, unitMeasureCode);
        }
	
        /// <summary>
        /// GetUnitMeasure to UnitMeasure / UnitMeasure
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public UnitMeasure GetUnitMeasure(DbConnector conn, string unitMeasureCode)
        {
            return this.UnitMeasureFactory.GetEntity(conn, unitMeasureCode);
        }
	
		/// <summary>
        /// GetUnitMeasureList to UnitMeasure / UnitMeasure
		/// Getting a list of UnitMeasure using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public UnitMeasureList GetUnitMeasureList(SqlWhereClause where)
        {
            return this.UnitMeasureFactory.GetEntities(where);
        }

		/// <summary>
        /// GetUnitMeasureList to UnitMeasure / UnitMeasure
		/// Getting all entities of UnitMeasure
        /// </summary>
        /// <returns>List of all found entities</returns>
        public UnitMeasureList GetUnitMeasureList()
        {
			var where = new SqlWhereClause();
            return this.UnitMeasureFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveUnitMeasure to UnitMeasure / UnitMeasure
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public UnitMeasure SaveUnitMeasure(UnitMeasure item)
        {
            return this.UnitMeasureFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveUnitMeasure to UnitMeasure / UnitMeasure
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public UnitMeasure SaveUnitMeasure(DbConnector conn, UnitMeasure item)
        {
            return this.UnitMeasureFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyUnitMeasure to UnitMeasure / UnitMeasure
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public UnitMeasure ApplyUnitMeasure(DbConnector conn, UnitMeasure item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.UnitMeasureFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveUnitMeasure to UnitMeasure / UnitMeasure
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveUnitMeasure(UnitMeasure item)
        {
            return this.UnitMeasureFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveUnitMeasure to UnitMeasure / UnitMeasure
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveUnitMeasure(DbConnector conn, UnitMeasure item)
        {
            return this.UnitMeasureFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities UnitMeasureList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveUnitMeasureList(UnitMeasureList items)
        {
			return this.UnitMeasureFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
