﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// Vendor / Vendor - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class Vendor
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for Vendor
        /// </summary>
	    public Vendor()
		{
		}

		///// <summary>
        ///// Creates a new instance of Vendor
        ///// </summary>
	    //internal Vendor CreateEntity()
		//{
		//    return new Vendor();
		//}

		#region Members

		
        /// <summary>
        /// BusinessEntityId / Vendor.BusinessEntityID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("BusinessEntityID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("BusinessEntity")]
        public virtual int? BusinessEntityId
        {
            get
            {
                return (int?)this["BusinessEntityID"];
            }
            set
            {
                this.Add("BusinessEntityID", value, typeof(int?));
            }
        }

        /// <summary>
        /// AccountNumber / Vendor.AccountNumber
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("AccountNumber"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string AccountNumber
        {
            get
            {
                return (string)this["AccountNumber"];
            }
            set
            {
                this.Add("AccountNumber", value, typeof(string));
            }
        }

        /// <summary>
        /// Name / Vendor.Name
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("Name"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string Name
        {
            get
            {
                return (string)this["Name"];
            }
            set
            {
                this.Add("Name", value, typeof(string));
            }
        }

        /// <summary>
        /// CreditRating / Vendor.CreditRating
        /// </summary>
        /// <returns>byte?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("CreditRating"), FieldOrder(0), TypeName("byte?"), FieldTypeName("byte?"), ForeignEntity(null)]
        public virtual byte? CreditRating
        {
            get
            {
                return (byte?)this["CreditRating"];
            }
            set
            {
                this.Add("CreditRating", value, typeof(byte?));
            }
        }

        /// <summary>
        /// PreferredVendorStatus / Vendor.PreferredVendorStatus
        /// </summary>
        /// <returns>bool?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("PreferredVendorStatus"), FieldOrder(0), TypeName("bool?"), FieldTypeName("bool?"), ForeignEntity(null)]
        public virtual bool? PreferredVendorStatus
        {
            get
            {
                return (bool?)this["PreferredVendorStatus"];
            }
            set
            {
                this.Add("PreferredVendorStatus", value, typeof(bool?));
            }
        }

        /// <summary>
        /// ActiveFlag / Vendor.ActiveFlag
        /// </summary>
        /// <returns>bool?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ActiveFlag"), FieldOrder(0), TypeName("bool?"), FieldTypeName("bool?"), ForeignEntity(null)]
        public virtual bool? ActiveFlag
        {
            get
            {
                return (bool?)this["ActiveFlag"];
            }
            set
            {
                this.Add("ActiveFlag", value, typeof(bool?));
            }
        }

        /// <summary>
        /// PurchasingWebServiceUrl / Vendor.PurchasingWebServiceURL
        /// </summary>
        /// <returns>string</returns>
        [DataMember]
        [FieldGroup(""), FieldName("PurchasingWebServiceURL"), FieldOrder(0), TypeName("string"), FieldTypeName("string"), ForeignEntity(null)]
        public virtual string PurchasingWebServiceUrl
        {
            get
            {
                return (string)this["PurchasingWebServiceURL"];
            }
            set
            {
                this.Add("PurchasingWebServiceURL", value, typeof(string));
            }
        }

        /// <summary>
        /// ModifiedDate / Vendor.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to BusinessEntity

        /// <summary>
        /// Link to parent/super Entity BusinessEntity / BusinessEntity (this.BusinessEntityId)
		/// Foreign key FK_Vendor_BusinessEntity_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual BusinessEntity BusinessEntity
        {
            get
            {
			    // Lazy loading
                if (this._BusinessEntity == null && this.BusinessEntityId != null)
                {
                    this._BusinessEntity = ((AdvEntityManager)this.Manager).GetBusinessEntity(this.BusinessEntityId);
                    if (! _BusinessEntity.ResultInfo.IsValid)
                    {
						this._BusinessEntity = null; // reset value
                        throw new Exception("wrong/missed constraint from Vendor to BusinessEntity.");
                    }
                }
                return this._BusinessEntity;
            }
            set
            {
                // reassign foreign key values from setter value
                this.BusinessEntityId = (value != null ? value.BusinessEntityId : null);


				// set foreign table
                this._BusinessEntity = value;
            }
        }
        private BusinessEntity _BusinessEntity = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from ProductVendor

        /// <summary>
        /// List of sub entities ProductVendor / ProductVendor (BusinessEntityID)
		/// Foreign Key FK_ProductVendor_Vendor_BusinessEntityID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ProductVendorList ProductVendorList
        {
            get
            {
			    // Lazy Loading
                if (_ProductVendorList == null && this.BusinessEntityId != null)
                {
					var where = new SqlWhereClause("WHERE ProductVendor.BusinessEntityID = @BusinessEntityID",
					    "@BusinessEntityID", this.BusinessEntityId);
                    _ProductVendorList = ((AdvEntityManager)this.Manager).GetProductVendorList(where);
                }
				if (_ProductVendorList == null)
				{
					_ProductVendorList = new ProductVendorList();
				}
                return _ProductVendorList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private ProductVendorList _ProductVendorList = null;

        #endregion

        #region Sub Entites from PurchaseOrderHeader

        /// <summary>
        /// List of sub entities PurchaseOrderHeader / PurchaseOrderHeader (VendorID)
		/// Foreign Key FK_PurchaseOrderHeader_Vendor_VendorID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual PurchaseOrderHeaderList PurchaseOrderHeaderList
        {
            get
            {
			    // Lazy Loading
                if (_PurchaseOrderHeaderList == null && this.BusinessEntityId != null)
                {
					var where = new SqlWhereClause("WHERE PurchaseOrderHeader.VendorID = @VendorID",
					    "@VendorID", this.BusinessEntityId);
                    _PurchaseOrderHeaderList = ((AdvEntityManager)this.Manager).GetPurchaseOrderHeaderList(where);
                }
				if (_PurchaseOrderHeaderList == null)
				{
					_PurchaseOrderHeaderList = new PurchaseOrderHeaderList();
				}
                return _PurchaseOrderHeaderList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private PurchaseOrderHeaderList _PurchaseOrderHeaderList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.VendorFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Vendor"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // Vendor

	#endregion

	#region Entity-List

    /// <summary>
    /// Vendor / VendorList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class VendorList
        : WebEntityList<Vendor>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "Vendor"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// Vendor - Vendor - Factory 
    /// </summary>
    public partial class VendorFactory
        : WebEntityFactory<Vendor, VendorList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property BusinessEntityId of Db-Field BusinessEntityID</summary>
        public static string Prop_BusinessEntityId = "BusinessEntityId";
        ///<summary>Property AccountNumber of Db-Field AccountNumber</summary>
        public static string Prop_AccountNumber = "AccountNumber";
        ///<summary>Property Name of Db-Field Name</summary>
        public static string Prop_Name = "Name";
        ///<summary>Property CreditRating of Db-Field CreditRating</summary>
        public static string Prop_CreditRating = "CreditRating";
        ///<summary>Property PreferredVendorStatus of Db-Field PreferredVendorStatus</summary>
        public static string Prop_PreferredVendorStatus = "PreferredVendorStatus";
        ///<summary>Property ActiveFlag of Db-Field ActiveFlag</summary>
        public static string Prop_ActiveFlag = "ActiveFlag";
        ///<summary>Property PurchasingWebServiceUrl of Db-Field PurchasingWebServiceURL</summary>
        public static string Prop_PurchasingWebServiceUrl = "PurchasingWebServiceUrl";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field BusinessEntityID of Property BusinessEntityId</summary>
        public static string Field_BusinessEntityId = "BusinessEntityID";
        ///<summary>Db-Field AccountNumber of Property AccountNumber</summary>
        public static string Field_AccountNumber = "AccountNumber";
        ///<summary>Db-Field Name of Property Name</summary>
        public static string Field_Name = "Name";
        ///<summary>Db-Field CreditRating of Property CreditRating</summary>
        public static string Field_CreditRating = "CreditRating";
        ///<summary>Db-Field PreferredVendorStatus of Property PreferredVendorStatus</summary>
        public static string Field_PreferredVendorStatus = "PreferredVendorStatus";
        ///<summary>Db-Field ActiveFlag of Property ActiveFlag</summary>
        public static string Field_ActiveFlag = "ActiveFlag";
        ///<summary>Db-Field PurchasingWebServiceURL of Property PurchasingWebServiceUrl</summary>
        public static string Field_PurchasingWebServiceUrl = "PurchasingWebServiceURL";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = Vendor, 
		/// Fields       = "BusinessEntityID"
		/// Query        = ...
        /// </summary>
        protected VendorFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Purchasing";
            this.TableName = "Vendor";
            this.Fields = new string[]
            {
                "BusinessEntityID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("BusinessEntityId", "int?", "BusinessEntityID", "int?", "", "BusinessEntity");
			this.Properties.Add("AccountNumber", "string", "AccountNumber", "string", "", null);
			this.Properties.Add("Name", "string", "Name", "string", "", null);
			this.Properties.Add("CreditRating", "byte?", "CreditRating", "byte?", "", null);
			this.Properties.Add("PreferredVendorStatus", "bool?", "PreferredVendorStatus", "bool?", "", null);
			this.Properties.Add("ActiveFlag", "bool?", "ActiveFlag", "bool?", "", null);
			this.Properties.Add("PurchasingWebServiceUrl", "string", "PurchasingWebServiceURL", "string", "", null);
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "Vendor"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "VendorList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "VendorFactory"; }
            set { }
        }

		#endregion

		internal static VendorFactory CreateFactory(EntityManager manager)
		{
		    return new VendorFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of Vendor. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo Vendor</returns>
        public override Vendor CreateEntity()
		{
			var item = new Vendor();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(Vendor item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity BusinessEntity / BusinessEntity
            // Foreign Key FK_Vendor_BusinessEntity_BusinessEntityID
            if (parent is BusinessEntity)
            {
                item.BusinessEntity = (BusinessEntity)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public Vendor GetItem(int? businessEntityId)
        {
            return this.GetEntity(0, businessEntityId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public Vendor GetItem(DbConnector conn, int? businessEntityId)
        {
            return this.GetEntity(conn, businessEntityId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(Vendor).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to VendorFactory / Vendor / Vendor.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// VendorFactory to Vendor / Vendor.
        /// </summary>
        public VendorFactory VendorFactory
		{
			get
			{
				if (_VendorFactory == null)
				{
					_VendorFactory = global::AdventureWorks.VendorFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_VendorFactory, typeof(Vendor));
				}
				return _VendorFactory;
			}
		}
		private VendorFactory _VendorFactory = null;
	
        /// <summary>
        /// GetVendor to Vendor / Vendor
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public Vendor GetVendor(int? businessEntityId)
        {
            return this.VendorFactory.GetEntity(0, businessEntityId);
        }
	
        /// <summary>
        /// GetVendor to Vendor / Vendor
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Vendor GetVendor(DbConnector conn, int? businessEntityId)
        {
            return this.VendorFactory.GetEntity(conn, businessEntityId);
        }
	
		/// <summary>
        /// GetVendorList to Vendor / Vendor
		/// Getting a list of Vendor using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public VendorList GetVendorList(SqlWhereClause where)
        {
            return this.VendorFactory.GetEntities(where);
        }

		/// <summary>
        /// GetVendorList to Vendor / Vendor
		/// Getting all entities of Vendor
        /// </summary>
        /// <returns>List of all found entities</returns>
        public VendorList GetVendorList()
        {
			var where = new SqlWhereClause();
            return this.VendorFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveVendor to Vendor / Vendor
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Vendor SaveVendor(Vendor item)
        {
            return this.VendorFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveVendor to Vendor / Vendor
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Vendor SaveVendor(DbConnector conn, Vendor item)
        {
            return this.VendorFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyVendor to Vendor / Vendor
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public Vendor ApplyVendor(DbConnector conn, Vendor item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.VendorFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveVendor to Vendor / Vendor
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveVendor(Vendor item)
        {
            return this.VendorFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveVendor to Vendor / Vendor
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveVendor(DbConnector conn, Vendor item)
        {
            return this.VendorFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities VendorList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveVendorList(VendorList items)
        {
			return this.VendorFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
