﻿//
// AUTO GENERATED, MANUAL CHANGES WILL BE REMOVED BY RECREATING ENTITY MODEL
// Auto generated using the Tool EntityMappingGenerator
//
// Copyright (c) 2016 - Wellcode Software, owned by Khamis Abuelkomboz
// Only using under the license terms of the Author, see http://wellcode.de
//
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Xml.Serialization;

using Wellcode.Basics;
using Wellcode.Frame;

namespace AdventureWorks
{
    #region Entity

    /// <summary>
    /// WorkOrder / WorkOrder - Entity 
    /// </summary>
	[Serializable] [DataContract]
    public partial class WorkOrder
        : WebEntity // Must be a derivat of 'WebEntity' 
    {
		/// <summary>
        /// Standard Constructor for WorkOrder
        /// </summary>
	    public WorkOrder()
		{
		}

		///// <summary>
        ///// Creates a new instance of WorkOrder
        ///// </summary>
	    //internal WorkOrder CreateEntity()
		//{
		//    return new WorkOrder();
		//}

		#region Members

		
        /// <summary>
        /// WorkOrderId / WorkOrder.WorkOrderID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("WorkOrderID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? WorkOrderId
        {
            get
            {
                return (int?)this["WorkOrderID"];
            }
            set
            {
                this.Add("WorkOrderID", value, typeof(int?));
            }
        }

        /// <summary>
        /// ProductId / WorkOrder.ProductID
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ProductID"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity("Product")]
        public virtual int? ProductId
        {
            get
            {
                return (int?)this["ProductID"];
            }
            set
            {
                this.Add("ProductID", value, typeof(int?));
            }
        }

        /// <summary>
        /// OrderQty / WorkOrder.OrderQty
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("OrderQty"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? OrderQty
        {
            get
            {
                return (int?)this["OrderQty"];
            }
            set
            {
                this.Add("OrderQty", value, typeof(int?));
            }
        }

        /// <summary>
        /// StockedQty / WorkOrder.StockedQty
        /// </summary>
        /// <returns>int?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("StockedQty"), FieldOrder(0), TypeName("int?"), FieldTypeName("int?"), ForeignEntity(null)]
        public virtual int? StockedQty
        {
            get
            {
                return (int?)this["StockedQty"];
            }
            set
            {
                this.Add("StockedQty", value, typeof(int?));
            }
        }

        /// <summary>
        /// ScrappedQty / WorkOrder.ScrappedQty
        /// </summary>
        /// <returns>short?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ScrappedQty"), FieldOrder(0), TypeName("short?"), FieldTypeName("short?"), ForeignEntity(null)]
        public virtual short? ScrappedQty
        {
            get
            {
                return (short?)this["ScrappedQty"];
            }
            set
            {
                this.Add("ScrappedQty", value, typeof(short?));
            }
        }

        /// <summary>
        /// StartDate / WorkOrder.StartDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("StartDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? StartDate
        {
            get
            {
                return (DateTime?)this["StartDate"];
            }
            set
            {
                this.Add("StartDate", value, typeof(DateTime?));
            }
        }

        /// <summary>
        /// EndDate / WorkOrder.EndDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("EndDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? EndDate
        {
            get
            {
                return (DateTime?)this["EndDate"];
            }
            set
            {
                this.Add("EndDate", value, typeof(DateTime?));
            }
        }

        /// <summary>
        /// DueDate / WorkOrder.DueDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("DueDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? DueDate
        {
            get
            {
                return (DateTime?)this["DueDate"];
            }
            set
            {
                this.Add("DueDate", value, typeof(DateTime?));
            }
        }

        /// <summary>
        /// ScrapReasonId / WorkOrder.ScrapReasonID
        /// </summary>
        /// <returns>short?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ScrapReasonID"), FieldOrder(0), TypeName("short?"), FieldTypeName("short?"), ForeignEntity("ScrapReason")]
        public virtual short? ScrapReasonId
        {
            get
            {
                return (short?)this["ScrapReasonID"];
            }
            set
            {
                this.Add("ScrapReasonID", value, typeof(short?));
            }
        }

        /// <summary>
        /// ModifiedDate / WorkOrder.ModifiedDate
        /// </summary>
        /// <returns>DateTime?</returns>
        [DataMember]
        [FieldGroup(""), FieldName("ModifiedDate"), FieldOrder(0), TypeName("DateTime?"), FieldTypeName("DateTime?"), ForeignEntity(null)]
        public virtual DateTime? ModifiedDate
        {
            get
            {
                return (DateTime?)this["ModifiedDate"];
            }
            set
            {
                this.Add("ModifiedDate", value, typeof(DateTime?));
            }
        }


		#endregion

		#region Foreign Constraints

		
        #region foreign constraint (parent entity) to Product

        /// <summary>
        /// Link to parent/super Entity Product / Product (this.ProductId)
		/// Foreign key FK_WorkOrder_Product_ProductID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual Product Product
        {
            get
            {
			    // Lazy loading
                if (this._Product == null && this.ProductId != null)
                {
                    this._Product = ((AdvEntityManager)this.Manager).GetProduct(this.ProductId);
                    if (! _Product.ResultInfo.IsValid)
                    {
						this._Product = null; // reset value
                        throw new Exception("wrong/missed constraint from WorkOrder to Product.");
                    }
                }
                return this._Product;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ProductId = (value != null ? value.ProductId : null);


				// set foreign table
                this._Product = value;
            }
        }
        private Product _Product = null;

        #endregion

        #region foreign constraint (parent entity) to ScrapReason

        /// <summary>
        /// Link to parent/super Entity ScrapReason / ScrapReason (this.ScrapReasonId)
		/// Foreign key FK_WorkOrder_ScrapReason_ScrapReasonID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual ScrapReason ScrapReason
        {
            get
            {
			    // Lazy loading
                if (this._ScrapReason == null && this.ScrapReasonId != null)
                {
                    this._ScrapReason = ((AdvEntityManager)this.Manager).GetScrapReason(this.ScrapReasonId);
                    if (! _ScrapReason.ResultInfo.IsValid)
                    {
						this._ScrapReason = null; // reset value
                        throw new Exception("wrong/missed constraint from WorkOrder to ScrapReason.");
                    }
                }
                return this._ScrapReason;
            }
            set
            {
                // reassign foreign key values from setter value
                this.ScrapReasonId = (value != null ? value.ScrapReasonId : null);


				// set foreign table
                this._ScrapReason = value;
            }
        }
        private ScrapReason _ScrapReason = null;

        #endregion


		#endregion

		#region Sub Entities (Listen)

		
        #region Sub Entites from WorkOrderRouting

        /// <summary>
        /// List of sub entities WorkOrderRouting / WorkOrderRouting (WorkOrderID)
		/// Foreign Key FK_WorkOrderRouting_WorkOrder_WorkOrderID
        /// </summary>
		[XmlIgnore]
		[IgnoreDataMember]
        public virtual WorkOrderRoutingList WorkOrderRoutingList
        {
            get
            {
			    // Lazy Loading
                if (_WorkOrderRoutingList == null && this.WorkOrderId != null)
                {
					var where = new SqlWhereClause("WHERE WorkOrderRouting.WorkOrderID = @WorkOrderID",
					    "@WorkOrderID", this.WorkOrderId);
                    _WorkOrderRoutingList = ((AdvEntityManager)this.Manager).GetWorkOrderRoutingList(where);
                }
				if (_WorkOrderRoutingList == null)
				{
					_WorkOrderRoutingList = new WorkOrderRoutingList();
				}
                return _WorkOrderRoutingList;
            }
			set
			{
				// not implemented (need to be defined for webservices)
			}
        }
        private WorkOrderRoutingList _WorkOrderRoutingList = null;

        #endregion


		#endregion

		#region Members - backward compatibility

		

		#endregion

		#region Functions

		/// <summary>
        /// tells if a field is part of a property in this entity, this is used to 
        /// optimize the dynamic ValuePair-List in the web service. 
		/// Fields that reflect properties are not listed in the ValuePair List.
        /// </summary>
        /// <param name="fieldName"></param>
        /// <returns></returns>
        public override bool IsRegisteredField(string fieldName)
        {
            var result = base.IsRegisteredField(fieldName);
			if (result == false)
			 result = AdvEntityManager.Manager.WorkOrderFactory.Properties.ContainsKey(fieldName);
			 return result;
        }

		#endregion

		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "WorkOrder"; }
            set { }
        }
		
		#endregion



        #region EntityManager / AdvEntityManager

        /// <summary>
        /// bound Entity manager of this factory. 
		/// Otherwise reference to the standard entity manager, if no manager is set.
        /// </summary>
		[IgnoreDataMember, XmlIgnore, System.Web.Script.Serialization.ScriptIgnore]
        public override EntityManager Manager
        {
            get
            {
				var manager = base.Manager;
                if (manager == null && EntityManager.ThreadManager is AdvEntityManager)
                    manager = EntityManager.ThreadManager;
                if (manager == null)
                    manager = AdvEntityManager.Manager;
                return manager;
            }
        }

		#endregion
	} // WorkOrder

	#endregion

	#region Entity-List

    /// <summary>
    /// WorkOrder / WorkOrderList - List
    /// </summary>
	[Serializable] [DataContract]
    public partial class WorkOrderList
        : WebEntityList<WorkOrder>
    {
		#region Meta-Data

        /// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        [DataMember]
        public override string EntityName
        {
            get { return "WorkOrder"; }
            set { }
        }

		#endregion
    }
	
	#endregion

	#region Factory

    /// <summary>
    /// WorkOrder - WorkOrder - Factory 
    /// </summary>
    public partial class WorkOrderFactory
        : WebEntityFactory<WorkOrder, WorkOrderList>
    {

        #region Property names
        // list of property names to easly reference names as constants for several porposes
        ///<summary>Property WorkOrderId of Db-Field WorkOrderID</summary>
        public static string Prop_WorkOrderId = "WorkOrderId";
        ///<summary>Property ProductId of Db-Field ProductID</summary>
        public static string Prop_ProductId = "ProductId";
        ///<summary>Property OrderQty of Db-Field OrderQty</summary>
        public static string Prop_OrderQty = "OrderQty";
        ///<summary>Property StockedQty of Db-Field StockedQty</summary>
        public static string Prop_StockedQty = "StockedQty";
        ///<summary>Property ScrappedQty of Db-Field ScrappedQty</summary>
        public static string Prop_ScrappedQty = "ScrappedQty";
        ///<summary>Property StartDate of Db-Field StartDate</summary>
        public static string Prop_StartDate = "StartDate";
        ///<summary>Property EndDate of Db-Field EndDate</summary>
        public static string Prop_EndDate = "EndDate";
        ///<summary>Property DueDate of Db-Field DueDate</summary>
        public static string Prop_DueDate = "DueDate";
        ///<summary>Property ScrapReasonId of Db-Field ScrapReasonID</summary>
        public static string Prop_ScrapReasonId = "ScrapReasonId";
        ///<summary>Property ModifiedDate of Db-Field ModifiedDate</summary>
        public static string Prop_ModifiedDate = "ModifiedDate";
        #endregion


        #region Field names
        // list of field names to easly reference names as constants for several porposes
        ///<summary>Db-Field WorkOrderID of Property WorkOrderId</summary>
        public static string Field_WorkOrderId = "WorkOrderID";
        ///<summary>Db-Field ProductID of Property ProductId</summary>
        public static string Field_ProductId = "ProductID";
        ///<summary>Db-Field OrderQty of Property OrderQty</summary>
        public static string Field_OrderQty = "OrderQty";
        ///<summary>Db-Field StockedQty of Property StockedQty</summary>
        public static string Field_StockedQty = "StockedQty";
        ///<summary>Db-Field ScrappedQty of Property ScrappedQty</summary>
        public static string Field_ScrappedQty = "ScrappedQty";
        ///<summary>Db-Field StartDate of Property StartDate</summary>
        public static string Field_StartDate = "StartDate";
        ///<summary>Db-Field EndDate of Property EndDate</summary>
        public static string Field_EndDate = "EndDate";
        ///<summary>Db-Field DueDate of Property DueDate</summary>
        public static string Field_DueDate = "DueDate";
        ///<summary>Db-Field ScrapReasonID of Property ScrapReasonId</summary>
        public static string Field_ScrapReasonId = "ScrapReasonID";
        ///<summary>Db-Field ModifiedDate of Property ModifiedDate</summary>
        public static string Field_ModifiedDate = "ModifiedDate";
        #endregion

        /// <summary>
        /// Factory Constructor / Initializer 
		/// Table name   = WorkOrder, 
		/// Fields       = "WorkOrderID"
		/// Query        = ...
        /// </summary>
        protected WorkOrderFactory(EntityManager manager)
			: base(manager)
        {
			this.Manager = manager;
			this.TableSchema = "Production";
            this.TableName = "WorkOrder";
            this.Fields = new string[]
            {
                "WorkOrderID"
            };
			this.Query = null;
            this.Database = null;

			//
			// registering Db-Field-Entity-Property combinations
			//
			this.Properties.Add("WorkOrderId", "int?", "WorkOrderID", "int?", "", null);
			this.Properties.Add("ProductId", "int?", "ProductID", "int?", "", "Product");
			this.Properties.Add("OrderQty", "int?", "OrderQty", "int?", "", null);
			this.Properties.Add("StockedQty", "int?", "StockedQty", "int?", "", null);
			this.Properties.Add("ScrappedQty", "short?", "ScrappedQty", "short?", "", null);
			this.Properties.Add("StartDate", "DateTime?", "StartDate", "DateTime?", "", null);
			this.Properties.Add("EndDate", "DateTime?", "EndDate", "DateTime?", "", null);
			this.Properties.Add("DueDate", "DateTime?", "DueDate", "DateTime?", "", null);
			this.Properties.Add("ScrapReasonId", "short?", "ScrapReasonID", "short?", "", "ScrapReason");
			this.Properties.Add("ModifiedDate", "DateTime?", "ModifiedDate", "DateTime?", "", null);

        }

		#region Meta-Data
		/// <summary>
        /// Name of the Entity
        /// </summary>
		[XmlIgnore]
        public static string EntityName
        {
            get { return "WorkOrder"; }
            set { }
        }
		/// <summary>
        /// Name of the Entity List
        /// </summary>
		[XmlIgnore]
        public static string EntityListName
        {
            get { return "WorkOrderList"; }
            set { }
        }
        /// <summary>
        /// Name of the Entity Factory
        /// </summary>
		[XmlIgnore]
        public static string EntityFactoryName
        {
            get { return "WorkOrderFactory"; }
            set { }
        }

		#endregion

		internal static WorkOrderFactory CreateFactory(EntityManager manager)
		{
		    return new WorkOrderFactory(manager);
		}

		/// <summary>
        /// Creates a new instance of WorkOrder. 
		/// New instances created using this routine are registered to the entity manager
        /// </summary>
        /// <returns>new instance fo WorkOrder</returns>
        public override WorkOrder CreateEntity()
		{
			var item = new WorkOrder();
			
			// report changes to the EntityManager
            item.PropertyChanging += this.Manager.WebEntity_PropertyChanging;
            item.PropertyChanged += this.Manager.WebEntity_PropertyChanged;
			item.AquireEntityManager += this.Manager.AquireEntityManager;

			return item;
		}

        /// <summary>
        /// This overriden method creates automatically a relation between the new entity and the given parent entity
		/// dependent on the defined foreign constraints
		/// <see cref="WebEntityFactory{T, TList}.OnCreateEntityAuto(T, WebEntity)"/>
        /// </summary>
        /// <param name="item"></param>
        /// <param name="parent"></param>
        public override void OnCreateEntityAuto(WorkOrder item, WebEntity parent)
        {
            base.OnCreateEntityAuto(item, parent);

			// see if parent is given.
			if (parent == null)
			    return;

			// make the relationship
			
            // make relation to parent/super Entity Product / Product
            // Foreign Key FK_WorkOrder_Product_ProductID
            if (parent is Product)
            {
                item.Product = (Product)parent;
                return;
            }

            // make relation to parent/super Entity ScrapReason / ScrapReason
            // Foreign Key FK_WorkOrder_ScrapReason_ScrapReasonID
            if (parent is ScrapReason)
            {
                item.ScrapReason = (ScrapReason)parent;
                return;
            }

        }

		/// <summary>
        /// getting an existing entity object using it's primary keys 
        /// </summary>
        /// <returns>
		/// a new object of the Entity containting the existing object, when available.
		/// <see href="ResultInfo.IsValid"/>
		/// </returns>
        public WorkOrder GetItem(int? workOrderId)
        {
            return this.GetEntity(0, workOrderId);
        }

        /// <summary>
        /// getting an existing entity object using it's primary keys using a specific database connection
        /// </summary>
        /// <returns>Entity, falls vorhanden</returns>
        public WorkOrder GetItem(DbConnector conn, int? workOrderId)
        {
            return this.GetEntity(conn, workOrderId);
        }

		/// <summary>
        /// get a reference to my entity manager (rather than the base class)
		/// <see href="Factory.EntityManager"/>
        /// </summary>
        public AdvEntityManager AdvEntityManager
		{
		    get { return (AdvEntityManager)this.Manager; }
		}

        /// <summary>
        /// translate texts for the current entity factory
        /// </summary>
        public string Translate(string text)
        {
            return this.Manager.Translate(text, EntityName, typeof(WorkOrder).Namespace);
        }

	}

	#endregion

	#region older class names - backward compatibility

    //-//

	#endregion

	#region Methods for the EntityManager
	/*
	/// <summary>
    /// AdvEntityManager Part to WorkOrderFactory / WorkOrder / WorkOrder.
    /// </summary>
	*/
	public partial class AdvEntityManager
	{
		/// <summary>
        /// WorkOrderFactory to WorkOrder / WorkOrder.
        /// </summary>
        public WorkOrderFactory WorkOrderFactory
		{
			get
			{
				if (_WorkOrderFactory == null)
				{
					_WorkOrderFactory = global::AdventureWorks.WorkOrderFactory.CreateFactory(this);

					// register factory to the entity manager
					this.Factories.Add(_WorkOrderFactory, typeof(WorkOrder));
				}
				return _WorkOrderFactory;
			}
		}
		private WorkOrderFactory _WorkOrderFactory = null;
	
        /// <summary>
        /// GetWorkOrder to WorkOrder / WorkOrder
		/// Getting an Entity using it's primary key fields
        /// </summary>
        /// <returns>existing Entity, <see href="ResultInfo.IsValid"/></returns>
        public WorkOrder GetWorkOrder(int? workOrderId)
        {
            return this.WorkOrderFactory.GetEntity(0, workOrderId);
        }
	
        /// <summary>
        /// GetWorkOrder to WorkOrder / WorkOrder
		/// Getting an Entity using it's primary key fields using an active database connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public WorkOrder GetWorkOrder(DbConnector conn, int? workOrderId)
        {
            return this.WorkOrderFactory.GetEntity(conn, workOrderId);
        }
	
		/// <summary>
        /// GetWorkOrderList to WorkOrder / WorkOrder
		/// Getting a list of WorkOrder using a Where clause
        /// </summary>
        /// <returns>List of matched entities</returns>
        public WorkOrderList GetWorkOrderList(SqlWhereClause where)
        {
            return this.WorkOrderFactory.GetEntities(where);
        }

		/// <summary>
        /// GetWorkOrderList to WorkOrder / WorkOrder
		/// Getting all entities of WorkOrder
        /// </summary>
        /// <returns>List of all found entities</returns>
        public WorkOrderList GetWorkOrderList()
        {
			var where = new SqlWhereClause();
            return this.WorkOrderFactory.GetEntities(where);
        }

        /// <summary>
        /// SaveWorkOrder to WorkOrder / WorkOrder
		/// Save or create an entity
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public WorkOrder SaveWorkOrder(WorkOrder item)
        {
            return this.WorkOrderFactory.SaveEntity(item);
        }

        /// <summary>
        /// SaveWorkOrder to WorkOrder / WorkOrder
		/// Save/Create an Entity using existing Db Connection
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public WorkOrder SaveWorkOrder(DbConnector conn, WorkOrder item)
        {
            return this.WorkOrderFactory.SaveEntity(conn, item);
        }

        /// <summary>
        /// ApplyWorkOrder to WorkOrder / WorkOrder
		/// Save/Create a changed Entity using existing Db Connection
		/// Route does not make any action if entity state is up to date.
        /// </summary>
        /// <returns>Entity, <see href="ResultInfo.IsValid"/></returns>
        public WorkOrder ApplyWorkOrder(DbConnector conn, WorkOrder item)
        {
		    if (item.EntityState != EntityState.UpToDate)
				return this.WorkOrderFactory.SaveEntity(conn, item);
			return item;
        }

        /// <summary>
        /// RemoveWorkOrder to WorkOrder / WorkOrder
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveWorkOrder(WorkOrder item)
        {
            return this.WorkOrderFactory.RemoveEntity(item);
        }
		
        /// <summary>
        /// RemoveWorkOrder to WorkOrder / WorkOrder
		/// Delete an entity object
        /// </summary>
        /// <returns>true, if removed</returns>
        public bool RemoveWorkOrder(DbConnector conn, WorkOrder item)
        {
            return this.WorkOrderFactory.RemoveEntity(conn, item);
        }

        /// <summary>
        /// Save a list of entities WorkOrderList. 
        /// Entities that are marked as deleted will be permanently removed.
        /// </summary>
        /// <param name="items"></param>
        /// <returns>number of database changes</returns>
        public int SaveWorkOrderList(WorkOrderList items)
        {
			return this.WorkOrderFactory.SaveEntities(items);
		}
	}

	#endregion

} // AdventureWorks
