﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Wellcode.Frame;

namespace AdventureWorks
{
    public partial class AdvEntityManager
        : EntityManager
    {
        /// <summary>
        /// this static instance provides functions for all new generated entities in the class library
        /// </summary>
        public static new AdvEntityManager Manager
        {
            get
            {
                if (EntityManager._Manager == null)
                    EntityManager._Manager = new AdvEntityManager();
                return (AdvEntityManager)EntityManager._Manager;
            }
        }

        public override string Translate(string text, string category = null, string nameSpace = null)
        {
            return text;
        }

        public override void Translate(string EntityName, IMenu menu)
        {
            ;
        }

        public override void Translate(string EntityName, EntityFieldList fields)
        {
            ;
        }

        public override bool AuthenticateUser(AccessLevel accessLevel)
        {
            return true;
        }

        public override IMenu CreateMenuEntry(WebEntity entity, string reason)
        {
            throw new NotImplementedException();
        }
    }
}

//
// Dummy Namespace to avoid compile errors
//
namespace Wellcode.Wello
{
    public class DummyWello
    {

    }
}