﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AdventureWorksServiceTest
{
    public class Program
    {
        static void Main(string[] args)
        {
            // access the adventure web service 
            // "http://wellcode.de/AdventureWorksService/AdventureWorksService.svc"
            using (var srv = new AdvSrv.AdventureWorksServiceClient())
            {
                // read the first person
                var where = new AdvSrv.SqlWhereClause();
                where.MaxResult = 1;
                var persons = srv.GetPersonList(where);

                if (persons.Count == 0)
                    throw new Exception("No Persons found");

                var thePerson = persons.Items[0];

                // change middle name of person
                thePerson.MiddleName = "Changed From Webservice";

                // store changes
                srv.SavePerson(thePerson);
            }
        }
    }
}
